# Badge Demo

- order: 0

各种用法集合

---

````js
/** @jsx createElement */
import { View, Text, Touchable, Badge, ListView, Icon, Page } from 'nuke';
import {createElement, Component,render} from 'rax';
const App =  class NukeDemoIndex extends Component {
    constructor(){
        super();
        this.state = {
            arr1 : [
                {key: 'a0',text:'所有类别'},
                {key: 'a1',text:'所有类别','arrow':true},
                {key: 'a2',text:'所有类别','arrow':true,sub:'请选择'}
            ]
        }
    }
    linkTo(item,e) {
        console.log(e);
    }
    renderItem(length , item, index){
        const wrapStyle = index === length - 1 ? [styles.cellItem,styles.cellItemLast] : styles.cellItem;
        return (
            <View style={wrapStyle}>
                <Badge style={styles.badgeStyle}><Icon type="comments" /></Badge>

                <Touchable style={[styles.cellInner,index === length - 1 ? styles.cellInnerLast:{}]} onPress={this.linkTo.bind(this,item)}>
                    <Text style={styles.itemTextList}>{item.text}</Text>
                {
                    item.arrow ? <Icon name="arrowRight" style={styles.arrow}></Icon> : null
                }
            </Touchable>
        </View>
        );
    }
    render(){
        return (
            <Page title="Badge">
                <Page.Intro main="Badge-dot" sub="normal"></Page.Intro>
                <View style={styles.containerWithMargin}>
                    <View style={styles.item}>
                        <Text style={styles.text}>列表项</Text>
                        <Badge style={{position:'absolute',top:'14rem',left:'110rem'}}><Icon type="comments" /></Badge>
                        </View>
                </View>
                <Page.Intro sub="list"></Page.Intro>
                <ListView
                    renderRow={this.renderItem.bind(this,this.state.arr1.length)}
                    dataSource={this.state.arr1}
                    style={styles.list1}
                />
                <Page.Intro main="Badge-number" sub="normal"></Page.Intro>
                <View style={styles.containerWithMargin}>
                    <View style={styles.item}>
                        <Text style={styles.text}>列表项</Text>
                        <Badge style={{position:'absolute',top:'4rem',left:'110rem'}} count={9} max={10}></Badge>
                    </View>

                    <View style={styles.item}>
                        <Text style={styles.text}>列表项</Text>
                        <Badge type="unread" style={{position:'absolute',top:'4rem',left:'110rem'}} count={722} max={222}></Badge>
                    </View>
                </View>
                <Page.Intro main="Badge-color" sub="自定义颜色"></Page.Intro>
                <View style={styles.containerWithMargin}>
                    <View style={styles.item}>
                        <Text style={styles.text}>列表项</Text>
                        <Badge style={{position:'absolute',top:'4rem',left:'110rem',color:'#ff6600'}}><Icon type="comments" /></Badge>
                    </View>

                    <View style={styles.item}>
                        <Text style={styles.text}>列表项</Text>
                        <Badge type="unread" style={{backgroundColor:'#ff6600',position:'absolute',top:'4rem',left:'110rem'}} count={722} max={222}></Badge>
                    </View>
                </View>
                <Page.Intro main="Badge-text" sub="自定义文字"></Page.Intro>
                <View style={styles.containerWithMargin}>
                    <View style={styles.item}>
                        <Text style={styles.text}>列表项</Text>
                        <Badge style={{position:'absolute',top:'4rem',left:'110rem',backgroundColor:'#ff6600'}} count="hot" ></Badge>
                    </View>
                </View>
        </Page>
        );
    }
}
const styles={
    containerWithMargin:{
        flexDirection:'row',
        marginTop:'20rem', 
        marginBottom:'40rem', 
        marginLeft:'42rem', 
        marginRight:'42rem' 
    },
    item:{
        width:'260rem'
    },
    text:{
        fontSize:'32rem'
    },
    list1:{
        height:(104*3+2)+'rem',
        marginTop:'35rem'
    },
    cellItem:{
        backgroundColor:"#ffffff",
        [`backgroundColor:active`]:'#f2f3f7',
        height:"104rem",
        paddingLeft:"50rem",
        
    },
    cellInner:{
        flex:1,
        borderBottomWidth:"2rem",
        borderBottomStyle:"solid",
        borderBottomColor:"#e6e7eb",
        alignItems:"center",
        flexDirection:"row"
    },
    cellInnerLast:{
        borderBottomWidth:"0rem",
    },
    cellItemLast:{
        // backgroundColor:"#ffffff",
        // height:"104rem",
        borderBottomWidth:"2rem",
        borderBottomStyle:"solid",
        borderBottomColor:"#e6e7eb",
        // paddingLeft:"30rem",
        // alignItems:"center",
        // flexDirection:"row"
    },
    badgeStyle:{
        position:'absolute',
        top:'38rem',
        left:'20rem'
    },
    itemTextList:{
        fontSize:"32rem",
        color:"#5F646E"
    },
    arrow:{
        color:'#c7c7cc',
        position:'absolute',
        top:'40rem',
        right:'24rem'   
    },
    wrapper:{
        padding:'20rem'
    },
    st:{
        marginTop:'30rem',
        marginBottom:'30rem',
        paddingTop:'10rem',
        paddingBottom:'10rem',
        paddingLeft:'20rem',
        backgroundColor:'#dddddd'
    },
    stText:{
        fontSize:'36rem'
    },
    btn:{
        marginRight:'20rem'
    },
    btnblock:{
        marginBottom:'20rem'
    },
    badgeBlock: {
        backgroundColor: '#eeeeee',
        width: '48rem',
        height: '48rem',
        borderRadius: '4rem',
    }
}
render(<App/>);

````
