# Input demo

- order: 1

自动获得焦点、强制获取或失去焦点

---

````js
/** @jsx createElement */
import { View, Text, Input, Button, Page } from 'nuke';
import {createElement, Component,findDOMNode,render } from 'rax';
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();

        this.state = {
            input:'',
            value:'',
        }
    }    
    focus = (e) => {
        this.refs.myinput.focus();
    }
    blur = (e) => {
        this.refs.myinput.blur();
    }
    change = (value,e) => {
        this.setState({value:value})
    }
    input = (e) => {
        this.setState({input:e.value})
        console.log(e);
    }
    render() {
        return (
            <Page title="Input">
                <Page.Intro main="autoFocus"></Page.Intro>
                <View style={styles.lineWithMargin}>
                    <Input autoFocus preventEnterKey returnKeyType="done" ref="myinput" onInput={this.input} onChange={this.change}/>
                </View>
                <View style={[styles.lineWithMargin,styles.textLine]}>
                    <Text style={styles.text}>用户输入：{this.state.value}</Text>
                </View>
                <View style={[styles.lineWithMargin,styles.textLine]}>
                    <Text style={styles.text}>onInput:{this.state.input}</Text>
                </View>
                <View style={styles.btns}>
                    <Button style={styles.btn} block type="primary" onPress={this.focus}>获得焦点</Button>
                    <Button style={styles.btn} block type="primary" onPress={this.blur}>失去焦点</Button>
                </View>
            </Page>

        );
    }
}
const styles={
    lineWithMargin:{
        marginLeft:'30rem',
        marginRight:'30rem',

    },
    textLine:{
        marginTop:'20rem',
        marginBottom:'40rem',
    },
    text:{
        fontSize:'26rem'
    },
    btns:{
        margin:'30rem',
    },
    btn:{
        marginBottom:'30rem'
    }

}

render(<App/>);

````
