# Input demo

* order: 0

包含单行和多行文本输入，return key 等

---

```js
/** @jsx createElement */
import { View, Text, Input, Button, Page } from 'nuke';
import { createElement, Component, findDOMNode, render } from 'rax';
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            content: ''
        };
    }
    change = (value, e) => {
        this.setState({
            content: value
        });
    };
    onReturnHandler = e => {
        this.setState({
            returnKeyType: e.returnKeyType,
            returnValue: e.value
        });
        console.log('in onReturnHandler');
    };
    render() {
        return (
            <Page title="Input">
                <Page.Intro main="基础样式" />
                <View style={styles.lineWithMargin}>
                    <Input
                        testId="112"
                        ref="myinput"
                        id="first"
                        onInput={e => {
                            console.log('input==>', e);
                        }}
                    />
                </View>
                <Page.Intro main="最多20个字" />
                <View style={styles.lineWithMargin}>
                    <Input
                        maxLength={20}
                        id="second"
                        ref="myinput"
                        onChange={this.change}
                        onInput={e => {
                            console.log('input==>', e);
                        }}
                    />
                </View>
                <View style={[styles.lineWithMargin, styles.textLine]}>
                    <Text style={styles.text}>
                        用户输入：{this.state.content}
                    </Text>
                </View>

                <Page.Intro main="多行" />
                <View style={styles.lineWithMargin}>
                    <Input
                        style={{ height: '300rem', marginBottom: '20rem' }}
                        multiple={true}
                        id="third"
                        placeholder="介绍一下"
                        onFocus={e => console.log('onFocus', e)}
                        onBlur={e => console.log('onBlur', e)}
                    />
                </View>
                <Page.Intro main="自定义样式" />
                <View style={styles.lineWithMargin}>
                    <Input
                        id="fourth"
                        style={{
                            borderWidth: 0,
                            height: 40,
                            backgroundColor: '#3089dc',
                            color: '#ffffff'
                        }}
                        inputStyle={{ padding: 0 }}
                    />
                </View>

                <Page.Intro main="不可修改" />
                <View
                    style={[styles.lineWithMargin, { marginBottom: '10rem' }]}
                >
                    <Input disabled id="fiveth" value="不可修改" />
                </View>

                <Page.Intro main="键盘类型" sub="密码" />
                <View style={styles.lineWithMargin}>
                    <Input placeholder="password" htmlType="password" />
                </View>
                <Page.Intro sub="email" />
                <View style={styles.lineWithMargin}>
                    <Input placeholder="email" htmlType="email" />
                </View>
                <Page.Intro sub="url" />
                <View style={styles.lineWithMargin}>
                    <Input placeholder="url" htmlType="url" />
                </View>
                <Page.Intro sub="tel" />
                <View style={styles.lineWithMargin}>
                    <Input placeholder="tel" type="tel" />
                </View>
                <Page.Intro sub="date" />
                <View style={styles.lineWithMargin}>
                    <Input placeholder="date" type="date" />
                </View>
                <Page.Intro sub="time" />
                <View style={styles.lineWithMargin}>
                    <Input placeholder="time" type="time" />
                </View>

                <Page.Intro main="return key" />
                <View style={styles.lineWithMargin}>
                    <Input
                        placeholder="go"
                        id="sixth"
                        returnKeyType="go"
                        onReturn={this.onReturnHandler}
                    />
                </View>
                <View style={[styles.lineWithMargin, styles.textLine]}>
                    <Text style={styles.text}>
                        return 类型： {this.state.returnKeyType} , 输入框值：{' '}
                        {this.state.returnValue}
                    </Text>
                </View>
                <View style={styles.lineWithMargin}>
                    <Input placeholder="next" returnKeyType="next" />
                </View>
                <View style={styles.lineWithMargin}>
                    <Input placeholder="search" returnKeyType="search" />
                </View>
                <View style={styles.lineWithMargin}>
                    <Input placeholder="send" returnKeyType="send" />
                </View>
                <View style={styles.lineWithMargin}>
                    <Input placeholder="done" returnKeyType="done" />
                </View>
            </Page>
        );
    }
};
const styles = {
    lineWithMargin: {
        marginLeft: '30rem',
        marginRight: '30rem'
    },
    textLine: {
        marginTop: '20rem',
        marginBottom: '40rem'
    },
    text: {
        fontSize: '26rem'
    }
};
render(<App />);
```
