# Mask 遮罩层 Demo

* order: 0

基础用法

---

```js
/** @jsx createElement */
import { View, Text, Button, Mask, Page } from 'nuke';
import { createElement, Component, findDOMNode, render } from 'rax';
let App = class NukeDemoIndex extends Component {
  constructor() {
    super();
    this.state = {
      maskVisible: false
    };
  }

  showMask(e) {
    //debugger;
    this.refs.myMask.show();
  }
  onVisibleChanged = e => {
    // alert('trigger by android')
  };
  hideMask(e) {
    this.refs.myMask.hide();
  }
  render() {
    return (
      <Page title="Mask">
        <Page.Intro main="普通用法" />
        <Button type="primary" onPress={e => this.showMask(e)}>
          打开浮层
        </Button>

        <Mask
          defaultVisible={false}
          onVisibleChanged={this.onVisibleChanged}
          ref="myMask"
          animate={true}
          style={styles.mask}
          maskClosable={true}
        >
          <View style={styles.bg}>
            <View style={styles.dialogWrap}>
              <Text style={styles.text}>遮罩层里的内容</Text>
              <Button type="primary" onPress={e => this.hideMask(e)}>
                点击关闭
              </Button>
            </View>
          </View>
        </Mask>
      </Page>
    );
  }
};
const styles = {
  textarea: {
    width: '750rem',
    height: '200rem',
    borderWidth: '1rem',
    borderStyle: 'solid',
    borderColor: '#cccccc'
  },
  mask: {},
  bg: {
    flex: 1,
    width: '750rem',
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: 'rgba(0,0,0,0.7)'
  },
  dialogWrap: {
    width: 600,
    height: 300,
    padding: 20,
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: '#ffffff'
  },
  text: {
    marginBottom: 20
    //color:'#ffffff'
  }
};
render(<App />);
```
