# Mask 遮罩层 Demo

* order: 2
* hide : true

## 测试用

```js
/** @jsx createElement */
import { Input, View, Text, Button, Mask, Page } from 'nuke';
import { createElement, Component, render } from 'rax';
let App = class NukeDemoIndex extends Component {
  constructor() {
    super();
    this.state = {
      maskVisible: false
    };
  }
  showMask = () => {
    this.setState({
      maskVisible: true
    });
  };
  hideMask = () => {
    this.setState({
      maskVisible: false
    });
  };
  render() {
    return (
      <Page title="Mask">
        <Page.Intro main="浮层中嵌入 Input" />
        <Button type="primary" onPress={this.showMask}>
          打开浮层
        </Button>
        {this.state.maskVisible ? (
          <Mask style={styles.mask}>
            <View style={styles.bg}>
              <Input autoFocus multiple style={styles.textarea} />
              <Text style={styles.text}>遮罩层里的内容</Text>
              <Button type="primary" onPress={this.hideMask}>
                确认
              </Button>
            </View>
          </Mask>
        ) : null}
      </Page>
    );
  }
};
const styles = {
  textarea: {
    width: '750rem',
    height: '200rem',
    borderWidth: '1rem',
    borderStyle: 'solid',
    borderColor: '#cccccc'
  },
  mask: {
    flex: 1
  },
  bg: {
    flex: 1,
    width: '750rem',
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: 'rgba(0,0,0,0.7)'
  },
  text: {
    color: '#ffffff'
  }
};
render(<App />);
```
