# Radio demo

- order: 2

list 模式 demo

---

````js
/** @jsx createElement */
import { View, Text, Touchable, Radio, Button, Page } from 'nuke';
import {createElement, Component, render} from 'rax';
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            value:2
        }
    }

    groupChange(value){
         this.setState({
            value:value
            });
        console.log('group',value);
    }

    onChange(value){
        console.log('item',value);
    }
    press(index){
        console.log(index);
        this.setState({
          value:index
        })
    }
    render() {
        const {value} = this.state;
        return (
            <Page title="radio">
                <Page.Intro main="list 模式"></Page.Intro>
                <Radio.Group style={styles.groupWrap} onChange = {this.groupChange.bind(this)} value={value}>
                    <View style={styles.item}>
                        <Text style={styles.title}>
                           请选择延迟天数
                        </Text>
                    </View>
                    <Touchable style={styles.item} onPress={this.press.bind(this,1)}>
                        <Text style={styles.delayValue}>
                            3天
                        </Text>
                        <Radio size="small" value={1} type="list"></Radio>
                    </Touchable>
                    <Touchable style={styles.item} onPress={this.press.bind(this,2)}>
                        <Text style={styles.delayValue}>
                            5天
                        </Text>
                        <Radio size="small" value={2} type="list"></Radio>
                    </Touchable>
                    <Touchable style={styles.item} onPress={this.press.bind(this,3)}>
                        <Text style={styles.delayValue}>
                            7天
                        </Text>
                        <Radio size="small" value={3} type="list"></Radio>
                    </Touchable>
                    <Touchable style={styles.item} onPress={this.press.bind(this,4)}>
                        <Text style={styles.delayValue}>
                            10天
                        </Text>
                        <Radio size="small" value={4} type="list"></Radio>
                    </Touchable>
                    <Touchable style={styles.item} onPress={this.press.bind(this,5)}>
                        <Text style={styles.delayValue}>
                            11天
                        </Text>
                        <Radio size="small" value={5} type="list"></Radio>
                    </Touchable>
                    <Touchable style={styles.item} onPress={this.press.bind(this,6)}>
                        <Text style={styles.delayValue}>
                            12天
                        </Text>
                        <Radio size="small" value={6} type="list"></Radio>
                    </Touchable>
                </Radio.Group>
            </Page>
        );
    }
}
const styles ={
    title:{
        color:'#3089dc',
        height:88,
        lineHeight:88,
        fontSize:30
    },
    groupWrap:{
        backgroundColor:'#ffffff',
        flexDirection:'column',
        paddingLeft:30,
        paddingRight:30,
    },
    item:{
        display:'flex',
        flexDirection:'row',
        alignItems:'center',
        justifyContent:'space-between',
        borderTopWidth:2,
        borderTopColor:'#EDEDEF',
        borderTopStyle:'solid',
        paddingTop:10,
        paddingBottom:10,
        paddingLeft:40,
        paddingRight:40,
        backgroundColor:'transparent',
        'backgroundColor:active':'#DADADA'
    },
    delayValue:{
        color:'#383B3E'
    }
}
render(<App/>);

````
