# Button Demo

* order: 0

包含各种类型的 Button

---

```js
/** @jsx createElement */
import { View, Button, Page } from 'nuke';
import { createElement, Component, render } from 'rax';
let App = class NukeDemoIndex extends Component {
  constructor() {
    super();
  }
  press() {
    console.log('111');
  }
  render() {
    return (
      <Page title="Button">
        <Page.Intro main="type:primary" sub="主操作" />
        <View style={styles.btnWithMargin}>
          <Button onPress={this.press} type="primary">
            test
          </Button>
        </View>
        <View style={styles.btnWithMargin}>
          <Button
            style={{ marginBottom: 20 }}
            size="large"
            block
            onPress={this.press}
            type="primary"
          >
            primary
          </Button>
          <Button size="large" block disabled type="primary">
            disabled
          </Button>
        </View>
        <Page.Intro main="type:primary" sub="自定义颜色" />
        <View style={styles.btnWithMargin}>
          <Button
            onPress={this.press}
            type="primary"
            style={{
              borderWidth: '1rem',
              borderStyle: 'solid',
              borderColor: '#ff6600',
              backgroundColor: '#ff6600',
              color: '#ffffff'
            }}
          >
            primary
          </Button>
        </View>

        <Page.Intro main="type:normal" sub="普通操作" />
        <View style={styles.btnWithMargin}>
          <Button block type="normal" size="large" style={{ marginBottom: 20 }}>
            normal
          </Button>
          <Button block disabled size="large" type="normal">
            disabled
          </Button>
        </View>
        <Page.Intro main="shape:warning" sub="警告类操作" />
        <View style={styles.btnWithMargin}>
          <Button shape="warning" block size="large">
            primary
          </Button>
        </View>

        <Page.Intro main="rect:true" sub="直角" />
        <Button.Group style={styles.btnWithMargin}>
          <Button style={styles.btn} rect type="normal">
            Normal
          </Button>
          <Button style={styles.btn} rect type="primary">
            Primary
          </Button>
          <Button style={styles.btn} rect type="secondary">
            Secondary
          </Button>
        </Button.Group>

        <Page.Intro main="size" sub="尺寸" />
        <Button.Group style={styles.btnWithMargin}>
          <Button style={styles.btn} size="large" type="primary">
            large
          </Button>
          <Button style={styles.btn} size="medium" type="primary">
            medium
          </Button>
        </Button.Group>

        <Page.Intro main="Button.Group rect" sub="Group用法" />
        <Button.Group style={styles.btnWithMargin} rect>
          <Button type="normal">Normal</Button>
          <Button type="third">Third</Button>
          <Button type="primary">Primary</Button>
        </Button.Group>
      </Page>
    );
  }
};
const styles = {
  btnWithMargin: {
    marginTop: '30rem',
    marginBottom: '50rem',
    marginLeft: '42rem',
    marginRight: '42rem'
  },
  btnLine: {
    marginTop: '30rem',
    marginBottom: '50rem',
    paddingLeft: '42rem',
    paddingRight: '42rem' //#1170bc;
  }
};
render(<App />);
```
