# SearchBar demo

* order: 0

通过 onSearch 获取搜索结果

---

```js
/** @jsx createElement */
import { View, Text, SearchBar, Icon, Page } from 'nuke';
import { createElement, Component, render } from 'rax';
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            value: ''
        };
    }

    search = (data, e) => {
        this.setState({
            value: data.value
        });
    };
    searchOnReturn = data => {
        this.setState({
            value2: data.value
        });
    };
    render() {
        return (
            <Page title="SearchBar">
                <Page.Intro main="normal" />
                <SearchBar
                    testId={{ input: 'input123', button: 'button123' }}
                    style={styles.searchbarwrap}
                    value={'羊毛大衣'}
                    onSearch={this.search}
                    placeholder="输入搜索关键词"
                />
                <View style={styles.relatedView}>
                    <Text>要搜索的值：{this.state.value}</Text>
                </View>
                <SearchBar
                    style={styles.searchbarwrap}
                    onSearch={this.searchOnReturn}
                    showSearchButton={false}
                    placeholder="输完敲回车"
                />
                <View style={styles.relatedView}>
                    <Text>要搜索的值：{this.state.value2}</Text>
                </View>
            </Page>
        );
    }
};
const styles = {
    searchbarwrap: {
        backgroundColor: '#EBECF0'
    },
    relatedView: {
        padding: '20rem'
    }
};
render(<App />);
```
