# Tabbar Embed 模式

- order: 2

Embed 模式下，内容区是单独的 bundle 。

-----------

````js
/** @jsx createElement */
import { View, Text, Image, Tabbar, Page, Iconfont } from 'nuke';
import {createElement, Component,render} from 'rax';
const iconsMap = {
    tab1:{
        icon:'\ue650',
        name:'标题一'
    },
    tab2:{
        icon:'\ue631',
        name:'标题二'
    },
    tab3:{
        icon:'\ue65e',
        name:'标题三'
    },
    tab4:{
        icon:'\ue65d',
        name:'标题四'
    }
}
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        Iconfont({name:"tabicons",url:"https://at.alicdn.com/t/font_jw65w2xs3tm7k3xr.ttf"});
        this.state =  {
            activeKey: {key: 'tab1'}
        };
    }

    renderContent = (pageText) => {
        return (
          <View style={[styles.tabContent]}>
            <Text style={styles.tabText}>{pageText}</Text>
          </View>
        );
    }

    renderItemWithIcon = (iconName,isActive, key) =>{
        return (<View style={styles.item}>
            <View style={[styles.itemIcon, isActive ? styles.itemIconActiveBg : {}]}>
                <Text style={[styles.icon,isActive ? styles.activeTextWithIcon:{}]}>{iconsMap[iconName]['icon']}</Text>
            </View>
            <Text style={[styles.itemText,isActive ? styles.activeText:{}]}>{iconsMap[iconName]['name']}</Text>
        </View>);
    }
    render() {
        return (

            <Tabbar iconBar={true} activeKey={this.state.activeKey}>
                <Tabbar.Item
                    tabKey="tab1"
                    render={this.renderItemWithIcon.bind(this,'tab1')}
                    src="https://h5.m.taobao.com/qn/mobile/weex-tpl.html?_wx_tpl=https://g.alicdn.com/nuke/components/0.2.21/view.js"
                    >
                </Tabbar.Item>
                <Tabbar.Item
                    tabKey="tab2"
                    render={this.renderItemWithIcon.bind(this,'tab2')}
                    src="https://h5.m.taobao.com/qn/mobile/weex-tpl.html?_wx_tpl=https://g.alicdn.com/nuke/button/0.3.13/basic.js"
                    >
                </Tabbar.Item>

            </Tabbar>
                
        );
    }
}
const styles = {

    tabContent:{
        flex:1,
        backgroundColor:'#ffffff',
        alignItems: 'center',
        justifyContent:'center'
    },
    tabText: {
        fontSize:'40rem'
    },
    item:{
        height:'70rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    icon:{
        fontFamily: 'tabicons',
        fontSize:'32rem',
        color:'#999999'
    },
    itemFixWidth:{
        width:'150rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    itemIcon:{
        width:'48rem',
        height:'48rem',
        borderRadius:'24rem',
        marginBottom:'6rem',
        marginTop:'14rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    activeText:{
        color:'#3089dc'
    },
    activeTextWithIcon:{
        color:'#ffffff'
    },

    itemIconActiveBg:{
        backgroundColor:'#3089dc',
    },
    
}
render(<App/>);
````
