'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('../../../nuke-touchable/lib/index.js');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeSlip = require('../../../nuke-slip/lib/index.js');

var _nukeSlip2 = _interopRequireDefault(_nukeSlip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var ActionSheet = function (_Component) {
    _inherits(ActionSheet, _Component);

    function ActionSheet(props) {
        _classCallCheck(this, ActionSheet);

        var _this = _possibleConstructorReturn(this, (ActionSheet.__proto__ || Object.getPrototypeOf(ActionSheet)).call(this, props));

        var visible = void 0;

        if ('visible' in props) {
            visible = props.visible;
        } else {
            visible = props.defaultVisible;
        }

        _this.state = { visible: visible };

        ['onSelect', 'onCancel', 'onClose', 'onMaskClose', 'afterOpen', 'afterClose'].forEach(function (m) {
            _this[m] = _this[m].bind(_this);
        });
        return _this;
    }

    _createClass(ActionSheet, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if ('visible' in nextProps) {
                this.setState({
                    visible: nextProps.visible
                });
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return !!(this.state.visible || nextState.visible);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {

            // todo: resize -> position
            this.componentDidUpdate();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.state.visible) {
                this.position();
            }
        }
    }, {
        key: 'position',
        value: function position() {
            var dialog = this.refs.dialog;
        }
    }, {
        key: 'show',
        value: function show() {
            this.setState({
                visible: true
            });
        }
    }, {
        key: 'hide',
        value: function hide() {
            this.setState({
                visible: false
            });
        }
    }, {
        key: 'onSelect',
        value: function onSelect(info, e) {
            if (!('visible' in this.props)) {
                this.hide();
            }

            this.props.onNotify(info);
        }
    }, {
        key: 'onCancel',
        value: function onCancel(e) {

            if (!('visible' in this.props)) {
                this.hide();
            }

            this.props.onNotify({ type: 'cancel' });
        }
    }, {
        key: 'onClose',
        value: function onClose(e) {

            if (!('visible' in this.props)) {
                this.hide();
            }
        }
    }, {
        key: 'onMaskClose',
        value: function onMaskClose(e) {

            if (!this.props.maskClosable) {
                return;
            }

            this.onClose(e);
        }
    }, {
        key: 'afterOpen',
        value: function afterOpen() {
            this.props.afterOpen(this);
        }
    }, {
        key: 'afterClose',
        value: function afterClose() {
            this.props.afterClose();
        }
    }, {
        key: 'getContent',
        value: function getContent() {
            var _this2 = this;

            // debugger;
            var dom = [];
            var _props = this.props,
                title = _props.title,
                options = _props.options,
                cancelButtonIndex = _props.cancelButtonIndex,
                destructiveButtonIndex = _props.destructiveButtonIndex;

            options.forEach(function (item, index) {
                if (index !== destructiveButtonIndex && index !== cancelButtonIndex) {

                    dom.push((0, _rax.createElement)(
                        _nukeTouchable2.default,
                        { onPress: _this2.onSelect.bind(_this2, { buttonIndex: index, type: 'button' }), style: _styles2.default['action-sheet-item'] },
                        (0, _rax.createElement)(
                            _nukeText2.default,
                            { style: _styles2.default['action-sheet-item-text'] },
                            item
                        )
                    ));
                }
            });
            if (destructiveButtonIndex) {
                dom.push((0, _rax.createElement)(
                    _nukeTouchable2.default,
                    { onPress: this.onSelect.bind(this, { buttonIndex: destructiveButtonIndex, type: 'destructive' }), style: _styles2.default['action-sheet-item'] },
                    (0, _rax.createElement)(
                        _nukeText2.default,
                        { style: [_styles2.default['action-sheet-item-text'], _styles2.default['action-sheet-item-destructive-text']] },
                        options[destructiveButtonIndex]
                    )
                ));
            }
            if (cancelButtonIndex) {
                dom.push((0, _rax.createElement)(_nukeView2.default, { style: _styles2.default['action-sheet-item-separator'] }));
                dom.push((0, _rax.createElement)(
                    _nukeTouchable2.default,
                    { onPress: this.onCancel.bind(this, { type: 'cancel' }), style: _styles2.default['action-sheet-item'] },
                    (0, _rax.createElement)(
                        _nukeText2.default,
                        { style: _styles2.default['action-sheet-item-text'] },
                        options[cancelButtonIndex]
                    )
                ));
            }
            return dom;
        }
    }, {
        key: 'render',
        value: function render() {
            var visible = this.state.visible;
            var _props2 = this.props,
                title = _props2.title,
                animation = _props2.animation,
                options = _props2.options,
                cancelButtonIndex = _props2.cancelButtonIndex,
                destructiveButtonIndex = _props2.destructiveButtonIndex,
                hasMask = _props2.hasMask,
                _props2$locale = _props2.locale,
                locale = _props2$locale === undefined ? {} : _props2$locale,
                _props2$style = _props2.style,
                style = _props2$style === undefined ? {} : _props2$style,
                _props2$prefix = _props2.prefix,
                prefix = _props2$prefix === undefined ? this.defaultPrefix : _props2$prefix;
            var styleSet = _extends({}, style),
                zIndex = styleSet.zIndex,
                header = this.props.header;


            if (header === undefined) {
                header = (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: _styles2.default['action-sheet-header'] },
                    (0, _rax.createElement)(
                        _nukeText2.default,
                        { style: _styles2.default['action-sheet-title'] },
                        title
                    )
                );
            }

            if (zIndex === undefined) {
                zIndex = 499;
                styleSet['zIndex'] = zIndex;
            }
            return (0, _rax.createElement)(
                _nukeSlip2.default,
                { style: { zIndex: style.zIndex, bottom: 0 }, visible: visible, direction: 'bottom', animation: true, depth: 'auto', title: false, afterOpen: this.afterOpen, afterClose: this.afterClose },
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { ref: '', style: _styles2.default['action-sheet'] },
                    header ? header : null,
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['action-sheet-content'] },
                        this.getContent(options)
                    )
                )
            );
        }
    }]);

    return ActionSheet;
}(_rax.Component);

ActionSheet.propTypes = {
    title: _rax.PropTypes.node,
    footer: _rax.PropTypes.node,
    visible: _rax.PropTypes.bool,
    hasMask: _rax.PropTypes.bool,
    closable: _rax.PropTypes.bool,
    maskClosable: _rax.PropTypes.bool,
    onSelect: _rax.PropTypes.func,
    afterOpen: _rax.PropTypes.func,
    afterClose: _rax.PropTypes.func,
    onCancel: _rax.PropTypes.func,
    onClose: _rax.PropTypes.func,
    defaultVisible: _rax.PropTypes.bool,
    locale: _rax.PropTypes.shape({
        ok: _rax.PropTypes.string,
        cancel: _rax.PropTypes.string
    }),
    animation: _rax.PropTypes.oneOfType([_rax.PropTypes.bool, _rax.PropTypes.shape({
        'in': _rax.PropTypes.string,
        'out': _rax.PropTypes.string
    })])
};
ActionSheet.defaultProps = {
    title: 'Title',
    hasMask: true,
    closable: false,
    maskClosable: false,
    defaultVisible: false,
    locale: {
        ok: 'Ok',
        cancel: 'Cancel'
    },
    animation: {
        'in': 'zoomIn',
        'out': 'zoomOut'
    },
    onSelect: noop,
    onCancel: noop,
    afterOpen: noop,
    afterClose: noop,
    onClose: noop
};
exports.default = ActionSheet;
module.exports = exports['default'];