'use strict';

// { scale: 2 } => 'scale(2)'

Object.defineProperty(exports, "__esModule", {
  value: true
});
function mapTransform(t) {
  var k = Object.keys(t)[0];
  var unit = '';
  // Only process translateX translateY translateZ
  if (k.indexOf('translate') === 0) {
    unit = 'rem';
  }
  return k + '(' + t[k] + unit + ')';
}

// NOTE(lmr):
// Since this is a hot code path, right now this is mutative...
// As far as I can tell, this shouldn't cause any unexpected behavior.
function mapStyle(style) {
  if (style && style.transform && typeof style.transform !== 'string') {
    // TODO(lmr): this doesn't attempt to use vendor prefixed styles
    style.transform = style.transform.map(mapTransform).join(' ');
    style['-webkit-transform'] = style.transform;
  }
  return style;
}

exports.default = mapStyle;
module.exports = exports['default'];