/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * @providesModule
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonGroup = function (_Component) {
    _inherits(ButtonGroup, _Component);

    function ButtonGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ButtonGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).call.apply(_ref, [this].concat(args))), _this), _this.getButtons = function () {
            var buttons = [];
            var _this$props = _this.props,
                block = _this$props.block,
                rect = _this$props.rect,
                children = _this$props.children;

            children.forEach(function (btn, index) {
                if ((0, _rax.isValidElement)(btn)) {
                    buttons.push((0, _rax.cloneElement)(btn, {
                        style: Object.assign({}, btn.props.style, block ? _styles2.default['group-block-button'] : _styles2.default['group-button'], index + 1 === children.length ? _styles2.default['group-button-last'] : {}, rect ? _styles2.default['group-button-rect'] : {})
                    }));
                }
            });
            return buttons;
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(ButtonGroup, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                block = _props.block,
                children = _props.children,
                _props$style = _props.style,
                style = _props$style === undefined ? {} : _props$style,
                others = _objectWithoutProperties(_props, ['block', 'children', 'style']);

            var wrapStyle = Object.assign({}, _styles2.default['group'], block ? _styles2.default['group-block'] : {}, style);
            return (0, _rax.createElement)(
                _nukeView2.default,
                _extends({}, others, { style: wrapStyle }),
                this.getButtons()
            );
        }
    }]);

    return ButtonGroup;
}(_rax.Component);

ButtonGroup.propTypes = {
    rect: _rax.PropTypes.bool,
    block: _rax.PropTypes.bool,
    fixed: _rax.PropTypes.bool,
    shape: _rax.PropTypes.oneOf(['normal', 'shadow'])
};
ButtonGroup.defaultProps = {
    rect: false,
    block: false,
    fixed: false,
    shape: 'normal'
};
exports.default = ButtonGroup;
module.exports = exports['default'];