/** @jsx createElement */
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _checkbox = require('./checkbox.js');

var _checkbox2 = _interopRequireDefault(_checkbox);

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CHECKBOX_TYPES = {
	'group': 'checkbox-group',
	'small-text': 'checkbox-group-small-text',
	'medium-text': 'checkbox-group-medium-text'
};
function filterValue(selectedValue, value) {
	return selectedValue.filter(function (v) {
		return v !== value;
	});
}

var CheckboxGroup = function (_Component) {
	_inherits(CheckboxGroup, _Component);

	function CheckboxGroup(props) {
		_classCallCheck(this, CheckboxGroup);

		var _this = _possibleConstructorReturn(this, (CheckboxGroup.__proto__ || Object.getPrototypeOf(CheckboxGroup)).call(this, props));

		_this.onChange = _this.onChange.bind(_this);
		return _this;
	}

	_createClass(CheckboxGroup, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				__group__: true,
				onChange: this.onChange,
				value: this.props.value
			};
		}
	}, {
		key: 'onChange',
		value: function onChange(value, checked, e) {
			var selectedValue = this.props.value;
			if (checked) {
				selectedValue = selectedValue.concat(value);
			} else {
				selectedValue = filterValue(selectedValue, value);
			}
			this.props.onChange(selectedValue);
		}
	}, {
		key: 'render',
		value: function render() {
			var children = this.props.children;
			var _props = this.props,
			    onChange = _props.onChange,
			    _props$dataSource = _props.dataSource,
			    dataSource = _props$dataSource === undefined ? [] : _props$dataSource,
			    style = _props.style,
			    size = _props.size;

			var groupStyle = _styles2.default[CHECKBOX_TYPES['group']];
			var textStyle = size && size == 'small' ? _styles2.default[CHECKBOX_TYPES['small-text']] : _styles2.default[CHECKBOX_TYPES['medium-text']];
			if (!children) {
				children = dataSource.map(function (item, index) {
					if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) !== 'object') {
						item = { label: item, value: item };
					}

					var _item = item,
					    label = _item.label,
					    value = _item.value,
					    disabled = _item.disabled,
					    others = _objectWithoutProperties(_item, ['label', 'value', 'disabled']);

					if (label) return (0, _rax.createElement)(
						_nukeView2.default,
						{ style: [groupStyle, style] },
						(0, _rax.createElement)(_checkbox2.default, { disabled: disabled, size: size, value: value }),
						(0, _rax.createElement)(
							_nukeText2.default,
							{ style: textStyle },
							label
						)
					);else return (0, _rax.createElement)(_checkbox2.default, _extends({}, others, { disabled: disabled, checked: value }));
				});
			}

			return (0, _rax.createElement)(
				_nukeView2.default,
				{ style: style, t: 'ttt' },
				children
			);
		}
	}]);

	return CheckboxGroup;
}(_rax.Component);

CheckboxGroup.propTypes = {
	dataSource: _rax.PropTypes.array,
	onChange: _rax.PropTypes.func,
	value: _rax.PropTypes.array,
	style: _rax.PropTypes.object
};

CheckboxGroup.defaultProps = {
	dataSource: [],
	onChange: function onChange() {},
	value: [],
	style: {}
};
CheckboxGroup.childContextTypes = {
	onChange: _rax.PropTypes.func,
	__group__: _rax.PropTypes.bool,
	value: _rax.PropTypes.any
};
exports.default = CheckboxGroup;
module.exports = exports['default'];