'use strict';

var _module$exports;

var _nukeVarLoader = require('../../../nuke-var-loader/lib/index.js');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

////
/// @group Variables 变量
/// @module corner: 边角
/// @category style
////


var cornerRadiusBase = (0, _nukeVarLoader.varLoader)('corner-radius-base', '8');

/// Radius 0
/// @export
/// @type String
var cornerRadiusR0 = (0, _nukeVarLoader.varLoader)('corner-radius-r0', '0');

/// Radius 1
/// @export
/// @type String
var cornerRadiusR1 = (0, _nukeVarLoader.varLoader)('corner-radius-r1', '8');

/// Radius 2
/// @export
/// @type String
var cornerRadiusR2 = (0, _nukeVarLoader.varLoader)('corner-radius-r2', '4');

/// Radius Half
/// @export
var cornerRadiusHalf = (0, _nukeVarLoader.varLoader)('corner-radius-half', '50%');

/// Radius Circle
/// @export
var cornerRadiusCircle = (0, _nukeVarLoader.varLoader)('corner-radius-circle', '100%');

var cornerSidesBase = (0, _nukeVarLoader.varLoader)('corner-sides-base', "base");
var cornerSidesTop = (0, _nukeVarLoader.varLoader)('corner-sides-top', "top");
var cornerSidesRight = (0, _nukeVarLoader.varLoader)('corner-sides-right', "right");
var cornerSidesBottom = (0, _nukeVarLoader.varLoader)('corner-sides-bottom', "bottom");
var cornerSidesLeft = (0, _nukeVarLoader.varLoader)('corner-sides-left', "left");
var cornerSidesTl = (0, _nukeVarLoader.varLoader)('corner-sides-tl', "topLeft");
var cornerSidesTr = (0, _nukeVarLoader.varLoader)('corner-sides-tr', "topRight");
var cornerSidesBl = (0, _nukeVarLoader.varLoader)('corner-sides-bl', "bottomLeft");
var cornerSidesBr = (0, _nukeVarLoader.varLoader)('corner-sides-br', "bottomRight");

/// Corner R0
/// @access private
/// @unconfigurable
var cornerR0 = (0, _nukeVarLoader.varLoader)('corner-r0', cornerMaker(cornerRadiusBase, cornerRadiusR0));

/// Corner R0 (top)
/// @access private
/// @unconfigurable
var cornerR0Top = (0, _nukeVarLoader.varLoader)('corner-r0-top', cornerMaker(cornerSidesTop, cornerRadiusR0));

/// Corner R0 (right)
/// @access private
/// @unconfigurable
var cornerR0Right = (0, _nukeVarLoader.varLoader)('corner-r0-right', cornerMaker(cornerSidesRight, cornerRadiusR0));

/// Corner R0 (bottom)
/// @access private
/// @unconfigurable
var cornerR0Bottom = (0, _nukeVarLoader.varLoader)('corner-r0-bottom', cornerMaker(cornerSidesBottom, cornerRadiusR0));

/// Corner R0 (left)
/// @access private
/// @unconfigurable
var cornerR0Left = (0, _nukeVarLoader.varLoader)('corner-r0-left', cornerMaker(cornerSidesLeft, cornerRadiusR0));

/// Corner R1
/// @unconfigurable
/// @access private
var cornerR1 = (0, _nukeVarLoader.varLoader)('corner-r1', cornerMaker());

/// Corner R1 (top)
/// @access private
/// @unconfigurable
var cornerR1Top = (0, _nukeVarLoader.varLoader)('corner-r1-top', cornerMaker(cornerSidesTop));

/// Corner R1 (right)
/// @access private
/// @unconfigurable
var cornerR1Right = (0, _nukeVarLoader.varLoader)('corner-r1-right', cornerMaker(cornerSidesRight));

/// Corner R1 (bottom)
/// @access private
/// @unconfigurable
var cornerR1Bottom = (0, _nukeVarLoader.varLoader)('corner-r1-bottom', cornerMaker(cornerSidesBottom));

/// Corner R1 (left)
/// @access private
/// @unconfigurable
var cornerR1Left = (0, _nukeVarLoader.varLoader)('corner-r1-left', cornerMaker(cornerSidesLeft));

/// Corner R2
/// @access private
/// @unconfigurable
var cornerR2 = (0, _nukeVarLoader.varLoader)('corner-r2', cornerMaker(cornerRadiusBase, cornerRadiusR2));

/// Corner R2 (top)
/// @access private
/// @unconfigurable
var cornerR2Top = (0, _nukeVarLoader.varLoader)('corner-r2-top', cornerMaker(cornerSidesTop, cornerRadiusR2));

/// Corner R2 (right)
/// @access private
/// @unconfigurable
var cornerR2Right = (0, _nukeVarLoader.varLoader)('corner-r2-right', cornerMaker(cornerSidesRight, cornerRadiusR2));

/// Corner R2 (bottom)
/// @access private
/// @unconfigurable
var cornerR2Bottom = (0, _nukeVarLoader.varLoader)('corner-r2-bottom', cornerMaker(cornerSidesBottom, cornerRadiusR2));

/// Corner R2 (left)
/// @access private
/// @unconfigurable
var cornerR2Left = (0, _nukeVarLoader.varLoader)('corner-r2-left', cornerMaker(cornerSidesLeft, cornerRadiusR2));

/// Corner Half
/// @access private
/// @unconfigurable
var cornerRHalf = (0, _nukeVarLoader.varLoader)('corner-r-half', cornerMaker(cornerRadiusBase, cornerRadiusHalf));

/// Corner Half (top)
/// @access private
/// @unconfigurable
var cornerRHalfTop = (0, _nukeVarLoader.varLoader)('corner-r-half-top', cornerMaker(cornerSidesTop, cornerRadiusHalf));

/// Corner Half (right)
/// @access private
/// @unconfigurable
var cornerRHalfRight = (0, _nukeVarLoader.varLoader)('corner-r-half-right', cornerMaker(cornerSidesRight, cornerRadiusHalf));

/// Corner Half (bottom)
/// @access private
/// @unconfigurable
var cornerRHalfBottom = (0, _nukeVarLoader.varLoader)('corner-r-half-bottom', cornerMaker(cornerSidesBottom, cornerRadiusHalf));

/// Corner Half (left)
/// @access private
/// @unconfigurable
var cornerRHalfLeft = (0, _nukeVarLoader.varLoader)('corner-r-half-left', cornerMaker(cornerSidesLeft, cornerRadiusHalf));

/// Corner Circle
/// @access private
/// @unconfigurable
var cornerRCircle = (0, _nukeVarLoader.varLoader)('corner-r-circle', cornerMaker(cornerRadiusBase, cornerRadiusCircle));

/// Corner Circle (top)
/// @access private
/// @unconfigurable
var cornerRCircleTop = (0, _nukeVarLoader.varLoader)('corner-r-circle-top', cornerMaker(cornerSidesTop, cornerRadiusCircle));

/// Corner Circle (right)
/// @access private
/// @unconfigurable
var cornerRCircleRight = (0, _nukeVarLoader.varLoader)('corner-r-circle-right', cornerMaker(cornerSidesRight, cornerRadiusCircle));

/// Corner Circle (bottom)
/// @access private
/// @unconfigurable
var cornerRCircleBottom = (0, _nukeVarLoader.varLoader)('corner-r-circle-bottom', cornerMaker(cornerSidesBottom, cornerRadiusCircle));

/// Corner Circle (left)
/// @access private
/// @unconfigurable
var cornerRCircleLeft = (0, _nukeVarLoader.varLoader)('corner-r-circle-left', cornerMaker(cornerSidesLeft, cornerRadiusCircle));

/// 圆角生成器
///
/// @access private
///
/// @param {String} $side [$corner-sides-base] - 需要加圆角的面
/// @param {String} $radius [$corner-radius-base] - 圆角曲率
///
/// @example.rxscss -.rxscss 用法
///   .element {
///     border-radius: corner-maker();
///   }
///
/// @example css - CSS 输出
///   .element {
///     border-radius: 3px 3px 3px 3px;
///   }
///
/// @return {List}

function cornerMaker() {
    var side = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : cornerSidesBase;
    var radius = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : cornerRadiusBase;


    var tl = radius;
    var tr = radius;
    var bl = radius;
    var br = radius;

    if (side == 'top') {
        br = 0;
        bl = 0;
    } else if (side == 'right') {
        tl = 0;
        bl = 0;
    } else if (side == 'down') {
        tr = 0;
        tl = 0;
    } else if (side == 'left') {
        tr = 0;
        br = 0;
    }

    return tl + ' ' + tr + ' ' + br + ' ' + bl;
}

module.exports = (_module$exports = {}, _defineProperty(_module$exports, 'corner-radius-base', cornerRadiusBase), _defineProperty(_module$exports, 'corner-radius-r0', cornerRadiusR0), _defineProperty(_module$exports, 'corner-radius-r1', cornerRadiusR1), _defineProperty(_module$exports, 'corner-radius-r2', cornerRadiusR2), _defineProperty(_module$exports, 'corner-radius-half', cornerRadiusHalf), _defineProperty(_module$exports, 'corner-radius-circle', cornerRadiusCircle), _defineProperty(_module$exports, 'corner-sides-base', cornerSidesBase), _defineProperty(_module$exports, 'corner-sides-top', cornerSidesTop), _defineProperty(_module$exports, 'corner-sides-right', cornerSidesRight), _defineProperty(_module$exports, 'corner-sides-bottom', cornerSidesBottom), _defineProperty(_module$exports, 'corner-sides-left', cornerSidesLeft), _defineProperty(_module$exports, 'corner-sides-tl', cornerSidesTl), _defineProperty(_module$exports, 'corner-sides-tr', cornerSidesTr), _defineProperty(_module$exports, 'corner-sides-bl', cornerSidesBl), _defineProperty(_module$exports, 'corner-sides-br', cornerSidesBr), _defineProperty(_module$exports, 'corner-r0', cornerR0), _defineProperty(_module$exports, 'corner-r0-top', cornerR0Top), _defineProperty(_module$exports, 'corner-r0-right', cornerR0Right), _defineProperty(_module$exports, 'corner-r0-bottom', cornerR0Bottom), _defineProperty(_module$exports, 'corner-r0-left', cornerR0Left), _defineProperty(_module$exports, 'corner-r1', cornerR1), _defineProperty(_module$exports, 'corner-r1-top', cornerR1Top), _defineProperty(_module$exports, 'corner-r1-right', cornerR1Right), _defineProperty(_module$exports, 'corner-r1-bottom', cornerR1Bottom), _defineProperty(_module$exports, 'corner-r1-left', cornerR1Left), _defineProperty(_module$exports, 'corner-r2', cornerR2), _defineProperty(_module$exports, 'corner-r2-top', cornerR2Top), _defineProperty(_module$exports, 'corner-r2-right', cornerR2Right), _defineProperty(_module$exports, 'corner-r2-bottom', cornerR2Bottom), _defineProperty(_module$exports, 'corner-r2-left', cornerR2Left), _defineProperty(_module$exports, 'corner-r-half', cornerRHalf), _defineProperty(_module$exports, 'corner-r-half-top', cornerRHalfTop), _defineProperty(_module$exports, 'corner-r-half-right', cornerRHalfRight), _defineProperty(_module$exports, 'corner-r-half-bottom', cornerRHalfBottom), _defineProperty(_module$exports, 'corner-r-half-left', cornerRHalfLeft), _defineProperty(_module$exports, 'corner-r-circle', cornerRCircle), _defineProperty(_module$exports, 'corner-r-circle-top', cornerRCircleTop), _defineProperty(_module$exports, 'corner-r-circle-right', cornerRCircleRight), _defineProperty(_module$exports, 'corner-r-circle-bottom', cornerRCircleBottom), _defineProperty(_module$exports, 'corner-r-circle-left', cornerRCircleLeft), _defineProperty(_module$exports, 'cornerMaker', cornerMaker), _module$exports);