'use strict';

var _module$exports;

var _nukeVarLoader = require('../../../nuke-var-loader/lib/index.js');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

////
/// @group Variables 变量
/// @module font: 字体
/// @type String
/// @category style
/// @export
////


/// Light
/// @export weightcore
/// @unconfigurable
var fontWeightCoreLight = (0, _nukeVarLoader.varLoader)('font-weight-core-light', 'lighter');

/// Thin
/// @export weightcore
/// @unconfigurable
var fontWeightCoreThin = (0, _nukeVarLoader.varLoader)('font-weight-core-thin', '200');

/// Regular
/// @export weightcore
/// @unconfigurable
var fontWeightCoreRegular = (0, _nukeVarLoader.varLoader)('font-weight-core-regular', 'normal');

/// Medium
/// @export weightcore
/// @unconfigurable
var fontWeightCoreMedium = (0, _nukeVarLoader.varLoader)('font-weight-core-medium', '500');

/// Bold
/// @export weightcore
/// @unconfigurable
var fontWeightCoreBold = (0, _nukeVarLoader.varLoader)('font-weight-core-bold', 'bold');

/// Bolder
/// @export weightcore
/// @unconfigurable
var fontWeightCoreBolder = (0, _nukeVarLoader.varLoader)('font-weight-core-bolder', 'bolder');

var fontFamilyBase = (0, _nukeVarLoader.varLoader)('font-family-base', 'roboto, "helvetica neue", helvetica, tahoma, arial, "microsoft yahei", "pingfang sc"');
var fontFamilyEn = (0, _nukeVarLoader.varLoader)('font-family-en', 'roboto, "helvetica neue", helvetica, tahoma, arial');
var fontFamilyZh = (0, _nukeVarLoader.varLoader)('font-family-zh', '"microsoft yahei", simsun, arial');

var fontCustomPath = (0, _nukeVarLoader.varLoader)('font-custom-path', "//i.alicdn.com/artascopeFont/20160419204543/font/");
var fontCustomName = (0, _nukeVarLoader.varLoader)('font-custom-name', 'roboto');
var fontNameThin = (0, _nukeVarLoader.varLoader)('font-name-thin', 'robotoThin');
var fontNameLight = (0, _nukeVarLoader.varLoader)('font-name-light', 'robotoLight');
var fontNameRegular = (0, _nukeVarLoader.varLoader)('font-name-regular', 'robotoRegular');
var fontNameMedium = (0, _nukeVarLoader.varLoader)('font-name-medium', 'robotoMedium');
var fontNameBold = (0, _nukeVarLoader.varLoader)('font-name-bold', 'robotoBold');
var fontNameBolder = (0, _nukeVarLoader.varLoader)('font-name-bolder', 'robotoBolder');
var fontLineheightBase = (0, _nukeVarLoader.varLoader)('font-lineheight-base', '1.2');

/// Display3 Size
/// @export size
var fontSizeBaseDisplay3 = (0, _nukeVarLoader.varLoader)('font-size-base-display3', '112');
/// Display2 Size
/// @export size
var fontSizeBaseDisplay2 = (0, _nukeVarLoader.varLoader)('font-size-base-display2', '96');
/// Display1 Size
/// @export size
var fontSizeBaseDisplay1 = (0, _nukeVarLoader.varLoader)('font-size-base-display1', '72');
/// Headline Size
/// @export size
var fontSizeBaseHeadline = (0, _nukeVarLoader.varLoader)('font-size-base-headline', '36');
var fontSizeBaseTitle = (0, _nukeVarLoader.varLoader)('font-size-base-title', '36');
/// Subhead Size
/// @export size
var fontSizeBaseSubhead = (0, _nukeVarLoader.varLoader)('font-size-base-subhead', '32');
/// Body2 Size
/// @export size
var fontSizeBaseBody2 = (0, _nukeVarLoader.varLoader)('font-size-base-body2', '28');
/// Body1 Size
/// @export size
var fontSizeBaseBody1 = (0, _nukeVarLoader.varLoader)('font-size-base-body1', '28');
/// Caption Size
/// @export size
var fontSizeBaseCaption = (0, _nukeVarLoader.varLoader)('font-size-base-caption', '24');
/// Footnote Size
/// @export size
var fontSizeBaseFootnote = (0, _nukeVarLoader.varLoader)('font-size-base-footnote', '20');

/// Display3 Weight
/// @export weight
var fontWeightBaseDisplay3 = (0, _nukeVarLoader.varLoader)('font-weight-base-display3', fontWeightCoreRegular);
/// Display2 Weight
/// @export weight
var fontWeightBaseDisplay2 = (0, _nukeVarLoader.varLoader)('font-weight-base-display2', fontWeightCoreRegular);
/// Display1 Weight
/// @export weight
var fontWeightBaseDisplay1 = (0, _nukeVarLoader.varLoader)('font-weight-base-display1', fontWeightCoreRegular);
/// Headline Weight
/// @export weight
var fontWeightBaseHeadline = (0, _nukeVarLoader.varLoader)('font-weight-base-headline', fontWeightCoreMedium);
var fontWeightBaseTitle = (0, _nukeVarLoader.varLoader)('font-weight-base-title', fontWeightCoreMedium);
/// Subhead Weight
/// @export weight
var fontWeightBaseSubhead = (0, _nukeVarLoader.varLoader)('font-weight-base-subhead', fontWeightCoreRegular);
/// Body2 Weight
/// @export weight
var fontWeightBaseBody2 = (0, _nukeVarLoader.varLoader)('font-weight-base-body2', fontWeightCoreMedium);
/// Body1 Weight
/// @export weight
var fontWeightBaseBody1 = (0, _nukeVarLoader.varLoader)('font-weight-base-body1', fontWeightCoreRegular);
/// Caption Weight
/// @export weight
var fontWeightBaseCaption = (0, _nukeVarLoader.varLoader)('font-weight-base-caption', fontWeightCoreRegular);
/// Footnote Weight
/// @export weight
var fontWeightBaseFootnote = (0, _nukeVarLoader.varLoader)('font-weight-base-footnote', fontWeightCoreRegular);

/// Display3 Line Height
/// @export lineheight
var fontLineheightBaseDisplay3 = (0, _nukeVarLoader.varLoader)('font-lineheight-base-display3', '124');
/// Display2 Line Height
/// @export lineheight
var fontLineheightBaseDisplay2 = (0, _nukeVarLoader.varLoader)('font-lineheight-base-display2', '102');
/// Display1 Line Height
/// @export lineheight
var fontLineheightBaseDisplay1 = (0, _nukeVarLoader.varLoader)('font-lineheight-base-display1', '78');
/// Headline Line Height
/// @export lineheight
var fontLineheightBaseHeadline = (0, _nukeVarLoader.varLoader)('font-lineheight-base-headline', '42');
var fontLineheightBaseTitle = (0, _nukeVarLoader.varLoader)('font-lineheight-base-title', '42');
/// Subhead Line Height
/// @export lineheight
var fontLineheightBaseSubhead = (0, _nukeVarLoader.varLoader)('font-lineheight-base-subhead', '38');
/// Body2 Line Height
/// @export lineheight
var fontLineheightBaseBody2 = (0, _nukeVarLoader.varLoader)('font-lineheight-base-body2', '34');
/// Body1 Line Height
/// @export lineheight
var fontLineheightBaseBody1 = (0, _nukeVarLoader.varLoader)('font-lineheight-base-body1', '34');
/// Caption Line Height
/// @export lineheight
var fontLineheightBaseCaption = (0, _nukeVarLoader.varLoader)('font-lineheight-base-caption', '30');
/// Footnote Line Height
/// @export lineheight
var fontLineheightBaseFootnote = (0, _nukeVarLoader.varLoader)('font-lineheight-base-footnote', '26');

/// Display3 Size
/// @export size
var fontSizeEnDisplay3 = (0, _nukeVarLoader.varLoader)('font-size-en-display3', '112');
/// Display2 Size
/// @export size
var fontSizeEnDisplay2 = (0, _nukeVarLoader.varLoader)('font-size-en-display2', '96');
/// Display1 size
/// @export size
var fontSizeEnDisplay1 = (0, _nukeVarLoader.varLoader)('font-size-en-display1', '72');
/// Headline size
/// @export size
var fontSizeEnHeadline = (0, _nukeVarLoader.varLoader)('font-size-en-headline', '36');
var fontSizeEnTitle = (0, _nukeVarLoader.varLoader)('font-size-en-title', '36');
/// Subhead size
/// @export size
var fontSizeEnSubhead = (0, _nukeVarLoader.varLoader)('font-size-en-subhead', '32');
/// Body2 size
/// @export size
var fontSizeEnBody2 = (0, _nukeVarLoader.varLoader)('font-size-en-body2', '28');
/// Body1 size
/// @export size
var fontSizeEnBody1 = (0, _nukeVarLoader.varLoader)('font-size-en-body1', '28');
/// Caption size
/// @export size
var fontSizeEnCaption = (0, _nukeVarLoader.varLoader)('font-size-en-caption', '24');
/// Footnote size
/// @export size
var fontSizeEnFootnote = (0, _nukeVarLoader.varLoader)('font-size-en-footnote', '20');

/// Display3 Weight
/// @export weight
var fontWeightEnDisplay3 = (0, _nukeVarLoader.varLoader)('font-weight-en-display3', fontWeightCoreRegular);
/// Display2 Weight
/// @export weight
var fontWeightEnDisplay2 = (0, _nukeVarLoader.varLoader)('font-weight-en-display2', fontWeightCoreRegular);
/// Display1 Weight
/// @export weight
var fontWeightEnDisplay1 = (0, _nukeVarLoader.varLoader)('font-weight-en-display1', fontWeightCoreRegular);
/// Headline Weight
/// @export weight
var fontWeightEnHeadline = (0, _nukeVarLoader.varLoader)('font-weight-en-headline', fontWeightCoreMedium);
var fontWeightEnTitle = (0, _nukeVarLoader.varLoader)('font-weight-en-title', fontWeightCoreMedium);
/// Subhead Weight
/// @export weight
var fontWeightEnSubhead = (0, _nukeVarLoader.varLoader)('font-weight-en-subhead', fontWeightCoreRegular);
/// Body2 Weight
/// @export weight
var fontWeightEnBody2 = (0, _nukeVarLoader.varLoader)('font-weight-en-body2', fontWeightCoreMedium);
/// Body1 Weight
/// @export weight
var fontWeightEnBody1 = (0, _nukeVarLoader.varLoader)('font-weight-en-body1', fontWeightCoreRegular);
/// Caption Weight
/// @export weight
var fontWeightEnCaption = (0, _nukeVarLoader.varLoader)('font-weight-en-caption', fontWeightCoreRegular);
/// Footnote Weight
/// @export weight
var fontWeightEnFootnote = (0, _nukeVarLoader.varLoader)('font-weight-en-footnote', fontWeightCoreRegular);

/// Display3 Line Height
/// @export lineheight
var fontLineheightEnDisplay3 = (0, _nukeVarLoader.varLoader)('font-lineheight-en-display3', '120');
/// Display2 Line Height
/// @export lineheight
var fontLineheightEnDisplay2 = (0, _nukeVarLoader.varLoader)('font-lineheight-en-display2', '102');
/// Display1 Line Height
/// @export lineheight
var fontLineheightEnDisplay1 = (0, _nukeVarLoader.varLoader)('font-lineheight-en-display1', '78');
/// Headline Line Height
/// @export lineheight
var fontLineheightEnHeadline = (0, _nukeVarLoader.varLoader)('font-lineheight-en-headline', '42');
var fontLineheightEnTitle = (0, _nukeVarLoader.varLoader)('font-lineheight-en-title', '42');
/// Subhead Line Height
/// @export lineheight
var fontLineheightEnSubhead = (0, _nukeVarLoader.varLoader)('font-lineheight-en-subhead', '39');
/// Body2 Line Height
/// @export lineheight
var fontLineheightEnBody2 = (0, _nukeVarLoader.varLoader)('font-lineheight-en-body2', '34');
/// Body1 Line Height
/// @export lineheight
var fontLineheightEnBody1 = (0, _nukeVarLoader.varLoader)('font-lineheight-en-body1', '34');
/// Caption Line Height
/// @export lineheight
var fontLineheightEnCaption = (0, _nukeVarLoader.varLoader)('font-lineheight-en-caption', '30');
/// Footnote Line Height
/// @export lineheight
var fontLineheightEnFootnote = (0, _nukeVarLoader.varLoader)('font-lineheight-en-footnote', '20');

/// Display3 Size
/// @export size
var fontSizeZhDisplay3 = (0, _nukeVarLoader.varLoader)('font-size-zh-display3', '112');
/// Display2 Size
/// @export size
var fontSizeZhDisplay2 = (0, _nukeVarLoader.varLoader)('font-size-zh-display2', '96');
/// Display1 size
/// @export size
var fontSizeZhDisplay1 = (0, _nukeVarLoader.varLoader)('font-size-zh-display1', '72');
/// Headline size
/// @export size
var fontSizeZhHeadline = (0, _nukeVarLoader.varLoader)('font-size-zh-headline', '36');
var fontSizeZhTitle = (0, _nukeVarLoader.varLoader)('font-size-zh-title', '36');
/// Subhead size
/// @export size
var fontSizeZhSubhead = (0, _nukeVarLoader.varLoader)('font-size-zh-subhead', '32');
/// Body2 size
/// @export size
var fontSizeZhBody2 = (0, _nukeVarLoader.varLoader)('font-size-zh-body2', '28');
/// Body1 size
/// @export size
var fontSizeZhBody1 = (0, _nukeVarLoader.varLoader)('font-size-zh-body1', '28');
/// Caption size
/// @export size
var fontSizeZhCaption = (0, _nukeVarLoader.varLoader)('font-size-zh-caption', '24');
/// Footnote size
/// @export size
var fontSizeZhFootnote = (0, _nukeVarLoader.varLoader)('font-size-zh-footnote', '20');

/// Display3 Weight
/// @export weight
var fontWeightZhDisplay3 = (0, _nukeVarLoader.varLoader)('font-weight-zh-display3', fontWeightCoreRegular);
/// Display2 Weight
/// @export weight
var fontWeightZhDisplay2 = (0, _nukeVarLoader.varLoader)('font-weight-zh-display2', fontWeightCoreRegular);
/// Display1 Weight
/// @export weight
var fontWeightZhDisplay1 = (0, _nukeVarLoader.varLoader)('font-weight-zh-display1', fontWeightCoreRegular);
/// Headline Weight
/// @export weight
var fontWeightZhHeadline = (0, _nukeVarLoader.varLoader)('font-weight-zh-headline', fontWeightCoreMedium);
var fontWeightZhTitle = (0, _nukeVarLoader.varLoader)('font-weight-zh-title', fontWeightCoreMedium);
/// Subhead Weight
/// @export weight
var fontWeightZhSubhead = (0, _nukeVarLoader.varLoader)('font-weight-zh-subhead', fontWeightCoreRegular);
/// Body2 Weight
/// @export weight
var fontWeightZhBody2 = (0, _nukeVarLoader.varLoader)('font-weight-zh-body2', fontWeightCoreMedium);
/// Body1 Weight
/// @export weight
var fontWeightZhBody1 = (0, _nukeVarLoader.varLoader)('font-weight-zh-body1', fontWeightCoreRegular);
/// Caption Weight
/// @export weight
var fontWeightZhCaption = (0, _nukeVarLoader.varLoader)('font-weight-zh-caption', fontWeightCoreRegular);
/// Footnote Weight
/// @export weight
var fontWeightZhFootnote = (0, _nukeVarLoader.varLoader)('font-weight-zh-footnote', fontWeightCoreRegular);

/// Display3 Line Height
/// @export lineheight
var fontLineheightZhDisplay3 = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-display3', '124');
/// Display2 Line Height
/// @export lineheight
var fontLineheightZhDisplay2 = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-display2', '102');
/// Display1 Line Height
/// @export lineheight
var fontLineheightZhDisplay1 = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-display1', '78');
/// Headline Line Height
/// @export lineheight
var fontLineheightZhHeadline = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-headline', '42');
var fontLineheightZhTitle = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-title', '42');
/// Subhead Line Height
/// @export lineheight
var fontLineheightZhSubhead = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-subhead', '39');
/// Body2 Line Height
/// @export lineheight
var fontLineheightZhBody2 = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-body2', '34');
/// Body1 Line Height
/// @export lineheight
var fontLineheightZhBody1 = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-body1', '34');
/// Caption Line Height
/// @export lineheight
var fontLineheightZhCaption = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-caption', '30');
/// Footnote Line Height
/// @export lineheight
var fontLineheightZhFootnote = (0, _nukeVarLoader.varLoader)('font-lineheight-zh-footnote', '26');

module.exports = (_module$exports = {}, _defineProperty(_module$exports, 'font-weight-core-light', fontWeightCoreLight), _defineProperty(_module$exports, 'font-weight-core-thin', fontWeightCoreThin), _defineProperty(_module$exports, 'font-weight-core-regular', fontWeightCoreRegular), _defineProperty(_module$exports, 'font-weight-core-medium', fontWeightCoreMedium), _defineProperty(_module$exports, 'font-weight-core-bold', fontWeightCoreBold), _defineProperty(_module$exports, 'font-weight-core-bolder', fontWeightCoreBolder), _defineProperty(_module$exports, 'font-family-base', fontFamilyBase), _defineProperty(_module$exports, 'font-family-en', fontFamilyEn), _defineProperty(_module$exports, 'font-family-zh', fontFamilyZh), _defineProperty(_module$exports, 'font-custom-path', fontCustomPath), _defineProperty(_module$exports, 'font-custom-name', fontCustomName), _defineProperty(_module$exports, 'font-name-thin', fontNameThin), _defineProperty(_module$exports, 'font-name-light', fontNameLight), _defineProperty(_module$exports, 'font-name-regular', fontNameRegular), _defineProperty(_module$exports, 'font-name-medium', fontNameMedium), _defineProperty(_module$exports, 'font-name-bold', fontNameBold), _defineProperty(_module$exports, 'font-name-bolder', fontNameBolder), _defineProperty(_module$exports, 'font-lineheight-base', fontLineheightBase), _defineProperty(_module$exports, 'font-size-base-display3', fontSizeBaseDisplay3), _defineProperty(_module$exports, 'font-size-base-display2', fontSizeBaseDisplay2), _defineProperty(_module$exports, 'font-size-base-display1', fontSizeBaseDisplay1), _defineProperty(_module$exports, 'font-size-base-headline', fontSizeBaseHeadline), _defineProperty(_module$exports, 'font-size-base-title', fontSizeBaseTitle), _defineProperty(_module$exports, 'font-size-base-subhead', fontSizeBaseSubhead), _defineProperty(_module$exports, 'font-size-base-body2', fontSizeBaseBody2), _defineProperty(_module$exports, 'font-size-base-body1', fontSizeBaseBody1), _defineProperty(_module$exports, 'font-size-base-caption', fontSizeBaseCaption), _defineProperty(_module$exports, 'font-size-base-footnote', fontSizeBaseFootnote), _defineProperty(_module$exports, 'font-weight-base-display3', fontWeightBaseDisplay3), _defineProperty(_module$exports, 'font-weight-base-display2', fontWeightBaseDisplay2), _defineProperty(_module$exports, 'font-weight-base-display1', fontWeightBaseDisplay1), _defineProperty(_module$exports, 'font-weight-base-headline', fontWeightBaseHeadline), _defineProperty(_module$exports, 'font-weight-base-title', fontWeightBaseTitle), _defineProperty(_module$exports, 'font-weight-base-subhead', fontWeightBaseSubhead), _defineProperty(_module$exports, 'font-weight-base-body2', fontWeightBaseBody2), _defineProperty(_module$exports, 'font-weight-base-body1', fontWeightBaseBody1), _defineProperty(_module$exports, 'font-weight-base-caption', fontWeightBaseCaption), _defineProperty(_module$exports, 'font-weight-base-footnote', fontWeightBaseFootnote), _defineProperty(_module$exports, 'font-lineheight-base-display3', fontLineheightBaseDisplay3), _defineProperty(_module$exports, 'font-lineheight-base-display2', fontLineheightBaseDisplay2), _defineProperty(_module$exports, 'font-lineheight-base-display1', fontLineheightBaseDisplay1), _defineProperty(_module$exports, 'font-lineheight-base-headline', fontLineheightBaseHeadline), _defineProperty(_module$exports, 'font-lineheight-base-title', fontLineheightBaseTitle), _defineProperty(_module$exports, 'font-lineheight-base-subhead', fontLineheightBaseSubhead), _defineProperty(_module$exports, 'font-lineheight-base-body2', fontLineheightBaseBody2), _defineProperty(_module$exports, 'font-lineheight-base-body1', fontLineheightBaseBody1), _defineProperty(_module$exports, 'font-lineheight-base-caption', fontLineheightBaseCaption), _defineProperty(_module$exports, 'font-lineheight-base-footnote', fontLineheightBaseFootnote), _defineProperty(_module$exports, 'font-size-en-display3', fontSizeEnDisplay3), _defineProperty(_module$exports, 'font-size-en-display2', fontSizeEnDisplay2), _defineProperty(_module$exports, 'font-size-en-display1', fontSizeEnDisplay1), _defineProperty(_module$exports, 'font-size-en-headline', fontSizeEnHeadline), _defineProperty(_module$exports, 'font-size-en-title', fontSizeEnTitle), _defineProperty(_module$exports, 'font-size-en-subhead', fontSizeEnSubhead), _defineProperty(_module$exports, 'font-size-en-body2', fontSizeEnBody2), _defineProperty(_module$exports, 'font-size-en-body1', fontSizeEnBody1), _defineProperty(_module$exports, 'font-size-en-caption', fontSizeEnCaption), _defineProperty(_module$exports, 'font-size-en-footnote', fontSizeEnFootnote), _defineProperty(_module$exports, 'font-weight-en-display3', fontWeightEnDisplay3), _defineProperty(_module$exports, 'font-weight-en-display2', fontWeightEnDisplay2), _defineProperty(_module$exports, 'font-weight-en-display1', fontWeightEnDisplay1), _defineProperty(_module$exports, 'font-weight-en-headline', fontWeightEnHeadline), _defineProperty(_module$exports, 'font-weight-en-title', fontWeightEnTitle), _defineProperty(_module$exports, 'font-weight-en-subhead', fontWeightEnSubhead), _defineProperty(_module$exports, 'font-weight-en-body2', fontWeightEnBody2), _defineProperty(_module$exports, 'font-weight-en-body1', fontWeightEnBody1), _defineProperty(_module$exports, 'font-weight-en-caption', fontWeightEnCaption), _defineProperty(_module$exports, 'font-weight-en-footnote', fontWeightEnFootnote), _defineProperty(_module$exports, 'font-lineheight-en-display3', fontLineheightEnDisplay3), _defineProperty(_module$exports, 'font-lineheight-en-display2', fontLineheightEnDisplay2), _defineProperty(_module$exports, 'font-lineheight-en-display1', fontLineheightEnDisplay1), _defineProperty(_module$exports, 'font-lineheight-en-headline', fontLineheightEnHeadline), _defineProperty(_module$exports, 'font-lineheight-en-title', fontLineheightEnTitle), _defineProperty(_module$exports, 'font-lineheight-en-subhead', fontLineheightEnSubhead), _defineProperty(_module$exports, 'font-lineheight-en-body2', fontLineheightEnBody2), _defineProperty(_module$exports, 'font-lineheight-en-body1', fontLineheightEnBody1), _defineProperty(_module$exports, 'font-lineheight-en-caption', fontLineheightEnCaption), _defineProperty(_module$exports, 'font-lineheight-en-footnote', fontLineheightEnFootnote), _defineProperty(_module$exports, 'font-size-zh-display3', fontSizeZhDisplay3), _defineProperty(_module$exports, 'font-size-zh-display2', fontSizeZhDisplay2), _defineProperty(_module$exports, 'font-size-zh-display1', fontSizeZhDisplay1), _defineProperty(_module$exports, 'font-size-zh-headline', fontSizeZhHeadline), _defineProperty(_module$exports, 'font-size-zh-title', fontSizeZhTitle), _defineProperty(_module$exports, 'font-size-zh-subhead', fontSizeZhSubhead), _defineProperty(_module$exports, 'font-size-zh-body2', fontSizeZhBody2), _defineProperty(_module$exports, 'font-size-zh-body1', fontSizeZhBody1), _defineProperty(_module$exports, 'font-size-zh-caption', fontSizeZhCaption), _defineProperty(_module$exports, 'font-size-zh-footnote', fontSizeZhFootnote), _defineProperty(_module$exports, 'font-weight-zh-display3', fontWeightZhDisplay3), _defineProperty(_module$exports, 'font-weight-zh-display2', fontWeightZhDisplay2), _defineProperty(_module$exports, 'font-weight-zh-display1', fontWeightZhDisplay1), _defineProperty(_module$exports, 'font-weight-zh-headline', fontWeightZhHeadline), _defineProperty(_module$exports, 'font-weight-zh-title', fontWeightZhTitle), _defineProperty(_module$exports, 'font-weight-zh-subhead', fontWeightZhSubhead), _defineProperty(_module$exports, 'font-weight-zh-body2', fontWeightZhBody2), _defineProperty(_module$exports, 'font-weight-zh-body1', fontWeightZhBody1), _defineProperty(_module$exports, 'font-weight-zh-caption', fontWeightZhCaption), _defineProperty(_module$exports, 'font-weight-zh-footnote', fontWeightZhFootnote), _defineProperty(_module$exports, 'font-lineheight-zh-display3', fontLineheightZhDisplay3), _defineProperty(_module$exports, 'font-lineheight-zh-display2', fontLineheightZhDisplay2), _defineProperty(_module$exports, 'font-lineheight-zh-display1', fontLineheightZhDisplay1), _defineProperty(_module$exports, 'font-lineheight-zh-headline', fontLineheightZhHeadline), _defineProperty(_module$exports, 'font-lineheight-zh-title', fontLineheightZhTitle), _defineProperty(_module$exports, 'font-lineheight-zh-subhead', fontLineheightZhSubhead), _defineProperty(_module$exports, 'font-lineheight-zh-body2', fontLineheightZhBody2), _defineProperty(_module$exports, 'font-lineheight-zh-body1', fontLineheightZhBody1), _defineProperty(_module$exports, 'font-lineheight-zh-caption', fontLineheightZhCaption), _defineProperty(_module$exports, 'font-lineheight-zh-footnote', fontLineheightZhFootnote), _module$exports);