'use strict';

var _module$exports;

var _nukeVarLoader = require('../../../nuke-var-loader/lib/index.js');

var _nukeCore = require('../../../nuke-core/lib/nuke.js');

var _nukeCore2 = _interopRequireDefault(_nukeCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

////
/// @module feedback: 反馈
/// @tag Feedback
/// @category component
/// @family feedback
/// @varPrefix $feedback-
/// @classPrefix {prefix}-feedback
////


/// background
/// @namespace statement
var feedbackToastBgColor = (0, _nukeVarLoader.varLoader)('feedback-toast-bg-color', _nukeCore2.default['color-n1-9']);

/// text
/// @namespace statement
var feedbackToastColor = (0, _nukeVarLoader.varLoader)('feedback-toast-color', _nukeCore2.default['color-n1-1']);

/// padding(l/r)
/// @namespace size/bounding
var feedbackToastPaddingLeftRight = (0, _nukeVarLoader.varLoader)('feedback-toast-padding-left-right', _nukeCore2.default['s3']);

/// padding(t,b)
/// @namespace size/bounding
var feedbackToastPaddingTopBottom = (0, _nukeVarLoader.varLoader)('feedback-toast-padding-top-bottom', _nukeCore2.default['s4']);

/// text
/// @namespace size/text
var feedbackToastFontSize = (0, _nukeVarLoader.varLoader)('feedback-toast-font-size', _nukeCore2.default['font-size-base-caption']);

/// margin(b)
/// @namespace size/icon
var feedbackToastIconMarginBottom = (0, _nukeVarLoader.varLoader)('feedback-toast-icon-margin-bottom', _nukeCore2.default['s3']);

/// corner
/// @namespace statement
var feedbackToastCorner = (0, _nukeVarLoader.varLoader)('feedback-toast-corner', _nukeCore2.default['corner-radius-r2']);

/// size
/// @namespace size/icon
var feedbackToastIconSize = (0, _nukeVarLoader.varLoader)('feedback-toast-icon-size', _nukeCore2.default['icon-l']);

/// icon-color
/// @namespace statement
var feedbackToastIconColor = (0, _nukeVarLoader.varLoader)('feedback-toast-icon-color', _nukeCore2.default['color-n1-1']);

/// opacity
/// @namespace statement
var feedbackToastOpacity = (0, _nukeVarLoader.varLoader)('feedback-toast-opacity', '70');

/// mask-opacity
/// @namespace statement
var feedbackToastMaskOpacity = (0, _nukeVarLoader.varLoader)('feedback-toast-mask-opacity', '30');

/// min width
/// @namespace size
var feedbackToastMinWidth = (0, _nukeVarLoader.varLoader)('feedback-toast-min-width', _nukeCore2.default['s25']);

/// max width
/// @namespace size
var feedbackToastMaxWidth = (0, _nukeVarLoader.varLoader)('feedback-toast-max-width', _nukeCore2.default['s40']);

/// min height
/// @namespace size
var feedbackToastMinHeight = (0, _nukeVarLoader.varLoader)('feedback-toast-min-height', _nukeCore2.default['s15']);

/// align
/// @namespace statement
var feedbackToastAlign = (0, _nukeVarLoader.varLoader)('feedback-toast-align', 'center');
/// padding(l,r)
/// @namespace size
var feedbackInlinePaddingLeftRight = (0, _nukeVarLoader.varLoader)('feedback-inline-padding-left-right', _nukeCore2.default['s4']);
/// padding(t)
/// @namespace size
var feedbackInlinePaddingTop = (0, _nukeVarLoader.varLoader)('feedback-inline-padding-top', _nukeCore2.default['s7']);
/// padding(b)
/// @namespace size
var feedbackInlinePaddingBottom = (0, _nukeVarLoader.varLoader)('feedback-inline-padding-bottom', _nukeCore2.default['s5']);
/// text
/// @namespace size/text
var feedbackInlineFontSize = (0, _nukeVarLoader.varLoader)('feedback-inline-font-size', _nukeCore2.default['font-size-base-body1']);
/// margin(b)
/// @namespace size/icon
var feedbackInlineIconBottomMargin = (0, _nukeVarLoader.varLoader)('feedback-inline-icon-bottom-margin', _nukeCore2.default['s5']);
/// size
/// @namespace size/icon
var feedbackInlineIconSize = (0, _nukeVarLoader.varLoader)('feedback-inline-icon-size', _nukeCore2.default['icon-xl']);

/// icon
/// @namespace statement/success
var feedbackInlineIconSuccessColor = (0, _nukeVarLoader.varLoader)('feedback-inline-icon-success-color', _nukeCore2.default['color-f3-1']);
/// icon
/// @namespace statement/error
var feedbackInlineIconErrorColor = (0, _nukeVarLoader.varLoader)('feedback-inline-icon-error-color', _nukeCore2.default['color-f2-1']);
/// icon
/// @namespace statement/warning
var feedbackInlineIconWarningColor = (0, _nukeVarLoader.varLoader)('feedback-inline-icon-warning-color', _nukeCore2.default['color-f1-3']);

/// text
/// @namespace statement/success
var feedbackInlineSuccessColor = (0, _nukeVarLoader.varLoader)('feedback-inline-success-color', _nukeCore2.default['color-n2-3']);
/// text
/// @namespace statement/error
var feedbackInlineErrorColor = (0, _nukeVarLoader.varLoader)('feedback-inline-error-color', _nukeCore2.default['color-n2-3']);
/// text
/// @namespace statement/warning
var feedbackInlineWarningColor = (0, _nukeVarLoader.varLoader)('feedback-inline-warning-color', _nukeCore2.default['color-n2-3']);

/// background
/// @namespace statement/success
var feedbackInlineSuccessBgColor = (0, _nukeVarLoader.varLoader)('feedback-inline-success-bg-color', _nukeCore2.default['color-n1-1']);
/// background
/// @namespace statement/error
var feedbackInlineErrorBgColor = (0, _nukeVarLoader.varLoader)('feedback-inline-error-bg-color', _nukeCore2.default['color-n1-1']);
/// background
/// @namespace statement/warning
var feedbackInlineWarningBgColor = (0, _nukeVarLoader.varLoader)('feedback-inline-warning-bg-color', _nukeCore2.default['color-n1-1']);

/// size
/// @namespace size/image
var feedbackPrImageSize = (0, _nukeVarLoader.varLoader)('feedback-pr-image-size', _nukeCore2.default['s20']);

/// margin(t)
/// @namespace size/text
var feedbackPrTextMarginTop = (0, _nukeVarLoader.varLoader)('feedback-pr-text-margin-top', _nukeCore2.default['s5']);

/// margin(b)
/// @namespace size/text
var feedbackPrTextMarginBottom = (0, _nukeVarLoader.varLoader)('feedback-pr-text-margin-bottom', _nukeCore2.default['s5']);

/// text
/// @namespace size/text
var feedbackPrFontSize = (0, _nukeVarLoader.varLoader)('feedback-pr-font-size', _nukeCore2.default['font-size-base-body1']);

/// color
/// @namespace statement
var feedbackPrColor = (0, _nukeVarLoader.varLoader)('feedback-pr-color', _nukeCore2.default['color-n2-4']);

module.exports = (_module$exports = {}, _defineProperty(_module$exports, 'feedback-toast-bg-color', feedbackToastBgColor), _defineProperty(_module$exports, 'feedback-toast-color', feedbackToastColor), _defineProperty(_module$exports, 'feedback-toast-padding-left-right', feedbackToastPaddingLeftRight), _defineProperty(_module$exports, 'feedback-toast-padding-top-bottom', feedbackToastPaddingTopBottom), _defineProperty(_module$exports, 'feedback-toast-font-size', feedbackToastFontSize), _defineProperty(_module$exports, 'feedback-toast-icon-margin-bottom', feedbackToastIconMarginBottom), _defineProperty(_module$exports, 'feedback-toast-corner', feedbackToastCorner), _defineProperty(_module$exports, 'feedback-toast-icon-size', feedbackToastIconSize), _defineProperty(_module$exports, 'feedback-toast-icon-color', feedbackToastIconColor), _defineProperty(_module$exports, 'feedback-toast-opacity', feedbackToastOpacity), _defineProperty(_module$exports, 'feedback-toast-mask-opacity', feedbackToastMaskOpacity), _defineProperty(_module$exports, 'feedback-toast-min-width', feedbackToastMinWidth), _defineProperty(_module$exports, 'feedback-toast-max-width', feedbackToastMaxWidth), _defineProperty(_module$exports, 'feedback-toast-min-height', feedbackToastMinHeight), _defineProperty(_module$exports, 'feedback-toast-align', feedbackToastAlign), _defineProperty(_module$exports, 'feedback-inline-padding-left-right', feedbackInlinePaddingLeftRight), _defineProperty(_module$exports, 'feedback-inline-padding-top', feedbackInlinePaddingTop), _defineProperty(_module$exports, 'feedback-inline-padding-bottom', feedbackInlinePaddingBottom), _defineProperty(_module$exports, 'feedback-inline-font-size', feedbackInlineFontSize), _defineProperty(_module$exports, 'feedback-inline-icon-bottom-margin', feedbackInlineIconBottomMargin), _defineProperty(_module$exports, 'feedback-inline-icon-size', feedbackInlineIconSize), _defineProperty(_module$exports, 'feedback-inline-icon-success-color', feedbackInlineIconSuccessColor), _defineProperty(_module$exports, 'feedback-inline-icon-error-color', feedbackInlineIconErrorColor), _defineProperty(_module$exports, 'feedback-inline-icon-warning-color', feedbackInlineIconWarningColor), _defineProperty(_module$exports, 'feedback-inline-success-color', feedbackInlineSuccessColor), _defineProperty(_module$exports, 'feedback-inline-error-color', feedbackInlineErrorColor), _defineProperty(_module$exports, 'feedback-inline-warning-color', feedbackInlineWarningColor), _defineProperty(_module$exports, 'feedback-inline-success-bg-color', feedbackInlineSuccessBgColor), _defineProperty(_module$exports, 'feedback-inline-error-bg-color', feedbackInlineErrorBgColor), _defineProperty(_module$exports, 'feedback-inline-warning-bg-color', feedbackInlineWarningBgColor), _defineProperty(_module$exports, 'feedback-pr-image-size', feedbackPrImageSize), _defineProperty(_module$exports, 'feedback-pr-text-margin-top', feedbackPrTextMarginTop), _defineProperty(_module$exports, 'feedback-pr-text-margin-bottom', feedbackPrTextMarginBottom), _defineProperty(_module$exports, 'feedback-pr-font-size', feedbackPrFontSize), _defineProperty(_module$exports, 'feedback-pr-color', feedbackPrColor), _module$exports);