"use strict";

/**
 * @param {*} hex
 * @param {*} opacity
 */
exports.hexToRgb = function (hex, opacity) {
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
  hex = hex.replace(shorthandRegex, function (m, r, g, b) {
    return r + r + g + g + b + b;
  });

  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  if (!result) return null;

  return {
    r: parseInt(result[1], 16),
    g: parseInt(result[2], 16),
    b: parseInt(result[3], 16)
  };
};
/**
 * @param {*} hex
 * @param {*} opacity
 */
exports.rgba = function (hex, opacity) {
  var result = exports.hexToRgb(hex);
  if (!result) return null;
  return "rgba(" + result.r + "," + result.g + "," + result.b + "," + opacity + ")";
};