/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * @providesModule
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeText = require('../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('../../nuke-touchable/lib/index.js');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeUtil = require('../../nuke-util/lib/index.js');

var _nukeUtil2 = _interopRequireDefault(_nukeUtil);

var _nukeEnv = require('../../nuke-env/lib/index.js');

var _nukeEnv2 = _interopRequireDefault(_nukeEnv);

var _bridge = require('./bridge.js');

var _bridge2 = _interopRequireDefault(_bridge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var urlHandler = _nukeUtil2.default.urlHandler;
var isWeex = _nukeEnv2.default.isWeex,
    isWeb = _nukeEnv2.default.isWeb,
    isQNWeb = _nukeEnv2.default.isQNWeb;

var Link = function (_Component) {
    _inherits(Link, _Component);

    function Link(props) {
        _classCallCheck(this, Link);

        var _this = _possibleConstructorReturn(this, (Link.__proto__ || Object.getPrototypeOf(Link)).call(this, props));

        _this.pushNext = function () {
            if (isWeex) {
                var navigator = require('@weex-module/navigator');
                try {
                    navigator.push({
                        url: _this.props.href
                    }, function (e) {});
                } catch (e) {}
            }
        };

        _this.onTextPress = function (e) {
            // 由于 native 端事件绑了2遍，因此 web 端需要去重
            if (isWeb) {
                e.stopPropagation();
            }
            _this.pushNext();
        };

        _this.pushto = function (url) {
            (0, _bridge2.default)(url);
        };

        return _this;
    }

    _createClass(Link, [{
        key: 'convertURL',
        value: function convertURL(url) {
            if (url.indexOf('qap://') > -1) {
                var options = {
                    refer: window.location.href
                };
                if (typeof window.__QAP__ !== 'undefined' && __QAP__.package && __QAP__.package.config && __QAP__.package.config.WebRootPath) {
                    options.webRootPath = __QAP__.package.config.WebRootPath;
                }
                url = urlHandler(url, options);
            }
            return url;
        }
    }, {
        key: 'render',
        value: function render() {
            var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'textAlign', 'textDecoration'];
            var _props = this.props,
                children = _props.children,
                href = _props.href,
                _props$target = _props.target,
                target = _props$target === undefined ? '_self' : _props$target,
                webUrl = _props.webUrl,
                activeStyle = _props.activeStyle;


            var style = _extends({}, styles.initial, this.props.style);
            var textStyle = {};
            var content = void 0;
            var activeObj = {};
            for (var k in activeStyle) {
                activeObj[k + ':active'] = activeStyle[k];
            }
            style = Object.assign(style, activeObj);

            if (isWeex) {
                if (typeof children === 'string') {
                    TextAttrArr.forEach(function (item) {
                        if (style[item]) {
                            textStyle[item] = style[item];
                        }
                        if (style[item + ':active']) {
                            textStyle[item + ':active'] = style[item + ':active'];
                        }
                    });
                    content = (0, _rax.createElement)(
                        _nukeText2.default,
                        { onPress: this.onTextPress, style: textStyle },
                        children
                    );
                }

                return (0, _rax.createElement)(
                    _nukeTouchable2.default,
                    _extends({}, this.props, { activeStyle: activeStyle, style: style, onPress: this.pushNext }),
                    typeof children !== 'string' ? children : content
                );
            } else {
                var linkURL = webUrl || (href ? this.convertURL(href) : '');

                if (isQNWeb && linkURL && target === '_blank') {
                    return (0, _rax.createElement)(
                        _nukeTouchable2.default,
                        _extends({}, this.props, { style: style, onPress: this.pushto(linkURL) }),
                        children || content
                    );
                } else {
                    return (0, _rax.createElement)(
                        'a',
                        _extends({}, this.props, { target: target, style: [{ display: 'flex' }, style], href: linkURL }),
                        this.props.children
                    );
                }
            }
        }
    }]);

    return Link;
}(_rax.Component);

var styles = {
    initial: {
        textDecoration: 'none'
    }
};
exports.default = Link;
module.exports = exports['default'];