'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Alert;

var _nukeEnv = require('../../../nuke-env/lib/index.js');

function Alert(message, callbackOrButtons) {
  var okTitle = void 0;
  var okCallback = void 0;
  if (typeof callbackOrButtons === 'function') {
    okCallback = callbackOrButtons;
  } else if (callbackOrButtons && callbackOrButtons[0]) {
    callbackOrButtons.forEach(function (btn, index) {
      var callback = btn.onPress;
      var text = btn.text;
      if (index === 0) {
        okTitle = text;
        okCallback = callback;
      }
    });
  }

  if (_nukeEnv.isWeex) {
    var Modal = require('@weex-module/modal');
    if (Modal.alert) {
      Modal.alert({
        message: message,
        okTitle: okTitle
      }, okCallback);
    }
  } else {
    alert(message);
    okCallback && okCallback();
  }
} /** @jsx createElement */
module.exports = exports['default'];