'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Confirm;

var _nukeEnv = require('../../../nuke-env/lib/index.js');

function Confirm(message, callbackOrButtons) {
  var okTitle = void 0;
  var okCallback = void 0;
  var cancelCallback = void 0;
  var cancelTitle = void 0;
  if (typeof callbackOrButtons === 'function') {
    okCallback = callbackOrButtons;
  } else if (callbackOrButtons && callbackOrButtons[0]) {
    callbackOrButtons.forEach(function (btn, index) {
      var callback = btn.onPress;
      var text = btn.text;
      if (index === 0) {
        okTitle = text;
        okCallback = callback;
      } else {
        cancelTitle = text;
        cancelCallback = callback;
      }
    });
  }

  if (_nukeEnv.isWeex) {
    var Modal = require('@weex-module/modal');
    okTitle = okTitle || 'OK';
    cancelTitle = cancelTitle || 'Cancel';
    if (Modal.confirm) {
      Modal.confirm({
        message: message,
        okTitle: okTitle,
        cancelTitle: cancelTitle
      }, function (ret) {
        if (ret === okTitle) {
          okCallback && okCallback(ret);
        } else {
          cancelCallback && cancelCallback();
        }
      });
    }
  } else {
    var ret = confirm(message);
    if (ret) {
      okCallback && okCallback(ret);
    } else {
      cancelCallback && cancelCallback();
    }
  }
} /** @jsx createElement */
module.exports = exports['default'];