'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.show = show;
exports.initFrame = initFrame;
exports.sendData = sendData;
exports.hide = hide;

var _rax = require('rax');

var _nativeDialog = require('./native-dialog.js');

var _nativeDialog2 = _interopRequireDefault(_nativeDialog);

var _nukeEnv = require('../../../nuke-env/lib/index.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var noop = function noop() {};

var defaultOptions = {
    title: '',
    onCancel: noop,
    onSelect: noop
};

var nativeDialogInstance = void 0,
    container = void 0,
    target = void 0,
    domain = void 0;

function show(url) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var onShow = arguments[2];
    var onFail = arguments[3];
    var onNotify = arguments[4];


    options = _extends({}, defaultOptions, options);
    // ignore `visible` attribute for uncontrolled dialog

    var _options = options,
        title = _options.title,
        width = _options.width,
        height = _options.height,
        _options$showMask = _options.showMask,
        showMask = _options$showMask === undefined ? true : _options$showMask,
        _options$cancelOnTouc = _options.cancelOnTouch,
        cancelOnTouch = _options$cancelOnTouc === undefined ? true : _options$cancelOnTouc,
        data = _options.data,
        others = _objectWithoutProperties(_options, ['title', 'width', 'height', 'showMask', 'cancelOnTouch', 'data']);

    if (_nukeEnv.isWeex) {
        var QAPDialog = require('@weex-module/qapfullscreendialog');

        QAPDialog.show(url, {
            width: width,
            height: height,
            showMask: showMask,
            cancelOnTouch: cancelOnTouch,
            data: data
        }, function (ret) {
            onShow && onShow(ret);
        }, function (err) {
            onFail && onFail(err);
        }, function (info) {

            onNotify && onNotify(info);
        });
    } else {
        var afterCloseCallback = function afterCloseCallback(data) {
            onNotify(data);
            (0, _rax.unmountComponentAtNode)(container);
            document.body.removeChild(container);

            target = domain = nativeDialogInstance = dialog = container = null;
        };

        var afterOpenCallback = function afterOpenCallback() {
            onShow();
        };

        // 
        var msgHandler = function msgHandler(e) {
            received = true;

            if (e.data.action && e.data.action === 'close') {
                if (nativeDialogInstance) {
                    nativeDialogInstance.hide(e.data.data);
                }
                // nativeDialogInstance = dialog = container = null;
            } else {
                    // debugger;
                    // data = e.data;
                }
        };

        var x = { backgroundColor: 'rgba(0,0,0,.7)', position: 'fixed', bottom: 0, left: 0, width: '750rem', height: '100%', justifyContent: 'center', alignItems: 'center' };
        var dialog = (0, _rax.createElement)(_nativeDialog2.default, _extends({ style: { width: width, height: height } }, others, { defaultVisible: true, url: url, afterOpen: afterOpenCallback, afterClose: afterCloseCallback }));

        container = document.getElementById('_nuke_wrap');
        if (!container) {
            container = document.createElement('div');
            container.setAttribute("id", '_nuke_wrap');
            document.body.appendChild(container);
            container = document.getElementById('_nuke_wrap');
        }
        var received = void 0;
        (0, _rax.render)(dialog, (0, _rax.findDOMNode)(document.getElementById('_nuke_wrap')), function () {
            window.addEventListener('message', msgHandler);
            function send() {
                document.getElementById('_nuke_dialog').contentWindow.postMessage('ifame', '*');

                if (!received) {
                    setTimeout(send, 100);
                }
            }
            send();

            nativeDialogInstance = this;
        });
    }
};

function initFrame(options) {
    var _options$inner = options.inner,
        inner = _options$inner === undefined ? false : _options$inner;


    if (inner) {
        var receiveMessage = function receiveMessage(event) {
            target = event.source;
            this.target = target;
            domain = event.origin;
            target.postMessage('iframe parent', domain);
        };

        window.addEventListener('message', receiveMessage);
    }
}
function sendData(data) {

    target.postMessage(data, domain);
}
function hide() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (_nukeEnv.isWeex) {
        var QAPDialog = require('@weex-module/qapfullscreendialog');
        QAPDialog.hide(data);
    } else {
        if (target) {
            target.postMessage({ action: 'close', data: data }, domain);
        } else {
            if (nativeDialogInstance) {
                nativeDialogInstance.hide();
            }
        }
    }
}