'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeUtil = require('../../../nuke-util/lib/index.js');

var _nukeUtil2 = _interopRequireDefault(_nukeUtil);

var _nukeSlip = require('../../../nuke-slip/lib/index.js');

var _nukeSlip2 = _interopRequireDefault(_nukeSlip);

var _nukeDimensions = require('../../../nuke-dimensions/lib/index.js');

var _nukeDimensions2 = _interopRequireDefault(_nukeDimensions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};
var urlHelper = _nukeUtil2.default.urlHelper;

var NativeDialog = function (_Component) {
    _inherits(NativeDialog, _Component);

    function NativeDialog(props) {
        _classCallCheck(this, NativeDialog);

        var _this = _possibleConstructorReturn(this, (NativeDialog.__proto__ || Object.getPrototypeOf(NativeDialog)).call(this, props));

        var visible = void 0;

        if ('visible' in props) {
            visible = props.visible;
        } else {
            visible = props.defaultVisible;
        }

        _this.state = { visible: visible };

        ['onSelect', 'onCancel', 'onClose', 'onMaskClose', 'afterOpen', 'afterClose'].forEach(function (m) {
            _this[m] = _this[m].bind(_this);
        });

        return _this;
    }

    _createClass(NativeDialog, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if ('visible' in nextProps) {
                this.setState({
                    visible: nextProps.visible
                });
            }
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return !!(this.state.visible || nextState.visible);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {

            // todo: resize -> position
            this.componentDidUpdate();
            var o = document.getElementsByTagName('iframe')[0];
            o.contentWindow.postMessage('from parent', "*"); //向框架页传消息
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.state.visible) {
                this.position();
            }
        }
    }, {
        key: 'position',
        value: function position() {
            var dialog = this.refs.dialog;
        }
    }, {
        key: 'show',
        value: function show() {
            this.setState({
                visible: true
            });
        }
    }, {
        key: 'hide',
        value: function hide(data) {
            this.setState({
                visible: false,
                data: data
            });
        }
    }, {
        key: 'onSelect',
        value: function onSelect(info, e) {
            if (!('visible' in this.props)) {
                this.hide();
            }

            this.props.onNotify(info);
        }
    }, {
        key: 'onCancel',
        value: function onCancel(e) {

            if (!('visible' in this.props)) {
                this.hide();
            }

            this.props.onNotify({ type: 'cancel' });
        }
    }, {
        key: 'onClose',
        value: function onClose(e) {

            if (!('visible' in this.props)) {
                this.hide();
            }
        }
    }, {
        key: 'onMaskClose',
        value: function onMaskClose(e) {

            if (!this.props.maskClosable) {
                return;
            }

            this.onClose(e);
        }
    }, {
        key: 'afterOpen',
        value: function afterOpen() {
            this.props.afterOpen(this);
        }
    }, {
        key: 'afterClose',
        value: function afterClose() {
            var data = this.state.data || {};
            this.props.afterClose(data);
        }
    }, {
        key: 'convertURL',
        value: function convertURL(url) {
            if (url.indexOf('qap://') > -1) {
                var search = urlHelper.urlParse(url).search;
                var result = url.match(/qap\:\/{2,3}(.*)\.js/);
                if (result && result[1]) {
                    if (typeof window.__QAP__ === 'undefined' || !__QAP__.package.config.WebRootPath) {
                        var newBundle = urlHelper.realPath(result[1]);
                        var patharr = location.pathname.split('/');
                        if (patharr && patharr[patharr.length - 1]) {
                            var p = patharr[patharr.length - 1].match(/(.*)\.html/);
                            if (p && p[1]) {
                                patharr[patharr.length - 1] = patharr[patharr.length - 1].replace(p[1], newBundle);
                            }
                        }
                        var path = patharr.join('/');
                        url = location.protocol + '//' + location.host + path + search;
                    } else {
                        //使用webroot 拼接url,而非当前路径
                        var url = __QAP__.package.config.WebRootPath + result[1] + '.html' + search;
                        if (url.indexOf(':3000') > 0) {
                            url = url.replace('3000', location.port);
                        }
                    }
                }
            }
            return url;
        }
    }, {
        key: 'render',
        value: function render() {
            var height = _nukeDimensions2.default.get('window').height;

            var visible = this.state.visible;
            var _props = this.props,
                url = _props.url,
                animation = _props.animation,
                options = _props.options,
                hasMask = _props.hasMask,
                _props$locale = _props.locale,
                locale = _props$locale === undefined ? {} : _props$locale,
                _props$style = _props.style,
                style = _props$style === undefined ? {} : _props$style,
                _props$prefix = _props.prefix,
                prefix = _props$prefix === undefined ? this.defaultPrefix : _props$prefix;
            var styleSet = _extends({}, style),
                zIndex = styleSet.zIndex,
                header = this.props.header;


            if (zIndex === undefined) {
                zIndex = 499;
                styleSet['zIndex'] = zIndex;
            }
            return (0, _rax.createElement)(
                _nukeSlip2.default,
                { style: { zIndex: style.zIndex, bottom: 0 }, visible: visible, direction: 'bottom', animation: true, depth: 'auto', title: false, afterOpen: this.afterOpen, afterClose: this.afterClose },
                (0, _rax.createElement)('iframe', { id: '_nuke_dialog', style: { width: '750rem', height: height }, frameborder: '0', src: this.convertURL(url) })
            );
        }
    }]);

    return NativeDialog;
}(_rax.Component);

NativeDialog.propTypes = {
    title: _rax.PropTypes.node,
    footer: _rax.PropTypes.node,
    visible: _rax.PropTypes.bool,
    hasMask: _rax.PropTypes.bool,
    closable: _rax.PropTypes.bool,
    maskClosable: _rax.PropTypes.bool,
    onSelect: _rax.PropTypes.func,
    afterOpen: _rax.PropTypes.func,
    afterClose: _rax.PropTypes.func,
    onCancel: _rax.PropTypes.func,
    onClose: _rax.PropTypes.func,
    defaultVisible: _rax.PropTypes.bool,
    locale: _rax.PropTypes.shape({
        ok: _rax.PropTypes.string,
        cancel: _rax.PropTypes.string
    }),
    animation: _rax.PropTypes.oneOfType([_rax.PropTypes.bool, _rax.PropTypes.shape({
        'in': _rax.PropTypes.string,
        'out': _rax.PropTypes.string
    })])
};
NativeDialog.defaultProps = {
    title: 'Title',
    hasMask: true,
    closable: false,
    maskClosable: false,
    defaultVisible: false,
    locale: {
        ok: 'Ok',
        cancel: 'Cancel'
    },
    animation: {
        'in': 'zoomIn',
        'out': 'zoomOut'
    },
    onSelect: noop,
    onCancel: noop,
    afterOpen: noop,
    afterClose: noop,
    onClose: noop
};
exports.default = NativeDialog;
module.exports = exports['default'];