'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nativeDialog = require('./native-dialog.js');

var _nativeDialog2 = _interopRequireDefault(_nativeDialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var NativeDialogWrap = function (_Component) {
    _inherits(NativeDialogWrap, _Component);

    function NativeDialogWrap() {
        _classCallCheck(this, NativeDialogWrap);

        return _possibleConstructorReturn(this, (NativeDialogWrap.__proto__ || Object.getPrototypeOf(NativeDialogWrap)).apply(this, arguments));
    }

    _createClass(NativeDialogWrap, [{
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return !!(this.props.visible || nextProps.visible);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.componentDidUpdate();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.inited) {

                (0, _rax.render)(this.getDialogEl(), this.getContainerEl());
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var _this2 = this;

            if (!this.containerEl) {
                return;
            }

            if (this.props.visible) {
                // close(re-render) for animation
                (0, _rax.render)(this.getDialogEl({
                    visible: false,
                    onClose: noop,
                    afterClose: function afterClose() {
                        _this2.cleanContainerEl();
                    }
                }), this.getContainerEl());
            } else {
                this.cleanContainerEl();
            }
        }
    }, {
        key: 'getDialogEl',
        value: function getDialogEl(props) {

            props = _extends({}, this.props, props);

            return (0, _rax.createElement)(_nativeDialog2.default, props);
        }
    }, {
        key: 'getContainerEl',
        value: function getContainerEl() {
            var containerEl = this.containerEl;
            if (!containerEl) {
                var container = document.getElementById('_nuke_wrap');
                if (!container) {
                    node = document.createElement('div');
                    node.setAttribute("id", '_nuke_wrap');
                    document.body.appendChild(node);
                    container = document.getElementById('_nuke_wrap');
                }
                containerEl = (0, _rax.findDOMNode)(container);
                document.body.appendChild(containerEl);

                this.containerEl = containerEl;
            }

            return containerEl;
        }
    }, {
        key: 'cleanContainerEl',
        value: function cleanContainerEl() {
            var containerEl = this.containerEl;

            if (containerEl) {
                (0, _rax.unmountComponentAtNode)(containerEl);
                document.body.removeChild(containerEl);
                this.containerEl = null;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            this.inited = this.inited || this.props.visible || this.props.defaultVisible;
            return null;
        }
    }]);

    return NativeDialogWrap;
}(_rax.Component);

exports.default = NativeDialogWrap;
module.exports = exports['default'];