'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeSlip = require('../../../nuke-slip/lib/index.js');

var _nukeSlip2 = _interopRequireDefault(_nukeSlip);

var _column = require('./column.js');

var _column2 = _interopRequireDefault(_column);

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var Picker = function (_Component) {
    _inherits(Picker, _Component);

    function Picker(props) {
        _classCallCheck(this, Picker);

        var _this = _possibleConstructorReturn(this, (Picker.__proto__ || Object.getPrototypeOf(Picker)).call(this, props));

        var visible = void 0,
            value = void 0;

        if ('visible' in props) {
            visible = props.visible;
        } else {
            visible = props.defaultVisible;
        }

        if ('value' in props) {
            value = props.value;
        } else {
            value = props.selectedKey;
        }

        _this.state = {
            value: value,
            visible: visible
        };

        _this.items = [];
        _this.columns = null; // calculate at some time

        ['onDone', 'onCancel', 'onClose', 'onChange', 'onUpdate', 'onVisibleChange', 'afterOpen', 'afterClose'].forEach(function (m) {
            _this[m] = _this[m].bind(_this);
        });
        return _this;
    }

    _createClass(Picker, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return {
                __picker__: true,
                onUpdate: this.onUpdate,
                onChange: this.onChange,
                selectedValue: this.state.value
            };
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // controlled component
            // sync state from props
            if ('visible' in nextProps) {
                this.setState({
                    visible: nextProps.visible
                });
            }

            if ('value' in nextProps) {
                this.setState({
                    value: nextProps.value
                });
            }
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
            if (nextState.value !== this.state.value || nextProps.dataSource !== this.props.dataSource || JSON.stringify(nextState.value) !== JSON.stringify(this.state.value) || JSON.stringify(nextProps.dataSource) !== JSON.stringify(this.props.dataSource)) {
                this.changed = true;
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this.changed = false;
        }
    }, {
        key: 'getColumns',
        value: function getColumns(value) {
            var _props = this.props,
                dataSource = _props.dataSource,
                valueMap = _props.valueMap,
                childrenMap = _props.childrenMap,
                keyMap = _props.keyMap;


            var columns = [];

            value = value || this.state.value;

            // normal data
            if ('children' in dataSource[0]) {

                // cascade data
                var cols = dataSource,
                    flag = false;

                if (cols.length > 0) {
                    if (value === "") {
                        value = [];
                    }
                    columns.push(cols);
                }

                for (var i = 0;; i++) {
                    for (var j = 0, l = cols.length; j < l; j++) {
                        var col = cols[j];
                        var colValue = value[i];

                        if (keyMap(col) === colValue) {
                            cols = childrenMap(col);
                            flag = true;
                            break;
                        }
                    }

                    if (!flag) {
                        if (cols.length > 0) {
                            value[i] = keyMap(cols[0]);
                            cols = childrenMap(cols[0]);
                        } else {
                            cols = null;
                            value[i] = null;
                        }
                    }

                    if (!cols || !cols.length) {
                        break;
                    } else {
                        columns.push(cols);
                        flag = false;
                    }
                }
            } else {
                columns = [dataSource];
            }

            // column change -> value change
            // dont setState() re-render
            if (value instanceof Array) {
                value.splice(columns.length);
            }

            this.columns = columns;

            return columns;
        }
    }, {
        key: 'show',
        value: function show() {
            if (!('visible' in this.props)) {
                this.setState({
                    visible: true
                });
            }
        }
    }, {
        key: 'hide',
        value: function hide() {
            if (!('visible' in this.props)) {
                this.setState({
                    visible: false
                });
            }
        }
    }, {
        key: 'setVisible',
        value: function setVisible(visible, cb) {

            if (this.state.visible === visible) {
                return;
            }

            var callback = this.props['' + cb];

            for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
                args[_key - 2] = arguments[_key];
            }

            if (!('visible' in this.props)) {
                if (callback.apply(null, args) !== false) {
                    this.setState({ visible: visible });
                }
            } else {
                callback.apply(null, args);
            }
        }
    }, {
        key: 'onDone',
        value: function onDone(e) {
            this.setVisible(false, 'onDone', this.items, e);
        }
    }, {
        key: 'onCancel',
        value: function onCancel(e) {
            this.setVisible(false, 'onCancel', e);
        }
    }, {
        key: 'onClose',
        value: function onClose(e) {
            this.setVisible(false, 'onClose', e);
        }
    }, {
        key: 'onUpdate',
        value: function onUpdate(item, index) {

            this.items[index] = item;
        }
    }, {
        key: 'onChange',
        value: function onChange(v, item, i) {
            var _this2 = this;

            var items = this.items;
            var value = this.state.value;

            var newValue = void 0,
                newItems = void 0;

            var _props2 = this.props,
                dataSource = _props2.dataSource,
                onChange = _props2.onChange;


            newValue = [].concat(_toConsumableArray(value));
            newValue[i] = v;

            newItems = [].concat(_toConsumableArray(items));
            newItems[i] = item;

            if (!('value' in this.props)) {
                this.setState({
                    value: newValue
                }, function () {
                    // use callback beacuse of dynamic data
                    if (onChange(newItems) === false) {
                        // reset
                        _this2.setState({
                            value: value
                        });
                    }
                });
            } else {

                // cascade data normalize value
                if (!(this.props.dataSource[0] instanceof Array)) {
                    this.getColumns(value);
                }
                onChange(newItems);
            }
        }
    }, {
        key: 'onVisibleChange',
        value: function onVisibleChange(visible) {
            this.setVisible(visible, 'onVisibleChange', visible);
        }
    }, {
        key: 'afterOpen',
        value: function afterOpen() {
            // debugger;
            this.props.afterOpen(this);
        }
    }, {
        key: 'afterClose',
        value: function afterClose() {
            this.props.afterClose();
        }
    }, {
        key: 'getPickerEl',
        value: function getPickerEl() {
            var _props3 = this.props,
                hasToolbar = _props3.hasToolbar,
                title = _props3.title,
                labelMap = _props3.labelMap,
                valueMap = _props3.valueMap,
                keyMap = _props3.keyMap,
                childrenMap = _props3.childrenMap,
                _props3$style = _props3.style,
                style = _props3$style === undefined ? {} : _props3$style,
                _props3$prefix = _props3.prefix,
                prefix = _props3$prefix === undefined ? this.defaultPrefix : _props3$prefix;
            var _props4 = this.props,
                toolbar = _props4.toolbar,
                children = _props4.children;

            var columns = this.columns;

            if (toolbar === undefined) {
                toolbar = (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: _styles2.default['picker-toolbar-inner'] },
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['picker-cancel'], onClick: this.onCancel },
                        '\u53D6\u6D88'
                    ),
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['picker-title'] },
                        title
                    ),
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['picker-done'], onClick: this.onDone },
                        '\u786E\u5B9A'
                    )
                );
            }

            if (!children) {

                if (!columns || this.changed) {
                    columns = this.getColumns();
                }

                children = columns.map(function (col, index) {
                    return (0, _rax.createElement)(_column2.default, { key: index, index: index, dataSource: col, labelMap: labelMap, valueMap: valueMap, keyMap: keyMap });
                });
            } else {

                if (children.map) {

                    children = children.map(function (col, index) {
                        return (0, _rax.cloneElement)(col, { index: index });
                    });
                } else {
                    var index = 0;
                    children = (0, _rax.cloneElement)(children, { index: index });
                }
            }
            return (0, _rax.createElement)(
                _nukeView2.default,
                { x: 'picker-wrap', style: [_styles2.default['picker']] },
                hasToolbar ? (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: _styles2.default['picker-toolbar'] },
                    toolbar
                ) : null,
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { x: 'picker-content', style: _styles2.default['picker-content'] },
                    children
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var visible = this.state.visible;
            var _props5 = this.props,
                trigger = _props5.trigger,
                inline = _props5.inline,
                _props5$style = _props5.style,
                style = _props5$style === undefined ? {} : _props5$style;


            var picker = null;

            // this.inited = this.inited || visible;

            // if (this.inited) {
            picker = this.getPickerEl();
            // }
            // return picker;
            // if (visible ) {
            //     return picker;
            // } else {
            // picker = (
            return (0, _rax.createElement)(
                _nukeSlip2.default,
                { style: { zIndex: style.zIndex }, visible: visible, direction: 'bottom', animation: true, depth: 'auto', title: false, afterOpen: this.afterOpen, afterClose: this.afterClose },
                picker
            );
            // );
            // return picker;
            // }

        }
    }]);

    return Picker;
}(_rax.Component);

// for cascade data，default key: children


Picker.propTypes = {
    title: _rax.PropTypes.node,
    value: _rax.PropTypes.array,
    visible: _rax.PropTypes.bool,
    trigger: _rax.PropTypes.element,

    selectedKey: _rax.PropTypes.array,
    defaultVisible: _rax.PropTypes.bool,

    inline: _rax.PropTypes.bool,
    toolbar: _rax.PropTypes.node,
    hasToolbar: _rax.PropTypes.bool,
    dataSource: _rax.PropTypes.array,

    // locale: PropTypes.shape({
    //     done: PropTypes.string,
    //     cancel: PropTypes.string
    // }),

    onDone: _rax.PropTypes.func,
    onCancel: _rax.PropTypes.func,
    onClose: _rax.PropTypes.func,

    onChange: _rax.PropTypes.func,
    afterOpen: _rax.PropTypes.func,
    afterClose: _rax.PropTypes.func,
    onVisibleChange: _rax.PropTypes.func,

    labelMap: _rax.PropTypes.func,
    valueMap: _rax.PropTypes.func,
    childrenMap: _rax.PropTypes.func,
    keyMap: _rax.PropTypes.func
};
Picker.defaultProps = {
    dataSource: [],
    selectedKey: '',
    defaultVisible: false,

    inline: false,
    hasToolbar: true,

    title: '',
    trigger: null,

    // locale: i18nMap['en-us'],

    onChange: noop,
    onDone: noop,
    onCancel: noop,
    onClose: noop,
    afterOpen: noop,
    afterClose: noop,
    onVisibleChange: noop,

    labelMap: _column.labelMap,
    valueMap: _column.valueMap,
    childrenMap: childrenMap,
    keyMap: _column.keyMap
};
Picker.childContextTypes = {
    onUpdate: _rax.PropTypes.func,
    onChange: _rax.PropTypes.func,
    __picker__: _rax.PropTypes.bool,
    selectedValue: _rax.PropTypes.array
};
function childrenMap(item) {
    if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object') {
        return item.children;
    }
}

exports.default = Picker;
module.exports = exports['default'];