/** @jsx createElement */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('../../../nuke-touchable/lib/index.js');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeIcon = require('../../../nuke-icon/lib/index.js');

var _nukeIcon2 = _interopRequireDefault(_nukeIcon);

var _nukeEnv = require('../../../nuke-env/lib/index.js');

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SHOW = _nukeEnv.isWeex ? 'show' : 'block';
var HIDE = _nukeEnv.isWeex ? 'hide' : 'none';
var RADIO_TYPES = {
    radio: 'radio',
    small: 'radio-small',
    medium: 'radio-medium',
    touch: 'radio-touch'
};

var Radio = function (_Component) {
    _inherits(Radio, _Component);

    function Radio(props, context) {
        _classCallCheck(this, Radio);

        var _this = _possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).call(this, props));

        _this.onChange = _this.onChange.bind(_this);
        var checked = props.checked || false;

        _this.state = {
            checked: checked,
            value: props.value || ''
        };
        return _this;
    }

    _createClass(Radio, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (this.context.__group__ && this.context.selectedValue == this.props.value) {
                this.state = {
                    checked: true
                };
            }
        }
    }, {
        key: 'onChange',
        value: function onChange(e) {
            var _props = this.props,
                onChange = _props.onChange,
                value = _props.value,
                disabled = _props.disabled;


            if (disabled) return;
            var tmp = this.state.checked;
            if (this.context.__group__) {
                this.context.onChange(value, e);
            } else {
                if (!('checked' in this.props)) {
                    this.setState({
                        checked: !tmp
                    });
                }
            }
            onChange(!tmp);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps, nextContext) {
            if (nextContext.__group__) {
                if ((typeof nextContext === 'undefined' ? 'undefined' : _typeof(nextContext)) == 'object' && nextContext.selectedValue == nextProps.value) {
                    this.setState({ checked: true });
                } else {
                    this.setState({ checked: false });
                }
            } else {
                if ('checked' in nextProps) {
                    if (nextProps.checked != this.props.checked) this.setState({
                        checked: nextProps.checked
                    });
                }
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                size = _props2.size,
                style = _props2.style,
                disabled = _props2.disabled,
                type = _props2.type,
                checkedStyle = _props2.checkedStyle,
                uncheckedStyle = _props2.uncheckedStyle,
                others = _objectWithoutProperties(_props2, ['size', 'style', 'disabled', 'type', 'checkedStyle', 'uncheckedStyle']);

            var _state = this.state,
                checked = _state.checked,
                value = _state.value;

            var wrapCSS = {},
                iconCSS = {};
            var sizeStyle = _styles2.default[RADIO_TYPES[size]];
            var disabledStyle = _styles2.default['radio-' + type + '-disabled'];
            var touchCSS = [_styles2.default[RADIO_TYPES['touch'] + '-' + size], style];
            var wrapSize = _styles2.default['radio-wrap-' + type + '-' + size];
            var unradioStyle = Object.assign({ backgroundColor: '#ffffff' }, sizeStyle, wrapSize);

            wrapCSS = Object.assign({}, unradioStyle, checked ? _styles2.default['radio-' + type + '-checked'] : {}, checked ? checkedStyle : {}, disabled ? disabledStyle : {});
            iconCSS = Object.assign({}, sizeStyle, { color: wrapCSS.color });

            return (0, _rax.createElement)(
                _nukeTouchable2.default,
                _extends({}, others, { style: touchCSS, onPress: this.onChange }),
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: wrapCSS, className: 'nuke-border-fix-1' },
                    checked ? (0, _rax.createElement)(_nukeIcon2.default, { style: iconCSS, name: 'select' }) : null
                )
            );
        }
    }]);

    return Radio;
}(_rax.Component);

Radio.propTypes = {
    checked: _rax.PropTypes.boolean,
    size: _rax.PropTypes.oneOf(['small', 'medium']),
    disabled: _rax.PropTypes.boolean,
    onChange: _rax.PropTypes.func,
    type: _rax.PropTypes.oneOf(['normal', 'list', 'dark']),
    value: _rax.PropTypes.string
};

Radio.defaultProps = {
    size: 'medium',
    disabled: false,
    onChange: function onChange() {},
    type: 'normal',
    value: ''
};
Radio.contextTypes = {
    onChange: _rax.PropTypes.func,
    __group__: _rax.PropTypes.bool,
    selectedValue: _rax.PropTypes.any
};
exports.default = Radio;
module.exports = exports['default'];