'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _nukeCore = require('../../nuke-core/lib/nuke.js');

function buttonColor(color, activeColor, bgColor, activeBgColor, borderColor, activeBorderColor, opacity) {
  return Object.assign({
    color: color,
    backgroundColor: bgColor,
    borderColor: borderColor,
    'color:active': activeColor,
    'backgroundColor:active': activeBgColor,
    'borderColor:active': activeBorderColor
  }, opacity ? { opacity: opacity } : {});
}

function buttonImage(color, activeColor, bgImage, activeBgImage, borderColor, activeBorderColor, opacity, noborder) {
  return Object.assign({
    color: color,
    backgroundImage: bgImage,
    borderColor: noborder ? 'transparent' : borderColor,
    'color:active': activeColor,
    'backgroundImage:active': activeBgImage
  }, opacity ? { opacity: opacity } : {});
}

function buttonSize() {
  var pd = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var height = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var fontSize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var iconSize = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var iconMargin = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  var corner = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
  var borderWidth = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 0;

  return _extends({
    height: height
  }, (0, _nukeCore.padding)(0, pd), {
    // padding: `0 ${padding}`,//todo
    fontSize: fontSize + 'rem',
    borderRadius: corner + 'rem',
    borderWidth: borderWidth
  });
}

function buttonDisabled(disabledColor, disabledBgColor, disabledBorderColor, disbledOpacity) {
  return {
    color: disabledColor,
    backgroundColor: disabledBgColor,
    borderColor: 'transparent',
    opacity: disbledOpacity,
    'color:active': disabledColor,
    'backgroundColor:active': disabledBgColor,
    backgroundImage: 'none',
    'backgroundImage:active': 'none'
  };
}

function hexToRgb(hex, opacity) {
  // Expand shorthand form (e.g. "03F") to full form (e.g. "0033FF")
  var shorthandRegex = /^#?([a-f\d])([a-f\d])([a-f\d])$/i;
  hex = hex.replace(shorthandRegex, function (m, r, g, b) {
    return r + r + g + g + b + b;
  });

  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  if (!result) return null;

  return {
    r: parseInt(result[1], 16),
    g: parseInt(result[2], 16),
    b: parseInt(result[3], 16)
  };
}
function rgba(hex, opacity) {
  var result = hexToRgb(hex);
  if (!result) return null;

  return 'rgba(' + result.r + ',' + result.g + ',' + result.b + ',' + opacity + ')';
}

module.exports = {
  buttonColor: buttonColor,
  buttonSize: buttonSize,
  buttonDisabled: buttonDisabled,
  buttonImage: buttonImage,
  rgba: rgba
};