'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeIcon = require('../../nuke-icon/lib/index.js');

var _nukeIcon2 = _interopRequireDefault(_nukeIcon);

var _nukeButton = require('../../nuke-button/lib/index.js');

var _nukeButton2 = _interopRequireDefault(_nukeButton);

var _nukeInput = require('../../nuke-input/lib/index.js');

var _nukeInput2 = _interopRequireDefault(_nukeInput);

var _nukeView = require('../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('../../nuke-touchable/lib/index.js');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeEnv = require('../../nuke-env/lib/index.js');

var _styles = require('./styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SearchBar = function (_Component) {
    _inherits(SearchBar, _Component);

    function SearchBar(props) {
        _classCallCheck(this, SearchBar);

        var _this = _possibleConstructorReturn(this, (SearchBar.__proto__ || Object.getPrototypeOf(SearchBar)).call(this, props));

        _this.state = {
            active: false,
            value: props.value || '',
            valueTemp: props.value || ''
        };
        var events = ['submitHandler', 'focusHandler', 'blurHandler', 'textSearchHandler', 'keyUpHandler', 'cancelHandler', 'changeHandler', 'inputHandler', 'clearHandler', 'searchHandler', 'returnHandler'];
        events.forEach(function (m) {
            _this[m] = _this[m].bind(_this);
        });
        return _this;
    }

    _createClass(SearchBar, [{
        key: 'getRect',
        value: function getRect(ref) {
            var _this2 = this;

            return new Promise(function (resolve) {
                var refEl = _this2.refs[ref];
                var domEl = refEl && (0, _rax.findDOMNode)(refEl);
                if (domEl) {
                    if (_nukeEnv.isWeex) {
                        try {
                            var dom = require('@weex-module/dom');
                            setTimeout(function () {
                                dom.getComponentRect(domEl.ref, function (e) {
                                    if (e && e.size && e.size.hasOwnProperty('height')) {
                                        resolve(e.size);
                                    } else {
                                        reject(0);
                                    }
                                });
                            }, 20);
                        } catch (e) {
                            reject(0);
                        }
                    } else {
                        resolve({
                            height: domEl.offsetHeight || 0,
                            width: domEl.offsetWidth || 0
                        });
                    }
                } else {
                    reject(0);
                }
            });
        }
        //   calcRem

    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this3 = this;

            var centered = this.props.centered;

            if (!centered) return;

            this.getRect('parentDOM').then(function (wrap) {
                // alert(JSON.stringify(wrap));
                _this3.setState({
                    strentchStyle: {
                        width: _nukeEnv.isWeb ? wrap.width + 'px' : wrap.width // web 端 offset 的单位是 px
                    }
                });
            }, function (err) {
                alert(JSON.stringify(err));
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                value = _props.value,
                disabled = _props.disabled,
                defaultValue = _props.defaultValue,
                placeholder = _props.placeholder,
                onInput = _props.onInput,
                onChange = _props.onChange,
                inputStyle = _props.inputStyle,
                _props$style = _props.style,
                style = _props$style === undefined ? {} : _props$style,
                others = _objectWithoutProperties(_props, ['value', 'disabled', 'defaultValue', 'placeholder', 'onInput', 'onChange', 'inputStyle', 'style']);

            var searchbarWrapStyle = Object.assign({}, _styles2.default['search-bar-wrap'], style);

            return (0, _rax.createElement)(
                _nukeView2.default,
                _extends({
                    clsName: 'search-bar-wrap',
                    style: searchbarWrapStyle
                }, others),
                (0, _rax.createElement)(
                    _nukeView2.default,
                    {
                        clsName: 'body',
                        ref: 'parentDOM',
                        style: [_styles2.default['body'], inputStyle]
                    },
                    this.renderPlaceholder(),
                    this.renderInput({
                        style: { height: _styles2.default['body']['height'] + 'rem' }
                    })
                ),
                this.renderSearchButton()
            );
        }
        //输入框以及placeholder

    }, {
        key: 'renderInput',
        value: function renderInput(custom) {
            var _createElement;

            var _props2 = this.props,
                maxLength = _props2.maxLength,
                disabled = _props2.disabled,
                _props2$testId = _props2.testId,
                testId = _props2$testId === undefined ? {} : _props2$testId;

            var inputStyleObj = Object.assign({}, _styles2.default['input'], custom.style);
            var inputInnerStyle = { paddingLeft: 10, paddingRight: 10 };
            return (0, _rax.createElement)(_nukeInput2.default, (_createElement = {
                ref: 'input',
                type: 'inset',
                x: 'search-bar-input',
                style: inputStyleObj
            }, _defineProperty(_createElement, 'type', 'search'), _defineProperty(_createElement, 'returnKeyType', 'search'), _defineProperty(_createElement, 'maxLength', maxLength), _defineProperty(_createElement, 'value', this.state.value), _defineProperty(_createElement, 'onFocus', this.focusHandler), _defineProperty(_createElement, 'onBlur', this.blurHandler), _defineProperty(_createElement, 'onReturn', this.returnHandler), _defineProperty(_createElement, 'disabled', disabled), _defineProperty(_createElement, 'inputStyle', inputInnerStyle), _defineProperty(_createElement, 'onInput', this.inputHandler), _defineProperty(_createElement, 'onChange', this.changeHandler), _defineProperty(_createElement, 'testId', testId.input || ''), _createElement));
        }
        //模拟的placeholder

    }, {
        key: 'renderPlaceholder',
        value: function renderPlaceholder(custom) {
            var _props3 = this.props,
                placeholder = _props3.placeholder,
                centered = _props3.centered,
                _props3$placeholderCo = _props3.placeholderColor,
                placeholderColor = _props3$placeholderCo === undefined ? '#cccccc' : _props3$placeholderCo;
            var _state = this.state,
                value = _state.value,
                valueTemp = _state.valueTemp,
                active = _state.active;

            var element = void 0,
                textStyle = {};
            var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight'];
            TextAttrArr.forEach(function (item) {
                if (_styles2.default['placeholder'][item]) {
                    textStyle[item] = _styles2.default['placeholder'][item];
                }
            });

            if (_nukeEnv.isWeb) {
                element = placeholder && !valueTemp && !active ? (0, _rax.createElement)(
                    _nukeText2.default,
                    { style: [textStyle, { color: placeholderColor }] },
                    placeholder
                ) : null;
            } else {
                element = placeholder && !valueTemp && !active ? (0, _rax.createElement)(
                    _nukeText2.default,
                    { style: [textStyle, { color: placeholderColor }] },
                    placeholder
                ) : null;
            }
            var iconDOM = (0, _rax.createElement)(_nukeIcon2.default, {
                version: 'v2',
                style: [_styles2.default['icon'], { color: placeholderColor }],
                name: 'search'
            });
            var placeholderStyle = centered && !active && !valueTemp ? _extends({}, _styles2.default['body-centered'], this.state.strentchStyle) : {};
            return (0, _rax.createElement)(
                _nukeView2.default,
                {
                    x: 'placeholder',
                    ref: 'placeholderDOM',
                    style: [_styles2.default['placeholder'], placeholderStyle]
                },
                iconDOM,
                element
            );
        }

        //搜索按钮

    }, {
        key: 'renderSearchButton',
        value: function renderSearchButton() {
            if (!this.props.showSearchButton) return null;
            var _props4 = this.props,
                locale = _props4.locale,
                _props4$testId = _props4.testId,
                testId = _props4$testId === undefined ? {} : _props4$testId;

            return (0, _rax.createElement)(
                _nukeTouchable2.default,
                {
                    testId: testId.button,
                    onPress: this.searchHandler,
                    style: _styles2.default['button']
                },
                (0, _rax.createElement)(
                    _nukeText2.default,
                    {
                        onPress: this.textSearchHandler,
                        style: _styles2.default['button-text']
                    },
                    locale.cancel
                )
            );
        }
    }, {
        key: 'setActive',
        value: function setActive(active) {
            this.setState({
                active: active
            });
        }

        //======================================== 事件列表 ========================================

    }, {
        key: 'submitHandler',
        value: function submitHandler(e) {
            e.preventDefault();
        }
    }, {
        key: 'cancelHandler',
        value: function cancelHandler(e) {
            this.setActive(false);
            // this.trigger('onCancel', e);
        }
    }, {
        key: 'focusHandler',
        value: function focusHandler(e) {
            this.setActive(true);
            // this.trigger('onFocus', e);
        }
    }, {
        key: 'blurHandler',
        value: function blurHandler(e) {
            // console.log('blur',e);
            this.setActive(false);
            // this.trigger('onBlur', e);
        }
    }, {
        key: 'keyUpHandler',
        value: function keyUpHandler(e) {
            var value = e.target.value;
            var code = e.which || e.keyCode;

            if (code === 13) {
                value = this.state.value;
                e.target.blur();
                this.setActive(false);
                // this.trigger('onEnter', value, e);
            }
        }
    }, {
        key: 'inputHandler',
        value: function inputHandler(e) {
            var text = e.target.value || e.value;
            this.setState({ valueTemp: text });
            this.props.onInput && this.props.onInput(text, e);
        }
    }, {
        key: 'changeHandler',
        value: function changeHandler(value, e) {
            this.setState({ value: value });
            if (this.props.onChange) {
                this.props.onChange(this.state.value, e);
            }
        }
    }, {
        key: 'returnHandler',
        value: function returnHandler(e) {
            this.setState({ value: e.target.value || e.value });
            this.searchHandler();
        }
    }, {
        key: 'clearHandler',
        value: function clearHandler(e) {
            var value = e.value || e.target.value;
            this.setState({ value: value });
            this.changeHandler(e);
        }
    }, {
        key: 'searchHandler',
        value: function searchHandler() {
            this.refs.input.blur();
            this.props.onSearch && this.props.onSearch({ value: this.state.valueTemp });
        }
    }, {
        key: 'textSearchHandler',
        value: function textSearchHandler(e) {
            if (_nukeEnv.isWeb) {
                e.stopPropagation();
            }
            this.searchHandler();
        }
    }]);

    return SearchBar;
}(_rax.Component);

SearchBar.propTypes = {
    //取消的事件
    onCancel: _rax.PropTypes.func,
    //文字改变的事件
    onChange: _rax.PropTypes.func,
    //按下Done键盘的事件
    onEnter: _rax.PropTypes.func,
    //提供的数据
    value: _rax.PropTypes.string,
    defaultValue: _rax.PropTypes.string,
    //本地化
    locale: _rax.PropTypes.object,
    //禁用
    disabled: _rax.PropTypes.bool,
    //是否可取消
    showSearchButton: _rax.PropTypes.bool,
    //icon和placeholder是否居中
    centered: _rax.PropTypes.bool
};
SearchBar.defaultProps = {
    locale: {
        cancel: '搜索'
    },
    onSearch: function onSearch() {},
    showSearchButton: true
};
exports.default = SearchBar;
module.exports = exports['default'];