'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeSwipe = require('../../nuke-swipe/lib/index.js');

var _nukeSwipe2 = _interopRequireDefault(_nukeSwipe);

var _h5style = require('./h5style.js');

var _h5style2 = _interopRequireDefault(_h5style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /** @jsx createElement */

var propTypes = {
    onchange: _rax.PropTypes.func,
    paginationStyle: _rax.PropTypes.object
};

var SliderNeighborWeb = function (_Component) {
    _inherits(SliderNeighborWeb, _Component);

    function SliderNeighborWeb(props) {
        _classCallCheck(this, SliderNeighborWeb);

        var _this = _possibleConstructorReturn(this, (SliderNeighborWeb.__proto__ || Object.getPrototypeOf(SliderNeighborWeb)).call(this, props));

        var initState = {
            isSwiping: false,
            width: props.width,
            height: props.height,
            offsetX: '',
            loopIdx: 0
        };

        initState.total = props.children ? props.children.length || 1 : 0;
        initState.index = initState.total > 1 ? Math.min(props.index, initState.total - 1) : 0;
        initState.width = parseFloat(initState.width) * document.documentElement.clientWidth / 750;

        // 新增默认偏移量
        initState.offsetX = initState.index * initState.width;

        // 新增默认参数
        initState.loopIdx = initState.index;

        // 第一次init的变量
        _this.firstInit = true;

        if (initState.total > 1) {
            var setup = props.loop === 'true' ? 1 : initState.index;
        }

        _this.state = initState;
        return _this;
    }

    _createClass(SliderNeighborWeb, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.slideTo(0);
            this.autoPlay();
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
            if (nextProps.data && this.props.data) {
                return this.props.data[0] !== nextProps.data[0];
            }
        }
    }, {
        key: 'autoPlay',
        value: function autoPlay() {
            var that = this;
            if (!Array.isArray(this.props.children) || this.props.autoPlay === 'false' || !this.props.autoPlay || this.state.isSwiping) {
                return;
            }

            clearTimeout(this.autoPlayTimer);

            this.autoPlayTimer = setTimeout(function () {
                // let toIndex = that.state.total > that.state.index + 1 ? that.state.index + 1 : 0;
                that.slideTo();
            }, parseFloat(this.props.autoplayTimeout));
        }
    }, {
        key: 'slideTo',
        value: function slideTo(index) {
            var that = this;
            var state = this.state;
            if (state.isSwiping || state.total < 2) {
                return;
            }
            var noIndex = typeof index === 'undefined';
            var diff = noIndex ? state.index : index;
            var x = diff * state.width;
            this.changeOffset(x, diff, noIndex);
            if (noIndex) {
                this.updateIndex();
            } else {
                this.setState({ index: diff });
            }
            this.setAutoTimer();
        }
    }, {
        key: 'setAutoTimer',
        value: function setAutoTimer() {
            var that = this;
            clearTimeout(this.autoTimer);
            this.autoTimer = setTimeout(function () {
                that.autoPlay();
            }, 0);
        }
    }, {
        key: 'changeOffset',
        value: function changeOffset(x, idx, distance) {

            var state = this.state,
                width = state.width;
            var _props = this.props,
                neighborAlpha = _props.neighborAlpha,
                neighborScale = _props.neighborScale,
                scale = _props.scale,
                distanceLevel = _props.distanceLevel;

            if (!this.refs.swipeView) {
                return;
            }
            // 外框translate3d for translate3d 为了性能
            var swipeView = (0, _rax.findDOMNode)(this.refs.swipeView);
            swipeView.style.transform = 'translate3d(' + -x + 'px, 0px, 0px)';
            swipeView.style.webkitTransform = 'translate3d(' + -x + 'px, 0px, 0px)';

            var len = this.props.children.length;
            idx = this.loopedIndex(idx, len);

            this.setState({ loopIdx: idx, offsetX: x });

            // 内层child changeleft
            this.changeChildPosition(idx, x, +scale, 1, true);

            var childNum = 'child' + idx;
            var childView = (0, _rax.findDOMNode)(this.refs[childNum]);
            var leftLength = childView.style.left;
            leftLength = leftLength.substr(0, leftLength.length - 2);

            // 确保当前页的前后页都已经具备了
            if (state.total < 3) {
                return;
            }
            // debugger;
            if (!distance) {
                this.changeChildPosition(this.loopedIndex(idx + 1, len), leftLength - 0 + state.width * distanceLevel / 15, neighborScale, neighborAlpha);
                this.changeChildPosition(this.loopedIndex(idx - 1, len), leftLength - state.width * distanceLevel / 15, neighborScale, neighborAlpha, false);
            } else if (distance && distance < 0) {
                //手指向左滑动
                this.changeChildPosition(this.loopedIndex(idx - 1, len), leftLength - state.width * distanceLevel / 15, neighborScale, neighborAlpha);
                this.changeChildPosition(this.loopedIndex(idx + 1, len), leftLength - 0 + state.width * distanceLevel / 15, neighborScale, neighborAlpha, false);
            } else if (distance && distance > 0) {
                //手指向右滑动
                this.changeChildPosition(this.loopedIndex(idx + 1, len), leftLength - 0 + state.width * distanceLevel / 15, neighborScale, neighborAlpha);
                this.changeChildPosition(this.loopedIndex(idx - 1, len), leftLength - state.width * distanceLevel / 15, neighborScale, neighborAlpha, false);
            }
        }
    }, {
        key: 'changeChildPosition',
        value: function changeChildPosition(idx, offset, percent, opacity) {
            var withAnimation = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

            if (idx < 0 || idx > this.props.children.length) {
                return;
            }
            var childNum = 'child' + idx;
            var childView = (0, _rax.findDOMNode)(this.refs[childNum]);
            childView.style.left = offset + 'px';
            childView.style.opacity = opacity;
            childView.style.transform = 'translate(0, 0px) scale(' + percent + ')';
            childView.style.webkitTransform = 'translate(0, 0px) scale(' + percent + ')';
            if (opacity === 1) {
                childView.style.zIndex = "999";
            } else {
                childView.style.zIndex = "auto";
            }
            if (withAnimation) {
                childView.style.transition = 'all 0.2s ease-in-out';
                childView.style.webkitTransition = 'all 0.2s ease-in-out';
            } else {
                childView.style.transition = 'none';
                childView.style.webkitTransition = 'none';
            }
        }
    }, {
        key: 'renderSwipeView',
        value: function renderSwipeView(pages) {
            var state = this.state;

            var style = {
                width: state.width + 'px',
                height: state.height
            };

            return state.total > 1 ? (0, _rax.createElement)(
                _nukeSwipe2.default,
                { style: [_h5style2.default.swipeWrapper, style],
                    onSwipeBegin: this.onSwipeBegin.bind(this),
                    onSwipeEnd: this.onSwipeEnd.bind(this),
                    onSwipe: this.onSwipe.bind(this),
                    initialVelocityThreshold: this.props.initialVelocityThreshold,
                    verticalThreshold: this.props.verticalThreshold,
                    vertical: this.props.vertical,
                    horizontalThreshold: this.props.horizontalThreshold },
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { ref: 'swipeView', style: [_h5style2.default.swipeStyle, style] },
                    pages
                )
            ) : (0, _rax.createElement)(
                _nukeView2.default,
                { ref: 'swipeView', style: [_h5style2.default.swipeStyle, style] },
                pages
            );
        }
    }, {
        key: 'onSwipeBegin',
        value: function onSwipeBegin(_ref) {
            var direction = _ref.direction,
                distance = _ref.distance,
                velocity = _ref.velocity;

            this.setState({
                isSwiping: true
            });
            // 手势翻页时暂定自动翻页
            clearTimeout(this.autoTimer);
        }
    }, {
        key: 'onSwipe',
        value: function onSwipe(_ref2) {
            var direction = _ref2.direction,
                distance = _ref2.distance,
                velocity = _ref2.velocity;

            var index = this.state.index,
                width = this.state.width,
                x = this.state.offsetX,
                num = this.props.children.length,
                idx = index;

            if (this.props.loop === 'false' && (index === num || index === 0)) {
                return;
            }

            var changeX = 0;
            if (distance < 0) {
                changeX = -(x + Math.abs(distance));
            } else {
                changeX = -(x - Math.abs(distance));
            }

            var swipeView = (0, _rax.findDOMNode)(this.refs.swipeView);
            swipeView.style.transform = 'translate3d(' + changeX + 'px, 0px, 0px)';
            swipeView.style.webkitTransform = 'translate3d(' + changeX + 'px, 0px, 0px)';
        }
    }, {
        key: 'onSwipeEnd',
        value: function onSwipeEnd(_ref3) {
            var direction = _ref3.direction,
                distance = _ref3.distance,
                velocity = _ref3.velocity;

            // 更加流畅的翻页体验 TODO
            this.setState({
                isSwiping: true
            });

            this.updateIndex(distance);
        }
    }, {
        key: 'updateIndex',
        value: function updateIndex(distance) {
            var _props2 = this.props,
                onchange = _props2.onchange,
                scale = _props2.scale;

            var that = this;
            var state = this.state,
                index = state.index,
                step = state.width,
                num = this.props.children.length;

            index = this.changeIndex(distance, index, num);

            // fix 左滑index为负数
            var idx = this.loopedIndex(index, num);
            // 暴露index
            onchange && onchange({ index: idx });

            this.setState({ index: index });
            // 手势改变改变位置
            if (distance) {
                var x = index * state.width * +scale;
                this.changeOffset(x, index, distance);
                this.setState({
                    isSwiping: false
                });
                // 手势翻页结束后基于当前index继续轮播
                this.setAutoTimer();
            }
        }

        // 循环改变index （自增、自减）

    }, {
        key: 'changeIndex',
        value: function changeIndex(distance, index, num) {
            if (this.props.loop === 'true') {
                if (distance && distance > 0) {
                    index = index - 1;
                } else {
                    index = index + 1;
                }
            } else if (this.props.loop === 'false') {
                if (distance && distance > 0 && index !== 0) {
                    index = index - 1;
                } else if (distance && distance < 0 && index !== num - 1) {
                    index = index + 1;
                } else {
                    return index;
                }
            }
            return index;
        }

        // 使index维持在0-length之间循环

    }, {
        key: 'loopedIndex',
        value: function loopedIndex(idx, len) {
            if (idx > 0 && idx >= len - 1) {
                idx = idx % len;
            } else if (idx < 0 && idx <= -(len + 1)) {
                idx = idx % len;
                idx = idx === 0 ? 0 : idx + len;
            } else if (idx < 0 && idx >= -(len + 1)) {
                idx = idx + len;
            }
            return idx;
        }
    }, {
        key: 'renderPagination',
        value: function renderPagination() {
            var props = this.props;
            if (this.state.total <= 1) {
                return;
            }
            // debugger;
            if (!props.showsPagination) {
                return;
            }
            var dots = [];
            var ActiveDot = this.props.activeDot || (0, _rax.createElement)(_nukeView2.default, { style: [_h5style2.default.activeDot, {
                    backgroundColor: props.paginationStyle && props.paginationStyle.itemSelectedColor ? props.paginationStyle.itemSelectedColor : _h5style2.default.defaultPaginationStyle.itemSelectedColor,
                    width: props.paginationStyle && props.paginationStyle.itemSize ? props.paginationStyle.itemSize : _h5style2.default.activeDot.width,
                    height: props.paginationStyle && props.paginationStyle.itemSize ? props.paginationStyle.itemSize : _h5style2.default.activeDot.height
                }]
            });
            var NormalDot = this.props.normalDot || (0, _rax.createElement)(_nukeView2.default, { style: [_h5style2.default.normalDot, {
                    backgroundColor: props.paginationStyle && props.paginationStyle.itemColor ? props.paginationStyle.itemColor : _h5style2.default.defaultPaginationStyle.itemColor,
                    width: props.paginationStyle && props.paginationStyle.itemSize ? props.paginationStyle.itemSize : _h5style2.default.normalDot.width,
                    height: props.paginationStyle && props.paginationStyle.itemSize ? props.paginationStyle.itemSize : _h5style2.default.normalDot.height
                }]
            });

            var activeIndex = this.firstInit ? this.state.loopIdx : this.state.loopIdx;

            for (var _i = 0; _i < this.state.total; _i++) {
                dots.push(_i === activeIndex ? (0, _rax.cloneElement)(ActiveDot, { key: _i }) : (0, _rax.cloneElement)(NormalDot, { key: _i }));
            }

            return (0, _rax.createElement)(
                _nukeView2.default,
                { style: [_h5style2.default.defaultPaginationStyle, props.paginationStyle] },
                dots
            );
        }
    }, {
        key: 'getPages',
        value: function getPages() {
            var state = this.state,
                props = this.props,
                children = props.children;
            var pages = [];
            // slide的屏数需大于1个
            if (state.total > 1) {
                children.forEach(function (child, i) {
                    var refStr = 'child' + i;
                    var translateStyle = void 0;
                    if (i == 0) {
                        translateStyle = {
                            transform: 'translate(0, 0px) scale(' + +props.scale + ')',
                            webkitTransform: 'translate(0, 0px) scale(' + +props.scale + ')',
                            width: state.width + 'px',
                            height: state.height + 'px',
                            left: '0px'
                        };
                        // } else if (i == this.props.children.length - 1 ) {
                        //     translateStyle = {
                        //         transform: 'translate(0, 0px) scale(' + props.neighborScale + ')',
                        //         webkitTransform: 'translate(0, 0px) scale(' + props.neighborScale + ')',
                        //         width: state.width + 'px',
                        //         height: state.height + 'px',
                        //         left: -(state.width * props.distanceLevel / 15) + 'px',
                        //         opacity: 0
                        //     };
                    } else {
                        translateStyle = {
                            transform: 'translate(0, 0px) scale(' + props.neighborScale + ')',
                            webkitTransform: 'translate(0, 0px) scale(' + props.neighborScale + ')',
                            width: state.width + 'px',
                            height: state.height + 'px',
                            left: i * state.width * props.distanceLevel / 15 + 'px',
                            opacity: 0
                        };
                    }
                    pages.push((0, _rax.createElement)(
                        _nukeView2.default,
                        { 'data-index': i + 1, ref: refStr, className: 'childWrap', style: [_h5style2.default.childrenStyle, translateStyle], key: i },
                        child
                    ));
                });
            } else {
                pages = (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: _h5style2.default.childrenStyle, 'data-index': i },
                    children
                );
            }
            return pages;
        }
    }, {
        key: 'getChild',
        value: function getChild(i, child) {
            var that = this,
                index = this.state.index,
                len = this.props.children.length;
            index = this.loopedIndex(index, len);
            var left = this.loopedIndex(index - 1, len),
                right = this.loopedIndex(index + 1, len);

            if (i === index || i === left || i === right) {
                return child;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var that = this;

            var _props3 = this.props,
                onchange = _props3.onchange,
                props = _objectWithoutProperties(_props3, ['onchange']);

            return (0, _rax.createElement)(
                _nukeView2.default,
                { style: _h5style2.default.slideWrapper },
                this.renderSwipeView(that.getPages()),
                this.props.showPagination ? this.renderPagination() : ''
            );
        }
    }]);

    return SliderNeighborWeb;
}(_rax.Component);

;

SliderNeighborWeb.defaultProps = {
    width: '750rem',
    height: '460rem',
    horizontal: true,
    showsPagination: false,
    loop: 'true',
    autoPlay: 'false',
    autoplayTimeout: '3000',
    index: 0,
    paginationStyle: null,
    initialVelocityThreshold: 0.7,
    verticalThreshold: 10,
    horizontalThreshold: 10,
    vertical: false,
    scale: '0.9',
    distanceLevel: 13,
    neighborAlpha: '0.8',
    neighborScale: '0.8'
};

var SliderNeighborWebComponent = function (_Component2) {
    _inherits(SliderNeighborWebComponent, _Component2);

    function SliderNeighborWebComponent(props) {
        _classCallCheck(this, SliderNeighborWebComponent);

        var _this2 = _possibleConstructorReturn(this, (SliderNeighborWebComponent.__proto__ || Object.getPrototypeOf(SliderNeighborWebComponent)).call(this, props));

        _this2.onChange = function (e) {
            if (_this2.props.onChange) {
                _this2.props.onChange(e);
            }
            _this2.setState({
                index: e.index
            });
        };

        return _this2;
    }

    _createClass(SliderNeighborWebComponent, [{
        key: 'componentWillMount',
        value: function componentWillMount() {}
    }, {
        key: 'render',
        value: function render() {
            var props = _extends({}, this.props, {
                'onchange': this.onChange
            });
            return (0, _rax.createElement)(SliderNeighborWeb, _extends({ ref: 'Slider' }, props));
        }
    }]);

    return SliderNeighborWebComponent;
}(_rax.Component);

exports.default = SliderNeighborWebComponent;
module.exports = exports['default'];