/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * @providesModule
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _h = require('./h5.js');

var _h2 = _interopRequireDefault(_h);

var _nukeEnv = require('../../nuke-env/lib/index.js');

var _nukeEnv2 = _interopRequireDefault(_nukeEnv);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isWeex = _nukeEnv2.default.isWeex;

var sliderNeighbor = function (_Component) {
    _inherits(sliderNeighbor, _Component);

    function sliderNeighbor(props) {
        _classCallCheck(this, sliderNeighbor);

        return _possibleConstructorReturn(this, (sliderNeighbor.__proto__ || Object.getPrototypeOf(sliderNeighbor)).call(this, props));
    }

    _createClass(sliderNeighbor, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                children = _props.children,
                showsPagination = _props.showsPagination,
                paginationStyle = _props.paginationStyle;

            var pagination = '';
            if (showsPagination !== 'false') {
                pagination = (0, _rax.createElement)('indicator', { style: [defaultStyle.indicator, paginationStyle || {}] });
            }
            if (isWeex) {
                var version = WXEnvironment.weexVersion.split('.');
                if (version[0] > 0 || version[0] == 0 && version[1] > 7 || version[0] == 0 && version[1] == 8 && version[2] >= 0) {
                    return (0, _rax.createElement)(
                        'slider-neighbor',
                        this.props,
                        children,
                        pagination
                    );
                } else {
                    return (0, _rax.createElement)(
                        'slider',
                        this.props,
                        children,
                        pagination
                    );
                }
            } else {
                return (0, _rax.createElement)(
                    _h2.default,
                    this.props,
                    children
                );
            }
        }
    }]);

    return sliderNeighbor;
}(_rax.Component);

var defaultStyle = {
    indicator: {
        width: '750rem',
        height: '10rem',
        position: 'absolute',
        itemColor: '#cccccc',
        itemSelectedColor: 'rgb(252, 81, 31)',
        itemSize: '10rem'
    }
};

exports.default = sliderNeighbor;
module.exports = exports['default'];