'use strict';

var _nukeEnv = require('../../../nuke-env/lib/index.js');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var isIOS = _nukeEnv.appInfo.platform.toLowerCase() === 'ios';

function vLoader() {
    if (arguments.length > 1 && isIOS) {
        return arguments[1];
    }
    return arguments[0];
}
function Variables() {
    var _switchVaribles;

    var wrapWidth = vLoader(68, 100);
    var wrapHeight = vLoader(28, 60);

    var wrapMargin = vLoader(0);
    var wrapPadding = vLoader(0);

    var wrapBorderRadius = vLoader(40);
    var wrapBorderWidth = vLoader(0, 2);
    var checkedBgColor = vLoader('#4FCEDB', '#00e158');
    var uncheckedBgColor = vLoader('#B1B1B1', '#ffffff');

    var checkedBorderColor = vLoader('transparent', '#00e158');
    var uncheckedBorderColor = vLoader('#dfdfdf');

    var checkedbBoxshadowColor = vLoader('#4FCEDB', '#00e158');
    var uncheckedBoxshadowColor = vLoader('#dfdfdf');

    var disabledCheckedBorderColor = vLoader('#1A9CB7', '#dfdfdf');
    var disabledCheckedBgColor = vLoader('rgba(34,31,31,0.26)', 'rgba(0,225,88,0.5)');
    var disabledUnCheckedBgColor = vLoader('rgba(34,31,31,0.26)', '#cccccc');

    var dotSize = vLoader(44, 60);
    var dotTop = vLoader((wrapHeight - dotSize) / 2, 0);
    var dotBgColor = vLoader('#EBEBEB', '#ffffff');
    var dotCheckedBgColor = vLoader('#009EB7', '#ffffff');
    var dotDisabledBgColor = vLoader('rgba(255,255,255,0.5)', '#ffffff');
    var switchVaribles = (_switchVaribles = {}, _defineProperty(_switchVaribles, 'wrap-width', wrapWidth), _defineProperty(_switchVaribles, 'wrap-height', wrapHeight), _defineProperty(_switchVaribles, 'wrap-border-radius', wrapBorderRadius), _defineProperty(_switchVaribles, 'wrap-border-width', wrapBorderWidth), _defineProperty(_switchVaribles, 'wrap-margin', wrapMargin), _defineProperty(_switchVaribles, 'wrap-padding', wrapPadding), _defineProperty(_switchVaribles, 'checked-bg-color', checkedBgColor), _defineProperty(_switchVaribles, 'checked-border-color', checkedBorderColor), _defineProperty(_switchVaribles, 'checked-boxshadow-color', checkedbBoxshadowColor), _defineProperty(_switchVaribles, 'unchecked-border-color', uncheckedBorderColor), _defineProperty(_switchVaribles, 'unchecked-bg-color', uncheckedBgColor), _defineProperty(_switchVaribles, 'unchecked-boxshadow-color', uncheckedBoxshadowColor), _defineProperty(_switchVaribles, 'disabled-checked-bg-color', disabledCheckedBgColor), _defineProperty(_switchVaribles, 'disabled-unchecked-bg-color', disabledUnCheckedBgColor), _defineProperty(_switchVaribles, 'disabled-checked-border-color', disabledCheckedBorderColor), _defineProperty(_switchVaribles, 'dot-size', dotSize), _defineProperty(_switchVaribles, 'dot-bg-color', dotBgColor), _defineProperty(_switchVaribles, 'dot-left', vLoader(-14, 0)), _defineProperty(_switchVaribles, 'dot-checked-bg-color', dotCheckedBgColor), _defineProperty(_switchVaribles, 'dot-transform', vLoader(48, 40)), _defineProperty(_switchVaribles, 'dot-top', dotTop), _defineProperty(_switchVaribles, 'dot-disabled-bg-color', dotDisabledBgColor), _switchVaribles);
    return switchVaribles;
}
module.exports = Variables;