'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeEnv = require('../../../nuke-env/lib/index.js');

var _styles = require('../styles/index.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* @jsx createElement */


var isIOS = _nukeEnv.appInfo.platform.toLowerCase() === 'ios';

var Switch = function (_Component) {
  _inherits(Switch, _Component);

  function Switch(props) {
    _classCallCheck(this, Switch);

    var _this = _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this, props));

    _this.handleClick = function (e) {
      if (_this.props.disabled) {
        return null;
      }
      var newVal = !_this.props.value;
      _this.props.onValueChange && _this.props.onValueChange.call(_this, newVal);
    };

    return _this;
  }

  _createClass(Switch, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          value = _props.value,
          disabled = _props.disabled,
          onValueChange = _props.onValueChange,
          others = _objectWithoutProperties(_props, ['style', 'value', 'disabled', 'onValueChange']);

      if (_nukeEnv.isWeex) {
        var nativeProps = {
          style: _extends({}, isIOS ? {} : { width: 95, height: 60 }, style),
          checked: value,
          disabled: disabled,
          onChange: function onChange(_ref) {
            var value = _ref.value;
            return onValueChange(value);
          }
        };

        return (0, _rax.createElement)('switch', _extends({}, others, nativeProps));
      } else {

        var wrapStyle = Object.assign({}, _styles2.default.wrap, value ? _styles2.default.checkedWrap : _styles2.default.uncheckedWrap, disabled ? _styles2.default.disabledWrap : {}, disabled ? _styles2.default['disabled' + (value ? 'Checked' : 'UnChecked') + 'Wrap'] : {}, style);
        var dotStyle = Object.assign({}, _styles2.default.dot, value ? _styles2.default.checkedDot : _styles2.default.uncheckedDot, disabled ? _styles2.default.disabledDot : {});

        return (0, _rax.createElement)(
          'span',
          _extends({ onClick: this.handleClick, style: wrapStyle }, others),
          (0, _rax.createElement)('small', { style: dotStyle })
        );
      }
    }
  }]);

  return Switch;
}(_rax.Component);

Switch.propTypes = {};
exports.default = Switch;
module.exports = exports['default'];