"use strict";
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeComponents = require('../../nuke-components/lib/index.js');

var _nukeListView = require('../../nuke-list-view/lib/index.js');

var _nukeListView2 = _interopRequireDefault(_nukeListView);

var _nukeSlider = require('../../nuke-slider/lib/index.js');

var _nukeSlider2 = _interopRequireDefault(_nukeSlider);

var _nukeIcon = require('../../nuke-icon/lib/index.js');

var _nukeIcon2 = _interopRequireDefault(_nukeIcon);

var _nukeBadge = require('../../nuke-badge/lib/index.js');

var _nukeBadge2 = _interopRequireDefault(_nukeBadge);

var _nukeDimensions = require('../../nuke-dimensions/lib/index.js');

var _nukeDimensions2 = _interopRequireDefault(_nukeDimensions);

var _pane = require('./pane.js');

var _pane2 = _interopRequireDefault(_pane);

var _styles = require('./styles.js');

var _styles2 = _interopRequireDefault(_styles);

var _util = require('./util.js');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WIDTH = 750;
var WINDOW_HEIGHT = _nukeDimensions2.default.get('window').height;

var TabSlider = function (_Component) {
  _inherits(TabSlider, _Component);

  function TabSlider(props) {
    _classCallCheck(this, TabSlider);

    var _this = _possibleConstructorReturn(this, (TabSlider.__proto__ || Object.getPrototypeOf(TabSlider)).call(this, props));

    _this.slideTo = function (index) {
      _this.refs.Slider.slideTo(index);
    };

    _this.state = {
      active: props.active || 0
    };
    return _this;
  }

  _createClass(TabSlider, [{
    key: 'sliderChange',
    value: function sliderChange(obj) {
      this.setState({
        active: obj.index
      });
      this.props.onChange(obj.index);
    }
    /**
     * [onPress 选中第几个tab,自动tab时可用]
     * @method onPress
     * @param  {[number]} index [tab索引]
     */

  }, {
    key: 'onPress',
    value: function onPress(index) {
      if (this.state.active !== index) {
        this.refs.Slider.slideTo(index);
      }
    }
    /**
     * [_renderBar 根据pane数量，render对应导航]
     * @method _renderBar
     * @param  {[object]}   state    [description]
     * @param  {[object]}   props    [description]
     * 逻辑：
     * 当不是自定义bar时= 均分显示
     * 当是自定义bar时=》不再设置导航宽度，只居中显示，选中效果由用户自己实现
     */

  }, {
    key: '_renderBar',
    value: function _renderBar(state, props) {
      var children = this.getFormatChildren(props.children);
      if (!props.customBar) {
        _styles2.default.navWrapStyle.width = 750 / children.length;
      }

      var barArray = [],
          that = this;

      children.forEach(function (child, index) {
        var iconSrc = child.icon && child.icon.src;
        var fontStyle = _styles2.default.navItemTitle;

        if (index == state.active) {
          fontStyle = Object.assign({}, _styles2.default.selectFontStyle);
          if (child.icon && child.icon.selected) {
            iconSrc = child.icon.selected;
          }
        }
        if (!props.customBar) barArray.push((0, _rax.createElement)(
          _nukeComponents.View,
          { style: _styles2.default.navWrapStyle },
          (0, _rax.createElement)(
            _nukeComponents.TouchableOpacity,
            { onPress: that.onPress.bind(that, index) },
            (0, _rax.createElement)(
              _nukeComponents.View,
              null,
              iconSrc ? (0, _rax.createElement)(_nukeIcon2.default, { size: 'medium', src: iconSrc, style: [_styles2.default.navItemIcon || {}] }) : null,
              (0, _rax.createElement)(
                _nukeComponents.Text,
                { style: fontStyle },
                child.title
              ),
              child.num && child.num > 0 ? (0, _rax.createElement)(_nukeBadge2.default, { count: child.num, style: [fontStyle, _styles2.default.navItemNum] }) : null
            )
          )
        ));else {
          barArray.push((0, _rax.createElement)(
            _nukeComponents.View,
            { style: ([_styles2.default.navWrapStyle], { alignItems: 'center', justifyContent: 'center' }) },
            child.renderTitleCustom()
          ));
        }
      });
      return barArray;
    }
  }, {
    key: '_renderPane',
    value: function _renderPane(children) {
      var paneArray = [];
      children.forEach(function (child) {
        paneArray.push((0, _rax.createElement)(
          _pane2.default,
          { style: child.style },
          child.children
        ));
      });
      return paneArray;
    }

    /**
     * [getFormatChildren 获取children，format 导航信息]
     * @method getFormatChildren
     * @param  {[type]}          children [description]
     */

  }, {
    key: 'getFormatChildren',
    value: function getFormatChildren(children) {
      var barArray = [];
      if (!children.length) barArray = [children.props];else children.forEach(function (child, index) {
        barArray.push(child.props);
      });
      return barArray;
    }

    // shouldComponentUpdate(){
    //     if(nextProps.active == this.props.active){
    //         return false;
    //     }
    //     return true;
    // }

    /*
    判断是否是自定义title
     */
    // componentWillMount(){
    //   const children = this.getFormatChildren(this.props.children);
    //   children.forEach((child)=>{
    //     if(child.renderTitleCustom){
    //       this.setState({
    //         customTitle:true
    //       })
    //       return false;
    //     }
    //   })
    // }

  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          index = _props.index,
          navTop = _props.navTop,
          width = _props.width,
          height = _props.height,
          style = _props.style,
          customBar = _props.customBar;


      var barItem = this.getFormatChildren(children);

      var barStyle = Object.assign({}, _styles2.default.navBar, style);

      if (!customBar) barStyle.width = WIDTH;

      var scollviewStyle = {
        width: 750,
        height: barStyle.height,
        display: 'flex',
        flexDirection: 'row'
      };
      var contentHeight = height ? height : WINDOW_HEIGHT - (barStyle.height ? _util2.default.deleteRem(barStyle.height) : 0);
      var barList = this._renderBar(this.state, this.props);
      return (0, _rax.createElement)(
        _nukeComponents.View,
        { style: { overflow: 'hidden' }, ref: 'TabSlider' },
        navTop ? (0, _rax.createElement)(
          _nukeComponents.ScrollView,
          { horizontal: true, showScrollbar: false, style: scollviewStyle, showsHorizontalScrollIndicator: false },
          barList
        ) : null,
        (0, _rax.createElement)(
          _nukeSlider2.default,
          { ref: 'Slider', width: width, height: contentHeight,
            autoplay: false,
            index: index,
            showsPagination: false,
            loop: 'false',
            autoplayTimeout: '3000',
            onChange: this.sliderChange.bind(this) },
          this._renderPane(this.getFormatChildren(children))
        ),
        !navTop ? (0, _rax.createElement)(
          _nukeComponents.View,
          { style: barStyle },
          (0, _rax.createElement)(
            _nukeComponents.ScrollView,
            { horizontal: true, showScrollbar: false, style: scollviewStyle, showsHorizontalScrollIndicator: false },
            barList
          )
        ) : null
      );
    }
  }]);

  return TabSlider;
}(_rax.Component);

TabSlider.propTypes = {
  active: _rax.PropTypes.active,
  navTop: _rax.PropTypes.boolean,
  width: _rax.PropTypes.number,
  height: _rax.PropTypes.number,
  customBar: _rax.PropTypes.boolean
};

TabSlider.defaultProps = {
  active: 0,
  navTop: false,
  width: 750,
  height: null,
  customBar: false
};

TabSlider.Pane = _pane2.default;

exports.default = TabSlider;
module.exports = exports['default'];