'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _item = require('./item.js');

var _item2 = _interopRequireDefault(_item);

var _animate = require('./animate.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var VISIBLE_ITEM_COUNT = 5;
var MAX_TOUCH_PATH_LENGTH = 20;
var VELOCITY_DETERMINE_PERIOD = 100;
var MILLISECONDS = 1000;
var MIN_VELOCITY = 50;
var VELOCITY_DECREASE_RATE = 0.9;
var BOUNCE_RESISTANCE = 0.5;
var BOUNCE_RESISTANCE_DISTANCE = 200; //px

function getComputedStyleHeight(el) {
    if (typeof window === 'undefined') {
        return 0;
    }
    return parseFloat(window.getComputedStyle((0, _rax.findDOMNode)(el)).height);
}

var PickerColumn = function (_Component) {
    _inherits(PickerColumn, _Component);

    function PickerColumn(props, context) {
        _classCallCheck(this, PickerColumn);

        var _this = _possibleConstructorReturn(this, (PickerColumn.__proto__ || Object.getPrototypeOf(PickerColumn)).call(this, props));

        var value = void 0;
        if (context.__picker__) {
            value = props.value;
        } else {
            if ('value' in props) {
                value = props.value;
            }
        }

        _this.state = {
            value: value,
            dataSource: _this.getDataSource(props)
        };

        _this.bound = null;

        _this.isTracking = false;
        _this.isDragging = false;
        _this.currentScrollTop = 0;
        _this.touchPath = []; //use to calculate move velocity

        ['onChange', 'swipeStart', 'swipeMove', 'swipeEnd'].forEach(function (m) {
            _this[m] = _this[m].bind(_this);
        });

        return _this;
    }

    _createClass(PickerColumn, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return {
                __column__: true,
                selectedValue: this.state.value
            };
        }
    }, {
        key: 'getDataSource',
        value: function getDataSource(props) {
            var start = props.start,
                end = props.end;

            var dataSource = [];
            for (var i = parseInt(start, 10); i <= parseInt(end, 10); i++) {
                if (i < 10) {
                    dataSource.push('0' + i.toString());
                } else {
                    dataSource.push(i.toString());
                }
            }
            return dataSource;
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps, nextContext) {
            if (nextContext.__picker__) {
                this.setState({
                    value: nextContext.selectedValue[nextProps.index],
                    dataSource: this.getDataSource(nextProps)
                });
            } else {
                if ('value' in nextProps) {
                    this.setState({
                        value: nextProps.value
                    });
                }
            }
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
            if (nextProps.dataSource !== this.props.dataSource || JSON.stringify(nextProps.dataSource) !== JSON.stringify(this.props.dataSource)) {
                this.changed = true;
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.componentDidUpdate();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {

            // calculate scroll content bound
            // inMatrix arg for config platform
            if (!this.bound || this.changed) {
                this.calculateBound();
            }

            // set scroll offset according to default value
            this.setScroll(this.state.value);

            this.changed = false;
        }
    }, {
        key: 'calculateBound',
        value: function calculateBound(props) {

            props = props || this.props;

            var indicator = this.refs.indicator;
            var _props = props,
                start = _props.start,
                end = _props.end;


            var top = void 0,
                bottom = void 0,
                itemHeight = void 0,
                length = void 0;
            var halfOfVisibleCount = Math.floor(VISIBLE_ITEM_COUNT / 2);
            itemHeight = getComputedStyleHeight(indicator);

            length = this.state.dataSource.length;

            bottom = itemHeight * halfOfVisibleCount;
            top = -itemHeight * (length - (VISIBLE_ITEM_COUNT - halfOfVisibleCount));

            this.bound = {
                top: top,
                bottom: bottom,
                itemHeight: itemHeight
            };
        }
    }, {
        key: 'setScroll',
        value: function setScroll(value) {
            var _bound = this.bound,
                itemHeight = _bound.itemHeight,
                bottom = _bound.bottom;


            var index = 0,
                item = void 0;
            if (typeof value === 'undefined') {
                value = dataSource[0];
            }

            for (var i = 0, l = this.state.dataSource.length; i < l; i++) {
                if (+this.state.dataSource[i] === +value) {
                    index = i;
                    item = this.state.dataSource[i];
                    break;
                }
            }

            if (this.context.__picker__) {
                this.context.onUpdate(item, this.props.index);
            }

            this.updateOffset(bottom - itemHeight * index);
        }
    }, {
        key: 'startAnimate',
        value: function startAnimate(stepFunc, callback, duration, easeFunc) {
            this.stopAnimate();
            return this.animateId = _animate.Animate.start(stepFunc, callback, duration, easeFunc);
        }
    }, {
        key: 'stopAnimate',
        value: function stopAnimate() {
            if (this.animateId) {
                _animate.Animate.stop(this.animateId);
                this.animateId = null;
            }
        }
    }, {
        key: 'isInBound',
        value: function isInBound(scrollTop) {
            var _bound2 = this.bound,
                top = _bound2.top,
                bottom = _bound2.bottom;


            if (scrollTop === undefined) {
                scrollTop = this.currentScrollTop;
            }

            return !(scrollTop > bottom || scrollTop < top);
        }
    }, {
        key: 'getBouncedDiff',
        value: function getBouncedDiff(scrollTop) {
            var _bound3 = this.bound,
                top = _bound3.top,
                bottom = _bound3.bottom;


            if (!this.isInBound(scrollTop)) {
                if (scrollTop > bottom) {
                    return scrollTop - bottom;
                }
                if (scrollTop < top) {
                    return scrollTop - top;
                }
            }

            return 0;
        }
    }, {
        key: 'setTransformStyle',
        value: function setTransformStyle(offset) {
            var content = this.refs.content;

            content = (0, _rax.findDOMNode)(content);
            if (content) {
                var style = 'translate(0, ' + offset + 'px)';
                //bug fix: avoid translate3d, bug in android 4.3
                content.style.WebkitTransform = style;
                content.style.transform = style;
            }
        }
    }, {
        key: 'setOffset',
        value: function setOffset(top) {
            this.currentScrollTop = top;
            this.setTransformStyle(top);
        }
    }, {
        key: 'updateOffset',
        value: function updateOffset(top, animation, callback, easeFunc) {
            var _this2 = this;

            var lastScrollTop = void 0,
                diff = void 0;

            if (animation) {
                lastScrollTop = this.currentScrollTop, diff = top - lastScrollTop;
                this.startAnimate(function (percent) {
                    _this2.setOffset(lastScrollTop + diff * percent);
                }, function () {
                    _this2.setOffset(top);
                    callback && callback();
                }, 200, easeFunc);
            } else {
                this.setOffset(top);
                callback && callback();
            }
        }
    }, {
        key: 'restrictScrollBound',
        value: function restrictScrollBound(scrollTop) {
            var _bound4 = this.bound,
                top = _bound4.top,
                bottom = _bound4.bottom;
            var max = Math.max,
                min = Math.min;


            return min(max(top, scrollTop), bottom);
        }

        // when touch move end or animation end,
        // adjust scrollTop value to stop by nearest picker item

    }, {
        key: 'stopBy',
        value: function stopBy() {
            var _this3 = this;

            var abs = Math.abs;

            var current = this.currentScrollTop,
                itemHeight = this.bound.itemHeight,
                remainder = current % itemHeight,
                multiple = parseInt(current / itemHeight, 10),
                stopBy = current;

            if (abs(remainder) >= itemHeight / 2) {
                // reserve the sign that represent scroll direction
                stopBy = remainder / abs(remainder) * (abs(multiple) + 1) * itemHeight;
            } else {
                stopBy = multiple * itemHeight;
            }
            stopBy = this.restrictScrollBound(stopBy);

            this.updateOffset(stopBy, false, function () {
                _this3.onChange();
            }, _animate.easeInOutQuad);
        }
    }, {
        key: 'swipeStart',
        value: function swipeStart(e) {

            e.preventDefault();

            var pageY = e.touches ? e.touches[0].pageY : e.clientY;

            this.isTracking = true;
            this.isDragging = false;
            this.touchPageY = pageY;
            this.lastScrollTop = this.currentScrollTop;

            this.touchPath = [{
                time: Date.now(),
                pageY: pageY
            }];

            this.stopAnimate();
        }
    }, {
        key: 'swipeMove',
        value: function swipeMove(e) {

            e.preventDefault();

            if (!this.isTracking) {
                return;
            }

            this.isDragging = true;

            var abs = Math.abs,
                max = Math.max,
                min = Math.min;

            var initPageY = this.touchPageY;
            var currentPageY = e.touches ? e.touches[0].pageY : e.clientY;

            var diff = currentPageY - initPageY;
            var currentScrollTop = this.lastScrollTop + diff;

            // bounce
            if (!this.isInBound(currentScrollTop)) {

                var bound = void 0,
                    bounce = void 0;

                //bounced diff
                diff = this.getBouncedDiff(currentScrollTop);
                bound = currentScrollTop - diff;

                //apply bounce resistance
                diff = min(max(-BOUNCE_RESISTANCE_DISTANCE, diff), BOUNCE_RESISTANCE_DISTANCE);
                bounce = diff * (1 - abs(diff) / (BOUNCE_RESISTANCE_DISTANCE * 2));

                currentScrollTop = bound + bounce;
            }

            this.updateOffset(currentScrollTop);

            // record move path
            this.touchPath.push({
                time: Date.now(),
                pageY: currentPageY
            });

            // restrict length
            if (this.touchPath.length > MAX_TOUCH_PATH_LENGTH) {
                this.touchPath = this.touchPath.slice(MAX_TOUCH_PATH_LENGTH / 2);
            }
        }
    }, {
        key: 'swipeEnd',
        value: function swipeEnd(e) {
            var _this4 = this;

            e.preventDefault();

            // Ignore event when tracking is not enabled (event might be outside of element)
            if (!this.isDragging) {
                return;
            }

            var abs = Math.abs;

            // velocity calculation

            var lastTouchTime = Date.now();
            var startPos = this.touchPath.length - 1;

            var endPos = startPos;
            var timeDiff = 0,
                velocity = 0;

            for (var i = startPos - 1; i >= 0 && timeDiff < VELOCITY_DETERMINE_PERIOD; i--) {
                var position = this.touchPath[i];
                timeDiff = lastTouchTime - position.time;
                endPos = i;
            }

            if (startPos !== endPos) {
                var firstPageY = this.touchPath[endPos].pageY;
                var lastPageY = this.touchPath[startPos].pageY;

                velocity = (lastPageY - firstPageY) / timeDiff * MILLISECONDS;
            }

            if (abs(velocity) > MIN_VELOCITY) {
                var animateId = this.startAnimate(function (percent, timeDiff, timeFrame) {
                    var currentScrollTop = _this4.currentScrollTop;

                    velocity *= VELOCITY_DECREASE_RATE;

                    // bounce
                    if (!_this4.isInBound(currentScrollTop)) {
                        velocity *= BOUNCE_RESISTANCE;
                    }

                    var diff = velocity * timeFrame / MILLISECONDS;

                    _this4.setOffset(currentScrollTop + diff);
                    if (abs(velocity) < MIN_VELOCITY) {
                        _animate.Animate.stop(animateId);
                        _this4.stopBy();
                    }
                });
            } else {
                this.stopBy();
            }

            this.isTracking = false;
            this.isDragging = false;
        }
    }, {
        key: 'setValue',
        value: function setValue(value) {
            if (!('value' in this.props)) {
                this.setState({
                    value: value
                });
            }
        }
    }, {
        key: 'getValue',
        value: function getValue() {
            return this.state.value;
        }
    }, {
        key: 'onChange',
        value: function onChange(e) {

            var scrollTop = this.currentScrollTop;
            var _bound5 = this.bound,
                bottom = _bound5.bottom,
                itemHeight = _bound5.itemHeight;

            var itemIndex = parseInt((bottom - scrollTop) / itemHeight, 10);
            var index = this.props.index;


            var value = void 0,
                item = void 0;

            item = this.state.dataSource[itemIndex];
            value = item;

            if (value === this.state.value) {
                return;
            }

            if (this.context.__picker__) {
                this.context.onChange(value, item, index);
            } else {
                this.setValue(value);
                this.props.onChange(value, item);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var value = this.state.value;
            var _props2 = this.props,
                _props2$style = _props2.style,
                style = _props2$style === undefined ? {} : _props2$style,
                _props2$prefix = _props2.prefix,
                prefix = _props2$prefix === undefined ? this.defaultPrefix : _props2$prefix;

            var klsStyle = Object.assign({}, _styles2.default['column']);

            var content = [];
            for (var i = 0; i < this.state.dataSource.length; i++) {
                content.push((0, _rax.createElement)(
                    _item2.default,
                    { key: i, value: this.state.dataSource[i] },
                    i
                ));
            }

            return (0, _rax.createElement)(
                _nukeView2.default,
                { x: 'column-item', style: [klsStyle, style],
                    onMouseDown: this.swipeStart, onMouseMove: this.swipeMove,
                    onMouseUp: this.swipeEnd, onMouseLeave: this.swipeEnd,
                    onTouchStart: this.swipeStart, onTouchMove: this.swipeMove,
                    onTouchEnd: this.swipeEnd, onTouchCancel: this.swipeEnd },
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { ref: 'content', x: 'column-item-scroll', style: _styles2.default['column-scroll'] },
                    content
                ),
                (0, _rax.createElement)(_nukeView2.default, { x: 'column-item-mask', style: _styles2.default['column-mask'] }),
                (0, _rax.createElement)(_nukeView2.default, { x: 'column-item-indicator', ref: 'indicator', style: _styles2.default['column-indicator'] })
            );
        }
    }]);

    return PickerColumn;
}(_rax.Component);

PickerColumn.propTypes = {
    value: _rax.PropTypes.any,
    dataSource: _rax.PropTypes.array,
    onChange: _rax.PropTypes.func
};
PickerColumn.defaultProps = {
    selectedKey: null,
    dataSource: [],
    onChange: noop
};
PickerColumn.contextTypes = {
    onUpdate: _rax.PropTypes.func,
    onChange: _rax.PropTypes.func,
    __picker__: _rax.PropTypes.bool,
    selectedValue: _rax.PropTypes.any
};
PickerColumn.childContextTypes = {
    __column__: _rax.PropTypes.bool,
    selectedValue: _rax.PropTypes.any
};
exports.default = PickerColumn;
module.exports = exports['default'];