'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('../../../nuke-view/lib/index.js');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('../../../nuke-text/lib/index.js');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeSlip = require('../../../nuke-slip/lib/index.js');

var _nukeSlip2 = _interopRequireDefault(_nukeSlip);

var _column = require('./column.js');

var _column2 = _interopRequireDefault(_column);

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var TimePicker = function (_Component) {
    _inherits(TimePicker, _Component);

    function TimePicker(props) {
        _classCallCheck(this, TimePicker);

        var _this = _possibleConstructorReturn(this, (TimePicker.__proto__ || Object.getPrototypeOf(TimePicker)).call(this, props));

        var visible = void 0,
            value = void 0,
            dateEnd = void 0; // dateEnd 用于解决年、月改变时，日期最大值的问题。

        if ('visible' in props) {
            visible = props.visible;
        } else {
            visible = props.defaultVisible;
        }

        value = _this.getValueArray(props['default'], props.type);
        dateEnd = _this.getDateEnd(value, props.type);

        _this.state = {
            value: value,
            visible: visible,
            dateEnd: dateEnd,
            rangeStart: _this.getValueArray(_this.getRange().rangeStart, props.type, true),
            rangeEnd: _this.getValueArray(_this.getRange().rangeEnd, props.type, true)
        };

        _this.items = [];
        _this.columns = null; // calculate at some time

        ['onDone', 'onCancel', 'onClose', 'onChange', 'onUpdate', 'onVisibleChange', 'afterOpen', 'afterClose'].forEach(function (m) {
            _this[m] = _this[m].bind(_this);
        });
        return _this;
    }

    _createClass(TimePicker, [{
        key: 'getChildContext',
        value: function getChildContext() {
            return {
                __picker__: true,
                onUpdate: this.onUpdate,
                onChange: this.onChange,
                selectedValue: this.state.value
            };
        }
    }, {
        key: 'getValueArray',
        value: function getValueArray(value, type, outputIsNumber) {
            var defaultDate = void 0,
                year = void 0,
                month = void 0,
                date = void 0,
                hour = void 0,
                minite = void 0,
                second = void 0,
                arr = [];
            if (type === 'time') {
                var now = new Date();
                defaultDate = value ? new Date(now.getFullYear().toString() + '/' + (now.getMonth() + 1).toString() + '/' + now.getDate().toString() + ' ' + value) : new Date(now.getFullYear().toString() + '/' + (now.getMonth() + 1).toString() + '/' + now.getDate().toString());
            } else {
                if (value) {
                    defaultDate = new Date(value.replace(/-/g, '/'));
                } else if (this.props.range && this.props.range[0]) {
                    //优先取range[0],如果没有range 再取今天
                    defaultDate = new Date(this.props.range[0].replace(/-/g, '/'));
                } else {
                    defaultDate = new Date();
                }
            }
            try {
                if (outputIsNumber) {
                    year = defaultDate.getFullYear();
                    month = defaultDate.getMonth() + 1;
                    date = defaultDate.getDate();
                    hour = defaultDate.getHours();
                    minite = defaultDate.getMinutes();
                    second = defaultDate.getSeconds();
                } else {
                    year = this.getValueString(defaultDate.getFullYear());
                    month = this.getValueString(defaultDate.getMonth() + 1);
                    date = this.getValueString(defaultDate.getDate());
                    hour = this.getValueString(defaultDate.getHours());
                    minite = this.getValueString(defaultDate.getMinutes());
                    second = this.getValueString(defaultDate.getSeconds());
                }

                if (type === 'date') {

                    arr = [year, month, date];
                } else if (type === 'time') {

                    arr = [hour, minite, second];
                } else {

                    arr = [year, month, date, hour, minite, second];
                }
            } catch (e) {}
            return arr;
        }
        /**
         * 根据当前column的index 获取 当前一列的range
         * @param  {[type]} index [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'getRealRangeByValue',
        value: function getRealRangeByValue(index) {
            var _state = this.state,
                rangeStart = _state.rangeStart,
                rangeEnd = _state.rangeEnd,
                value = _state.value;

            var defaultValue = void 0,
                rangeStartValue = void 0,
                rangeEndValue = void 0;
            if (index === 0) {
                return [rangeStart[0], rangeEnd[0]];
            } else if (index === 1) {

                defaultValue = value[0];
                rangeStartValue = rangeStart.slice(0, 2);
                rangeEndValue = rangeEnd.slice(0, 2);
                var minEnd = this.getMinDate(rangeEndValue.join('/') + '/' + this.getDateEndByDate(rangeEndValue), defaultValue + '/12/31 23:59:59');
                var maxStart = this.getMaxDate(rangeStartValue.join('/'), defaultValue + '/01/01');
                return [new Date(maxStart).getMonth() + 1, new Date(minEnd).getMonth() + 1];
            } else if (index === 2) {
                defaultValue = value.slice(0, 2);
                rangeStartValue = rangeStart.slice(0, 3);
                rangeEndValue = rangeEnd.slice(0, 3);
                var minEnd = this.getMinDate(rangeEndValue.join('/'), defaultValue.join('/') + '/' + this.getDateEndByDate(defaultValue) + ' 23:59:59');
                var maxStart = this.getMaxDate(rangeStartValue.join('/'), defaultValue.join('/') + '/01');
                return [new Date(maxStart).getDate(), new Date(minEnd).getDate()];
            }
        }
    }, {
        key: 'getMinDate',
        value: function getMinDate(val1, val2) {
            var d1 = new Date(val1).getTime();
            var d2 = new Date(val2).getTime();
            return d1 > d2 ? val2 : val1;
        }
    }, {
        key: 'getMaxDate',
        value: function getMaxDate(val1, val2) {
            var d1 = new Date(val1).getTime();
            var d2 = new Date(val2).getTime();
            return d1 > d2 ? val1 : val2;
        }
    }, {
        key: 'getDateEnd',
        value: function getDateEnd(value, type) {
            if (type === 'time') return -1;
            var year,
                month,
                maxDate,
                dateEnd = 31;
            year = +value[0];
            month = +value[1];
            if (month === 12) return dateEnd;
            maxDate = new Date(+new Date(year + '/' + (month + 1) + '/' + '01') - 24 * 60 * 60 * 1000);
            dateEnd = maxDate.getDate();

            return dateEnd;
        }
    }, {
        key: 'getDateEndByDate',
        value: function getDateEndByDate(val) {
            var year,
                month,
                maxDate,
                dateEnd = 31;
            year = +val[0];
            month = +val[1];
            if (month === 12) return dateEnd;
            maxDate = new Date(+new Date(year + '/' + (month + 1) + '/' + '01') - 24 * 60 * 60 * 1000);
            dateEnd = maxDate.getDate();

            return dateEnd;
        }
    }, {
        key: 'getItemRange',
        value: function getItemRange(value, index) {}
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // controlled component
            // sync state from props
            if ('visible' in nextProps) {
                this.setState({
                    visible: nextProps.visible
                });
            }

            if ('value' in nextProps) {
                this.setState({
                    value: nextProps.value
                });
            }
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
            if (nextState.value !== this.state.value || nextProps.dataSource !== this.props.dataSource || JSON.stringify(nextState.value) !== JSON.stringify(this.state.value) || JSON.stringify(nextProps.dataSource) !== JSON.stringify(this.props.dataSource)) {
                this.changed = true;
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            this.changed = false;
        }
    }, {
        key: 'show',
        value: function show() {
            if (!('visible' in this.props)) {
                this.setState({
                    visible: true
                });
            }
        }
    }, {
        key: 'hide',
        value: function hide() {
            if (!('visible' in this.props)) {
                this.setState({
                    visible: false
                });
            }
        }
    }, {
        key: 'setVisible',
        value: function setVisible(visible, cb) {

            if (this.state.visible === visible) {
                return;
            }

            var callback = this.props['' + cb];

            for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
                args[_key - 2] = arguments[_key];
            }

            if (!('visible' in this.props)) {
                if (callback.apply(null, args) !== false) {
                    this.setState({ visible: visible });
                }
            } else {
                callback.apply(null, args);
            }
        }
    }, {
        key: 'onDone',
        value: function onDone(e) {
            this.setVisible(false, 'onDone', this.state.value, this.items, e);
        }
    }, {
        key: 'onCancel',
        value: function onCancel(e) {
            this.setVisible(false, 'onCancel', e);
        }
    }, {
        key: 'onClose',
        value: function onClose(e) {
            this.setVisible(false, 'onClose', e);
        }
    }, {
        key: 'onUpdate',
        value: function onUpdate(item, index) {
            this.items[index] = item;
        }
    }, {
        key: 'onChange',
        value: function onChange(v, item, i) {
            var items = this.items;
            var value = this.state.value;


            var newValue = void 0,
                newItems = void 0;

            var _props = this.props,
                dataSource = _props.dataSource,
                onChange = _props.onChange;


            newValue = value;
            newValue[i] = v;

            newItems = items;
            newItems[i] = item;
            if (!('value' in this.props)) {
                //日期联动
                var data = {
                    value: newValue
                };
                var dateEnd = -1;
                if (i <= 1 && (this.props.type === 'date' || this.props.type === 'datetime')) {

                    data['dateEnd'] = this.getDateEnd(newValue, this.props.type);
                    if (newValue[2] > data['dateEnd']) {
                        // 如果日期比最大值大，默认回到最大值
                        newValue[2] = this.getValueString(data['dateEnd']);
                    }
                    this.setState(data);
                } else {
                    this.setState(data);
                }
            } else {
                // cascade data normalize value
                onChange(newValue, newItems);
            }
        }
    }, {
        key: 'onVisibleChange',
        value: function onVisibleChange(visible) {
            this.setVisible(visible, 'onVisibleChange', visible);
        }
    }, {
        key: 'afterOpen',
        value: function afterOpen() {
            this.props.afterOpen(this);
        }
    }, {
        key: 'afterClose',
        value: function afterClose() {
            this.props.afterClose();
        }
    }, {
        key: 'getValueString',
        value: function getValueString(value) {
            if (parseInt(value, 10) < 10) {
                return '0' + parseInt(value, 10).toString();
            } else {
                return parseInt(value, 10).toString();
            }
        }
    }, {
        key: 'getRange',
        value: function getRange() {
            var range = this.props.range ? this.props.range : ['1970-01-01 00:00:00', '2099-12-31 23:59:59'];

            return {
                rangeStart: range[0],
                rangeEnd: range[1]
            };
        }
    }, {
        key: 'getPickerEl',
        value: function getPickerEl() {
            var _props2 = this.props,
                hasToolbar = _props2.hasToolbar,
                title = _props2.title,
                type = _props2.type,
                range = _props2.range,
                _props2$style = _props2.style,
                style = _props2$style === undefined ? {} : _props2$style;
            var _state2 = this.state,
                value = _state2.value,
                dateEnd = _state2.dateEnd;
            // const rangeStart, rangeEnd = this.getRange();

            var klsStyle = Object.assign({}, _styles2.default['time-picker']);

            var _props3 = this.props,
                toolbar = _props3.toolbar,
                children = _props3.children;

            var columns = this.columns;

            if (toolbar === undefined) {
                toolbar = (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: _styles2.default['toolbar-inner'] },
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['cancel'], onClick: this.onCancel },
                        '\u53D6\u6D88'
                    ),
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['title'] },
                        title
                    ),
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: _styles2.default['done'], onClick: this.onDone },
                        '\u786E\u5B9A'
                    )
                );
            }

            var content = [];
            if (type === 'date') {
                var year = void 0,
                    month = void 0,
                    date = void 0,
                    yearRange = void 0,
                    monthRange = void 0,
                    dateRange = void 0;
                year = value[0];

                month = value[1];

                date = value[2];
                yearRange = this.getRealRangeByValue(0);
                monthRange = this.getRealRangeByValue(1);
                dateRange = this.getRealRangeByValue(2);
                content.push((0, _rax.createElement)(_column2.default, { start: yearRange[0], end: yearRange[1], value: year, index: 0 }));
                content.push((0, _rax.createElement)(_column2.default, { start: monthRange[0], end: monthRange[1], value: month, index: 1 }));
                content.push((0, _rax.createElement)(_column2.default, { start: dateRange[0], end: dateRange[1], value: date, index: 2 }));
            } else if (type === 'time') {
                var hour = void 0,
                    minite = void 0,
                    second = void 0;
                hour = value[0];
                minite = value[1];
                second = value[2];
                content.push((0, _rax.createElement)(_column2.default, { start: 0, end: 23, value: hour, index: 0 }));
                content.push((0, _rax.createElement)(_column2.default, { start: 0, end: 59, value: minite, index: 1 }));
                content.push((0, _rax.createElement)(_column2.default, { start: 0, end: 59, value: second, index: 2 }));
            } else {
                var _year = void 0,
                    _month = void 0,
                    _date = void 0,
                    _hour = void 0,
                    _minite = void 0,
                    _second = void 0,
                    _yearRange = void 0,
                    _monthRange = void 0,
                    _dateRange = void 0;
                _year = value[0];
                _month = value[1];
                _date = value[2];
                _hour = value[3];
                _minite = value[4];
                _second = value[5];
                _yearRange = this.getRealRangeByValue(0);
                _monthRange = this.getRealRangeByValue(1);
                _dateRange = this.getRealRangeByValue(2);
                content.push((0, _rax.createElement)(_column2.default, { start: _yearRange[0], end: _yearRange[1], value: _year, index: 0 }));
                content.push((0, _rax.createElement)(_column2.default, { start: _monthRange[0], end: _monthRange[1], value: _month, index: 1 }));
                content.push((0, _rax.createElement)(_column2.default, { start: _dateRange[0], end: _dateRange[1], value: _date, index: 2 }));
                content.push((0, _rax.createElement)(_column2.default, { start: 0, end: 23, value: _hour, index: 3 }));
                content.push((0, _rax.createElement)(_column2.default, { start: 0, end: 59, value: _minite, index: 4 }));
                content.push((0, _rax.createElement)(_column2.default, { start: 0, end: 59, value: _second, index: 5 }));
            }

            return (0, _rax.createElement)(
                _nukeView2.default,
                { style: [klsStyle, style] },
                hasToolbar ? (0, _rax.createElement)(
                    _nukeView2.default,
                    { style: _styles2.default['toolbar'] },
                    toolbar
                ) : null,
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { x: 'picker-content', style: _styles2.default['content'] },
                    content
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var visible = this.state.visible;
            var _props4 = this.props,
                trigger = _props4.trigger,
                inline = _props4.inline,
                _props4$style = _props4.style,
                style = _props4$style === undefined ? {} : _props4$style;


            var picker = null;

            // this.inited = this.inited || visible;

            // if (this.inited) {
            picker = this.getPickerEl();
            // }
            // return picker;
            // if (visible ) {
            //     return picker;
            // } else {
            // picker = (
            return (0, _rax.createElement)(
                _nukeSlip2.default,
                { style: { zIndex: style.zIndex }, visible: visible, direction: 'bottom', animation: true, depth: 'auto', title: false,
                    afterOpen: this.afterOpen, afterClose: this.afterClose },
                picker
            );
            // );
            // return picker;
            // }

        }
    }]);

    return TimePicker;
}(_rax.Component);

// for cascade data，default key: children


TimePicker.propTypes = {
    title: _rax.PropTypes.node,
    value: _rax.PropTypes.array,
    visible: _rax.PropTypes.bool,
    trigger: _rax.PropTypes.element,

    selectedKey: _rax.PropTypes.array,
    defaultVisible: _rax.PropTypes.bool,

    inline: _rax.PropTypes.bool,
    toolbar: _rax.PropTypes.node,
    hasToolbar: _rax.PropTypes.bool,
    dataSource: _rax.PropTypes.array,

    onDone: _rax.PropTypes.func,
    onCancel: _rax.PropTypes.func,
    onClose: _rax.PropTypes.func,

    onChange: _rax.PropTypes.func,
    afterOpen: _rax.PropTypes.func,
    afterClose: _rax.PropTypes.func,
    onVisibleChange: _rax.PropTypes.func,

    childrenMap: _rax.PropTypes.func
};
TimePicker.defaultProps = {
    dataSource: [],
    selectedKey: '',
    defaultVisible: false,

    inline: false,
    hasToolbar: true,

    title: '',
    trigger: null,

    // locale: i18nMap['en-us'],

    onChange: noop,
    onDone: noop,
    onCancel: noop,
    onClose: noop,
    afterOpen: noop,
    afterClose: noop,
    onVisibleChange: noop,

    childrenMap: childrenMap
};
TimePicker.childContextTypes = {
    onUpdate: _rax.PropTypes.func,
    onChange: _rax.PropTypes.func,
    __picker__: _rax.PropTypes.bool,
    selectedValue: _rax.PropTypes.array
};
function childrenMap(item) {
    if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object') {
        return item.children;
    }
}

exports.default = TimePicker;
module.exports = exports['default'];