'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = stringFormat;
function stringFormat(date) {
    var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'datetime';
    var spliter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '/';


    var yyyy = date.getFullYear();
    var mm = date.getMonth() < 9 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1; // getMonth() is zero-based
    var dd = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();
    var hh = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
    var min = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
    var ss = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();
    if (type === 'time') {
        return hh + ':' + min + ':' + ss;
    } else if (type === 'date') {
        return yyyy + spliter + mm + spliter + dd;
    } else {
        return yyyy + spliter + mm + spliter + dd + ' ' + hh + ':' + min + ':' + ss;
    }
}
module.exports = exports['default'];