# ActionSheet

- category: UI
- chinese: 弹出菜单
- type: UI组件

---

## 何时使用

ActionSheet 定义一组动作菜单，使用者在菜单中选择一项，或取消不做操作。


## API
### ActionSheet.show(params,onNotify,afterOpen,onFail)

ActionSheet 组件采用静态方法形式调用。

```js
ActionSheet.show(params,onNotify,afterOpen,onFail)
```


### params
params 对象包含下面几个基本属性


属性 | 说明 | 类型 | 默认值
-----|-----|-----|------
title | 标题 | string | 无
options | 菜单数组  | array | 无
cancelButtonIndex| cancelButton在options中的index |num|无
destructiveButtonIndex| destructiveButton在options中的index |num|无



- destructiveButton

    destructiveButton 是指在一系列菜单项中唯一的一个具有危险性、不可恢复性操作的按钮，按照ios的设计规范，这个按钮在 ActionSheet 中最多只能有1个，并且排列在列表倒数第二项。
    ```js
    {
        options: ['拨打电话','发送短信','删除订单','取消'],
        cancelButtonIndex: 3,
        destructiveButtonIndex: 2,
        title:'ActionSheet Title'
    }
    ```
 **建议把 destructiveButtonIndex 与 cancelButtonIndex 分别放在数组倒数第二项和倒数第一项。**


- cancelButton

 cancelButton 在 iOS 和 Android 2 端展现方式不同。

 在 iOS 端作为取消按钮，排列在列表最后一项，在安卓端不展示。

### onNotify 回调

 点击菜单项或取消按钮的回调，具有以下几种类型

 - `{ type : "cancel"}`

 - `{ type : "button",buttonIndex : 1/2/3 }`

 - `{ type : "destructive"}`

### afterOpen 成功渲染菜单的回调

### onFail 渲染菜单失败的回调
