'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.show = show;
exports.hide = hide;

var _rax = require('rax');

var _actionSheet = require('./action-sheet');

var _actionSheet2 = _interopRequireDefault(_actionSheet);

var _nukeEnv = require('nuke-env');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var noop = function noop() {};

var defaultOptions = {
    title: '',
    onFail: noop,
    afterOpen: noop,
    afterClose: noop,
    onNotify: noop
};

var ActionSheetInstance = void 0,
    container = void 0;

function show() {
    var paramOptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var onNotify = arguments[1];
    var afterOpen = arguments[2];
    var onFail = arguments[3];


    paramOptions = _extends({}, defaultOptions, paramOptions);
    afterOpen = afterOpen || noop;
    onNotify = onNotify || noop;
    var afterClose = noop;

    var _paramOptions = paramOptions,
        title = _paramOptions.title,
        options = _paramOptions.options,
        cancelButtonIndex = _paramOptions.cancelButtonIndex,
        destructiveButtonIndex = _paramOptions.destructiveButtonIndex,
        others = _objectWithoutProperties(_paramOptions, ['title', 'options', 'cancelButtonIndex', 'destructiveButtonIndex']);

    if (_nukeEnv.isWeex) {
        var nativeActionSheet = require('@weex-module/qapactionsheet');

        nativeActionSheet.show({
            options: options,
            cancelButtonIndex: cancelButtonIndex,
            destructiveButtonIndex: destructiveButtonIndex,
            title: title
        }, function (ret) {
            afterOpen && afterOpen(ret);
        }, function (err) {
            onFail && onFail(err);
        }, function (info) {
            onNotify && onNotify(info);
        });
    } else {
        var onFailCallback = function onFailCallback(e) {
            onFail(e);
        };

        var afterOpenCallback = function afterOpenCallback(d) {
            afterOpen(d);
        };

        var afterCloseCallback = function afterCloseCallback() {
            (0, _rax.unmountComponentAtNode)(container);

            document.body.removeChild(container);
            container = component = null;
            afterClose();
        };

        var onNotifyCallback = function onNotifyCallback(d) {
            onNotify && onNotify(d);
        };

        var component = (0, _rax.createElement)(_actionSheet2.default, _extends({}, others, { defaultVisible: true, title: title,
            afterOpen: afterOpenCallback, afterClose: afterCloseCallback, onFail: onFailCallback, onNotify: onNotifyCallback, options: options, cancelButtonIndex: cancelButtonIndex, destructiveButtonIndex: destructiveButtonIndex }));

        container = document.getElementById('_nuke_wrap');
        if (!container) {
            container = document.createElement('div');
            container.setAttribute("id", '_nuke_wrap');
            document.body.appendChild(container);
            container = document.getElementById('_nuke_wrap');
        }

        (0, _rax.render)(component, (0, _rax.findDOMNode)(container), function () {
            ActionSheetInstance = this;
        });
    }
};

function hide() {
    if (_nukeEnv.isWeex) {
        // native 暂不支持
        // let NativeActionSheet = require('@weex-module/qapactionsheet');
        // nativeActionSheet.hide();
    } else {

        if (ActionSheetInstance) {
            ActionSheetInstance.hide();
        }
    }
}