
/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Button from 'nuke-button';
import ActionSheet from 'nuke-action-sheet';
import Page from 'nuke-page';

class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            data:null
        }
    }
    press = () => {
        ActionSheet.show({
            options: ['拨打电话','发送短信','删除订单','取消'],
            cancelButtonIndex: 3,
            destructiveButtonIndex: 2,
            title:'ActionSheet Title'
        }, (notify)=>{
            //{ type : "cancel"}
            //{ type : "button",buttonIndex : 1/2/3 }
            //{ type : "destructive"}
            // console.log(JSON.stringify(notify));
            this.setState({
                data:JSON.stringify(notify)
            });
        }, (ret) => {
            console.log('action sheet showed');
        }, (fail) => {

        });
       
    }
    render() {
        return (
            <Page title="ActionSheet">
                <Page.Intro main="静态调用"></Page.Intro>
                <View style={styles.result}>
                    {this.state.data ? <Text style={styles.resultText}>{this.state.data}</Text> :null}
                </View>
                <View style={styles.btns}>
                    <Button onPress={this.press} block="true" type="primary">点击打开</Button>
                </View>
            </Page>
        );
    }
}
const styles = {
    result : {
        height:'480rem',
        margin:'30rem',
        padding:'10rem',
        backgroundColor:'#ffffff',
        justifyContent:'center',
        alignItems:'center'
    },
    resultText : {
        fontSize:'28rem'
    },
    btns:{
        margin:'30rem',
    }
}
render(<NukeDemoIndex/>);
