/* @jsx createElement */
import {createElement, Component, render} from 'rax';
import Animated from 'nuke-animated';

class AnimatedSample extends Component {
  constructor(){
    super();
    this.state = {
      bounceValue: new Animated.Value(0),
    };
  }

  render() {
    return (
      <Animated.Image
        source={{uri: 'https://gw.alicdn.com/tps/TB1km2SOpXXXXb6aXXXXXXXXXXX-608-336.png'}}
        style={{
          flex: 1,
          width:400,
          height:400,
          transform: [
            {scale: this.state.bounceValue},
          ]
        }}
      />
    );
  }

  componentDidMount() {
    this.state.bounceValue.setValue(1.5);     // Start large
    Animated.spring(                          // Base: spring, decay, timing
      this.state.bounceValue,                 // Animate `bounceValue`
      {
        toValue: 0.8,                         // Animate to smaller size
        friction: 1,                          // Bouncier spring
      }
    ).start();                                // Start the animation
  }
}

render(<AnimatedSample />);
