/** @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Badge = function (_Component) {
  _inherits(Badge, _Component);

  function Badge() {
    _classCallCheck(this, Badge);

    return _possibleConstructorReturn(this, (Badge.__proto__ || Object.getPrototypeOf(Badge)).apply(this, arguments));
  }

  _createClass(Badge, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          max = _props.max,
          count = _props.count,
          type = _props.type,
          children = _props.children,
          _props$style = _props.style,
          style = _props$style === undefined ? {} : _props$style,
          others = _objectWithoutProperties(_props, ['max', 'count', 'type', 'children', 'style']);

      var sup = count,
          hidden = false;

      sup = Number(count);

      if (!isNaN(sup)) {
        sup = sup > max ? max + '+' : count;
        (sup === 0 || sup === '0') && (hidden = true);
      } else {
        sup = count; // for string
      }

      var wrapStyle = Object.assign({}, _styles2.default['badge'], _styles2.default[type + '-span'], sup ? _styles2.default['number-span'] : _styles2.default['dot-span'], _styles2.default['standalone-span'], style);
      var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight'];
      var inheritStyle = {};
      TextAttrArr.forEach(function (item) {
        if (wrapStyle[item]) {
          inheritStyle[item] = wrapStyle[item];
        }
      });
      var textStyle = Object.assign({}, _styles2.default['span'], sup ? null : _styles2.default['dot-span'], inheritStyle);
      return (0, _rax.createElement)(
        _nukeView2.default,
        _extends({}, others, { style: wrapStyle }),
        !hidden ? (0, _rax.createElement)(
          _nukeText2.default,
          { style: textStyle },
          sup
        ) : null
      );
    }
  }]);

  return Badge;
}(_rax.Component);

Badge.propTypes = {
  max: _rax.PropTypes.number,
  count: _rax.PropTypes.oneOfType([_rax.PropTypes.number, _rax.PropTypes.string]),
  type: _rax.PropTypes.oneOf(['normal', 'unread'])
};
Badge.defaultProps = {
  max: 99,
  count: '',
  type: 'normal'
};
exports.default = Badge;
module.exports = exports['default'];