/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Touchable from 'nuke-touchable';
import ScrollView from 'nuke-scroll-view';
import Icon from 'nuke-icon';
import Badge from 'nuke-badge';


let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
    }

    render() {
        return (
            <ScrollView>
                <View style={styles.st}><Text style={styles.stText}>使用绝对定位设置显示位置</Text></View>
                <View style={{padding:'20rem',position:'relative'}}>
                    <Text style={{fontSize:'30rem'}}>您有新消息</Text>
                    <Badge style={{position:'absolute',top:'20rem',left:'200rem'}} count={722} max={222}></Badge>
                </View>
                <View style={styles.st}><Text style={styles.stText}>type 为unread</Text></View>
                <View style={{padding:'30rem',position:'relative'}}>
                    <Text style={{fontSize:'30rem'}}>您有新消息</Text>
                    <Badge type="unread" style={{position:'absolute',top:'20rem',left:'200rem'}} count={722} max={222}></Badge>
                </View>
                <View style={styles.st}><Text style={styles.stText}>自定义颜色</Text></View>
                <View style={{padding:'30rem',position:'relative'}}>
                    <Text style={{fontSize:'30rem'}}>您有新消息</Text>
                    <Badge style={{backgroundColor:'#ff6600',position:'absolute',top:'20rem',left:'200rem'}} count={722} max={222}></Badge>
                </View>
                <View style={styles.st}><Text style={styles.stText}>超过N，显示为N+</Text></View>
                <View style={{padding:'30rem',position:'relative'}}>
                    <Text style={{fontSize:'30rem'}}>显示为99</Text>
                    <Badge style={{position:'absolute',top:'20rem',left:'200rem'}} count={100} max={99}>
                        <View style={styles.badgeBlock}></View>
                    </Badge>
                </View>
                <View style={styles.st}><Text style={styles.stText}>讨嫌的小红点</Text></View>
                <View style={{padding:'30rem',position:'relative'}}>
                    <Text style={{fontSize:'30rem'}}>您有新消息</Text>
                    <Badge style={{position:'absolute',top:'20rem',left:'200rem'}}>
                        <Icon type="comments" />
                    </Badge>
                </View>
                <View style={styles.st}><Text style={styles.stText}>自定义文字</Text></View>
                <View style={{padding:'30rem',position:'relative'}}>
                    <Text style={{fontSize:'30rem'}}>您有新消息</Text>
                    <Badge style={{position:'absolute',top:'20rem',left:'200rem'}} count="hot" />
                </View>

            </ScrollView>

        );
    }
}
const styles={
    wrapper:{
        padding:'20rem'
    },
    st:{
        marginTop:'30rem',
        marginBottom:'30rem',
        paddingTop:'10rem',
        paddingBottom:'10rem',
        paddingLeft:'20rem',
        backgroundColor:'#dddddd'
    },
    stText:{
        fontSize:'36rem'
    },
    btn:{
        marginRight:'20rem'
    },
    btnblock:{
        marginBottom:'20rem'
    },
    badgeBlock: {
        backgroundColor: '#eeeeee',
        width: '48rem',
        height: '48rem',
        borderRadius: '4rem',
    }
}
render(<App/>);
