'use strict';

var _nukeVarLoader = require('nuke-var-loader');

var _nukeCore = require('nuke-core');

var _nukeCore2 = _interopRequireDefault(_nukeCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// //
// / @module button: 按钮
// / @tag Button
// / @category component
// / @family button
// / @varPrefix $button-
// / @classPrefix {prefix}-btn
// //


// / height
// / @namespace size/bounding
var buttonSizeSHeight = (0, _nukeVarLoader.varLoader)('button-size-s-height', _nukeCore2.default.s7);

// / height
// / @namespace size/bounding
var buttonSizeMHeight = (0, _nukeVarLoader.varLoader)('button-size-m-height', _nukeCore2.default.s8);

// / height
// / @namespace size/bounding
var buttonSizeLHeight = (0, _nukeVarLoader.varLoader)('button-size-l-height', _nukeCore2.default.s12);

// / padding(l, r)
// / @namespace size/bounding
var buttonSizeSPaddingLr = (0, _nukeVarLoader.varLoader)('button-size-s-padding-lr', _nukeCore2.default.s4);
var buttonSizeSPadding = (0, _nukeVarLoader.varLoader)('button-size-s-padding', '0 ' + buttonSizeSPaddingLr);

// / padding(l, r)
// / @namespace size/bounding
var buttonSizeMPaddingLr = (0, _nukeVarLoader.varLoader)('button-size-m-padding-lr', _nukeCore2.default.s5);
var buttonSizeMPadding = (0, _nukeVarLoader.varLoader)('button-size-m-padding', buttonSizeMPaddingLr);

// / padding(l, r)
// / @namespace size/bounding
var buttonSizeLPaddingLr = (0, _nukeVarLoader.varLoader)('button-size-l-padding-lr', _nukeCore2.default.s6);
var buttonSizeLPadding = (0, _nukeVarLoader.varLoader)('button-size-l-padding', buttonSizeLPaddingLr);

// / text
// / @namespace size/text
var buttonSizeLFont = (0, _nukeVarLoader.varLoader)('button-size-l-font', _nukeCore2.default['font-size-base-subhead']);
// / text
// / @namespace size/text
var buttonSizeMFont = (0, _nukeVarLoader.varLoader)('button-size-m-font', _nukeCore2.default['font-size-base-body1']);
// / text
// / @namespace size/text
var buttonSizeSFont = (0, _nukeVarLoader.varLoader)('button-size-s-font', _nukeCore2.default['font-size-base-caption']);

// / margin(l, r)
// / @namespace size/icon
var buttonIconLMarginLr = (0, _nukeVarLoader.varLoader)('button-icon-l-margin-lr', _nukeCore2.default.s2);
// / margin(l, r)
// / @namespace size/icon
var buttonIconMMarginLr = (0, _nukeVarLoader.varLoader)('button-icon-m-margin-lr', _nukeCore2.default.s1);
// / margin(l, r)
// / @namespace size/icon
var buttonIconSMarginLr = (0, _nukeVarLoader.varLoader)('button-icon-s-margin-lr', _nukeCore2.default.s1);

// / size
// / @namespace size/icon
var buttonIconSizeL = (0, _nukeVarLoader.varLoader)('button-icon-size-l', _nukeCore2.default['icon-s']);
// / size
// / @namespace size/icon
var buttonIconSizeM = (0, _nukeVarLoader.varLoader)('button-icon-size-m', _nukeCore2.default['icon-xs']);
// / size
// / @namespace size/icon
var buttonIconSizeS = (0, _nukeVarLoader.varLoader)('button-icon-size-s', _nukeCore2.default['icon-xs']);

// / corner
// / @namespace statements
var buttonCornerL = (0, _nukeVarLoader.varLoader)('button-corner-l', _nukeCore2.default['corner-radius-r1']);

// / corner
// / @namespace statements
var buttonCornerM = (0, _nukeVarLoader.varLoader)('button-corner-m', _nukeCore2.default['corner-radius-r1']);

// / corner
// / @namespace statements
var buttonCornerS = (0, _nukeVarLoader.varLoader)('button-corner-s', _nukeCore2.default['corner-radius-r1']);

// / width
// / @namespace size/border
var buttonSizeBorderWidthL = (0, _nukeVarLoader.varLoader)('button-size-border-width-l', _nukeCore2.default['line-1-width']);
// / width
// / @namespace size/border
var buttonSizeBorderWidthM = (0, _nukeVarLoader.varLoader)('button-size-border-width-m', _nukeCore2.default['line-1-width']);
// / width
// / @namespace size/border
var buttonSizeBorderWidthS = (0, _nukeVarLoader.varLoader)('button-size-border-width-s', _nukeCore2.default['line-1-width']);

// / border-style
// / @namespace statements
var buttonNormalLineStyle = (0, _nukeVarLoader.varLoader)('button-normal-line-style', _nukeCore2.default['line-solid']);
// / text
// / @namespace statements/disabled
var buttonNormalDisabledColor = (0, _nukeVarLoader.varLoader)('button-normal-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonNormalDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-normal-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonNormalDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonNormalNormalColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-color', _nukeCore2.default['color-n2-3']);
// / background
// / @namespace statements
var buttonNormalNormalBgColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-bg-color', _nukeCore2.default['color-n1-1']);
// / border
// / @namespace statements
var buttonNormalNormalBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-border-color', _nukeCore2.default['color-n1-6']);
// / text
// / @namespace statements/selected
var buttonNormalNormalActiveColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-active-color', _nukeCore2.default['color-n2-3']);
// / border
// / @namespace statements/selected
var buttonNormalNormalActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-active-border-color', _nukeCore2.default['color-n1-6']);
// / background
// / @namespace statements/selected
var buttonNormalNormalActiveBgColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-active-bg-color', _nukeCore2.default['color-n1-3']);
// / text
// / @namespace statements/disabled
var buttonNormalNormalDisabledColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonNormalNormalDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonNormalNormalDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-normal-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonNormalPrimaryColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements
var buttonNormalPrimaryBgColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-bg-color', _nukeCore2.default['color-b1-6']);
// / border
// / @namespace statements
var buttonNormalPrimaryBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-border-color', _nukeCore2.default['color-b1-6']);
// / text
// / @namespace statements/selected
var buttonNormalPrimaryActiveColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-active-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements/selected
var buttonNormalPrimaryActiveBgColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-active-bg-color', _nukeCore2.default['color-b1-9']);
// / border
// / @namespace statements/selected
var buttonNormalPrimaryActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-active-border-color', _nukeCore2.default['color-b1-9']);
// / text
// / @namespace statements/disabled
var buttonNormalPrimaryDisabledColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonNormalPrimaryDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonNormalPrimaryDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-primary-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonNormalSecondaryColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-color', _nukeCore2.default['color-b1-6']);
// / background
// / @namespace statements
var buttonNormalSecondaryBgColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-bg-color', _nukeCore2.default['color-n1-1']);
// / border
// / @namespace statements
var buttonNormalSecondaryBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-border-color', _nukeCore2.default['color-b1-6']);
// / text
// / @namespace statements/selected
var buttonNormalSecondaryActiveColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-active-color', _nukeCore2.default['color-b1-6']);
// / background
// / @namespace statements/selected
var buttonNormalSecondaryActiveBgColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-active-bg-color', _nukeCore2.default['color-b1-1']);
// / border
// / @namespace statements/selected
var buttonNormalSecondaryActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-active-border-color', _nukeCore2.default['color-b1-6']);
// / text
// / @namespace statements/disabled
var buttonNormalSecondaryDisabledColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonNormalSecondaryDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonNormalSecondaryDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-normal-secondary-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / border-style
// / @namespace statements
var buttonGhostLineStyle = (0, _nukeVarLoader.varLoader)('button-ghost-line-style', _nukeCore2.default['line-solid']);

// / text
// / @namespace statements
var buttonGhostDarkColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-color', _nukeCore2.default['color-n1-1']);
var buttonGhostDarkBgColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-bg-color', 'transparent');
// / border
// / @namespace statements
var buttonGhostDarkBorderColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-border-color', _nukeCore2.default['color-n1-1']);
// / text
// / @namespace statements/selected
var buttonGhostDarkActiveColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-active-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements/selected
var buttonGhostDarkActiveBgColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-active-bg-color', _nukeCore2.default['color-n1-1']);
// / opacity
// / @namespace statements/selected
var buttonGhostDarkActiveBgOpacity = (0, _nukeVarLoader.varLoader)('button-ghost-dark-active-bg-opacity', '0.2');
// / border
// / @namespace statements/selected
var buttonGhostDarkActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-active-border-color', _nukeCore2.default['color-n1-1']);
// / text
// / @namespace statements/disabled
var buttonGhostDarkDisabledColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-disabled-color', _nukeCore2.default['color-n1-1']);
// / text-opacity
// / @namespace statements/disabled
var buttonGhostDarkDisabledOpacity = (0, _nukeVarLoader.varLoader)('button-ghost-dark-disabled-opacity', '0.4');
var buttonGhostDarkDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-disabled-bg-color', 'transparent');
// / border
// / @namespace statements/disabled
var buttonGhostDarkDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-ghost-dark-disabled-border-color', _nukeCore2.default['color-n1-1']);
// / border-opacity
// / @namespace statements/disabled
var buttonGhostDarkDisabledBorderOpacity = (0, _nukeVarLoader.varLoader)('button-ghost-dark-disabled-border-opacity', '0.4');

// / text
// / @namespace statements
var buttonGhostLightColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-color', _nukeCore2.default['color-n2-4']);
var buttonGhostLightBgColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-bg-color', 'transparent');
// / border
// / @namespace statements
var buttonGhostLightBorderColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-border-color', _nukeCore2.default['color-n2-4']);
// / text
// / @namespace statements/selected
var buttonGhostLightActiveColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-active-color', _nukeCore2.default['color-n2-4']);
// / background
// / @namespace statements/selected
var buttonGhostLightActiveBgColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-active-bg-color', _nukeCore2.default['color-n1-9']);
// / opacity
// / @namespace statements/selected
var buttonGhostLightActiveBgOpacity = (0, _nukeVarLoader.varLoader)('button-ghost-light-active-bg-opacity', '0.3');
// / border
// / @namespace statements/selected
var buttonGhostLightActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-active-border-color', _nukeCore2.default['color-n2-4']);
// / text
// / @namespace statements/disabled
var buttonGhostLightDisabledColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-disabled-color', _nukeCore2.default['color-n1-9']);
// / text-opacity
// / @namespace statements/disabled
var buttonGhostLightDisabledOpacity = (0, _nukeVarLoader.varLoader)('button-ghost-light-disabled-opacity', '0.4');
var buttonGhostLightDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-disabled-bg-color', 'transparent');
// / border
// / @namespace statements/disabled
var buttonGhostLightDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-ghost-light-disabled-border-color', _nukeCore2.default['color-n1-8']);
// / border-opacity
// / @namespace statements/disabled
var buttonGhostLightDisabledBorderOpacity = (0, _nukeVarLoader.varLoader)('button-ghost-light-disabled-border-opacity', '0.1');

// / border-style
// / @namespace statements
var buttonWarningLineStyle = (0, _nukeVarLoader.varLoader)('button-warning-line-style', _nukeCore2.default['line-solid']);
// / text
// / @namespace statements/disabled
var buttonWarningDisabledColor = (0, _nukeVarLoader.varLoader)('button-warning-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonWarningDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-warning-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonWarningDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonWarningNormalColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-color', _nukeCore2.default['color-f2-1']);
// / background
// / @namespace statements
var buttonWarningNormalBgColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-bg-color', _nukeCore2.default['color-n1-1']);
// / border
// / @namespace statements
var buttonWarningNormalBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-border-color', _nukeCore2.default['color-f2-1']);
// / text
// / @namespace statements/selected
var buttonWarningNormalActiveColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-active-color', _nukeCore2.default['color-f2-1']);
// / background
// / @namespace statements/selected
var buttonWarningNormalActiveBgColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-active-bg-color', _nukeCore2.default['color-f2-2']);
// / border
// / @namespace statements/selected
var buttonWarningNormalActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-active-border-color', _nukeCore2.default['color-f2-1']);
// / text
// / @namespace statements/disabled
var buttonWarningNormalDisabledColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonWarningNormalDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonWarningNormalDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-normal-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonWarningPrimaryColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements
var buttonWarningPrimaryBgColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-bg-color', _nukeCore2.default['color-f2-1']);
// / border
// / @namespace statements
var buttonWarningPrimaryBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-border-color', _nukeCore2.default['color-f2-1']);
// / text
// / @namespace statements/selected
var buttonWarningPrimaryActiveColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-active-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements/selected
var buttonWarningPrimaryActiveBgColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-active-bg-color', _nukeCore2.default['color-f2-3']);
// / border
// / @namespace statements/selected
var buttonWarningPrimaryActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-active-border-color', _nukeCore2.default['color-f2-1']);
// / text
// / @namespace statements/disabled
var buttonWarningPrimaryDisabledColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonWarningPrimaryDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonWarningPrimaryDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-warning-primary-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements/disabled
var buttonTextDisabledColor = (0, _nukeVarLoader.varLoader)('button-text-disabled-color', _nukeCore2.default['color-n2-1']);
var buttonTextDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-text-disabled-bg-color', 'transparent');
var buttonTextDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-text-disabled-border-color', 'transparent');

// / text
// / @namespace statements
var buttonTextNormalColor = (0, _nukeVarLoader.varLoader)('button-text-normal-color', _nukeCore2.default['color-n2-3']);
var buttonTextNormalBgColor = (0, _nukeVarLoader.varLoader)('button-text-normal-bg-color', 'transparent');
var buttonTextNormalBorderColor = (0, _nukeVarLoader.varLoader)('button-text-normal-border-color', 'transparent');
// / text
// / @namespace statements/selected
var buttonTextNormalActiveColor = (0, _nukeVarLoader.varLoader)('button-text-normal-active-color', _nukeCore2.default['color-b1-6']);
var buttonTextNormalActiveBgColor = (0, _nukeVarLoader.varLoader)('button-text-normal-active-bg-color', 'transparent');
var buttonTextNormalActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-text-normal-active-border-color', 'transparent');
// / text
// / @namespace statements/disabled
var buttonTextNormalDisabledColor = (0, _nukeVarLoader.varLoader)('button-text-normal-disabled-color', _nukeCore2.default['color-n2-1']);
var buttonTextNormalDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-text-normal-disabled-bg-color', 'transparent');
var buttonTextNormalDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-text-normal-disabled-border-color', 'transparent');

// / text
// / @namespace statements
var buttonTextPrimaryColor = (0, _nukeVarLoader.varLoader)('button-text-primary-color', _nukeCore2.default['color-b2-6']);
var buttonTextPrimaryBgColor = (0, _nukeVarLoader.varLoader)('button-text-primary-bg-color', 'transparent');
var buttonTextPrimaryBorderColor = (0, _nukeVarLoader.varLoader)('button-text-primary-border-color', 'transparent');
// / text
// / @namespace statements/selected
var buttonTextPrimaryActiveColor = (0, _nukeVarLoader.varLoader)('button-text-primary-active-color', _nukeCore2.default['color-b1-6']);
var buttonTextPrimaryActiveBgColor = (0, _nukeVarLoader.varLoader)('button-text-primary-active-bg-color', 'transparent');
var buttonTextPrimaryActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-text-primary-active-border-color', 'transparent');
// / text
// / @namespace statements/disabled
var buttonTextPrimaryDisabledColor = (0, _nukeVarLoader.varLoader)('button-text-primary-disabled-color', _nukeCore2.default['color-n2-1']);
var buttonTextPrimaryDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-text-primary-disabled-bg-color', 'transparent');
var buttonTextPrimaryDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-text-primary-disabled-border-color', 'transparent');

// / size
// / @namespace size/icon
var buttonIconLSize = (0, _nukeVarLoader.varLoader)('button-icon-l-size', _nukeCore2.default['icon-l']);
// / size
// / @namespace size/icon
var buttonIconMSize = (0, _nukeVarLoader.varLoader)('button-icon-m-size', _nukeCore2.default['icon-m']);
// / size
// / @namespace size/icon
var buttonIconSSize = (0, _nukeVarLoader.varLoader)('button-icon-s-size', _nukeCore2.default['icon-s']);

// / width
// / @namespace size/bounding
var buttonIconLHeight = (0, _nukeVarLoader.varLoader)('button-icon-l-height', _nukeCore2.default.s10);
// / width
// / @namespace size/bounding
var buttonIconMHeight = (0, _nukeVarLoader.varLoader)('button-icon-m-height', _nukeCore2.default.s7);
// / width
// / @namespace size/bounding
var buttonIconSHeight = (0, _nukeVarLoader.varLoader)('button-icon-s-height', _nukeCore2.default.s5);

// / text
// / @namespace statements/disabled
var buttonIconDisabledColor = (0, _nukeVarLoader.varLoader)('button-icon-disabled-color', _nukeCore2.default['color-n2-1']);
var buttonIconDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-icon-disabled-bg-color', 'transparent');
var buttonIconDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-icon-disabled-border-color', 'transparent');

// / text
// / @namespace statements
var buttonIconNormalColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-color', _nukeCore2.default['color-n2-3']);
var buttonIconNormalBgColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-bg-color', 'transparent');
var buttonIconNormalBorderColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-border-color', 'transparent');
// / text
// / @namespace statements/selected
var buttonIconNormalActiveColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-active-color', _nukeCore2.default['color-b1-6']);
var buttonIconNormalActiveBgColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-active-bg-color', 'transparent');
var buttonIconNormalActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-active-border-color', 'transparent');
// / text
// / @namespace statements/disabled
var buttonIconNormalDisabledColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-disabled-color', _nukeCore2.default['color-n2-1']);
var buttonIconNormalDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-disabled-bg-color', 'transparent');
var buttonIconNormalDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-icon-normal-disabled-border-color', 'transparent');

// / border-style
// / @namespace statements
var buttonFixedLineStyle = (0, _nukeVarLoader.varLoader)('button-fixed-line-style', _nukeCore2.default['line-solid']);

// / text
// / @namespace statements/disabled
var buttonFixedDisabledColor = (0, _nukeVarLoader.varLoader)('button-fixed-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonFixedDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonFixedDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonFixedNormalColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-color', _nukeCore2.default['color-n2-4']);
// / background
// / @namespace statements
var buttonFixedNormalBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-bg-color', _nukeCore2.default['color-n1-1']);
// / border
// / @namespace statements
var buttonFixedNormalBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-border-color', _nukeCore2.default['color-n1-6']);
// / text
// / @namespace statements/selected
var buttonFixedNormalActiveColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-active-color', _nukeCore2.default['color-n2-4']);
// / background
// / @namespace statements/selected
var buttonFixedNormalActiveBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-active-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/selected
var buttonFixedNormalActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-active-border-color', _nukeCore2.default['color-n1-8']);
// / text
// / @namespace statements/disabled
var buttonFixedNormalDisabledColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonFixedNormalDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonFixedNormalDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-normal-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonFixedPrimaryColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements
var buttonFixedPrimaryBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-bg-color', _nukeCore2.default['color-b1-6']);
// / border
// / @namespace statements
var buttonFixedPrimaryBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-border-color', _nukeCore2.default['color-b1-6']);
// / text
// / @namespace statements/selected
var buttonFixedPrimaryActiveColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-active-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements/selected
var buttonFixedPrimaryActiveBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-active-bg-color', _nukeCore2.default['color-b1-9']);
// / border
// / @namespace statements/selected
var buttonFixedPrimaryActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-active-border-color', _nukeCore2.default['color-b1-9']);
// / text
// / @namespace statements/disabled
var buttonFixedPrimaryDisabledColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonFixedPrimaryDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonFixedPrimaryDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-primary-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonFixedSecondaryColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-color', _nukeCore2.default['color-b1-6']);
// / background
// / @namespace statements
var buttonFixedSecondaryBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-bg-color', _nukeCore2.default['color-n1-1']);
// / border
// / @namespace statements
var buttonFixedSecondaryBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-border-color', _nukeCore2.default['color-n1-6']);
// / text
// / @namespace statements/selected
var buttonFixedSecondaryActiveColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-active-color', _nukeCore2.default['color-b1-6']);
// / background
// / @namespace statements/selected
var buttonFixedSecondaryActiveBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-active-bg-color', _nukeCore2.default['color-b1-1']);
// / border
// / @namespace statements/selected
var buttonFixedSecondaryActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-active-border-color', _nukeCore2.default['color-n1-6']);
// / text
// / @namespace statements/disabled
var buttonFixedSecondaryDisabledColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonFixedSecondaryDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonFixedSecondaryDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-secondary-disabled-border-color', _nukeCore2.default['color-n1-5']);

// / text
// / @namespace statements
var buttonFixedThirdColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements
var buttonFixedThirdBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-bg-color', _nukeCore2.default['color-b1-9']);
// / border
// / @namespace statements
var buttonFixedThirdBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-border-color', _nukeCore2.default['color-b1-6']);
// / text
// / @namespace statements/selected
var buttonFixedThirdActiveColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-active-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statements/selected
var buttonFixedThirdActiveBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-active-bg-color', _nukeCore2.default['color-b1-9']);
// / border
// / @namespace statements/selected
var buttonFixedThirdActiveBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-active-border-color', _nukeCore2.default['color-b1-6']);
// / text
// / @namespace statements/disabled
var buttonFixedThirdDisabledColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-disabled-color', _nukeCore2.default['color-n2-1']);
// / background
// / @namespace statements/disabled
var buttonFixedThirdDisabledBgColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-disabled-bg-color', _nukeCore2.default['color-n1-3']);
// / border
// / @namespace statements/disabled
var buttonFixedThirdDisabledBorderColor = (0, _nukeVarLoader.varLoader)('button-fixed-third-disabled-border-color', _nukeCore2.default['color-n1-5']);

var buttonGroupMargin = (0, _nukeVarLoader.varLoader)('button-group-margin', _nukeCore2.default.s2);

module.exports = {
  'button-size-s-height': buttonSizeSHeight,
  'button-size-m-height': buttonSizeMHeight,
  'button-size-l-height': buttonSizeLHeight,
  'button-size-s-padding-lr': buttonSizeSPaddingLr,
  'button-size-s-padding': buttonSizeSPadding,
  'button-size-m-padding-lr': buttonSizeMPaddingLr,
  'button-size-m-padding': buttonSizeMPadding,
  'button-size-l-padding-lr': buttonSizeLPaddingLr,
  'button-size-l-padding': buttonSizeLPadding,
  'button-size-l-font': buttonSizeLFont,
  'button-size-m-font': buttonSizeMFont,
  'button-size-s-font': buttonSizeSFont,
  'button-icon-l-margin-lr': buttonIconLMarginLr,
  'button-icon-m-margin-lr': buttonIconMMarginLr,
  'button-icon-s-margin-lr': buttonIconSMarginLr,
  'button-icon-size-l': buttonIconSizeL,
  'button-icon-size-m': buttonIconSizeM,
  'button-icon-size-s': buttonIconSizeS,
  'button-corner-l': buttonCornerL,
  'button-corner-m': buttonCornerM,
  'button-corner-s': buttonCornerS,
  'button-size-border-width-l': buttonSizeBorderWidthL,
  'button-size-border-width-m': buttonSizeBorderWidthM,
  'button-size-border-width-s': buttonSizeBorderWidthS,
  'button-normal-line-style': buttonNormalLineStyle,
  'button-normal-disabled-color': buttonNormalDisabledColor,
  'button-normal-disabled-bg-color': buttonNormalDisabledBgColor,
  'button-normal-disabled-border-color': buttonNormalDisabledBorderColor,
  'button-normal-normal-color': buttonNormalNormalColor,
  'button-normal-normal-bg-color': buttonNormalNormalBgColor,
  'button-normal-normal-border-color': buttonNormalNormalBorderColor,
  'button-normal-normal-active-color': buttonNormalNormalActiveColor,
  'button-normal-normal-active-border-color': buttonNormalNormalActiveBorderColor,
  'button-normal-normal-active-bg-color': buttonNormalNormalActiveBgColor,
  'button-normal-normal-disabled-color': buttonNormalNormalDisabledColor,
  'button-normal-normal-disabled-bg-color': buttonNormalNormalDisabledBgColor,
  'button-normal-normal-disabled-border-color': buttonNormalNormalDisabledBorderColor,
  'button-normal-primary-color': buttonNormalPrimaryColor,
  'button-normal-primary-bg-color': buttonNormalPrimaryBgColor,
  'button-normal-primary-border-color': buttonNormalPrimaryBorderColor,
  'button-normal-primary-active-color': buttonNormalPrimaryActiveColor,
  'button-normal-primary-active-bg-color': buttonNormalPrimaryActiveBgColor,
  'button-normal-primary-active-border-color': buttonNormalPrimaryActiveBorderColor,
  'button-normal-primary-disabled-color': buttonNormalPrimaryDisabledColor,
  'button-normal-primary-disabled-bg-color': buttonNormalPrimaryDisabledBgColor,
  'button-normal-primary-disabled-border-color': buttonNormalPrimaryDisabledBorderColor,
  'button-normal-secondary-color': buttonNormalSecondaryColor,
  'button-normal-secondary-bg-color': buttonNormalSecondaryBgColor,
  'button-normal-secondary-border-color': buttonNormalSecondaryBorderColor,
  'button-normal-secondary-active-color': buttonNormalSecondaryActiveColor,
  'button-normal-secondary-active-bg-color': buttonNormalSecondaryActiveBgColor,
  'button-normal-secondary-active-border-color': buttonNormalSecondaryActiveBorderColor,
  'button-normal-secondary-disabled-color': buttonNormalSecondaryDisabledColor,
  'button-normal-secondary-disabled-bg-color': buttonNormalSecondaryDisabledBgColor,
  'button-normal-secondary-disabled-border-color': buttonNormalSecondaryDisabledBorderColor,
  'button-ghost-line-style': buttonGhostLineStyle,
  'button-ghost-dark-color': buttonGhostDarkColor,
  'button-ghost-dark-bg-color': buttonGhostDarkBgColor,
  'button-ghost-dark-border-color': buttonGhostDarkBorderColor,
  'button-ghost-dark-active-color': buttonGhostDarkActiveColor,
  'button-ghost-dark-active-bg-color': buttonGhostDarkActiveBgColor,
  'button-ghost-dark-active-bg-opacity': buttonGhostDarkActiveBgOpacity,
  'button-ghost-dark-active-border-color': buttonGhostDarkActiveBorderColor,
  'button-ghost-dark-disabled-color': buttonGhostDarkDisabledColor,
  'button-ghost-dark-disabled-opacity': buttonGhostDarkDisabledOpacity,
  'button-ghost-dark-disabled-bg-color': buttonGhostDarkDisabledBgColor,
  'button-ghost-dark-disabled-border-color': buttonGhostDarkDisabledBorderColor,
  'button-ghost-dark-disabled-border-opacity': buttonGhostDarkDisabledBorderOpacity,
  'button-ghost-light-color': buttonGhostLightColor,
  'button-ghost-light-bg-color': buttonGhostLightBgColor,
  'button-ghost-light-border-color': buttonGhostLightBorderColor,
  'button-ghost-light-active-color': buttonGhostLightActiveColor,
  'button-ghost-light-active-bg-color': buttonGhostLightActiveBgColor,
  'button-ghost-light-active-bg-opacity': buttonGhostLightActiveBgOpacity,
  'button-ghost-light-active-border-color': buttonGhostLightActiveBorderColor,
  'button-ghost-light-disabled-color': buttonGhostLightDisabledColor,
  'button-ghost-light-disabled-opacity': buttonGhostLightDisabledOpacity,
  'button-ghost-light-disabled-bg-color': buttonGhostLightDisabledBgColor,
  'button-ghost-light-disabled-border-color': buttonGhostLightDisabledBorderColor,
  'button-ghost-light-disabled-border-opacity': buttonGhostLightDisabledBorderOpacity,
  'button-warning-line-style': buttonWarningLineStyle,
  'button-warning-disabled-color': buttonWarningDisabledColor,
  'button-warning-disabled-bg-color': buttonWarningDisabledBgColor,
  'button-warning-disabled-border-color': buttonWarningDisabledBorderColor,
  'button-warning-normal-color': buttonWarningNormalColor,
  'button-warning-normal-bg-color': buttonWarningNormalBgColor,
  'button-warning-normal-border-color': buttonWarningNormalBorderColor,
  'button-warning-normal-active-color': buttonWarningNormalActiveColor,
  'button-warning-normal-active-bg-color': buttonWarningNormalActiveBgColor,
  'button-warning-normal-active-border-color': buttonWarningNormalActiveBorderColor,
  'button-warning-normal-disabled-color': buttonWarningNormalDisabledColor,
  'button-warning-normal-disabled-bg-color': buttonWarningNormalDisabledBgColor,
  'button-warning-normal-disabled-border-color': buttonWarningNormalDisabledBorderColor,
  'button-warning-primary-color': buttonWarningPrimaryColor,
  'button-warning-primary-bg-color': buttonWarningPrimaryBgColor,
  'button-warning-primary-border-color': buttonWarningPrimaryBorderColor,
  'button-warning-primary-active-color': buttonWarningPrimaryActiveColor,
  'button-warning-primary-active-bg-color': buttonWarningPrimaryActiveBgColor,
  'button-warning-primary-active-border-color': buttonWarningPrimaryActiveBorderColor,
  'button-warning-primary-disabled-color': buttonWarningPrimaryDisabledColor,
  'button-warning-primary-disabled-bg-color': buttonWarningPrimaryDisabledBgColor,
  'button-warning-primary-disabled-border-color': buttonWarningPrimaryDisabledBorderColor,
  'button-text-disabled-color': buttonTextDisabledColor,
  'button-text-disabled-bg-color': buttonTextDisabledBgColor,
  'button-text-disabled-border-color': buttonTextDisabledBorderColor,
  'button-text-normal-color': buttonTextNormalColor,
  'button-text-normal-bg-color': buttonTextNormalBgColor,
  'button-text-normal-border-color': buttonTextNormalBorderColor,
  'button-text-normal-active-color': buttonTextNormalActiveColor,
  'button-text-normal-active-bg-color': buttonTextNormalActiveBgColor,
  'button-text-normal-active-border-color': buttonTextNormalActiveBorderColor,
  'button-text-normal-disabled-color': buttonTextNormalDisabledColor,
  'button-text-normal-disabled-bg-color': buttonTextNormalDisabledBgColor,
  'button-text-normal-disabled-border-color': buttonTextNormalDisabledBorderColor,
  'button-text-primary-color': buttonTextPrimaryColor,
  'button-text-primary-bg-color': buttonTextPrimaryBgColor,
  'button-text-primary-border-color': buttonTextPrimaryBorderColor,
  'button-text-primary-active-color': buttonTextPrimaryActiveColor,
  'button-text-primary-active-bg-color': buttonTextPrimaryActiveBgColor,
  'button-text-primary-active-border-color': buttonTextPrimaryActiveBorderColor,
  'button-text-primary-disabled-color': buttonTextPrimaryDisabledColor,
  'button-text-primary-disabled-bg-color': buttonTextPrimaryDisabledBgColor,
  'button-text-primary-disabled-border-color': buttonTextPrimaryDisabledBorderColor,
  'button-icon-l-size': buttonIconLSize,
  'button-icon-m-size': buttonIconMSize,
  'button-icon-s-size': buttonIconSSize,
  'button-icon-l-height': buttonIconLHeight,
  'button-icon-m-height': buttonIconMHeight,
  'button-icon-s-height': buttonIconSHeight,
  'button-icon-disabled-color': buttonIconDisabledColor,
  'button-icon-disabled-bg-color': buttonIconDisabledBgColor,
  'button-icon-disabled-border-color': buttonIconDisabledBorderColor,
  'button-icon-normal-color': buttonIconNormalColor,
  'button-icon-normal-bg-color': buttonIconNormalBgColor,
  'button-icon-normal-border-color': buttonIconNormalBorderColor,
  'button-icon-normal-active-color': buttonIconNormalActiveColor,
  'button-icon-normal-active-bg-color': buttonIconNormalActiveBgColor,
  'button-icon-normal-active-border-color': buttonIconNormalActiveBorderColor,
  'button-icon-normal-disabled-color': buttonIconNormalDisabledColor,
  'button-icon-normal-disabled-bg-color': buttonIconNormalDisabledBgColor,
  'button-icon-normal-disabled-border-color': buttonIconNormalDisabledBorderColor,
  'button-fixed-line-style': buttonFixedLineStyle,
  'button-fixed-disabled-color': buttonFixedDisabledColor,
  'button-fixed-disabled-bg-color': buttonFixedDisabledBgColor,
  'button-fixed-disabled-border-color': buttonFixedDisabledBorderColor,
  'button-fixed-normal-color': buttonFixedNormalColor,
  'button-fixed-normal-bg-color': buttonFixedNormalBgColor,
  'button-fixed-normal-border-color': buttonFixedNormalBorderColor,
  'button-fixed-normal-active-color': buttonFixedNormalActiveColor,
  'button-fixed-normal-active-bg-color': buttonFixedNormalActiveBgColor,
  'button-fixed-normal-active-border-color': buttonFixedNormalActiveBorderColor,
  'button-fixed-normal-disabled-color': buttonFixedNormalDisabledColor,
  'button-fixed-normal-disabled-bg-color': buttonFixedNormalDisabledBgColor,
  'button-fixed-normal-disabled-border-color': buttonFixedNormalDisabledBorderColor,
  'button-fixed-primary-color': buttonFixedPrimaryColor,
  'button-fixed-primary-bg-color': buttonFixedPrimaryBgColor,
  'button-fixed-primary-border-color': buttonFixedPrimaryBorderColor,
  'button-fixed-primary-active-color': buttonFixedPrimaryActiveColor,
  'button-fixed-primary-active-bg-color': buttonFixedPrimaryActiveBgColor,
  'button-fixed-primary-active-border-color': buttonFixedPrimaryActiveBorderColor,
  'button-fixed-primary-disabled-color': buttonFixedPrimaryDisabledColor,
  'button-fixed-primary-disabled-bg-color': buttonFixedPrimaryDisabledBgColor,
  'button-fixed-primary-disabled-border-color': buttonFixedPrimaryDisabledBorderColor,
  'button-fixed-secondary-color': buttonFixedSecondaryColor,
  'button-fixed-secondary-bg-color': buttonFixedSecondaryBgColor,
  'button-fixed-secondary-border-color': buttonFixedSecondaryBorderColor,
  'button-fixed-secondary-active-color': buttonFixedSecondaryActiveColor,
  'button-fixed-secondary-active-bg-color': buttonFixedSecondaryActiveBgColor,
  'button-fixed-secondary-active-border-color': buttonFixedSecondaryActiveBorderColor,
  'button-fixed-secondary-disabled-color': buttonFixedSecondaryDisabledColor,
  'button-fixed-secondary-disabled-bg-color': buttonFixedSecondaryDisabledBgColor,
  'button-fixed-secondary-disabled-border-color': buttonFixedSecondaryDisabledBorderColor,
  'button-fixed-third-color': buttonFixedThirdColor,
  'button-fixed-third-bg-color': buttonFixedThirdBgColor,
  'button-fixed-third-border-color': buttonFixedThirdBorderColor,
  'button-fixed-third-active-color': buttonFixedThirdActiveColor,
  'button-fixed-third-active-bg-color': buttonFixedThirdActiveBgColor,
  'button-fixed-third-active-border-color': buttonFixedThirdActiveBorderColor,
  'button-fixed-third-disabled-color': buttonFixedThirdDisabledColor,
  'button-fixed-third-disabled-bg-color': buttonFixedThirdDisabledBgColor,
  'button-fixed-third-disabled-border-color': buttonFixedThirdDisabledBorderColor,
  'button-group-margin': buttonGroupMargin
};