/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import View from 'nuke-view';
import ScrollView from 'nuke-scroll-view';
import Button from 'nuke-button';


const App = class NukeDemoIndex extends Component {
  constructor() {
    super();
  }

  press() {
    alert('触发按钮');
  }

  render() {
    return (
      <ScrollView style={styles.wrapper}>
        <View style={styles.st}><Text style={styles.stText}>基础用法</Text></View>
        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="normal">Normal</Button>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="primary">Primary</Button>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="secondary">Secondary</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>block</Text></View>
        <View style={{ marginBottom: '20rem' }}>
          <Button style={styles.btnblock} onPress={this.press.bind(this)} block="true" type="normal">Block Normal</Button>
          <Button style={styles.btnblock} onPress={this.press.bind(this)} block="true" type="primary">Block Primary</Button>
          <Button style={styles.btnblock} onPress={this.press.bind(this)} block="true" type="secondary">Block Secondary</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>rect 直角</Text></View>
        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} rect onPress={this.press.bind(this)} type="normal">Normal</Button>
          <Button style={styles.btn} rect onPress={this.press.bind(this)} type="primary">Primary</Button>
          <Button style={styles.btn} rect onPress={this.press.bind(this)} type="secondary">Secondary</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>Ghost Dark</Text></View>
        <View style={{ backgroundColor: '#4f74b3', height: '120rem', justifyContent: 'center' }}>
          <Button style={styles.btn} type="dark" shape="ghost">Ghost</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>Ghost Light</Text></View>
        <View style={{ backgroundColor: '#e3eaf7', height: '120rem', justifyContent: 'center' }}>
          <Button style={styles.btn} type="light" shape="ghost">Light</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>Warning</Text></View>
        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} type="normal" shape="warning">Normal</Button>
          <Button style={styles.btn} type="primary" shape="warning">Primary</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>icon用法</Text></View>
        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} icon="//img.alicdn.com/tfs/TB1t7x_LpXXXXbLXFXXXXXXXXXX-64-64.png" onPress={this.press.bind(this)} type="secondary">secondary width icon</Button>
          <Button style={styles.btn} loading="true" onPress={this.press.bind(this)} type="primary">加载中</Button>
        </View>
        <View>
          <Button icon="//img.alicdn.com/tfs/TB1t7x_LpXXXXbLXFXXXXXXXXXX-64-64.png" onPress={this.press.bind(this)} block="true" type="normal">block normal</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>Size用法</Text></View>

        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="primary" size="large">large</Button>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="primary" size="medium">medium</Button>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="primary" size="small">small</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>disabled</Text></View>
        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="normal" disabled>normal</Button>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="primary" disabled>primary</Button>
          <Button style={styles.btn} onPress={this.press.bind(this)} type="secondary" disabled>secondary</Button>
        </View>
        <View style={{ backgroundColor: '#4f74b3', height: '120rem', justifyContent: 'center', marginBottom: '20rem' }}>
          <Button style={styles.btn} type="dark" shape="ghost" disabled>Ghost</Button>
        </View>
        <View style={{ backgroundColor: '#e3eaf7', height: '120rem', justifyContent: 'center', marginBottom: '20rem' }}>
          <Button style={styles.btn} type="light" shape="ghost" disabled>Light</Button>
        </View>
        <View style={{ flexDirection: 'row', marginBottom: '20rem' }}>
          <Button style={styles.btn} type="normal" shape="warning" disabled>Normal</Button>
          <Button style={styles.btn} type="primary" shape="warning" disabled>Primary</Button>
        </View>
        <View style={styles.st}><Text style={styles.stText}>Group用法</Text></View>
        <Button.Group style={{ marginBottom: '20rem' }}>
          <Button type="normal">Normal</Button>
          <Button type="primary">Primary</Button>
          <Button type="secondary">Secondary</Button>
        </Button.Group>
        <Button.Group style={{ marginBottom: '20rem' }} block>
          <Button type="normal" size="large">Normal</Button>
          <Button type="primary" size="large">Primary</Button>
          <Button type="secondary" size="large">Secondary</Button>
        </Button.Group>
        <Button.Group style={{ marginBottom: '20rem' }} rect>
          <Button type="normal" size="large">Normal</Button>
          <Button type="third" size="large">Third</Button>
          <Button type="primary" size="large">Primary</Button>
        </Button.Group>
      </ScrollView>

    );
  }
};
const styles = {
  wrapper: {
    padding: '20rem',
  },
  st: {
    marginTop: '30rem',
    marginBottom: '30rem',
    paddingTop: '10rem',
    paddingBottom: '10rem',
    paddingLeft: '20rem',
    backgroundColor: '#dddddd',
  },
  stText: {
    fontSize: '36rem',
  },
  btn: {
    marginRight: '20rem',
  },
  btnblock: {
    marginBottom: '20rem',
  },
};
render(<App />);
