'use strict';

var _module$exports;

var _nukeVarLoader = require('nuke-var-loader');

var _nukeCore = require('nuke-core');

var _nukeCore2 = _interopRequireDefault(_nukeCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

////
/// @module checkbox: 复选框
/// @tag Checkbox
/// @category component
/// @family selector
/// @varPrefix $checkbox-
/// @classPrefix {prefix}-checkbox
////


// checkbox - size
// --------------------------------------------------

/// size
/// @namespace size/bounding
var checkboxMediumSizeWidth = (0, _nukeVarLoader.varLoader)('checkbox-medium-size-width', _nukeCore2.default['s6']);
var checkboxMediumSizeHeight = (0, _nukeVarLoader.varLoader)('checkbox-medium-size-height', _nukeCore2.default['s6']);

/// size
/// @namespace size/icon
var checkboxMediumIconSize = (0, _nukeVarLoader.varLoader)('checkbox-medium-icon-size', _nukeCore2.default['icon-s']);
var checkboxMediumSpanText = (0, _nukeVarLoader.varLoader)('checkbox-medium-span-text', checkboxMediumIconSize);
/// height
/// @namespace size/bounding
var checkboxSmallSizeWidth = (0, _nukeVarLoader.varLoader)('checkbox-small-size-width', _nukeCore2.default['s5']);
var checkboxSmallSizeHeight = (0, _nukeVarLoader.varLoader)('checkbox-small-size-height', checkboxSmallSizeWidth);
/// size
/// @namespace size/icon
var checkboxSmallIconSize = (0, _nukeVarLoader.varLoader)('checkbox-small-icon-size', _nukeCore2.default['icon-xs']);
var checkboxSmallIconText = (0, _nukeVarLoader.varLoader)('checkbox-small-icon-text', checkboxSmallIconSize);

// checkbox - normal
// --------------------------------------------------


/// width
/// @namespace size/border
var checkboxNormalBorderWidth = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-width', _nukeCore2.default['line-1-width']);
/// border
/// @namespace statement/normal
var checkboxNormalBorderColor = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-color', _nukeCore2.default['color-n1-7']);

/// border-style
/// @namespace statement/normal
var checkboxNormalBorderStyle = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-style', _nukeCore2.default['line-solid']);

/// corner
/// @namespace statement/normal
var checkboxNormalBorderRadius = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-radius', _nukeCore2.default['corner-radius-circle']);
/// background
/// @namespace statement/normal
var checkboxNormalBgColor = (0, _nukeVarLoader.varLoader)('checkbox-normal-bg-color', _nukeCore2.default['color-n1-1']);
/// icon
/// @namespace statement/selected
var checkboxNormalIconColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-normal-icon-color-selected', _nukeCore2.default['color-n1-1']);
/// border
/// @namespace statement/selected
var checkboxNormalBorderColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-color-selected', _nukeCore2.default['color-b1-6']);
/// background
/// @namespace statement/selected
var checkboxNormalBgColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-normal-bg-color-selected', _nukeCore2.default['color-b1-6']);
/// icon
/// @namespace statement/indeterminate
var checkboxNormalIconColorIndeterminate = (0, _nukeVarLoader.varLoader)('checkbox-normal-icon-color-indeterminate', _nukeCore2.default['color-b1-6']);
/// border
/// @namespace statement/indeterminate
var checkboxNormalBorderColorIndeterminate = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-color-indeterminate', _nukeCore2.default['color-b1-6']);
/// background
/// @namespace statement/indeterminate
var checkboxNormalBgColorIndeterminate = (0, _nukeVarLoader.varLoader)('checkbox-normal-bg-color-indeterminate', _nukeCore2.default['color-n1-1']);
/// icon
/// @namespace statement/disabled
var checkboxNormalIconColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-normal-icon-color-disabled', _nukeCore2.default['color-n2-1']);
/// border
/// @namespace statement/disabled
var checkboxNormalBorderColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-normal-border-color-disabled', _nukeCore2.default['color-n1-6']);
/// background
/// @namespace statement/disabled
var checkboxNormalBgColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-normal-bg-color-disabled', _nukeCore2.default['color-n1-2']);

// checkbox - list
// --------------------------------------------------

/// icon
/// @namespace statement/selected
var checkboxListIconColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-list-icon-color-selected', _nukeCore2.default['color-b1-6']);
/// icon
/// @namespace statement/disabled
var checkboxListIconColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-list-icon-color-disabled', _nukeCore2.default['color-n2-1']);
/// border
/// @namespace statement/disabled
var checkboxListBorderColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-list-border-color-disabled', _nukeCore2.default['color-n1-6']);
/// background
/// @namespace statement/disabled
var checkboxListBgColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-list-bg-color-disabled', _nukeCore2.default['color-n1-2']);

// checkbox - dark
// --------------------------------------------------
/// width
/// @namespace size/border
var checkboxDarkBorderWidth = (0, _nukeVarLoader.varLoader)('checkbox-dark-border-width', _nukeCore2.default['line-1-width']);
/// border
/// @namespace statement/normal
var checkboxDarkBorderColor = (0, _nukeVarLoader.varLoader)('checkbox-dark-border-color', _nukeCore2.default['color-n1-1']);
/// border-style
/// @namespace statement/normal
var checkboxDarkBorderStyle = (0, _nukeVarLoader.varLoader)('checkbox-dark-border-style', _nukeCore2.default['line-solid']);
/// corner
/// @namespace statement/normal
var checkboxDarkBorderRadius = (0, _nukeVarLoader.varLoader)('checkbox-dark-border-radius', _nukeCore2.default['corner-radius-circle']);
/// background
/// @namespace statement/normal
var checkboxDarkBgColor = (0, _nukeVarLoader.varLoader)('checkbox-dark-bg-color', _nukeCore2.default['color-n1-9']);
/// icon
/// @namespace statement/selected
var checkboxDarkIconColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-dark-icon-color-selected', _nukeCore2.default['color-n1-1']);
/// border
/// @namespace statement/selected
var checkboxDarkBorderColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-dark-border-color-selected', _nukeCore2.default['color-n1-1']);
/// background
/// @namespace statement/selected
var checkboxDarkBgColorSelected = (0, _nukeVarLoader.varLoader)('checkbox-dark-bg-color-selected', _nukeCore2.default['color-b1-6']);
/// icon
/// @namespace statement/disabled
var checkboxDarkIconColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-dark-icon-color-disabled', _nukeCore2.default['color-n2-1']);
/// border
/// @namespace statement/disabled
var checkboxDarkBorderColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-dark-border-color-disabled', _nukeCore2.default['color-n1-6']);
/// background
/// @namespace statement/disabled
var checkboxDarkBgColorDisabled = (0, _nukeVarLoader.varLoader)('checkbox-dark-bg-color-disabled', _nukeCore2.default['color-n1-2']);

// unconfigurable
var checkboxMediumTouchWidth = (0, _nukeVarLoader.varLoader)('checkbox-medium-touch-width', _nukeCore2.default['s11']);
var checkboxMediumTouchHeight = (0, _nukeVarLoader.varLoader)('checkbox-medium-touch-height', _nukeCore2.default['s11']);
var checkboxSmallTouchWidth = (0, _nukeVarLoader.varLoader)('checkbox-small-touch-width', _nukeCore2.default['s11']);
var checkboxSmallTouchHeight = (0, _nukeVarLoader.varLoader)('checkbox-small-touch-height', _nukeCore2.default['s11']);

module.exports = (_module$exports = {}, _defineProperty(_module$exports, 'checkbox-medium-size-width', checkboxMediumSizeWidth), _defineProperty(_module$exports, 'checkbox-medium-size-height', checkboxMediumSizeHeight), _defineProperty(_module$exports, 'checkbox-medium-icon-size', checkboxMediumIconSize), _defineProperty(_module$exports, 'checkbox-medium-span-text', checkboxMediumSpanText), _defineProperty(_module$exports, 'checkbox-small-size-width', checkboxSmallSizeWidth), _defineProperty(_module$exports, 'checkbox-small-size-height', checkboxSmallSizeHeight), _defineProperty(_module$exports, 'checkbox-small-icon-size', checkboxSmallIconSize), _defineProperty(_module$exports, 'checkbox-small-icon-text', checkboxSmallIconText), _defineProperty(_module$exports, 'checkbox-normal-border-width', checkboxNormalBorderWidth), _defineProperty(_module$exports, 'checkbox-normal-border-color', checkboxNormalBorderColor), _defineProperty(_module$exports, 'checkbox-normal-border-style', checkboxNormalBorderStyle), _defineProperty(_module$exports, 'checkbox-normal-border-radius', checkboxNormalBorderRadius), _defineProperty(_module$exports, 'checkbox-normal-bg-color', checkboxNormalBgColor), _defineProperty(_module$exports, 'checkbox-normal-icon-color-selected', checkboxNormalIconColorSelected), _defineProperty(_module$exports, 'checkbox-normal-border-color-selected', checkboxNormalBorderColorSelected), _defineProperty(_module$exports, 'checkbox-normal-bg-color-selected', checkboxNormalBgColorSelected), _defineProperty(_module$exports, 'checkbox-normal-icon-color-indeterminate', checkboxNormalIconColorIndeterminate), _defineProperty(_module$exports, 'checkbox-normal-border-color-indeterminate', checkboxNormalBorderColorIndeterminate), _defineProperty(_module$exports, 'checkbox-normal-bg-color-indeterminate', checkboxNormalBgColorIndeterminate), _defineProperty(_module$exports, 'checkbox-normal-icon-color-disabled', checkboxNormalIconColorDisabled), _defineProperty(_module$exports, 'checkbox-normal-border-color-disabled', checkboxNormalBorderColorDisabled), _defineProperty(_module$exports, 'checkbox-normal-bg-color-disabled', checkboxNormalBgColorDisabled), _defineProperty(_module$exports, 'checkbox-list-icon-color-selected', checkboxListIconColorSelected), _defineProperty(_module$exports, 'checkbox-list-icon-color-disabled', checkboxListIconColorDisabled), _defineProperty(_module$exports, 'checkbox-list-border-color-disabled', checkboxListBorderColorDisabled), _defineProperty(_module$exports, 'checkbox-list-bg-color-disabled', checkboxListBgColorDisabled), _defineProperty(_module$exports, 'checkbox-dark-border-width', checkboxDarkBorderWidth), _defineProperty(_module$exports, 'checkbox-dark-border-color', checkboxDarkBorderColor), _defineProperty(_module$exports, 'checkbox-dark-border-style', checkboxDarkBorderStyle), _defineProperty(_module$exports, 'checkbox-dark-border-radius', checkboxDarkBorderRadius), _defineProperty(_module$exports, 'checkbox-dark-bg-color', checkboxDarkBgColor), _defineProperty(_module$exports, 'checkbox-dark-icon-color-selected', checkboxDarkIconColorSelected), _defineProperty(_module$exports, 'checkbox-dark-border-color-selected', checkboxDarkBorderColorSelected), _defineProperty(_module$exports, 'checkbox-dark-bg-color-selected', checkboxDarkBgColorSelected), _defineProperty(_module$exports, 'checkbox-dark-icon-color-disabled', checkboxDarkIconColorDisabled), _defineProperty(_module$exports, 'checkbox-dark-border-color-disabled', checkboxDarkBorderColorDisabled), _defineProperty(_module$exports, 'checkbox-dark-bg-color-disabled', checkboxDarkBgColorDisabled), _defineProperty(_module$exports, 'checkbox-medium-touch-width', checkboxMediumTouchWidth), _defineProperty(_module$exports, 'checkbox-medium-touch-height', checkboxMediumTouchHeight), _defineProperty(_module$exports, 'checkbox-small-touch-width', checkboxSmallTouchWidth), _defineProperty(_module$exports, 'checkbox-small-touch-height', checkboxSmallTouchHeight), _module$exports);