
/** @jsx createElement */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('nuke-touchable');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeIcon = require('nuke-icon');

var _nukeIcon2 = _interopRequireDefault(_nukeIcon);

var _nukeEnv = require('nuke-env');

var _styles = require('../styles.js');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CHECKBOX_TYPES = {
  'checkbox': 'checkbox',
  'wrap': 'checkbox-wrap',
  'small': 'checkbox-small',
  'medium': 'checkbox-medium',
  'disabled': 'checkbox-disabled',
  "list-disabled": "checkbox-list-disabled",
  'normal-checked': 'checkbox-normal-checked',
  'empty-checked': 'checkbox-empty-checked',
  'list-checked': 'checkbox-list-checked',
  'touch': 'checkbox-touch'
};
var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight'];

var Checkbox = function (_Component) {
  _inherits(Checkbox, _Component);

  function Checkbox(props, context) {
    _classCallCheck(this, Checkbox);

    var _this = _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    var checked = void 0;
    if (context.value && context.value.indexOf(props.value) > -1) checked = props.value;else {
      if ('checked' in props) checked = props.checked;else checked = props.defaultChecked;
    }
    _this.state = {
      checked: checked
    };
    return _this;
  }

  _createClass(Checkbox, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextContext) {
      if (this.context.__group__) {
        if (_typeof(nextContext.value) == 'object' && nextContext.value.indexOf(nextProps.value) > -1) this.setState({
          checked: true
        });else this.setState({
          checked: false
        });
      } else {
        if ('checked' in nextProps) {
          if (nextProps.checked != this.props.checked) {
            // if(this.props.disabled)
            //     return;
            this.setState({
              checked: nextProps.checked
            });
          }
        }
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      var _props = this.props,
          onChange = _props.onChange,
          disabled = _props.disabled,
          value = _props.value;


      if (disabled) return;
      var tmp = this.state.checked;

      if (this.context && this.context.__group__) {
        this.context.onChange(value, !tmp, value);
      } else {
        if (!('checked' in this.props)) {
          this.setState({
            checked: !tmp
          });
        }
      }
      onChange(!tmp);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          size = _props2.size,
          style = _props2.style,
          disabled = _props2.disabled,
          type = _props2.type,
          checkedStyle = _props2.checkedStyle,
          unCheckedStyle = _props2.unCheckedStyle,
          others = _objectWithoutProperties(_props2, ['size', 'style', 'disabled', 'type', 'checkedStyle', 'unCheckedStyle']);

      var checked = this.state.checked;
      var sizeStyle = _styles2.default[CHECKBOX_TYPES[size]];
      var checkedStyleAll = Object.assign({}, _styles2.default[CHECKBOX_TYPES[type + '-checked']], style, checkedStyle);
      var touchCSS = Object.assign({}, _styles2.default['checkbox-touch-' + size]);
      var unCheckedStyleAll = Object.assign({ backgroundColor: '#ffffff' }, sizeStyle, _styles2.default[CHECKBOX_TYPES['wrap'] + '-' + type + '-' + size], style, unCheckedStyle);

      var disabledStyle = {};
      if (type === 'list') {
        //list的disable样式区别于其他两种
        disabledStyle = _styles2.default[CHECKBOX_TYPES['list-disabled']];
      } else {
        disabledStyle = _styles2.default[CHECKBOX_TYPES['disabled']];
      }

      var iconWrapStyle = Object.assign({}, style, unCheckedStyleAll, checked ? checkedStyleAll : {}, disabled ? disabledStyle : {});
      var iconStyle = Object.assign({}, checked ? { color: checkedStyleAll['color'] } : {}, sizeStyle, disabled ? disabledStyle : {});
      TextAttrArr.forEach(function (item) {
        if (iconWrapStyle[item]) {
          iconStyle[item] = iconWrapStyle[item];
        }
      });

      return (0, _rax.createElement)(
        _nukeTouchable2.default,
        _extends({}, others, { style: touchCSS, onPress: this.onChange }),
        (0, _rax.createElement)(
          _nukeView2.default,
          { style: iconWrapStyle, className: 'nuke-border-fix-1' },
          checked ? (0, _rax.createElement)(_nukeIcon2.default, { style: iconStyle, name: 'right' }) : null
        )
      );
    }
  }]);

  return Checkbox;
}(_rax.Component);

Checkbox.propTypes = {
  checked: _rax.PropTypes.bool,
  defaultChecked: _rax.PropTypes.bool,
  size: _rax.PropTypes.oneOf(['small', 'medium']),
  disabled: _rax.PropTypes.bool,
  onChange: _rax.PropTypes.func,
  type: _rax.PropTypes.oneOf(['normal', 'list', 'empty']),
  value: _rax.PropTypes.any
};

Checkbox.defaultProps = {
  size: 'medium',
  disabled: false,
  defaultChecked: false,
  onChange: function onChange() {},
  type: 'normal',
  value: ''
};
Checkbox.contextTypes = {
  onChange: _rax.PropTypes.func,
  __group__: _rax.PropTypes.bool,
  value: _rax.PropTypes.any
};
exports.default = Checkbox;
module.exports = exports['default'];