
/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import ScrollView from 'nuke-scroll-view';
import Checkbox from 'nuke-checkbox';
import Button from 'nuke-button';
import core from 'nuke-core';

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            checked:true,
            dataSource:[
                {value: 'apple', label: '苹果'},
                {value: 'pear', label: '梨', disabled: true},
                {value: 'orange', label: '橘子'}
            ],
            value:['apple'],
            group_value:[3,4]
        }
    }
    changeData(){
        let newSource = [
            {value: 'apple', label: '苹果',disabled: true},
            {value: 'pear', label: '梨',disabled: true},
            {value: 'orange', label: '橘子',disabled: true}
            ];
            var tmp = this.state.checked;
            this.setState({
                dataSource:newSource,
                checked:!tmp
            })
    }

    onChange(value){
      console.log(value);
    }
    onChangeGroup(value){
      console.log(value);
    }

    press(){
        let tmp = this.state.group_value;
        tmp.pop()
        this.setState({
            group_value:tmp
        })
        console.log(this.state.group_value);
    }

    onChangeState(value){
        this.setState({
            value:value
            })
        console.log(this.state.value)
    }

    changeControl(value){
        console.log(value)
    }

    render() {
        return (
            <ScrollView>
               <Text>----基本使用----非受限用法----</Text>
               <Checkbox defaultChecked={false} size="small"></Checkbox>
               <Text>----基本使用----受限用法----{this.state.checked}----</Text>
               <Checkbox checked={this.state.checked} size="medium" onChange={this.changeControl.bind(this)}></Checkbox>
                 <Text>--------问题复现----受限用法----{this.state.checked}---</Text>
                 <Checkbox checked={this.state.checked} size="small" disabled={true} onChange={this.changeControl.bind(this)}></Checkbox>
               <View>
               <Text>------dataSource用法-----{this.state.value}------ </Text>
                 <Button onPress={this.changeData.bind(this)}>点击切换datasource</Button>
                 <Checkbox.Group value={this.state.value} onChange={ this.onChangeState.bind(this) }size="small" dataSource={ this.state.dataSource }></Checkbox.Group>
               </View>
               <View>
                 <Text>-----自定义group用法-------{JSON.stringify(this.state.group_value)}--</Text>
                 <Button onPress={this.press.bind(this)}>受限使用+{this.state.group_value}</Button>
                 <Checkbox.Group onChange={this.onChangeGroup.bind(this)} value={this.state.group_value}>
                     <Checkbox value={3} style={{marginTop:'10px'}}  size="small"></Checkbox>
                     <Checkbox value={4} style={{marginTop:'10px'}}  size="medium"></Checkbox>
                 </Checkbox.Group>
               </View>
            </ScrollView>
        );
    }
}

render(<App/>);
