/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Checkbox from 'nuke-checkbox';
import Page from 'nuke-page';

const Styles = {
    demo_item:{
        width:750,
        height:104,
        marginTop:30,
        backgroundColor:'#ffffff',
        justifyContent:'center',
        paddingLeft:12
    }
}

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            checked:false
        }
    }
    render() {
        return (
            <Page title="checkbox">
                <Page.Intro main="Checkbox" sub="normal"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small"></Checkbox>
                </View>
                <Page.Intro sub="selected"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" defaultChecked={true}></Checkbox>
                </View>
                <Page.Intro sub="selected"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" defaultChecked={true} type="empty"></Checkbox>
                </View>
                <Page.Intro sub="disabled"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" disabled={true} type="normal"></Checkbox>
                </View>
                 <Page.Intro sub="disabled-selected"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" disabled={true} defaultChecked={true} type="empty"></Checkbox>
                </View>
                <Page.Intro main="Checkbox-List" sub="normal"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" defaultChecked={false} type="list"></Checkbox>
                </View>
                 <Page.Intro sub="selected"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" defaultChecked={true} type="list"></Checkbox>
                </View>
                 <Page.Intro sub="disabled"></Page.Intro>
                 <View style={Styles.demo_item}>
                    <Checkbox size="small" disabled={true} defaultChecked={false} type="list"></Checkbox>
                </View>
                 <Page.Intro sub="disabled-selected"></Page.Intro>
                <View style={Styles.demo_item}>
                    <Checkbox size="small" disabled={true} defaultChecked={true} type="list"></Checkbox>
                </View>
            </Page>
        );
    }
}
render(<App/>);