# 滚动视图

- order: 0

可以滚动到指定位置

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import { View, Text , ScrollView} from 'nuke-components';
import Button from 'nuke-button';
import Modal from 'nuke-modal';
import Page from 'nuke-page';

let arr=[
    {key:'A',bg:'#1170bc',color:'#ffffff'},
    {key:'B',bg:'#3089dc',color:'#ffffff'},
    {key:'C',bg:'#f1f1f1',color:'#3d4145'}
]
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
    }
    getViews(){
        let doms=[];
        arr.forEach(function(item,index) {
            doms.push(<View style={[styles.item,{backgroundColor:item.bg}]}>
                    <Text style={{color:item.color}}>{item.key}</Text>
                </View>
            );
        });
        
        return doms;
    }
    render() {
        return (
            <Page title="ScrollView">
                <Page.Intro main="Vertical Scroll" sub="纵向滚动"></Page.Intro>
                <ScrollView ref="vscroller" style={styles.vscroller}  onEndReachedThreshold={20} onEndReached={this.loadmore}>
                    {this.getViews()}
                </ScrollView>
                <Page.Intro main="Horizontal Scroll" sub="横向滚动"></Page.Intro>
                <ScrollView ref="hscroller" horizontal={true} style={styles.hscroller}  onEndReachedThreshold={20}>
                    {this.getViews()}
                </ScrollView>
                
            </Page>
        )
    }
}
const styles={
    vscroller:{
        paddingLeft:'75rem',
        paddingRight:'75rem',
        height:'300rem',
        marginTop:'65rem',
        marginBottom:'80rem'
    },
    hscroller:{
        marginLeft:'75rem',
        marginTop:'65rem',
        marginRight:'75rem',
        marginBottom:'80rem',
        height:'300rem',
        width:'600rem'
    },
    item:{
        height:'300rem',
        width:'600rem',
        alignItems:'center',
        justifyContent:'center',
    }
}
render(<App/>);

````
