# 开关切换

- order: 0

开关切换，受控用法

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import { View, Text, Switch } from 'nuke-components';
import Page from 'nuke-page';
import Modal from 'nuke-modal';


let App = class NukeDemoIndex extends Component {
    constructor() {
        super();

        this.state = {
            advanced: false,
            disabled:true
        };
        setTimeout(()=>{
            this.setState({
                disabled:false
            })
        },4000)
    }


    onValueChange(value){
        this.setState({advanced:value});
        setTimeout(()=>{
            Modal.toast('对不起，您没有权限打开高级版~');
            this.setState({advanced:false})
        },2000);
    }
    render() {
        let disabledProps = this.state.disabled ? {disabled:this.state.disabled} : {};
        return (
            <Page title="Switch">
                <Page.Intro main="normal"></Page.Intro>
                <View style={styles.row}>
                    <View style={styles.cellItem}>
                        <Text style={styles.cellTitle}>M</Text>
                        <Switch />

                    </View>

                </View>

                <Page.Intro main="disabled"></Page.Intro>
                <View style={styles.row}>
                    <View style={styles.cellItem}>
                        <Switch disabled checked={true}/>

                    </View>
                </View>
                <Page.Intro main="双向绑定用于某些逻辑处理"></Page.Intro>
                <View style={styles.row}>
                    <View style={styles.cellItem}>
                        <Text style={styles.cellTitle}>开启高级版</Text>
                        <Switch checked={this.state.advanced} onValueChange={this.onValueChange.bind(this)} />

                    </View>

                </View>
                <Page.Intro main="先 disabled 再 enabled"></Page.Intro>
                <View style={styles.row}>
                    <View style={styles.cellItem}>
                        <Text style={styles.cellTitle}>disabled:{this.state.disabled}</Text>
                        <Switch {...disabledProps} />

                    </View>

                </View>
            </Page>
        );
    }
}
const styles={
    row:{
        flexDirection:'row',
        paddingLeft:'40rem',
        marginTop:'30rem'
    },
    cellItem:{
        width:'200rem',
        height:'120rem',
        // justifyContent:'center'
    },

    cellTitle:{
        marginLeft:'10rem',
        fontSize:'30rem',
        color:'#999999'
    }
}
render(<App/>);

````
