# 文字

- order: 0

文本

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import { View, Text} from 'nuke-components';
import Page from 'nuke-page';

const FontSizeArr=[
    {name:'FootNote',size:10},
    {name:'Caption',size:12},
    {name:'Body',size:14},
    {name:'SubHead',size:16},
    {name:'HeadLine',size:18},
    {name:'Display',size:28}

    
]

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
    }
    render() {
        return (
            <Page title="Text">
                <Page.Intro main="Normal"></Page.Intro>
                {
                    FontSizeArr.map((item,index)=>{
                        return (
                            <View style={styles.textLine}>
                                <View style={styles.label}>
                                    <Text style={styles.labelText}>{item.name}</Text>
                                </View>
                                <View style={styles.result}>
                                    <Text style={[styles.resultText,{fontSize : item.size * 2 + 'rem'}]}>常规 {item.size*2} rem</Text>
                                </View>
                            </View>
                        )
                    })
                }
                <Page.Intro main="固定字号" sub="仅native生效"></Page.Intro>
                <View style={styles.textLine}>
                    <View style={styles.label}>
                        <Text style={styles.labelText}>14wx</Text>
                    </View>
                    <View style={styles.result}>
                        <Text style={[styles.resultText,{fontSize : '14wx'}]}>14wx</Text>
                    </View>
                </View>
                <View style={styles.textLine}>
                    <View style={styles.label}>
                        <Text style={styles.labelText}>16wx</Text>
                    </View>
                    <View style={styles.result}>
                        <Text style={[styles.resultText,{fontSize : '16wx'}]}>16wx</Text>
                    </View>
                </View>
                <View style={styles.textLine}>
                    <View style={styles.label}>
                        <Text style={styles.labelText}>20wx</Text>
                    </View>
                    <View style={styles.result}>
                        <Text style={[styles.resultText,{fontSize : '20wx'}]}>20wx</Text>
                    </View>
                </View>
            </Page>
        )
    }
}
const styles={
    textLine:{
        justifyContent:'center',
        alignItems:'center',
        paddingLeft:'40rem',
        paddingRight:'40rem',
        marginTop:'40rem',
        flexDirection:'row'
    },
    label:{
        width:'150rem',
    },
    labelText:{
        color:'#ea118d',
        fontSize:'20rem'
    },
    result:{
        flex:1
    },
    resultText:{
        color:'#333940',
    }

}
render(<App/>);

````
