/* @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeEnv = require('nuke-env');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var Switch = function (_Component) {
    _inherits(Switch, _Component);

    function Switch(props) {
        _classCallCheck(this, Switch);

        var _this = _possibleConstructorReturn(this, (Switch.__proto__ || Object.getPrototypeOf(Switch)).call(this, props));

        _initialiseProps.call(_this);

        var checked = false;
        if ('checked' in props) {
            checked = props.checked;
        } else {
            checked = props.defaultChecked;
        }

        _this.state = {
            checked: checked
            // indeterminate
        };
        return _this;
    }

    _createClass(Switch, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if ('checked' in nextProps) {
                this.setState({ checked: nextProps.checked });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                style = _props.style,
                _props$disabled = _props.disabled,
                disabled = _props$disabled === undefined ? false : _props$disabled,
                size = _props.size,
                onValueChange = _props.onValueChange,
                others = _objectWithoutProperties(_props, ['style', 'disabled', 'size', 'onValueChange']);

            var checked = this.state.checked;


            if (_nukeEnv.isWeex) {
                var nativeProps = {
                    style: _extends({}, styles.initial, this.props.style),
                    disabled: disabled,
                    checked: checked,
                    onChange: this.handleClick
                };
                // if(disabled){
                //     nativeProps.disabled = disabled;
                // }

                return (0, _rax.createElement)('switch', _extends({}, nativeProps, others));
            } else {
                var _styles = this.getStyles();
                var wraperStyle = Object.assign({}, _styles.span, checked ? _styles.checkedSpan : _styles.uncheckedSpan, disabled ? _styles.disabledSpan : {});

                var innerStyle = Object.assign({}, _styles.small, checked ? _styles.checkedSmall : _styles.uncheckedSmall);

                return (0, _rax.createElement)(
                    'span',
                    _extends({ onClick: this.handleClick.bind(this), style: wraperStyle }, others, { className: 'nuke-border-fix-1' }),
                    (0, _rax.createElement)('small', { style: innerStyle })
                );
            }
        }
    }, {
        key: 'getStyles',
        value: function getStyles() {
            var sizeObj = this.props.size === 'small' ? Size.small : Size.medium;
            return {
                span: {
                    width: sizeObj.width,
                    height: sizeObj.height,
                    borderRadius: sizeObj.borderRadius,
                    position: 'relative',
                    display: 'inline-block',
                    margin: '4rem',
                    cursor: 'default', // pointer will cause a grey background color on chrome
                    verticalAlign: 'middle',
                    borderColor: '#dfdfdf',
                    borderWidth: '1rem',
                    borderStyle: 'solid',
                    WebkitUserSelect: 'none',
                    WebkitBoxSizing: 'content-box',
                    WebkitBackfaceVisibility: 'hidden'
                },
                checkedSpan: {
                    borderColor: this.props.onTintColor,
                    backgroundColor: this.props.onTintColor,
                    boxShadow: this.props.onTintColor + ' 0 0 0 16px inset',
                    WebkitTransition: 'border 0.2s, box-shadow 0.2s, background-color 1s'
                },
                uncheckedSpan: {
                    borderColor: '#dfdfdf',
                    backgroundColor: this.props.tintColor,
                    boxShadow: '#dfdfdf 0 0 0 0 inset',
                    WebkitTransition: 'border 0.2s, box-shadow 0.2s'
                },
                disabledSpan: {
                    opacity: 0.5,
                    cursor: 'not-allowed',
                    boxShadow: 'none'
                },
                small: {
                    position: 'absolute',
                    top: 0,
                    width: sizeObj.height,
                    height: sizeObj.height,
                    backgroundColor: this.props.thumbTintColor,
                    borderRadius: '100%',
                    boxShadow: '0 1px 3px rgba(0,0,0,0.4)',
                    WebkitTransition: '-webkit-transform 0.2s ease-in'
                },
                checkedSmall: {
                    WebkitTransform: 'translateX(' + sizeObj.animLength + ')'
                },
                uncheckedSmall: {
                    WebkitTransform: 'translateX(0)'
                }
            };
        }
    }]);

    return Switch;
}(_rax.Component);

Switch.defaultProps = {
    onValueChange: noop,
    size: 'medium',
    defaultChecked: false,
    defaultIndeterminate: false,
    onTintColor: '#00e158',
    thumbTintColor: '#fff',
    tintColor: '#ffffff'
};

var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.handleClick = function (e) {
        var _props2 = _this2.props,
            _props2$disabled = _props2.disabled,
            disabled = _props2$disabled === undefined ? false : _props2$disabled,
            onValueChange = _props2.onValueChange;

        if (disabled) {
            return null;
        }
        var checked = !_this2.state.checked;
        if (!('checked' in _this2.props)) {
            _this2.setState({
                checked: checked
            });
        }

        onValueChange(checked, e);
    };
};

var Size = {
    medium: {
        width: '100rem',
        height: '60rem',
        borderRadius: '40rem',
        animLength: '40rem'
    },
    small: {
        width: '80rem',
        height: '48rem',
        borderRadius: '24rem',
        animLength: '32rem'
    }
};
var styles = {
    initial: {
        width: Size.medium.width,
        height: Size.medium.height
    }
};

exports.default = Switch;
module.exports = exports['default'];