'use strict';

// ////
// /// @group Utils 工具
// ////

// /// 去除数值单位的方法
// ///
// /// @param {String} $value
// ///   带单位的数值
// ///
// /// @example.rxscss -.rxscss 用法
// ///   $dimension: strip-units(10px);
// ///
// /// @example css - CSS 输出
// ///   $dimension: 10;
// ///
// /// @return {Number}
// function stripUnits(value) {
//     return (value / (value * 0 + 1));
// }

// /// 检查一个值是否为合法的CSS长度
// ///
// /// @param {String} $value
// /// @return {Number}
// function isLength(value) {
//     @return typeOf(value) != "null" and (strSlice(value + "", 1, 4) == "calc" // 是calc函数来计算的长度
//     or typeOf(index(auto inherit initial 0, value)) == 'number'
//     or (typeOf(value) == "number" and not(unitless(value))));
// }

// /// 将pixel单位转换为em单位
// ///
// /// @param {Number} $pxval
// ///   pixel单位下的数值
// ///
// /// @param {Number} $base
// ///   全局基础pixel单位下的字号
// ///
// /// @example.rxscss -.rxscss 用法
// ///   .element {
// ///     font-size: em(12, 14);
// ///   }
// ///
// /// @example css - CSS 输出
// ///   .element {
// ///     font-size: 0.85714em;
// ///   }
// /// @require {function} strip-units
// /// @require {variable} $font-size-base-body1
// ///
// /// @return {String}

// function em(pxval, base: fontSizeBaseBody1) {
//     @if not unitless(pxval) {
//         pxval: stripUnits(pxval);
//     }
//     @if not unitless(base) {
//         base: stripUnits(base);
//     }
//     @return (pxval / base) * 1em;
// }

// /// 将pixel单位转换为rem单位
// ///
// /// @param {Number} $pxval
// ///   pixel单位下的数值
// ///
// /// @param {Number} $base
// ///   全局基础pixel单位下的宽高或者字号
// ///
// /// @example.rxscss -.rxscss 用法
// ///   .element {
// ///     font-size: dp2rem(375);
// ///   }
// ///
// /// @example css - CSS 输出
// ///   .element {
// ///     font-size: 10rem;
// /// @require {function} strip-units
// /// @require {variable} $rem-base
// ///
// /// @return {String}
// function dp2rem(dp) {
//     @if (unit(dp) == rem) {
//         @return dp;
//     } @else {
//         @return stripUnits(dp) / remBase * 1rem;
//     }
// }


// /// 转化为四值属性的方法，该属性可以有 1 到 4 个值，如：margin, padding, position
// ///
// /// @param {List} $shorthand
// ///
// /// @example.rxscss -.rxscss 用法
// ///   .element {
// ///     margin: unpack(1em 2em);
// ///     padding: unpack(1em 2em 2em);
// ///   }
// ///
// /// @example css - CSS 输出
// ///   .element {
// ///     margin: 1em 2em 1em 2em;
// ///     padding: 1em 2em 2em 2em;
// ///   }
// ///
// /// @return {List}
// function unpack(shorthand) {
//     @if length(shorthand) == 1 {
//         @return nth(shorthand, 1) nth(shorthand, 1) nth(shorthand, 1) nth(shorthand, 1);
//     } @else if length(shorthand) == 2 {
//         @return nth(shorthand, 1) nth(shorthand, 2) nth(shorthand, 1) nth(shorthand, 2);
//     } @else if length(shorthand) == 3 {
//         @return nth(shorthand, 1) nth(shorthand, 2) nth(shorthand, 3) nth(shorthand, 2);
//     } @else {
//         @return shorthand;
//     }
// }

/// 圆角生成器
///
/// @access private
///
/// @param {String} $side [$corner-sides-base] - 需要加圆角的面
/// @param {String} $radius [$corner-radius-base] - 圆角曲率
///
/// @example.rxscss -.rxscss 用法
///   .element {
///     border-radius: corner-maker();
///   }
///
/// @example css - CSS 输出
///   .element {
///     border-radius: 3px 3px 3px 3px;
///   }
///
/// @return {List}


module.exports = {
    // stripUnits,
    // isLength,
    // em,
    // dp2rem,
    // unpack,
};