'use strict';

var _module$exports;

var _nukeVarLoader = require('nuke-var-loader');

var _color = require('./_color');

var _color2 = _interopRequireDefault(_color);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

////
/// @group Variables 变量
/// @module shadow: 阴影
/// @category style
////


/// 阴影x方向常规值
/// @unconfigurable
/// @access private
/// @type {Number}
var shadowX = (0, _nukeVarLoader.varLoader)('shadow-x', 1);

/// 阴影y方向常规值
/// @unconfigurable
/// @access private
/// @type {Number}
var shadowY = (0, _nukeVarLoader.varLoader)('shadow-y', shadowX);

/// Distance 1
/// @type {Number}
var shadowDistanceSd1 = (0, _nukeVarLoader.varLoader)('shadow-distance-sd1', '1');
/// Distance 2
/// @type {Number}
var shadowDistanceSd2 = (0, _nukeVarLoader.varLoader)('shadow-distance-sd2', '2');
/// Distance 3
/// @type {Number}
var shadowDistanceSd3 = (0, _nukeVarLoader.varLoader)('shadow-distance-sd3', '3');
/// Distance 4
/// @type {Number}
var shadowDistanceSd4 = (0, _nukeVarLoader.varLoader)('shadow-distance-sd4', '4');
/// Distance 5
/// @type {Number}
var shadowDistanceSd5 = (0, _nukeVarLoader.varLoader)('shadow-distance-sd5', '5');

/// Opacity 1
/// @type {Number}
var shadowOpacitySd1 = (0, _nukeVarLoader.varLoader)('shadow-opacity-sd1', '0.32');
/// Opacity 2
/// @type {Number}
var shadowOpacitySd2 = (0, _nukeVarLoader.varLoader)('shadow-opacity-sd2', '0.32');
/// Opacity 3
/// @type {Number}
var shadowOpacitySd3 = (0, _nukeVarLoader.varLoader)('shadow-opacity-sd3', '0.32');
/// Opacity 4
/// @type {Number}
var shadowOpacitySd4 = (0, _nukeVarLoader.varLoader)('shadow-opacity-sd4', '0.32');
/// Opacity 4
/// @type {Number}
var shadowOpacitySd5 = (0, _nukeVarLoader.varLoader)('shadow-opacity-sd5', '0.32');

/// Color 1
/// @type {Color}
var shadowColorSd1 = (0, _nukeVarLoader.varLoader)('shadow-color-sd1', _color2.default['color-n1-9']);

/// Color 2
/// @type {Color}
var shadowColorSd2 = (0, _nukeVarLoader.varLoader)('shadow-color-sd2', _color2.default['color-n1-9']);

/// Color 3
/// @type {Color}
var shadowColorSd3 = (0, _nukeVarLoader.varLoader)('shadow-color-sd3', _color2.default['color-n1-9']);

/// Color 4
/// @type {Color}
var shadowColorSd4 = (0, _nukeVarLoader.varLoader)('shadow-color-sd4', _color2.default['color-n1-9']);

/// Color 5
/// @type {Color}
var shadowColorSd5 = (0, _nukeVarLoader.varLoader)('shadow-color-sd5', _color2.default['color-n1-9']);

var shadowColorOpacitySd1 = (0, _nukeVarLoader.varLoader)('shadow-color-opacity-sd1', 'rgba(' + shadowColorSd1 + ', ' + shadowOpacitySd1 + ')');
var shadowColorOpacitySd2 = (0, _nukeVarLoader.varLoader)('shadow-color-opacity-sd2', 'rgba(' + shadowColorSd2 + ', ' + shadowOpacitySd2 + ')');
var shadowColorOpacitySd3 = (0, _nukeVarLoader.varLoader)('shadow-color-opacity-sd3', 'rgba(' + shadowColorSd3 + ', ' + shadowOpacitySd3 + ')');
var shadowColorOpacitySd4 = (0, _nukeVarLoader.varLoader)('shadow-color-opacity-sd4', 'rgba(' + shadowColorSd4 + ', ' + shadowOpacitySd4 + ')');
var shadowColorOpacitySd5 = (0, _nukeVarLoader.varLoader)('shadow-color-opacity-sd5', 'rgba(' + shadowColorSd5 + ', ' + shadowOpacitySd5 + ')');

var shadowSidesBase = (0, _nukeVarLoader.varLoader)('shadow-sides-base', "base");
var shadowSidesUp = (0, _nukeVarLoader.varLoader)('shadow-sides-up', "up");
var shadowSidesRight = (0, _nukeVarLoader.varLoader)('shadow-sides-right', "right");
var shadowSidesDown = (0, _nukeVarLoader.varLoader)('shadow-sides-down', "down");
var shadowSidesLeft = (0, _nukeVarLoader.varLoader)('shadow-sides-left', "left");

/// Blur 1
/// @type {Number}
var shadowElevationSd1 = (0, _nukeVarLoader.varLoader)('shadow-elevation-sd1', '3');

/// Blur 2
/// @type {Number}
var shadowElevationSd2 = (0, _nukeVarLoader.varLoader)('shadow-elevation-sd2', '3');

/// Blur 3
/// @type {Number}
var shadowElevationSd3 = (0, _nukeVarLoader.varLoader)('shadow-elevation-sd3', '5');

/// Blur 4
/// @type {Number}
var shadowElevationSd4 = (0, _nukeVarLoader.varLoader)('shadow-elevation-sd4', '7');

/// Blur 5
/// @type {Number}
var shadowElevationSd5 = (0, _nukeVarLoader.varLoader)('shadow-elevation-sd5', '10');

/// Shadow 0
/// @export
/// @access private
/// @unconfigurable
var shadowSd0 = (0, _nukeVarLoader.varLoader)('shadow-sd0', shadowMaker(shadowSidesBase, 0, 1, 0, 0));

/// Shadow 1
/// @export
/// @access private
/// @unconfigurable
var shadowSd1 = (0, _nukeVarLoader.varLoader)('shadow-sd1', shadowMaker(shadowSidesBase, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Up)
/// @export
/// @access private
/// @unconfigurable
var shadowSd1Up = (0, _nukeVarLoader.varLoader)('shadow-sd1-up', shadowMaker(shadowSidesUp, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Right)
/// @export
/// @access private
/// @unconfigurable
var shadowSd1Right = (0, _nukeVarLoader.varLoader)('shadow-sd1-right', shadowMaker(shadowSidesRight, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Down)
/// @export
/// @access private
/// @unconfigurable
var shadowSd1Down = (0, _nukeVarLoader.varLoader)('shadow-sd1-down', shadowMaker(shadowSidesDown, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Left)
/// @export
/// @access private
/// @unconfigurable
var shadowSd1Left = (0, _nukeVarLoader.varLoader)('shadow-sd1-left', shadowMaker(shadowSidesLeft, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 2
/// @export
/// @access private
/// @unconfigurable
var shadowSd2 = (0, _nukeVarLoader.varLoader)('shadow-sd2', shadowMaker(shadowSidesBase, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Up)
/// @export
/// @access private
/// @unconfigurable
var shadowSd2Up = (0, _nukeVarLoader.varLoader)('shadow-sd2-up', shadowMaker(shadowSidesUp, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Right)
/// @export
/// @access private
/// @unconfigurable
var shadowSd2Right = (0, _nukeVarLoader.varLoader)('shadow-sd2-right', shadowMaker(shadowSidesRight, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Down)
/// @export
/// @access private
/// @unconfigurable
var shadowSd2Down = (0, _nukeVarLoader.varLoader)('shadow-sd2-down', shadowMaker(shadowSidesDown, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Left)
/// @export
/// @access private
/// @unconfigurable
var shadowSd2Left = (0, _nukeVarLoader.varLoader)('shadow-sd2-left', shadowMaker(shadowSidesLeft, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));

/// Shadow 3
/// @export
/// @access private
/// @unconfigurable
var shadowSd3 = (0, _nukeVarLoader.varLoader)('shadow-sd3', shadowMaker(shadowSidesBase, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Up)
/// @export
/// @access private
/// @unconfigurable
var shadowSd3Up = (0, _nukeVarLoader.varLoader)('shadow-sd3-up', shadowMaker(shadowSidesUp, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Right)
/// @export
/// @access private
/// @unconfigurable
var shadowSd3Right = (0, _nukeVarLoader.varLoader)('shadow-sd3-right', shadowMaker(shadowSidesRight, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Down)
/// @export
/// @access private
/// @unconfigurable
var shadowSd3Down = (0, _nukeVarLoader.varLoader)('shadow-sd3-down', shadowMaker(shadowSidesDown, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Left)
/// @export
/// @access private
/// @unconfigurable
var shadowSd3Left = (0, _nukeVarLoader.varLoader)('shadow-sd3-left', shadowMaker(shadowSidesLeft, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));

/// Shadow 4
/// @export
/// @access private
/// @unconfigurable
var shadowSd4 = (0, _nukeVarLoader.varLoader)('shadow-sd4', shadowMaker(shadowSidesBase, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Up)
/// @export
/// @access private
/// @unconfigurable
var shadowSd4Up = (0, _nukeVarLoader.varLoader)('shadow-sd4-up', shadowMaker(shadowSidesUp, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Right)
/// @export
/// @access private
/// @unconfigurable
var shadowSd4Right = (0, _nukeVarLoader.varLoader)('shadow-sd4-right', shadowMaker(shadowSidesRight, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Down)
/// @export
/// @access private
/// @unconfigurable
var shadowSd4Down = (0, _nukeVarLoader.varLoader)('shadow-sd4-down', shadowMaker(shadowSidesDown, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Left)
/// @export
/// @access private
/// @unconfigurable
var shadowSd4Left = (0, _nukeVarLoader.varLoader)('shadow-sd4-left', shadowMaker(shadowSidesLeft, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));

/// Shadow 5
/// @export
/// @access private
/// @unconfigurable
var shadowSd5 = (0, _nukeVarLoader.varLoader)('shadow-sd5', shadowMaker(shadowSidesBase, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Up)
/// @export
/// @access private
/// @unconfigurable
var shadowSd5Up = (0, _nukeVarLoader.varLoader)('shadow-sd5-up', shadowMaker(shadowSidesUp, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Right)
/// @export
/// @access private
/// @unconfigurable
var shadowSd5Right = (0, _nukeVarLoader.varLoader)('shadow-sd5-right', shadowMaker(shadowSidesRight, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Down)
/// @export
/// @access private
/// @unconfigurable
var shadowSd5Down = (0, _nukeVarLoader.varLoader)('shadow-sd5-down', shadowMaker(shadowSidesDown, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Left)
/// @export
/// @access private
/// @unconfigurable
var shadowSd5Left = (0, _nukeVarLoader.varLoader)('shadow-sd5-left', shadowMaker(shadowSidesLeft, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));

function shadowMaker() {
    var direction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : shadowSidesBase;
    var elevation = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : shadowElevationSd1;
    var shadowColor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : shadowColorOpacitySd1;
    var shadowX = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : shadowX;
    var shadowY = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : shadowY;


    var x = shadowX;
    var y = shadowY;
    var e = elevation;
    var c = shadowColor;

    if (e == 0) {
        return '0 0 0 #ffffff';
    }

    if (direction == shadowSidesUp) {
        x = 0;
        y = shadowY;
    } else if (direction == shadowSidesRight) {
        y = 0;
    } else if (direction == shadowSidesDown) {
        x = 0;
    } else if (direction == shadowSidesLeft) {
        x = shadowX;
        y = 0;
    }

    return x + 'px ' + y + 'px ' + e + 'px ' + c;
}

module.exports = (_module$exports = {}, _defineProperty(_module$exports, 'shadow-x', shadowX), _defineProperty(_module$exports, 'shadow-y', shadowY), _defineProperty(_module$exports, 'shadow-distance-sd1', shadowDistanceSd1), _defineProperty(_module$exports, 'shadow-distance-sd2', shadowDistanceSd2), _defineProperty(_module$exports, 'shadow-distance-sd3', shadowDistanceSd3), _defineProperty(_module$exports, 'shadow-distance-sd4', shadowDistanceSd4), _defineProperty(_module$exports, 'shadow-distance-sd5', shadowDistanceSd5), _defineProperty(_module$exports, 'shadow-opacity-sd1', shadowOpacitySd1), _defineProperty(_module$exports, 'shadow-opacity-sd2', shadowOpacitySd2), _defineProperty(_module$exports, 'shadow-opacity-sd3', shadowOpacitySd3), _defineProperty(_module$exports, 'shadow-opacity-sd4', shadowOpacitySd4), _defineProperty(_module$exports, 'shadow-opacity-sd5', shadowOpacitySd5), _defineProperty(_module$exports, 'shadow-color-sd1', shadowColorSd1), _defineProperty(_module$exports, 'shadow-color-sd2', shadowColorSd2), _defineProperty(_module$exports, 'shadow-color-sd3', shadowColorSd3), _defineProperty(_module$exports, 'shadow-color-sd4', shadowColorSd4), _defineProperty(_module$exports, 'shadow-color-sd5', shadowColorSd5), _defineProperty(_module$exports, 'shadow-color-opacity-sd1', shadowColorOpacitySd1), _defineProperty(_module$exports, 'shadow-color-opacity-sd2', shadowColorOpacitySd2), _defineProperty(_module$exports, 'shadow-color-opacity-sd3', shadowColorOpacitySd3), _defineProperty(_module$exports, 'shadow-color-opacity-sd4', shadowColorOpacitySd4), _defineProperty(_module$exports, 'shadow-color-opacity-sd5', shadowColorOpacitySd5), _defineProperty(_module$exports, 'shadow-sides-base', shadowSidesBase), _defineProperty(_module$exports, 'shadow-sides-up', shadowSidesUp), _defineProperty(_module$exports, 'shadow-sides-right', shadowSidesRight), _defineProperty(_module$exports, 'shadow-sides-down', shadowSidesDown), _defineProperty(_module$exports, 'shadow-sides-left', shadowSidesLeft), _defineProperty(_module$exports, 'shadow-elevation-sd1', shadowElevationSd1), _defineProperty(_module$exports, 'shadow-elevation-sd2', shadowElevationSd2), _defineProperty(_module$exports, 'shadow-elevation-sd3', shadowElevationSd3), _defineProperty(_module$exports, 'shadow-elevation-sd4', shadowElevationSd4), _defineProperty(_module$exports, 'shadow-elevation-sd5', shadowElevationSd5), _defineProperty(_module$exports, 'shadow-sd0', shadowSd0), _defineProperty(_module$exports, 'shadow-sd1', shadowSd1), _defineProperty(_module$exports, 'shadow-sd1-up', shadowSd1Up), _defineProperty(_module$exports, 'shadow-sd1-right', shadowSd1Right), _defineProperty(_module$exports, 'shadow-sd1-down', shadowSd1Down), _defineProperty(_module$exports, 'shadow-sd1-left', shadowSd1Left), _defineProperty(_module$exports, 'shadow-sd2', shadowSd2), _defineProperty(_module$exports, 'shadow-sd2-up', shadowSd2Up), _defineProperty(_module$exports, 'shadow-sd2-right', shadowSd2Right), _defineProperty(_module$exports, 'shadow-sd2-down', shadowSd2Down), _defineProperty(_module$exports, 'shadow-sd2-left', shadowSd2Left), _defineProperty(_module$exports, 'shadow-sd3', shadowSd3), _defineProperty(_module$exports, 'shadow-sd3-up', shadowSd3Up), _defineProperty(_module$exports, 'shadow-sd3-right', shadowSd3Right), _defineProperty(_module$exports, 'shadow-sd3-down', shadowSd3Down), _defineProperty(_module$exports, 'shadow-sd3-left', shadowSd3Left), _defineProperty(_module$exports, 'shadow-sd4', shadowSd4), _defineProperty(_module$exports, 'shadow-sd4-up', shadowSd4Up), _defineProperty(_module$exports, 'shadow-sd4-right', shadowSd4Right), _defineProperty(_module$exports, 'shadow-sd4-down', shadowSd4Down), _defineProperty(_module$exports, 'shadow-sd4-left', shadowSd4Left), _defineProperty(_module$exports, 'shadow-sd5', shadowSd5), _defineProperty(_module$exports, 'shadow-sd5-up', shadowSd5Up), _defineProperty(_module$exports, 'shadow-sd5-right', shadowSd5Right), _defineProperty(_module$exports, 'shadow-sd5-down', shadowSd5Down), _defineProperty(_module$exports, 'shadow-sd5-left', shadowSd5Left), _defineProperty(_module$exports, 'shadowMaker', shadowMaker), _module$exports);