'use strict';

import { varLoader } from 'nuke-var-loader';


////
/// @group Variables 变量
/// @module font: 字体
/// @type String
/// @category style
/// @export
////



/// Light
/// @export weightcore
/// @unconfigurable
let fontWeightCoreLight = varLoader('font-weight-core-light', 'lighter');

/// Thin
/// @export weightcore
/// @unconfigurable
let fontWeightCoreThin = varLoader('font-weight-core-thin', '200');

/// Regular
/// @export weightcore
/// @unconfigurable
let fontWeightCoreRegular = varLoader('font-weight-core-regular', 'normal');

/// Medium
/// @export weightcore
/// @unconfigurable
let fontWeightCoreMedium = varLoader('font-weight-core-medium', '500');

/// Bold
/// @export weightcore
/// @unconfigurable
let fontWeightCoreBold = varLoader('font-weight-core-bold', 'bold');

/// Bolder
/// @export weightcore
/// @unconfigurable
let fontWeightCoreBolder = varLoader('font-weight-core-bolder', 'bolder');



let fontFamilyBase = varLoader('font-family-base', 'roboto, "helvetica neue", helvetica, tahoma, arial, "microsoft yahei", "pingfang sc"');
let fontFamilyEn = varLoader('font-family-en', 'roboto, "helvetica neue", helvetica, tahoma, arial');
let fontFamilyZh = varLoader('font-family-zh', '"microsoft yahei", simsun, arial');

let fontCustomPath = varLoader('font-custom-path', "//i.alicdn.com/artascopeFont/20160419204543/font/");
let fontCustomName = varLoader('font-custom-name', 'roboto');
let fontNameThin = varLoader('font-name-thin', 'robotoThin');
let fontNameLight = varLoader('font-name-light', 'robotoLight');
let fontNameRegular = varLoader('font-name-regular', 'robotoRegular');
let fontNameMedium = varLoader('font-name-medium', 'robotoMedium');
let fontNameBold = varLoader('font-name-bold', 'robotoBold');
let fontNameBolder = varLoader('font-name-bolder', 'robotoBolder');
let fontLineheightBase = varLoader('font-lineheight-base', '1.2');



/// Display3 Size
/// @export size
let fontSizeBaseDisplay3 = varLoader('font-size-base-display3', '112');
/// Display2 Size
/// @export size
let fontSizeBaseDisplay2 = varLoader('font-size-base-display2', '96');
/// Display1 Size
/// @export size
let fontSizeBaseDisplay1 = varLoader('font-size-base-display1', '72');
/// Headline Size
/// @export size
let fontSizeBaseHeadline = varLoader('font-size-base-headline', '36');
let fontSizeBaseTitle = varLoader('font-size-base-title', '36');
/// Subhead Size
/// @export size
let fontSizeBaseSubhead = varLoader('font-size-base-subhead', '32');
/// Body2 Size
/// @export size
let fontSizeBaseBody2 = varLoader('font-size-base-body2', '28');
/// Body1 Size
/// @export size
let fontSizeBaseBody1 = varLoader('font-size-base-body1', '28');
/// Caption Size
/// @export size
let fontSizeBaseCaption = varLoader('font-size-base-caption', '24');
/// Footnote Size
/// @export size
let fontSizeBaseFootnote = varLoader('font-size-base-footnote', '20');



/// Display3 Weight
/// @export weight
let fontWeightBaseDisplay3 = varLoader('font-weight-base-display3', fontWeightCoreRegular);
/// Display2 Weight
/// @export weight
let fontWeightBaseDisplay2 = varLoader('font-weight-base-display2', fontWeightCoreRegular);
/// Display1 Weight
/// @export weight
let fontWeightBaseDisplay1 = varLoader('font-weight-base-display1', fontWeightCoreRegular);
/// Headline Weight
/// @export weight
let fontWeightBaseHeadline = varLoader('font-weight-base-headline', fontWeightCoreMedium);
let fontWeightBaseTitle = varLoader('font-weight-base-title', fontWeightCoreMedium);
/// Subhead Weight
/// @export weight
let fontWeightBaseSubhead = varLoader('font-weight-base-subhead', fontWeightCoreRegular);
/// Body2 Weight
/// @export weight
let fontWeightBaseBody2 = varLoader('font-weight-base-body2', fontWeightCoreMedium);
/// Body1 Weight
/// @export weight
let fontWeightBaseBody1 = varLoader('font-weight-base-body1', fontWeightCoreRegular);
/// Caption Weight
/// @export weight
let fontWeightBaseCaption = varLoader('font-weight-base-caption', fontWeightCoreRegular);
/// Footnote Weight
/// @export weight
let fontWeightBaseFootnote = varLoader('font-weight-base-footnote', fontWeightCoreRegular);



/// Display3 Line Height
/// @export lineheight
let fontLineheightBaseDisplay3 = varLoader('font-lineheight-base-display3', '124');
/// Display2 Line Height
/// @export lineheight
let fontLineheightBaseDisplay2 = varLoader('font-lineheight-base-display2', '102');
/// Display1 Line Height
/// @export lineheight
let fontLineheightBaseDisplay1 = varLoader('font-lineheight-base-display1', '78');
/// Headline Line Height
/// @export lineheight
let fontLineheightBaseHeadline = varLoader('font-lineheight-base-headline', '42');
let fontLineheightBaseTitle = varLoader('font-lineheight-base-title', '42');
/// Subhead Line Height
/// @export lineheight
let fontLineheightBaseSubhead = varLoader('font-lineheight-base-subhead', '38');
/// Body2 Line Height
/// @export lineheight
let fontLineheightBaseBody2 = varLoader('font-lineheight-base-body2', '34');
/// Body1 Line Height
/// @export lineheight
let fontLineheightBaseBody1 = varLoader('font-lineheight-base-body1', '34');
/// Caption Line Height
/// @export lineheight
let fontLineheightBaseCaption = varLoader('font-lineheight-base-caption', '30');
/// Footnote Line Height
/// @export lineheight
let fontLineheightBaseFootnote = varLoader('font-lineheight-base-footnote', '26');




/// Display3 Size
/// @export size
let fontSizeEnDisplay3 = varLoader('font-size-en-display3', '112');
/// Display2 Size
/// @export size
let fontSizeEnDisplay2 = varLoader('font-size-en-display2', '96');
/// Display1 size
/// @export size
let fontSizeEnDisplay1 = varLoader('font-size-en-display1', '72');
/// Headline size
/// @export size
let fontSizeEnHeadline = varLoader('font-size-en-headline', '36');
let fontSizeEnTitle = varLoader('font-size-en-title', '36');
/// Subhead size
/// @export size
let fontSizeEnSubhead = varLoader('font-size-en-subhead', '32');
/// Body2 size
/// @export size
let fontSizeEnBody2 = varLoader('font-size-en-body2', '28');
/// Body1 size
/// @export size
let fontSizeEnBody1 = varLoader('font-size-en-body1', '28');
/// Caption size
/// @export size
let fontSizeEnCaption = varLoader('font-size-en-caption', '24');
/// Footnote size
/// @export size
let fontSizeEnFootnote = varLoader('font-size-en-footnote', '20');


/// Display3 Weight
/// @export weight
let fontWeightEnDisplay3 = varLoader('font-weight-en-display3', fontWeightCoreRegular);
/// Display2 Weight
/// @export weight
let fontWeightEnDisplay2 = varLoader('font-weight-en-display2', fontWeightCoreRegular);
/// Display1 Weight
/// @export weight
let fontWeightEnDisplay1 = varLoader('font-weight-en-display1', fontWeightCoreRegular);
/// Headline Weight
/// @export weight
let fontWeightEnHeadline = varLoader('font-weight-en-headline', fontWeightCoreMedium);
let fontWeightEnTitle = varLoader('font-weight-en-title', fontWeightCoreMedium);
/// Subhead Weight
/// @export weight
let fontWeightEnSubhead = varLoader('font-weight-en-subhead', fontWeightCoreRegular);
/// Body2 Weight
/// @export weight
let fontWeightEnBody2 = varLoader('font-weight-en-body2', fontWeightCoreMedium);
/// Body1 Weight
/// @export weight
let fontWeightEnBody1 = varLoader('font-weight-en-body1', fontWeightCoreRegular);
/// Caption Weight
/// @export weight
let fontWeightEnCaption = varLoader('font-weight-en-caption', fontWeightCoreRegular);
/// Footnote Weight
/// @export weight
let fontWeightEnFootnote = varLoader('font-weight-en-footnote', fontWeightCoreRegular);


/// Display3 Line Height
/// @export lineheight
let fontLineheightEnDisplay3 = varLoader('font-lineheight-en-display3', '120');
/// Display2 Line Height
/// @export lineheight
let fontLineheightEnDisplay2 = varLoader('font-lineheight-en-display2', '102');
/// Display1 Line Height
/// @export lineheight
let fontLineheightEnDisplay1 = varLoader('font-lineheight-en-display1', '78');
/// Headline Line Height
/// @export lineheight
let fontLineheightEnHeadline = varLoader('font-lineheight-en-headline', '42');
let fontLineheightEnTitle = varLoader('font-lineheight-en-title', '42');
/// Subhead Line Height
/// @export lineheight
let fontLineheightEnSubhead = varLoader('font-lineheight-en-subhead', '39');
/// Body2 Line Height
/// @export lineheight
let fontLineheightEnBody2 = varLoader('font-lineheight-en-body2', '34');
/// Body1 Line Height
/// @export lineheight
let fontLineheightEnBody1 = varLoader('font-lineheight-en-body1', '34');
/// Caption Line Height
/// @export lineheight
let fontLineheightEnCaption = varLoader('font-lineheight-en-caption', '30');
/// Footnote Line Height
/// @export lineheight
let fontLineheightEnFootnote = varLoader('font-lineheight-en-footnote', '20');




/// Display3 Size
/// @export size
let fontSizeZhDisplay3 = varLoader('font-size-zh-display3', '112');
/// Display2 Size
/// @export size
let fontSizeZhDisplay2 = varLoader('font-size-zh-display2', '96');
/// Display1 size
/// @export size
let fontSizeZhDisplay1 = varLoader('font-size-zh-display1', '72');
/// Headline size
/// @export size
let fontSizeZhHeadline = varLoader('font-size-zh-headline', '36');
let fontSizeZhTitle = varLoader('font-size-zh-title', '36');
/// Subhead size
/// @export size
let fontSizeZhSubhead = varLoader('font-size-zh-subhead', '32');
/// Body2 size
/// @export size
let fontSizeZhBody2 = varLoader('font-size-zh-body2', '28');
/// Body1 size
/// @export size
let fontSizeZhBody1 = varLoader('font-size-zh-body1', '28');
/// Caption size
/// @export size
let fontSizeZhCaption = varLoader('font-size-zh-caption', '24');
/// Footnote size
/// @export size
let fontSizeZhFootnote = varLoader('font-size-zh-footnote', '20');


/// Display3 Weight
/// @export weight
let fontWeightZhDisplay3 = varLoader('font-weight-zh-display3', fontWeightCoreRegular);
/// Display2 Weight
/// @export weight
let fontWeightZhDisplay2 = varLoader('font-weight-zh-display2', fontWeightCoreRegular);
/// Display1 Weight
/// @export weight
let fontWeightZhDisplay1 = varLoader('font-weight-zh-display1', fontWeightCoreRegular);
/// Headline Weight
/// @export weight
let fontWeightZhHeadline = varLoader('font-weight-zh-headline', fontWeightCoreMedium);
let fontWeightZhTitle = varLoader('font-weight-zh-title', fontWeightCoreMedium);
/// Subhead Weight
/// @export weight
let fontWeightZhSubhead = varLoader('font-weight-zh-subhead', fontWeightCoreRegular);
/// Body2 Weight
/// @export weight
let fontWeightZhBody2 = varLoader('font-weight-zh-body2', fontWeightCoreMedium);
/// Body1 Weight
/// @export weight
let fontWeightZhBody1 = varLoader('font-weight-zh-body1', fontWeightCoreRegular);
/// Caption Weight
/// @export weight
let fontWeightZhCaption = varLoader('font-weight-zh-caption', fontWeightCoreRegular);
/// Footnote Weight
/// @export weight
let fontWeightZhFootnote = varLoader('font-weight-zh-footnote', fontWeightCoreRegular);


/// Display3 Line Height
/// @export lineheight
let fontLineheightZhDisplay3 = varLoader('font-lineheight-zh-display3', '124');
/// Display2 Line Height
/// @export lineheight
let fontLineheightZhDisplay2 = varLoader('font-lineheight-zh-display2', '102');
/// Display1 Line Height
/// @export lineheight
let fontLineheightZhDisplay1 = varLoader('font-lineheight-zh-display1', '78');
/// Headline Line Height
/// @export lineheight
let fontLineheightZhHeadline = varLoader('font-lineheight-zh-headline', '42');
let fontLineheightZhTitle = varLoader('font-lineheight-zh-title', '42');
/// Subhead Line Height
/// @export lineheight
let fontLineheightZhSubhead = varLoader('font-lineheight-zh-subhead', '39');
/// Body2 Line Height
/// @export lineheight
let fontLineheightZhBody2 = varLoader('font-lineheight-zh-body2', '34');
/// Body1 Line Height
/// @export lineheight
let fontLineheightZhBody1 = varLoader('font-lineheight-zh-body1', '34');
/// Caption Line Height
/// @export lineheight
let fontLineheightZhCaption = varLoader('font-lineheight-zh-caption', '30');
/// Footnote Line Height
/// @export lineheight
let fontLineheightZhFootnote = varLoader('font-lineheight-zh-footnote', '26');












module.exports = {
    ['font-weight-core-light']: fontWeightCoreLight,
    ['font-weight-core-thin']: fontWeightCoreThin,
    ['font-weight-core-regular']: fontWeightCoreRegular,
    ['font-weight-core-medium']: fontWeightCoreMedium,
    ['font-weight-core-bold']: fontWeightCoreBold,
    ['font-weight-core-bolder']: fontWeightCoreBolder,
    ['font-family-base']: fontFamilyBase,
    ['font-family-en']: fontFamilyEn,
    ['font-family-zh']: fontFamilyZh,
    ['font-custom-path']: fontCustomPath,
    ['font-custom-name']: fontCustomName,
    ['font-name-thin']: fontNameThin,
    ['font-name-light']: fontNameLight,
    ['font-name-regular']: fontNameRegular,
    ['font-name-medium']: fontNameMedium,
    ['font-name-bold']: fontNameBold,
    ['font-name-bolder']: fontNameBolder,
    ['font-lineheight-base']: fontLineheightBase,
    ['font-size-base-display3']: fontSizeBaseDisplay3,
    ['font-size-base-display2']: fontSizeBaseDisplay2,
    ['font-size-base-display1']: fontSizeBaseDisplay1,
    ['font-size-base-headline']: fontSizeBaseHeadline,
    ['font-size-base-title']: fontSizeBaseTitle,
    ['font-size-base-subhead']: fontSizeBaseSubhead,
    ['font-size-base-body2']: fontSizeBaseBody2,
    ['font-size-base-body1']: fontSizeBaseBody1,
    ['font-size-base-caption']: fontSizeBaseCaption,
    ['font-size-base-footnote']: fontSizeBaseFootnote,
    ['font-weight-base-display3']: fontWeightBaseDisplay3,
    ['font-weight-base-display2']: fontWeightBaseDisplay2,
    ['font-weight-base-display1']: fontWeightBaseDisplay1,
    ['font-weight-base-headline']: fontWeightBaseHeadline,
    ['font-weight-base-title']: fontWeightBaseTitle,
    ['font-weight-base-subhead']: fontWeightBaseSubhead,
    ['font-weight-base-body2']: fontWeightBaseBody2,
    ['font-weight-base-body1']: fontWeightBaseBody1,
    ['font-weight-base-caption']: fontWeightBaseCaption,
    ['font-weight-base-footnote']: fontWeightBaseFootnote,
    ['font-lineheight-base-display3']: fontLineheightBaseDisplay3,
    ['font-lineheight-base-display2']: fontLineheightBaseDisplay2,
    ['font-lineheight-base-display1']: fontLineheightBaseDisplay1,
    ['font-lineheight-base-headline']: fontLineheightBaseHeadline,
    ['font-lineheight-base-title']: fontLineheightBaseTitle,
    ['font-lineheight-base-subhead']: fontLineheightBaseSubhead,
    ['font-lineheight-base-body2']: fontLineheightBaseBody2,
    ['font-lineheight-base-body1']: fontLineheightBaseBody1,
    ['font-lineheight-base-caption']: fontLineheightBaseCaption,
    ['font-lineheight-base-footnote']: fontLineheightBaseFootnote,
    ['font-size-en-display3']: fontSizeEnDisplay3,
    ['font-size-en-display2']: fontSizeEnDisplay2,
    ['font-size-en-display1']: fontSizeEnDisplay1,
    ['font-size-en-headline']: fontSizeEnHeadline,
    ['font-size-en-title']: fontSizeEnTitle,
    ['font-size-en-subhead']: fontSizeEnSubhead,
    ['font-size-en-body2']: fontSizeEnBody2,
    ['font-size-en-body1']: fontSizeEnBody1,
    ['font-size-en-caption']: fontSizeEnCaption,
    ['font-size-en-footnote']: fontSizeEnFootnote,
    ['font-weight-en-display3']: fontWeightEnDisplay3,
    ['font-weight-en-display2']: fontWeightEnDisplay2,
    ['font-weight-en-display1']: fontWeightEnDisplay1,
    ['font-weight-en-headline']: fontWeightEnHeadline,
    ['font-weight-en-title']: fontWeightEnTitle,
    ['font-weight-en-subhead']: fontWeightEnSubhead,
    ['font-weight-en-body2']: fontWeightEnBody2,
    ['font-weight-en-body1']: fontWeightEnBody1,
    ['font-weight-en-caption']: fontWeightEnCaption,
    ['font-weight-en-footnote']: fontWeightEnFootnote,
    ['font-lineheight-en-display3']: fontLineheightEnDisplay3,
    ['font-lineheight-en-display2']: fontLineheightEnDisplay2,
    ['font-lineheight-en-display1']: fontLineheightEnDisplay1,
    ['font-lineheight-en-headline']: fontLineheightEnHeadline,
    ['font-lineheight-en-title']: fontLineheightEnTitle,
    ['font-lineheight-en-subhead']: fontLineheightEnSubhead,
    ['font-lineheight-en-body2']: fontLineheightEnBody2,
    ['font-lineheight-en-body1']: fontLineheightEnBody1,
    ['font-lineheight-en-caption']: fontLineheightEnCaption,
    ['font-lineheight-en-footnote']: fontLineheightEnFootnote,
    ['font-size-zh-display3']: fontSizeZhDisplay3,
    ['font-size-zh-display2']: fontSizeZhDisplay2,
    ['font-size-zh-display1']: fontSizeZhDisplay1,
    ['font-size-zh-headline']: fontSizeZhHeadline,
    ['font-size-zh-title']: fontSizeZhTitle,
    ['font-size-zh-subhead']: fontSizeZhSubhead,
    ['font-size-zh-body2']: fontSizeZhBody2,
    ['font-size-zh-body1']: fontSizeZhBody1,
    ['font-size-zh-caption']: fontSizeZhCaption,
    ['font-size-zh-footnote']: fontSizeZhFootnote,
    ['font-weight-zh-display3']: fontWeightZhDisplay3,
    ['font-weight-zh-display2']: fontWeightZhDisplay2,
    ['font-weight-zh-display1']: fontWeightZhDisplay1,
    ['font-weight-zh-headline']: fontWeightZhHeadline,
    ['font-weight-zh-title']: fontWeightZhTitle,
    ['font-weight-zh-subhead']: fontWeightZhSubhead,
    ['font-weight-zh-body2']: fontWeightZhBody2,
    ['font-weight-zh-body1']: fontWeightZhBody1,
    ['font-weight-zh-caption']: fontWeightZhCaption,
    ['font-weight-zh-footnote']: fontWeightZhFootnote,
    ['font-lineheight-zh-display3']: fontLineheightZhDisplay3,
    ['font-lineheight-zh-display2']: fontLineheightZhDisplay2,
    ['font-lineheight-zh-display1']: fontLineheightZhDisplay1,
    ['font-lineheight-zh-headline']: fontLineheightZhHeadline,
    ['font-lineheight-zh-title']: fontLineheightZhTitle,
    ['font-lineheight-zh-subhead']: fontLineheightZhSubhead,
    ['font-lineheight-zh-body2']: fontLineheightZhBody2,
    ['font-lineheight-zh-body1']: fontLineheightZhBody1,
    ['font-lineheight-zh-caption']: fontLineheightZhCaption,
    ['font-lineheight-zh-footnote']: fontLineheightZhFootnote
}
