'use strict';

import { varLoader } from 'nuke-var-loader';
import {s2,s3,s4,s5,s6,s8,s12,s16} from './_global';


////
/// @group Variables 变量
/// @module icon: 图标
/// @type String
/// @category style
////


/// icon font path 字体路径
let iconFontPath = varLoader('icon-font-path', "//at.alicdn.com/t/font_1465717286_116059");


/// icon font name 自定义的icon font 名称
let iconFontName = varLoader('icon-font-name', "icon");

let iconFontFamily = varLoader('icon-font-family', 'mexticon');

/// Icon XXS
/// @export
let iconXxs = varLoader('icon-xxs', s2);

/// Icon XS
/// @export
let iconXs = varLoader('icon-xs', s3);

/// Icon S
/// @export
let iconS = varLoader('icon-s', s4);

/// Icon M
/// @export
let iconM = varLoader('icon-m', s5);

/// Icon L
/// @export
let iconL = varLoader('icon-l', s6);

/// Icon XL
/// @export
let iconXl = varLoader('icon-xl', s8);

/// Icon XXL
/// @export
let iconXxl = varLoader('icon-xxl', s12);

/// Icon XXXL
/// @export
let iconXxxl = varLoader('icon-xxxl', s16);


let iconContentAll = varLoader('icon-content-all', "\e600");
let iconContentCart = varLoader('icon-content-cart', "\e602");
let iconContentComments = varLoader('icon-content-comments', "\e605");
let iconContentCry = varLoader('icon-content-cry', "\e606");
let iconContentEmail = varLoader('icon-content-email', "\e609");
let iconContentFavorite = varLoader('icon-content-favorite', "\e60a");
let iconContentFolder = varLoader('icon-content-folder', "\e60b");
let iconContentForm = varLoader('icon-content-form', "\e60c");
let iconContentHelp = varLoader('icon-content-help', "\e60d");
let iconContentRefresh = varLoader('icon-content-refresh', "\e614");
let iconContentSet = varLoader('icon-content-set', "\e618");
let iconContentSurvey = varLoader('icon-content-survey', "\e61b");
let iconContentTraining = varLoader('icon-content-training', "\e61c");
let iconContentAccount = varLoader('icon-content-account', "\e621");
let iconContentAtm = varLoader('icon-content-atm', "\e623");
let iconContentClock = varLoader('icon-content-clock', "\e624");
let iconContentAttachment = varLoader('icon-content-attachment', "\e627");
let iconContent3column = varLoader('icon-content-3column', "\e628");
let iconContent4column = varLoader('icon-content-4column', "\e629");
let iconContentDiscount = varLoader('icon-content-discount', "\e62a");
let iconContentService = varLoader('icon-content-service', "\e62b");
let iconContentPrint = varLoader('icon-content-print', "\e62c");
let iconContentBox = varLoader('icon-content-box', "\e62d");
let iconContentProcess = varLoader('icon-content-process', "\e62e");
let iconContentBags = varLoader('icon-content-bags', "\e62f");
let iconContentElectronics = varLoader('icon-content-electronics', "\e633");
let iconContentGifts = varLoader('icon-content-gifts', "\e634");
let iconContentLights = varLoader('icon-content-lights', "\e636");
let iconContentAuto = varLoader('icon-content-auto', "\e639");
let iconContentBrowse = varLoader('icon-content-browse', "\e63c");
let iconContentAtmAway = varLoader('icon-content-atm-away', "\e63f");
let iconContentScanning = varLoader('icon-content-scanning', "\e641");
let iconContentCompare = varLoader('icon-content-compare', "\e642");
let iconContentFilter = varLoader('icon-content-filter', "\e643");
let iconContentPin = varLoader('icon-content-pin', "\e644");
let iconContentHistory = varLoader('icon-content-history', "\e645");
let iconContentSimilarProduct = varLoader('icon-content-similar-product', "\e648");
let iconContentLink = varLoader('icon-content-link', "\e649");
let iconContentCut = varLoader('icon-content-cut', "\e64a");
let iconContentTable = varLoader('icon-content-table', "\e64b");
let iconContentNavList = varLoader('icon-content-nav-list', "\e64c");
let iconContentImageText = varLoader('icon-content-image-text', "\e64d");
let iconContentText = varLoader('icon-content-text', "\e64e");
let iconContentMove = varLoader('icon-content-move', "\e64f");
let iconContentSubtract = varLoader('icon-content-subtract', "\e650");
let iconContentDollar = varLoader('icon-content-dollar', "\e651");
let iconContentOffice = varLoader('icon-content-office', "\e653");
let iconContentOperation = varLoader('icon-content-operation', "\e65a");
let iconContentDownload = varLoader('icon-content-download', "\e65c");
let iconContentMap = varLoader('icon-content-map', "\e65d");
let iconContentBad = varLoader('icon-content-bad', "\e65e");
let iconContentGood = varLoader('icon-content-good', "\e65f");
let iconContentSkip = varLoader('icon-content-skip', "\e660");
let iconContentPlay = varLoader('icon-content-play', "\e661");
let iconContentStop = varLoader('icon-content-stop', "\e662");
let iconContentCompass = varLoader('icon-content-compass', "\e663");
let iconContentSecurity = varLoader('icon-content-security', "\e664");
let iconContentShare = varLoader('icon-content-share', "\e665");
let iconContentStore = varLoader('icon-content-store', "\e666");
let iconContentPhone = varLoader('icon-content-phone', "\e669");
let iconContentEllipsis = varLoader('icon-content-ellipsis', "\e674");
let iconContentEmailFilling = varLoader('icon-content-email-filling', "\e66d");
let iconContentFavoritesFilling = varLoader('icon-content-favorites-filling', "\e66e");
let iconContentAccountFilling = varLoader('icon-content-account-filling', "\e66f");
let iconContentCreditLevel = varLoader('icon-content-credit-level', "\e671");
let iconContentCreditLevelFilling = varLoader('icon-content-credit-level-filling', "\e672");
let iconContentMobilePhone = varLoader('icon-content-mobile-phone', "\e675");
let iconContentSmile = varLoader('icon-content-smile', "\e61f");
let iconContentPersonalCenter = varLoader('icon-content-personal-center', "\e681");
let iconContentArrowUpFilling = varLoader('icon-content-arrow-up-filling', "\e601");
let iconContentArrowRight = varLoader('icon-content-arrow-right', "\e603");
let iconContentArrowLeft = varLoader('icon-content-arrow-left', "\e604");
let iconContentArrowDown = varLoader('icon-content-arrow-down', "\e607");
let iconContentArrowUp = varLoader('icon-content-arrow-up', "\e60e");
let iconContentAdd = varLoader('icon-content-add', "\e60f");
let iconContentMinus = varLoader('icon-content-minus', "\e610");
let iconContentDeleteFilling = varLoader('icon-content-delete-filling', "\e611");
let iconContentEdit = varLoader('icon-content-edit', "\e613");
let iconContentLoading = varLoader('icon-content-loading', "\e615");
let iconContentError = varLoader('icon-content-error', "\e619");
let iconContentSelect = varLoader('icon-content-select', "\e61d");
let iconContentAshbin = varLoader('icon-content-ashbin', "\e61e");
let iconContentCalendar = varLoader('icon-content-calendar', "\e620");
let iconContentTime = varLoader('icon-content-time', "\e622");
let iconContentSuccess = varLoader('icon-content-success', "\e617");
let iconContentWarning = varLoader('icon-content-warning', "\e63d");
let iconContentSearch = varLoader('icon-content-search', "\e656");
let iconContentDisplay = varLoader('icon-content-display', "\e657");
let iconContentCategory = varLoader('icon-content-category', "\e658");
let iconContentPrompt = varLoader('icon-content-prompt', "\e659");
let iconContentArrowDownFilling = varLoader('icon-content-arrow-down-filling', "\e65b");
let iconContentSorting = varLoader('icon-content-sorting', "\e676");
let iconContentAscending = varLoader('icon-content-ascending', "\e66a");
let iconContentDescending = varLoader('icon-content-descending', "\e66c");
let iconContentSuccessFilling = varLoader('icon-content-success-filling', "\e670");
let iconContentPicture = varLoader('icon-content-picture', "\e616");
let iconContentClose = varLoader('icon-content-close', "\e608");
let iconContentSemiSelect = varLoader('icon-content-semi-select', "\e612");
let iconContentTagSubscript = varLoader('icon-content-tag-subscript', "\e61a");



module.exports = {
    ['icon-font-path']: iconFontPath,
    ['icon-font-name']: iconFontName,
    ['icon-font-family']: iconFontFamily,
    ['icon-xxs']: iconXxs,
    ['icon-xs']: iconXs,
    ['icon-s']: iconS,
    ['icon-m']: iconM,
    ['icon-l']: iconL,
    ['icon-xl']: iconXl,
    ['icon-xxl']: iconXxl,
    ['icon-xxxl']: iconXxxl,
    ['icon-content-all']: iconContentAll,
    ['icon-content-cart']: iconContentCart,
    ['icon-content-comments']: iconContentComments,
    ['icon-content-cry']: iconContentCry,
    ['icon-content-email']: iconContentEmail,
    ['icon-content-favorite']: iconContentFavorite,
    ['icon-content-folder']: iconContentFolder,
    ['icon-content-form']: iconContentForm,
    ['icon-content-help']: iconContentHelp,
    ['icon-content-refresh']: iconContentRefresh,
    ['icon-content-set']: iconContentSet,
    ['icon-content-survey']: iconContentSurvey,
    ['icon-content-training']: iconContentTraining,
    ['icon-content-account']: iconContentAccount,
    ['icon-content-atm']: iconContentAtm,
    ['icon-content-clock']: iconContentClock,
    ['icon-content-attachment']: iconContentAttachment,
    ['icon-content-3column']: iconContent3column,
    ['icon-content-4column']: iconContent4column,
    ['icon-content-discount']: iconContentDiscount,
    ['icon-content-service']: iconContentService,
    ['icon-content-print']: iconContentPrint,
    ['icon-content-box']: iconContentBox,
    ['icon-content-process']: iconContentProcess,
    ['icon-content-bags']: iconContentBags,
    ['icon-content-electronics']: iconContentElectronics,
    ['icon-content-gifts']: iconContentGifts,
    ['icon-content-lights']: iconContentLights,
    ['icon-content-auto']: iconContentAuto,
    ['icon-content-browse']: iconContentBrowse,
    ['icon-content-atm-away']: iconContentAtmAway,
    ['icon-content-scanning']: iconContentScanning,
    ['icon-content-compare']: iconContentCompare,
    ['icon-content-filter']: iconContentFilter,
    ['icon-content-pin']: iconContentPin,
    ['icon-content-history']: iconContentHistory,
    ['icon-content-similar-product']: iconContentSimilarProduct,
    ['icon-content-link']: iconContentLink,
    ['icon-content-cut']: iconContentCut,
    ['icon-content-table']: iconContentTable,
    ['icon-content-nav-list']: iconContentNavList,
    ['icon-content-image-text']: iconContentImageText,
    ['icon-content-text']: iconContentText,
    ['icon-content-move']: iconContentMove,
    ['icon-content-subtract']: iconContentSubtract,
    ['icon-content-dollar']: iconContentDollar,
    ['icon-content-office']: iconContentOffice,
    ['icon-content-operation']: iconContentOperation,
    ['icon-content-download']: iconContentDownload,
    ['icon-content-map']: iconContentMap,
    ['icon-content-bad']: iconContentBad,
    ['icon-content-good']: iconContentGood,
    ['icon-content-skip']: iconContentSkip,
    ['icon-content-play']: iconContentPlay,
    ['icon-content-stop']: iconContentStop,
    ['icon-content-compass']: iconContentCompass,
    ['icon-content-security']: iconContentSecurity,
    ['icon-content-share']: iconContentShare,
    ['icon-content-store']: iconContentStore,
    ['icon-content-phone']: iconContentPhone,
    ['icon-content-ellipsis']: iconContentEllipsis,
    ['icon-content-email-filling']: iconContentEmailFilling,
    ['icon-content-favorites-filling']: iconContentFavoritesFilling,
    ['icon-content-account-filling']: iconContentAccountFilling,
    ['icon-content-credit-level']: iconContentCreditLevel,
    ['icon-content-credit-level-filling']: iconContentCreditLevelFilling,
    ['icon-content-mobile-phone']: iconContentMobilePhone,
    ['icon-content-smile']: iconContentSmile,
    ['icon-content-personal-center']: iconContentPersonalCenter,
    ['icon-content-arrow-up-filling']: iconContentArrowUpFilling,
    ['icon-content-arrow-right']: iconContentArrowRight,
    ['icon-content-arrow-left']: iconContentArrowLeft,
    ['icon-content-arrow-down']: iconContentArrowDown,
    ['icon-content-arrow-up']: iconContentArrowUp,
    ['icon-content-add']: iconContentAdd,
    ['icon-content-minus']: iconContentMinus,
    ['icon-content-delete-filling']: iconContentDeleteFilling,
    ['icon-content-edit']: iconContentEdit,
    ['icon-content-loading']: iconContentLoading,
    ['icon-content-error']: iconContentError,
    ['icon-content-select']: iconContentSelect,
    ['icon-content-ashbin']: iconContentAshbin,
    ['icon-content-calendar']: iconContentCalendar,
    ['icon-content-time']: iconContentTime,
    ['icon-content-success']: iconContentSuccess,
    ['icon-content-warning']: iconContentWarning,
    ['icon-content-search']: iconContentSearch,
    ['icon-content-display']: iconContentDisplay,
    ['icon-content-category']: iconContentCategory,
    ['icon-content-prompt']: iconContentPrompt,
    ['icon-content-arrow-down-filling']: iconContentArrowDownFilling,
    ['icon-content-sorting']: iconContentSorting,
    ['icon-content-ascending']: iconContentAscending,
    ['icon-content-descending']: iconContentDescending,
    ['icon-content-success-filling']: iconContentSuccessFilling,
    ['icon-content-picture']: iconContentPicture,
    ['icon-content-close']: iconContentClose,
    ['icon-content-semi-select']: iconContentSemiSelect,
    ['icon-content-tag-subscript']: iconContentTagSubscript
}
