'use strict';

import { varLoader } from 'nuke-var-loader';



////
/// @group Variables 变量
/// @module line: 线条
/// @type String
/// @category style
////


/// Line0
/// @export width
let line0Width = varLoader('line-0-width', 0);

/// Line1
/// @export width
let line1Width = varLoader('line-1-width', 1);

/// Line2
/// @export width
let line2Width = varLoader('line-2-width', 2);

/// Line3
/// @export width
let line3Width = varLoader('line-3-width', 8);

/// Solid
/// @export style
/// @unconfigurable
let lineSolid = varLoader('line-solid', 'solid');
/// Dashed
/// @export style
/// @unconfigurable
let lineDashed = varLoader('line-dashed', 'dashed');
/// Dotted
/// @export style
/// @unconfigurable
let lineDotted = varLoader('line-dotted', 'dotted');

let line0 = varLoader('line0', `${line0Width} ${lineSolid}`);
let line0Dashed = varLoader('line0-dashed', `${line0Width} ${lineDashed}`);
let line0Dotted = varLoader('line0-dotted', `${line0Width} ${lineDotted}`);

let line1 = varLoader('line1', `${line1Width} ${lineSolid}`);
let line1Dashed = varLoader('line1-dashed', `${line1Width} ${lineDashed}`);
let line1Dotted = varLoader('line1-dotted', `${line1Width} ${lineDotted}`);

let line2 = varLoader('line2', `${line2Width} ${lineSolid}`);
let line2Dashed = varLoader('line2-dashed', `${line2Width} ${lineDashed}`);
let line2Dotted = varLoader('line2-dotted', `${line2Width} ${lineDotted}`);

let line3 = varLoader('line3', `${line3Width} ${lineSolid}`);
let line3Dashed = varLoader('line3-dashed', `${line3Width} ${lineDashed}`);
let line3Dotted = varLoader('line3-dotted', `${line3Width} ${lineDotted}`);

module.exports = {
    ['line-0-width']: line0Width,
    ['line-1-width']: line1Width,
    ['line-2-width']: line2Width,
    ['line-3-width']: line3Width,
    ['line-solid']: lineSolid,
    ['line-dashed']: lineDashed,
    ['line-dotted']: lineDotted,
    ['line0']: line0,
    ['line0-dashed']: line0Dashed,
    ['line0-dotted']: line0Dotted,
    ['line1']: line1,
    ['line1-dashed']: line1Dashed,
    ['line1-dotted']: line1Dotted,
    ['line2']: line2,
    ['line2-dashed']: line2Dashed,
    ['line2-dotted']: line2Dotted,
    ['line3']: line3,
    ['line3-dashed']: line3Dashed,
    ['line3-dotted']: line3Dotted
}
