'use strict';

import { varLoader } from 'nuke-var-loader';
import color from './_color';


////
/// @group Variables 变量
/// @module shadow: 阴影
/// @category style
////



/// 阴影x方向常规值
/// @unconfigurable
/// @access private
/// @type {Number}
let shadowX = varLoader('shadow-x', 1);

/// 阴影y方向常规值
/// @unconfigurable
/// @access private
/// @type {Number}
let shadowY = varLoader('shadow-y', shadowX);

/// Distance 1
/// @type {Number}
let shadowDistanceSd1 = varLoader('shadow-distance-sd1', '1');
/// Distance 2
/// @type {Number}
let shadowDistanceSd2 = varLoader('shadow-distance-sd2', '2');
/// Distance 3
/// @type {Number}
let shadowDistanceSd3 = varLoader('shadow-distance-sd3', '3');
/// Distance 4
/// @type {Number}
let shadowDistanceSd4 = varLoader('shadow-distance-sd4', '4');
/// Distance 5
/// @type {Number}
let shadowDistanceSd5 = varLoader('shadow-distance-sd5', '5');

/// Opacity 1
/// @type {Number}
let shadowOpacitySd1 = varLoader('shadow-opacity-sd1', '0.32');
/// Opacity 2
/// @type {Number}
let shadowOpacitySd2 = varLoader('shadow-opacity-sd2', '0.32');
/// Opacity 3
/// @type {Number}
let shadowOpacitySd3 = varLoader('shadow-opacity-sd3', '0.32');
/// Opacity 4
/// @type {Number}
let shadowOpacitySd4 = varLoader('shadow-opacity-sd4', '0.32');
/// Opacity 4
/// @type {Number}
let shadowOpacitySd5 = varLoader('shadow-opacity-sd5', '0.32');

/// Color 1
/// @type {Color}
let shadowColorSd1 = varLoader('shadow-color-sd1', color['color-n1-9']);

/// Color 2
/// @type {Color}
let shadowColorSd2 = varLoader('shadow-color-sd2', color['color-n1-9']);

/// Color 3
/// @type {Color}
let shadowColorSd3 = varLoader('shadow-color-sd3', color['color-n1-9']);

/// Color 4
/// @type {Color}
let shadowColorSd4 = varLoader('shadow-color-sd4', color['color-n1-9']);

/// Color 5
/// @type {Color}
let shadowColorSd5 = varLoader('shadow-color-sd5', color['color-n1-9']);

let shadowColorOpacitySd1 = varLoader('shadow-color-opacity-sd1', `rgba(${shadowColorSd1}, ${shadowOpacitySd1})`);
let shadowColorOpacitySd2 = varLoader('shadow-color-opacity-sd2', `rgba(${shadowColorSd2}, ${shadowOpacitySd2})`);
let shadowColorOpacitySd3 = varLoader('shadow-color-opacity-sd3', `rgba(${shadowColorSd3}, ${shadowOpacitySd3})`);
let shadowColorOpacitySd4 = varLoader('shadow-color-opacity-sd4', `rgba(${shadowColorSd4}, ${shadowOpacitySd4})`);
let shadowColorOpacitySd5 = varLoader('shadow-color-opacity-sd5', `rgba(${shadowColorSd5}, ${shadowOpacitySd5})`);

let shadowSidesBase = varLoader('shadow-sides-base', "base");
let shadowSidesUp = varLoader('shadow-sides-up', "up");
let shadowSidesRight = varLoader('shadow-sides-right', "right");
let shadowSidesDown = varLoader('shadow-sides-down', "down");
let shadowSidesLeft = varLoader('shadow-sides-left', "left");


/// Blur 1
/// @type {Number}
let shadowElevationSd1 = varLoader('shadow-elevation-sd1', '3');

/// Blur 2
/// @type {Number}
let shadowElevationSd2 = varLoader('shadow-elevation-sd2', '3');

/// Blur 3
/// @type {Number}
let shadowElevationSd3 = varLoader('shadow-elevation-sd3', '5');

/// Blur 4
/// @type {Number}
let shadowElevationSd4 = varLoader('shadow-elevation-sd4', '7');

/// Blur 5
/// @type {Number}
let shadowElevationSd5 = varLoader('shadow-elevation-sd5', '10');

/// Shadow 0
/// @export
/// @access private
/// @unconfigurable
let shadowSd0 = varLoader('shadow-sd0', shadowMaker(shadowSidesBase, 0, 1, 0, 0));

/// Shadow 1
/// @export
/// @access private
/// @unconfigurable
let shadowSd1 = varLoader('shadow-sd1', shadowMaker(shadowSidesBase, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Up)
/// @export
/// @access private
/// @unconfigurable
let shadowSd1Up = varLoader('shadow-sd1-up', shadowMaker(shadowSidesUp, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Right)
/// @export
/// @access private
/// @unconfigurable
let shadowSd1Right = varLoader('shadow-sd1-right', shadowMaker(shadowSidesRight, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Down)
/// @export
/// @access private
/// @unconfigurable
let shadowSd1Down = varLoader('shadow-sd1-down', shadowMaker(shadowSidesDown, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 1 (Left)
/// @export
/// @access private
/// @unconfigurable
let shadowSd1Left = varLoader('shadow-sd1-left', shadowMaker(shadowSidesLeft, shadowElevationSd1, shadowColorOpacitySd1, shadowDistanceSd1, shadowDistanceSd1));

/// Shadow 2
/// @export
/// @access private
/// @unconfigurable
let shadowSd2 = varLoader('shadow-sd2', shadowMaker(shadowSidesBase, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Up)
/// @export
/// @access private
/// @unconfigurable
let shadowSd2Up = varLoader('shadow-sd2-up', shadowMaker(shadowSidesUp, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Right)
/// @export
/// @access private
/// @unconfigurable
let shadowSd2Right = varLoader('shadow-sd2-right', shadowMaker(shadowSidesRight, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Down)
/// @export
/// @access private
/// @unconfigurable
let shadowSd2Down = varLoader('shadow-sd2-down', shadowMaker(shadowSidesDown, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));
/// Shadow 2 (Left)
/// @export
/// @access private
/// @unconfigurable
let shadowSd2Left = varLoader('shadow-sd2-left', shadowMaker(shadowSidesLeft, shadowElevationSd2, shadowColorOpacitySd2, shadowDistanceSd2, shadowDistanceSd2));

/// Shadow 3
/// @export
/// @access private
/// @unconfigurable
let shadowSd3 = varLoader('shadow-sd3', shadowMaker(shadowSidesBase, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Up)
/// @export
/// @access private
/// @unconfigurable
let shadowSd3Up = varLoader('shadow-sd3-up', shadowMaker(shadowSidesUp, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Right)
/// @export
/// @access private
/// @unconfigurable
let shadowSd3Right = varLoader('shadow-sd3-right', shadowMaker(shadowSidesRight, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Down)
/// @export
/// @access private
/// @unconfigurable
let shadowSd3Down = varLoader('shadow-sd3-down', shadowMaker(shadowSidesDown, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));
/// Shadow 3 (Left)
/// @export
/// @access private
/// @unconfigurable
let shadowSd3Left = varLoader('shadow-sd3-left', shadowMaker(shadowSidesLeft, shadowElevationSd3, shadowColorOpacitySd3, shadowDistanceSd3, shadowDistanceSd3));

/// Shadow 4
/// @export
/// @access private
/// @unconfigurable
let shadowSd4 = varLoader('shadow-sd4', shadowMaker(shadowSidesBase, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Up)
/// @export
/// @access private
/// @unconfigurable
let shadowSd4Up = varLoader('shadow-sd4-up', shadowMaker(shadowSidesUp, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Right)
/// @export
/// @access private
/// @unconfigurable
let shadowSd4Right = varLoader('shadow-sd4-right', shadowMaker(shadowSidesRight, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Down)
/// @export
/// @access private
/// @unconfigurable
let shadowSd4Down = varLoader('shadow-sd4-down', shadowMaker(shadowSidesDown, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));
/// Shadow 4 (Left)
/// @export
/// @access private
/// @unconfigurable
let shadowSd4Left = varLoader('shadow-sd4-left', shadowMaker(shadowSidesLeft, shadowElevationSd4, shadowColorOpacitySd4, shadowDistanceSd4, shadowDistanceSd4));

/// Shadow 5
/// @export
/// @access private
/// @unconfigurable
let shadowSd5 = varLoader('shadow-sd5', shadowMaker(shadowSidesBase, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Up)
/// @export
/// @access private
/// @unconfigurable
let shadowSd5Up = varLoader('shadow-sd5-up', shadowMaker(shadowSidesUp, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Right)
/// @export
/// @access private
/// @unconfigurable
let shadowSd5Right = varLoader('shadow-sd5-right', shadowMaker(shadowSidesRight, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Down)
/// @export
/// @access private
/// @unconfigurable
let shadowSd5Down = varLoader('shadow-sd5-down', shadowMaker(shadowSidesDown, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));
/// Shadow 5 (Left)
/// @export
/// @access private
/// @unconfigurable
let shadowSd5Left = varLoader('shadow-sd5-left', shadowMaker(shadowSidesLeft, shadowElevationSd5, shadowColorOpacitySd5, shadowDistanceSd5, shadowDistanceSd5));


function shadowMaker(
    direction=shadowSidesBase ,
    elevation=shadowElevationSd1,
    shadowColor=shadowColorOpacitySd1,
    shadowX=shadowX,
    shadowY=shadowY
) {

    let x = shadowX;
    let y = shadowY;
    let e = elevation;
    let c = shadowColor;

    if (e == 0) {
        return '0 0 0 #ffffff';
    }

    if (direction == shadowSidesUp) {
        x = 0;
        y = shadowY;
    } else if (direction == shadowSidesRight) {
        y = 0;
    } else if (direction == shadowSidesDown) {
        x = 0;
    } else if (direction == shadowSidesLeft) {
        x = shadowX;
        y = 0;
    }

    return `${x}px ${y}px ${e}px ${c}`;
}

module.exports = {
    ['shadow-x']: shadowX,
    ['shadow-y']: shadowY,
    ['shadow-distance-sd1']: shadowDistanceSd1,
    ['shadow-distance-sd2']: shadowDistanceSd2,
    ['shadow-distance-sd3']: shadowDistanceSd3,
    ['shadow-distance-sd4']: shadowDistanceSd4,
    ['shadow-distance-sd5']: shadowDistanceSd5,
    ['shadow-opacity-sd1']: shadowOpacitySd1,
    ['shadow-opacity-sd2']: shadowOpacitySd2,
    ['shadow-opacity-sd3']: shadowOpacitySd3,
    ['shadow-opacity-sd4']: shadowOpacitySd4,
    ['shadow-opacity-sd5']: shadowOpacitySd5,
    ['shadow-color-sd1']: shadowColorSd1,
    ['shadow-color-sd2']: shadowColorSd2,
    ['shadow-color-sd3']: shadowColorSd3,
    ['shadow-color-sd4']: shadowColorSd4,
    ['shadow-color-sd5']: shadowColorSd5,
    ['shadow-color-opacity-sd1']: shadowColorOpacitySd1,
    ['shadow-color-opacity-sd2']: shadowColorOpacitySd2,
    ['shadow-color-opacity-sd3']: shadowColorOpacitySd3,
    ['shadow-color-opacity-sd4']: shadowColorOpacitySd4,
    ['shadow-color-opacity-sd5']: shadowColorOpacitySd5,
    ['shadow-sides-base']: shadowSidesBase,
    ['shadow-sides-up']: shadowSidesUp,
    ['shadow-sides-right']: shadowSidesRight,
    ['shadow-sides-down']: shadowSidesDown,
    ['shadow-sides-left']: shadowSidesLeft,
    ['shadow-elevation-sd1']: shadowElevationSd1,
    ['shadow-elevation-sd2']: shadowElevationSd2,
    ['shadow-elevation-sd3']: shadowElevationSd3,
    ['shadow-elevation-sd4']: shadowElevationSd4,
    ['shadow-elevation-sd5']: shadowElevationSd5,
    ['shadow-sd0']: shadowSd0,
    ['shadow-sd1']: shadowSd1,
    ['shadow-sd1-up']: shadowSd1Up,
    ['shadow-sd1-right']: shadowSd1Right,
    ['shadow-sd1-down']: shadowSd1Down,
    ['shadow-sd1-left']: shadowSd1Left,
    ['shadow-sd2']: shadowSd2,
    ['shadow-sd2-up']: shadowSd2Up,
    ['shadow-sd2-right']: shadowSd2Right,
    ['shadow-sd2-down']: shadowSd2Down,
    ['shadow-sd2-left']: shadowSd2Left,
    ['shadow-sd3']: shadowSd3,
    ['shadow-sd3-up']: shadowSd3Up,
    ['shadow-sd3-right']: shadowSd3Right,
    ['shadow-sd3-down']: shadowSd3Down,
    ['shadow-sd3-left']: shadowSd3Left,
    ['shadow-sd4']: shadowSd4,
    ['shadow-sd4-up']: shadowSd4Up,
    ['shadow-sd4-right']: shadowSd4Right,
    ['shadow-sd4-down']: shadowSd4Down,
    ['shadow-sd4-left']: shadowSd4Left,
    ['shadow-sd5']: shadowSd5,
    ['shadow-sd5-up']: shadowSd5Up,
    ['shadow-sd5-right']: shadowSd5Right,
    ['shadow-sd5-down']: shadowSd5Down,
    ['shadow-sd5-left']: shadowSd5Left,
    shadowMaker
}
