'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeEnv = require('nuke-env');

var _index = require('./animate-value/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /** @jsx createElement */


var Dialog = function (_Component) {
  _inherits(Dialog, _Component);

  function Dialog(props) {
    _classCallCheck(this, Dialog);

    var _this = _possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props));

    _this.state = {
      visible: false
    };
    _this.wrapPress = _this.wrapPress.bind(_this);
    _this.maskPress = _this.maskPress.bind(_this);
    return _this;
  }

  _createClass(Dialog, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({
        visible: this.props.visible
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.animated(this.state);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.visible !== this.props.visible && nextProps.visible !== this.state.visible) {
        this.toggle(nextProps.visible);
      }
    }
  }, {
    key: 'animated',
    value: function animated(state, callback) {
      var _this2 = this;

      var self = this;
      var visible = state.visible;

      var from = visible ? 1 : 0;
      var to = visible ? 0 : 1;
      (0, _index2.default)({
        from: to,
        to: from,
        duration: 200,
        loop: 1,
        change: function change(value) {
          // console.log('valueChange',value);
          _this2.setState({ animOpacity: value });
        },
        done: function done() {
          callback && callback.call(self);
        }
      });
    }
  }, {
    key: 'show',
    value: function show(e) {
      var _this3 = this;

      var currentState = { visible: true };
      this.setState(currentState, function () {
        return _this3.animated(currentState, function () {
          return _this3.props.onShow && _this3.props.onShow(e);
        });
      });
    }
  }, {
    key: 'hide',
    value: function hide(e) {
      var _this4 = this;

      var currentState = { visible: false };
      this.animated(currentState, function () {
        return _this4.setState(currentState, function () {
          return _this4.props.onHide && _this4.props.onHide(e);
        });
      });
    }
  }, {
    key: 'toggle',
    value: function toggle(visible) {
      if (visible) {
        this.show();
      } else {
        this.hide();
      }
    }
  }, {
    key: 'maskPress',
    value: function maskPress(e) {
      var closeOnMaskPress = this.props.closeOnMaskPress;

      if (closeOnMaskPress) {
        this.hide();
      }
      this.props.onMaskPress && this.props.onMaskPress(e);
    }
  }, {
    key: 'wrapPress',
    value: function wrapPress(e) {
      if (_nukeEnv.isWeb) {
        e.stopPropagation();
      }
    }
  }, {
    key: 'touchmove',
    value: function touchmove(e) {
      if (_nukeEnv.isWeb) {
        e.preventDefault();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$contentStyle = _props.contentStyle,
          contentStyle = _props$contentStyle === undefined ? {} : _props$contentStyle,
          _props$maskStyle = _props.maskStyle,
          maskStyle = _props$maskStyle === undefined ? {} : _props$maskStyle,
          children = _props.children,
          others = _objectWithoutProperties(_props, ['contentStyle', 'maskStyle', 'children']);

      var visible = this.state.visible;

      return visible ? (0, _rax.createElement)(
        _nukeView2.default,
        _extends({}, others, {
          ref: 'modalMask',

          style: [styles.mask, { opacity: this.state.animOpacity }, maskStyle],
          onClick: this.maskPress,
          ontouchmove: this.touchmove

        }),
        (0, _rax.createElement)(
          _nukeView2.default,
          { style: [styles.main, contentStyle], onClick: this.wrapPress },
          children
        )
      ) : null;
    }
  }]);

  return Dialog;
}(_rax.Component);

var styles = {
  mask: {
    position: 'fixed',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    backgroundColor: 'rgba(0, 0, 0, 0.6)',
    zIndex: 100,
    alignItems: 'center',
    justifyContent: 'center'
  },
  main: {
    width: '640rem',
    backgroundColor: '#ffffff'
  }
};
Dialog.propTypes = {
  onHide: _rax.PropTypes.func,
  onShow: _rax.PropTypes.func,
  onMaskPress: _rax.PropTypes.func,
  visible: _rax.PropTypes.bool,
  closeOnMaskPress: _rax.PropTypes.boolean,
  contentStyle: _rax.PropTypes.any,
  maskStyle: _rax.PropTypes.any,
  children: _rax.PropTypes.any
};

Dialog.defaultProps = {
  visible: false,
  onHide: function onHide() {},
  onShow: function onShow() {},
  onMaskPress: function onMaskPress() {},
  closeOnMaskPress: false,
  contentStyle: {},
  maskStyle: {},
  children: null
};
exports.default = Dialog;
module.exports = exports['default'];