'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _env = require('./env');

var _ua = require('./ua');

var _ua2 = _interopRequireDefault(_ua);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nukeEnv = {
    isWeb: _env.isWeb,
    isNode: _env.isNode,
    isWeex: _env.isWeex,
    isReactNative: _env.isReactNative
};

var isQNWeb = false,
    isQNWeex = false,
    appInfo = "",
    params = {},
    runtimeInfo = {};

if (_env.isWeex) {
    var WeexEnv = typeof window !== 'undefined' && window.hasOwnProperty('__weex_env__') ? Object.assign({}, window.__weex_env__) : Object.assign({}, WXEnvironment);
    isQNWeb = false;
    isQNWeex = WeexEnv.appName === 'QN';
    appInfo = Object.assign({}, WeexEnv);
    params = typeof __weex_data__ !== 'undefined' ? __weex_data__ : {};
    runtimeInfo = typeof __weex_options__ !== 'undefined' ? __weex_options__ : {};
} else {
    isQNWeex = false;
    appInfo = (0, _ua2.default)();
    isQNWeb = appInfo.appName === 'QN';
    if (location.search) {
        var searchString = location.search.substring(1),
            i,
            val,
            paramsArr = searchString.split("&");
        for (i = 0; i < paramsArr.length; i++) {
            val = paramsArr[i].split("=");
            params[val[0]] = decodeURIComponent(val[1]);
        }
    }
}
nukeEnv.isQNWeb = isQNWeb;
nukeEnv.isQNWeex = isQNWeex;
nukeEnv.appInfo = appInfo;
nukeEnv.params = params;
nukeEnv.runtimeInfo = runtimeInfo;
exports.default = nukeEnv;
module.exports = exports['default'];