'use strict';

var _universalEnv = require('universal-env');

/**
 * @description parse rem to even px to solve andoird float px issue.
 */
exports.caculateRemToPx = function (rem) {
  var defaultWidth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 750;

  // Default 1 rem to 1 px
  if (_universalEnv.isWeex) return rem;
  rem = exports.removeRemUnit(rem);
  var defaultPixUnit = document.documentElement.clientWidth / defaultWidth;
  var num = Math.round(parseFloat(rem) * defaultPixUnit);
  if (num % 2 === 0) {
    return num + 'px';
  } else {
    return num - 1 + 'px';
  }
};
/**
 * @description remove rem unit for string like 12rem => 12
 * @param {string or number} rem
 */
exports.removeRemUnit = function (rem) {
  rem = String(rem);
  return rem.replace('rem', '');
};