/** @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('nuke-touchable');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _nukeImage = require('nuke-image');

var _nukeImage2 = _interopRequireDefault(_nukeImage);

var _nukeIconfont = require('nuke-iconfont');

var _nukeIconfont2 = _interopRequireDefault(_nukeIconfont);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _code = require('./code');

var _code2 = _interopRequireDefault(_code);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ICON_TYPES = {
    'xs': _styles2.default['nuke-icon-xs'],
    'medium': _styles2.default['nuke-icon-medium'],
    'large': _styles2.default['nuke-icon-large'],
    'small': _styles2.default['nuke-icon-small']
};

var Icon = function (_Component) {
    _inherits(Icon, _Component);

    function Icon(props) {
        _classCallCheck(this, Icon);

        var _this = _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).call(this, props));

        _this.state = {};
        return _this;
    }

    _createClass(Icon, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _props = this.props,
                name = _props.name,
                _props$version = _props.version,
                version = _props$version === undefined ? "default" : _props$version;

            var iconConfig = _code2.default[version];
            if (name && iconConfig) {

                (0, _nukeIconfont2.default)({ name: iconConfig['fontName'], url: iconConfig['url'] });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                size = _props2.size,
                name = _props2.name,
                _props2$style = _props2.style,
                style = _props2$style === undefined ? {} : _props2$style,
                _props2$type = _props2.type,
                type = _props2$type === undefined ? '' : _props2$type,
                _props2$version = _props2.version,
                version = _props2$version === undefined ? "default" : _props2$version,
                _props2$onPress = _props2.onPress,
                onPress = _props2$onPress === undefined ? function () {} : _props2$onPress,
                others = _objectWithoutProperties(_props2, ['size', 'name', 'style', 'type', 'version', 'onPress']);

            var iconConfig = _code2.default[version];

            if (name && iconConfig) {
                var textStyle = Object.assign({}, style, { fontFamily: iconConfig['fontName'] });
                return (0, _rax.createElement)(
                    _nukeText2.default,
                    _extends({}, others, { style: textStyle }),
                    iconConfig['codes'][name]
                );
            } else {
                var wrapStyle = Object.assign({}, _styles2.default['nuke-icon'], style);
                var sizeStyle = ICON_TYPES[size];
                return (0, _rax.createElement)(
                    _nukeTouchable2.default,
                    _extends({ onPress: this.props.onPress, style: wrapStyle }, others),
                    (0, _rax.createElement)(_nukeImage2.default, { source: { uri: this.props.src }, style: sizeStyle, resizeMode: 'cover' })
                );
            }
        }
    }]);

    return Icon;
}(_rax.Component);

Icon.defaultProps = {
    size: 'medium'
};
Icon.propTypes = {
    size: _rax.PropTypes.oneOf(['xs', 'small', 'medium', 'large'])
};
exports.default = Icon;
module.exports = exports['default'];