/** @jsx createElement */
import {createElement, Component,render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Icon from 'nuke-icon';
import {MultiRow} from 'nuke-layout';
import Page from 'nuke-page';
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state={
            icons:[
                "all",
                "email",
                "account",
                "emailFilling",
                "favoritesFilling",
                "accountFilling",
                "smile",
                "personalCenter",
                "back",
                "arrowDown",
                "arrowUp",
                "add",
                "minus",
                "errorFilling",
                "error",
                "select",
                "success",
                "warning",
                "display",
                "prompt",
                "successFilling",
                "close",
                "semiSelect",
                "loading",
                "navMore",
                "search",
                "arrowRight",
                "favorites",
                "deleteFilling",
                "arrowLeft",
                "radio",
                "right"
            ]
        }
        
    }
    renderGridCell=(item,index)=>{
        return <View style={styles.iconCell}>
                <Icon style={styles.icon} name={item} />
                <Text style={styles.iconShowCode}>{item}</Text>
            </View>
    }

    render() {
        return (
            <Page title="Icon">
                <Page.Intro main="方形图片"></Page.Intro>
                <View style={styles.listLine}>
                    <Icon style={styles.icon} src="https://img.alicdn.com/tfs/TB1vUv.JFXXXXbAXFXXXXXXXXXX-50-50.png" />
                    <View><Text>一行文字 </Text></View>
                </View>
                <Page.Intro main="自带的 iconfont 集合"></Page.Intro>
                <View style={styles.lineWithMargin}><MultiRow dataSource={this.state.icons} rows={4} renderRow={this.renderGridCell} /></View>
            </Page>

        );
    }
}
const styles={
    icon:{
        
        marginRight:'10rem'
    },
    iconCell:{
        paddingTop:'40rem',
        alignItems:'center',
    },
    listLine:{
        marginLeft:'40rem',
        marginRight:'40rem',
        padding:'20rem',
        flexDirection:'row',
        backgroundColor:'#ffffff'

    },
    lineWithMargin:{
        marginLeft:'40rem',
        marginRight:'40rem',
        backgroundColor:'#ffffff'

    },
    
    iconShowCode:{
        fontSize: '24rem',
        color:'#999999',
    }
}
render(<App/>);
