/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * @providesModule
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _nukeEnv = require('nuke-env');

function Iconfont(options) {
    var url = options.url,
        name = options.name;


    if (!url || !name) return;
    var urlFit = url;
    if (_nukeEnv.isWeex) {
        if (url.indexOf('//at.alicdn.com') === 0) {
            urlFit = 'https:' + urlFit;
        }
        var domModule = require('@weex-module/dom');
        domModule.addRule('fontFace', {
            'fontFamily': name,
            'src': "url('" + urlFit + "')"
        });
    } else {

        var css = "@font-face {font-family: '" + name + "';src: url('" + urlFit + "');}",
            head = document.head || document.getElementsByTagName('head')[0],
            style = document.createElement('style');

        style.type = 'text/css';
        if (style.styleSheet) {
            style.styleSheet.cssText = css;
        } else {
            style.appendChild(document.createTextNode(css));
        }

        head.appendChild(style);
    }
}

exports.default = Iconfont;
module.exports = exports['default'];