/* @jsx createElement */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeEnv = require('nuke-env');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Image = function (_Component) {
    _inherits(Image, _Component);

    function Image(props) {
        _classCallCheck(this, Image);

        var _this = _possibleConstructorReturn(this, (Image.__proto__ || Object.getPrototypeOf(Image)).call(this, props));

        _this.load = function (e) {
            var width = void 0,
                height = void 0;
            if (_nukeEnv.isWeex) {
                if (e.size && e.size.naturalWidth > 0 && e.size.naturalHeight > 0) {
                    width = _this.convertToRem(e.target.naturalWidth);
                    height = _this.convertToRem(e.target.naturalHeight);
                }
            } else {
                if (e.target) {
                    width = _this.convertToRem(e.target.naturalWidth);
                    height = _this.convertToRem(e.target.naturalHeight);
                    e.size = {
                        naturalWidth: width,
                        naturalHeight: height
                    };
                }
            }
            if (_this.props.autoFit && width && height) {
                _this.setState({
                    width: width,
                    height: height
                });
            }

            _this.props.onLoad && _this.props.onLoad(e);
        };

        _this.state = {
            width: 1,
            height: 1
        };
        return _this;
    }

    _createClass(Image, [{
        key: 'convertToRem',
        value: function convertToRem(num) {
            var pxWidth = void 0;
            if (_nukeEnv.isWeex) {
                pxWidth = WXEnvironment.deviceWidth;
            } else {
                pxWidth = document.documentElement.clientWidth * devicePixelRatio;
            }
            return Math.round(num * 750 / pxWidth);
        }
    }, {
        key: 'render',
        value: function render() {
            var nativeProps = _extends({}, this.props);

            var src = nativeProps.src,
                _nativeProps$source = nativeProps.source,
                source = _nativeProps$source === undefined ? {} : _nativeProps$source;


            if (src || source.uri) {
                nativeProps.src = src || source.uri;
                var width = source.width,
                    height = source.height;

                nativeProps.style = _extends({
                    width: width || 1,
                    height: height || 1
                }, nativeProps.style);
                if (this.props.autoFit) {
                    nativeProps.style.width = this.state.width;
                    nativeProps.style.height = this.state.height;
                }
                if (nativeProps.style.quality && nativeProps.style.quality === 'original') {
                    nativeProps.quality = 'original';
                }

                delete nativeProps.source;

                var ImageElement = void 0;
                if (_nukeEnv.isWeex) {
                    ImageElement = 'image';
                } else {
                    ImageElement = 'img';
                }

                // for cover and contain
                var propsResizeMode = nativeProps.resizeMode || nativeProps.style.resizeMode;
                if (propsResizeMode) {
                    if (_nukeEnv.isWeex) {
                        nativeProps.resize = propsResizeMode;
                        nativeProps.style.resizeMode = propsResizeMode;
                    } else {
                        nativeProps.style.objectFit = propsResizeMode;
                    }
                }

                if (nativeProps.children) {
                    var imageProps = _extends({}, nativeProps, {
                        style: _extends({}, nativeProps.style, styles.absoluteImage)
                    });

                    return (0, _rax.createElement)(
                        _nukeView2.default,
                        { style: nativeProps.style },
                        (0, _rax.createElement)(ImageElement, imageProps),
                        this.props.children
                    );
                } else {
                    return (0, _rax.createElement)(ImageElement, _extends({}, nativeProps, { onLoad: this.load }));
                }
            }
            return null;
        }
    }]);

    return Image;
}(_rax.Component);

Image.resizeMode = {
    contain: 'contain',
    cover: 'cover',
    stretch: 'stretch',
    center: 'center',
    repeat: 'repeat'
};


var styles = {
    absoluteImage: {
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        position: 'absolute'
    }
};

exports.default = Image;
module.exports = exports['default'];