/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 */
'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _h5Normalize;

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeIcon = require('nuke-icon');

var _nukeIcon2 = _interopRequireDefault(_nukeIcon);

var _nukeButton = require('nuke-button');

var _nukeButton2 = _interopRequireDefault(_nukeButton);

var _nukeEnv = require('nuke-env');

var _styles = require('./styles.js');

var _styles2 = _interopRequireDefault(_styles);

var _attributes = require('./mods/attributes');

var _attributes2 = _interopRequireDefault(_attributes);

var _events = require('./mods/events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// 下面的属性需要在Text上手工继承
var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight', 'textAlign', 'textDecoration'];
var h5Normalize = (_h5Normalize = {}, _defineProperty(_h5Normalize, '-webkit-appearance', 'none'), _defineProperty(_h5Normalize, 'outline', 'none'), _defineProperty(_h5Normalize, 'box-sizing', 'border-box'), _defineProperty(_h5Normalize, 'width', '100%'), _defineProperty(_h5Normalize, 'border', 'none'), _defineProperty(_h5Normalize, 'resize', 'none'), _h5Normalize);

function getText(event) {
    var text = void 0;
    if (_nukeEnv.isWeex) {
        text = event.value;
    } else {
        text = event.target.value;
    }
    return text;
}

function genEventObject(originalEvent) {
    var text = getText(originalEvent);
    return {
        nativeEvent: {
            text: text
        },
        value: text,
        target: originalEvent.target,
        originalEvent: originalEvent
    };
}

var Input = function (_Component) {
    _inherits(Input, _Component);

    /**
     * 构造函数
     */


    /**
     * 设置默认属性
     */
    function Input(props) {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

        _this.focus = function () {
            _this.refs.input.focus && _this.refs.input.focus();
        };

        _this.blur = function () {
            _this.refs.input.blur && _this.refs.input.blur();
        };

        _this.getValue = function () {
            if (_nukeEnv.isWeb) {
                return _this.refs.input.value;
            }
            return _this.refs.input.attr.value;
        };

        _this.changeHandler = _this.changeHandler.bind(_this);
        _this.inputHandler = _this.inputHandler.bind(_this);
        _this.focusHandler = _this.focusHandler.bind(_this);
        _this.blurHandler = _this.blurHandler.bind(_this);
        _this.clearHandler = _this.clearHandler.bind(_this);
        _this.returnHandler = _this.returnHandler.bind(_this);

        // this.timer = null;
        _this.state = {
            focus: false,
            value: _this.getPropValue(props, 'value')
        };
        return _this;
    }

    /**
     * 设置默认状态
     */

    /**
     * 声明属性类型
     */


    _createClass(Input, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // debugger;
            if ('value' in nextProps) {
                this.setState({
                    value: nextProps.value
                });
            }
            // this.updateStateFromProps(newProps, ['type', 'value']);
        }

        /**
         * 渲染: 当state发生改变时立即执行
         */

    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                hasFeedback = _props.hasFeedback,
                hasClear = _props.hasClear,
                _props$prefix = _props.prefix,
                prefix = _props$prefix === undefined ? this.defaultPrefix : _props$prefix,
                ref = _props.ref,
                className = _props.className,
                defaultValue = _props.defaultValue,
                value = _props.value,
                onChange = _props.onChange,
                onFocus = _props.onFocus,
                onInput = _props.onInput,
                onBlur = _props.onBlur,
                readOnly = _props.readOnly,
                size = _props.size,
                disabled = _props.disabled,
                _props$style = _props.style,
                style = _props$style === undefined ? {} : _props$style,
                addonBefore = _props.addonBefore,
                addonAfter = _props.addonAfter,
                maxLength = _props.maxLength,
                multiple = _props.multiple,
                _props$encrypt = _props.encrypt,
                encrypt = _props$encrypt === undefined ? false : _props$encrypt,
                _props$inputStyle = _props.inputStyle,
                inputStyle = _props$inputStyle === undefined ? {} : _props$inputStyle,
                _props$returnKeyType = _props.returnKeyType,
                returnKeyType = _props$returnKeyType === undefined ? 'default' : _props$returnKeyType,
                _props$autoFocus = _props.autoFocus,
                autoFocus = _props$autoFocus === undefined ? false : _props$autoFocus,
                _props$type = _props.type,
                type = _props$type === undefined ? 'text' : _props$type,
                _props$testId = _props.testId,
                testId = _props$testId === undefined ? '' : _props$testId,
                _props$placeholderCol = _props.placeholderColor,
                placeholderColor = _props$placeholderCol === undefined ? '#999999' : _props$placeholderCol,
                others = _objectWithoutProperties(_props, ['hasFeedback', 'hasClear', 'prefix', 'ref', 'className', 'defaultValue', 'value', 'onChange', 'onFocus', 'onInput', 'onBlur', 'readOnly', 'size', 'disabled', 'style', 'addonBefore', 'addonAfter', 'maxLength', 'multiple', 'encrypt', 'inputStyle', 'returnKeyType', 'autoFocus', 'type', 'testId', 'placeholderColor']);
            //兼容 htmlType to type


            var typeForStyle = 'enclosed',
                htmlType = 'text';
            if (type === 'inset' || type === 'enclosed') {
                typeForStyle = type;
            } else {
                htmlType = type;
            }
            var baseClass = 'input';
            var inputWrapperStyle = Object.assign({}, _styles2.default['input'], _styles2.default[size], _styles2.default['' + typeForStyle], _styles2.default['' + (multiple ? 'multiple' : 'single')], _styles2.default[typeForStyle + '-' + (multiple ? 'multiple' : 'single')], this.state.focus ? _styles2.default['focus'] : {}, readOnly ? _styles2.default[(multiple ? 'multiple' : 'single') + '-readonly'] : {}, disabled ? _styles2.default[typeForStyle + '-' + (multiple ? 'multiple' : 'single') + '-disabled'] : {}, _styles2.default[typeForStyle + '-' + (multiple ? 'multiple' : 'single')], style
            // {
            //     [state]: state
            );
            var attrs = {
                // style: style,
                onChange: this.changeHandler,
                onReturn: this.returnHandler,
                onInput: this.inputHandler,
                onFocus: this.focusHandler,
                onBlur: this.blurHandler,
                encrypt: encrypt,
                disabled: disabled,
                readOnly: readOnly,
                returnKeyType: returnKeyType,
                value: this.state.value,
                maxlength: maxLength,
                autofocus: autoFocus,
                placeholderColor: placeholderColor,
                defaultValue: defaultValue,
                testId: testId
            };
            /**
             * 如果是多行文本，添加returnKeyType 会导致无法换换
             * @param  {[type]} !this.props.onReturn [description]
             * @return {[type]}                      [description]
             */
            if (multiple && !this.props.onReturn) {
                delete attrs.onReturn;
                delete attrs.returnKeyType;
            }
            if (value) {
                delete attrs.defaultValue;
            }
            // 绕过h5下 readOnly 默认值问题
            if ('readOnly' in attrs && !attrs.readOnly) {
                delete attrs.readOnly;
            }
            // 绕过h5下 autofocus 默认值问题
            if ('autofocus' in attrs && !attrs.autofocus) {
                delete attrs.autofocus;
            }

            var inputElement = void 0;
            var flexVal = 'flex-' + (10 - (addonBefore ? 1 : 0) - (addonAfter ? 1 : 0));
            var isAddonMode = (addonBefore || addonAfter) && !multiple;
            var customStyleFilter = {};
            ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight', 'textAlign', 'textDecoration'].forEach(function (item) {
                if (style[item]) {
                    // debugger;
                    customStyleFilter[item] = style[item];
                }
            });

            var elementStyle = Object.assign({}, _styles2.default['input-inner'], _styles2.default[size], _styles2.default[typeForStyle + '-' + (multiple ? 'multiple' : 'single') + '-input'], _styles2.default[(multiple ? 'multiple' : 'single') + '-input'], hasFeedback ? _styles2.default['has-feedback-input'] : {}, hasClear && this.state.focus ? _styles2.default['has-clear-input'] : {}, this.state.focus ? _styles2.default['focus-input'] : {}, readOnly ? _styles2.default[(multiple ? 'multiple' : 'single') + '-readonly-input'] : {}, disabled ? _styles2.default[typeForStyle + '-' + (multiple ? 'multiple' : 'single') + '-disabled-input'] : {}, customStyleFilter, inputStyle);

            if (multiple) {
                if (_nukeEnv.isWeb) {
                    inputElement = (0, _rax.createElement)(
                        'textarea',
                        _extends({
                            ref: 'input',
                            style: [h5Normalize, elementStyle]
                        }, attrs, this.pickAttrs(others)),
                        attrs.value
                    );
                } else {
                    // type="text" 修一个 return key 的bug http://dotwe.org/weex/6a75d9164c4186c9a9d46b51daed6b2e
                    // 如果不加 type="text" ，return key 可能会出问题
                    inputElement = (0, _rax.createElement)('textarea', _extends({
                        ref: 'input',
                        style: [elementStyle, { paddingTop: '4rem' }]
                    }, attrs, this.pickAttrs(others)));
                }
            } else {
                var x = _nukeEnv.isWeb ? Object.assign({}, h5Normalize, elementStyle) : elementStyle;
                if ('height' in x) {
                    delete x.height;
                }
                inputElement = (0, _rax.createElement)('input', _extends({
                    ref: 'input',
                    className: 'nuke-input'
                }, attrs, this.pickAttrs(others), {
                    type: this.props.htmlType,
                    style: x,
                    'data-placeholder-color': placeholderColor
                }));
                // console.log('x',x);
            }
            var classNameForBorder = parseInt(inputWrapperStyle.borderWidth, 10) ? { className: 'nuke-border-fix-1' } : {};
            return (0, _rax.createElement)(
                _nukeView2.default,
                _extends({}, others, {
                    x: 'input-wrap',
                    style: inputWrapperStyle
                }, classNameForBorder),
                (0, _rax.createElement)(
                    _nukeView2.default,
                    { x: 'innner-flex', style: _styles2.default['inner-flex'] },
                    (0, _rax.createElement)(
                        _nukeView2.default,
                        {
                            x: 'innner-input-box',
                            style: [_styles2.default['inner-input-box'], _styles2.default[flexVal]]
                        },
                        inputElement,
                        this.renderClear(baseClass),
                        this.renderFeedback(baseClass),
                        this.renderCounter(baseClass)
                    )
                )
            );
        }
    }, {
        key: 'getPropValue',
        value: function getPropValue(props, key) {
            var capitalKey = key.charAt(0).toUpperCase() + key.slice(1);

            var name = props[key] !== undefined ? key : 'default' + capitalKey;
            return props[name];
        }
    }, {
        key: 'getValueFromContextAndProp',
        value: function getValueFromContextAndProp(key) {
            var value = this.context[key];
            if (this.props.hasOwnProperty(key)) {
                value = this.props[key];
            }
            return value;
        }
    }, {
        key: 'pickAttrs',
        value: function pickAttrs(props) {
            var attrsPrefix = ['data-', 'aria-'];
            var attrs = {};
            for (var key in props) {
                if (_attributes2.default.indexOf(key) > -1 || _events2.default.indexOf(key) > -1) {
                    attrs[key] = props[key];
                } else if (attrsPrefix.map(function (prefix) {
                    return new RegExp('^' + prefix);
                }).some(function (reg) {
                    return key.replace(reg, '') != key;
                })) {
                    attrs[key] = props[key];
                }
            }
            return attrs;
        }
        //计数器

    }, {
        key: 'renderCounter',
        value: function renderCounter() {
            var _props2 = this.props,
                multiple = _props2.multiple,
                maxLength = _props2.maxLength,
                hasLimitHint = _props2.hasLimitHint,
                type = _props2.type;

            var typeForStyle = 'enclosed',
                htmlType = 'text';
            if (type === 'inset' || type === 'enclosed') {
                typeForStyle = type;
            }
            if (!(multiple && maxLength && hasLimitHint)) return;
            var counterStyle = Object.assign({}, _styles2.default['input-counter'], _styles2.default[typeForStyle + '-' + (multiple ? 'multiple' : 'single') + '-counter']);
            return (0, _rax.createElement)(
                _nukeView2.default,
                { style: counterStyle },
                (0, _rax.createElement)(
                    _nukeText2.default,
                    { style: _styles2.default['input-counter-text'] },
                    this.state.value.length,
                    '/',
                    maxLength
                )
            );
        }
    }, {
        key: 'renderClear',
        value: function renderClear(baseClass) {
            //如果已经设置了feedback, 则不出现clear
            var _props3 = this.props,
                hasClear = _props3.hasClear,
                multiple = _props3.multiple,
                inMatrix = _props3.inMatrix,
                readOnly = _props3.readOnly,
                hasFeedback = _props3.hasFeedback,
                type = _props3.type;

            var typeForStyle = 'enclosed';
            if (type === 'inset' || type === 'enclosed') {
                typeForStyle = type;
            }
            var _state = this.state,
                focus = _state.focus,
                value = _state.value;

            //hasClear与hasFeedback互斥

            if (typeof hasFeedback === 'boolean' && hasFeedback === true) {
                hasClear = false;
            }

            if (!hasClear || multiple || !value || readOnly || hasFeedback) return null;

            // 这里的button是一个清空按钮
            // 如果input在表单里需要处理回车事件
            // 但是这里又没有指定htmlType为button
            // 则会直接触发清空操作
            var clearStyle = Object.assign({}, _styles2.default['clear'], _styles2.default['single-clear'], _styles2.default[typeForStyle + '-single-clear']);
            return (0, _rax.createElement)(_nukeIcon2.default, {
                x: 'clear-icon',
                onPress: this.clearHandler,
                size: 'medium',
                name: 'deleteFilling',
                style: clearStyle
            });
        }
    }, {
        key: 'renderFeedback',
        value: function renderFeedback() {
            var _props4 = this.props,
                type = _props4.type,
                multiple = _props4.multiple,
                hasFeedback = _props4.hasFeedback;

            var typeForStyle = 'enclosed';
            if (type === 'inset' || type === 'enclosed') {
                typeForStyle = type;
            }
            //多行不出现反馈
            if (multiple || !hasFeedback) return null;

            var iconType = '';
            var state = this.props.state;
            //如果没有设置state, 则从context中取state
            if (state === undefined) state = this.context.state;

            // switch(state){
            //     case 'success':
            //         iconType = 'success-filling';
            //         break;
            //     case 'error':
            //         iconType = 'error-filling';
            //         break;
            // }
            // debugger;
            var feedbackStyle = Object.assign({}, _styles2.default['feedback'], _styles2.default['single-feedback'], _styles2.default[typeForStyle + '-single-feedback'], _styles2.default['single-' + state + '-feedback']);
            return (0, _rax.createElement)(_nukeIcon2.default, {
                x: 'feedback-icon',
                name: state + 'Filling',
                size: 'medium',
                style: feedbackStyle
            });
        }
    }, {
        key: 'changeHandler',
        value: function changeHandler(e) {
            var value = void 0,
                event = void 0;
            if (_nukeEnv.isWeb) {
                value = e.target.value;
            } else {
                value = e.value;
                e.target['value'] = value;
            }
            var maxLength = this.props.maxLength;


            if (maxLength && value.length > maxLength) return;
            if ('value' in this.props) {
                this.setState({ value: getText(e) });
            }
            this.trigger('onChange', getText(e), genEventObject(e));
        }
    }, {
        key: 'returnHandler',
        value: function returnHandler(e) {
            this.trigger('onReturn', e);
        }
    }, {
        key: 'inputHandler',
        value: function inputHandler(e) {
            // this.props.onInput(genEventObject(e));
            if (_nukeEnv.isWeex) {
                e.target['value'] = e.value;
            }

            this.trigger('onInput', genEventObject(e));
        }
    }, {
        key: 'trigger',
        value: function trigger(fn) {
            if (typeof fn === 'string') fn = this.props[fn];
            if (!(typeof fn === 'function')) return;

            for (var _len = arguments.length, attrs = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                attrs[_key - 1] = arguments[_key];
            }

            return fn.apply(this, attrs);
        }
    }, {
        key: 'focusHandler',
        value: function focusHandler(e) {
            this.setState({
                focus: true
            });

            this.trigger('onFocus', e);
        }
    }, {
        key: 'blurHandler',
        value: function blurHandler(e) {
            this.setState({
                focus: false
            });

            this.trigger('onBlur', e);
        }
    }, {
        key: 'clearHandler',
        value: function clearHandler(e) {
            this.setUnControlledState('value', '');
            this.trigger('onChange', '', e);
        }
    }, {
        key: 'setUnControlledState',
        value: function setUnControlledState(key, value) {
            if (this.props[key] !== undefined) return;

            this.setState(_defineProperty({}, key, value));
        }
    }]);

    return Input;
}(_rax.Component);

Input.propTypes = {
    readOnly: _rax.PropTypes.bool,
    inMatrix: _rax.PropTypes.bool,
    align: _rax.PropTypes.oneOf(['left', 'right', 'center']),
    multiple: _rax.PropTypes.bool,
    hasFeedback: _rax.PropTypes.bool,
    hasClear: _rax.PropTypes.bool,
    type: _rax.PropTypes.oneOf(['enclosed', 'inset', 'search', 'text', 'tel', 'email', 'url', 'password', 'number']),
    state: _rax.PropTypes.oneOf(['', 'success', 'error', 'warning']),
    value: _rax.PropTypes.any,
    defaultValue: _rax.PropTypes.any,
    size: _rax.PropTypes.oneOf(['small', 'large', 'medium']),
    disabled: _rax.PropTypes.bool,
    onClick: _rax.PropTypes.func,
    maxLength: _rax.PropTypes.number,
    //是否显示限制长度的提示
    hasLimitHint: _rax.PropTypes.bool,

    // 文本域前后附加内容
    addonBefore: _rax.PropTypes.string,
    addonAfter: _rax.PropTypes.string
};
Input.defaultProps = {
    hasClear: false,
    hasFeedback: false,
    multiple: false,
    size: 'medium',
    htmlType: 'text',
    hasLimitHint: false
};
Input.contextTypes = {
    align: _rax.PropTypes.string,
    type: _rax.PropTypes.string,
    form: _rax.PropTypes.object,
    state: _rax.PropTypes.string
};
exports.default = Input;
module.exports = exports['default'];