/** @jsx createElement */
import { createElement, Component, findDOMNode, render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Input from 'nuke-input';
import Button from 'nuke-button';
import Page from 'nuke-page';


let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            content: '',
            inputStr: ''
        }

    }
    change = (value, e) => {
        this.setState({
            content: value
        })
    }

    render() {
        return (
            <Page title="Input">
                <Page.Intro main="基础样式"></Page.Intro>
                <View style={styles.lineWithMargin}>
                    <Input ref="myinput" defaultValue="春装 连衣裙" onChange={this.change} onInput={(e) => { console.log('input==>', value) }} />
                </View>
                <View style={[styles.lineWithMargin, styles.textLine]}>
                    <Text style={styles.text}>用户输入：{this.state.content}</Text>
                </View>

                <Page.Intro main="只能输入10个字符"></Page.Intro>
                <View style={styles.lineWithMargin}>
                    <Input onInput={(e) => { console.log('input==>', value) }} maxLength={10} />
                </View>


                <Page.Intro main="多行"></Page.Intro>
                <View style={styles.lineWithMargin}>
                    <Input style={{ height: '300rem', marginBottom: '20rem' }} multiple={true} placeholder="介绍一下" onFocus={(e) => console.log('onFocus', e)} onBlur={(e) => console.log('onBlur', e)} />
                </View>

                <Page.Intro main="不可修改"></Page.Intro>
                <View style={[styles.lineWithMargin, { marginBottom: '10rem' }]}><Input disabled value="不可修改" /></View>
                <Page.Intro main="键盘类型" sub="密码"></Page.Intro>
                <View style={styles.lineWithMargin}><Input placeholder="password" htmlType="password" /></View>
                <Page.Intro sub="email"></Page.Intro>
                <View style={styles.lineWithMargin}><Input placeholder="email" htmlType="email" /></View>
                <Page.Intro sub="url"></Page.Intro>
                <View style={styles.lineWithMargin}><Input placeholder="url" htmlType="url" /></View>
                <Page.Intro sub="tel"></Page.Intro>
                <View style={styles.lineWithMargin}><Input placeholder="tel" htmlType="tel" /></View>
                <Page.Intro sub="date"></Page.Intro>
                <View style={styles.lineWithMargin}><Input placeholder="date" htmlType="date" /></View>
                <Page.Intro sub="time"></Page.Intro>
                <View style={styles.lineWithMargin}><Input placeholder="time" htmlType="time" /></View>
                <Page.Intro main="encrypt"></Page.Intro>
                <View style={styles.lineWithMargin}>
                    <Input
                        style={styles.input}
                        encrypt={true}
                        encryptFormat={2}
                        encryptSeckeyType={1}
                        onChange={(value, e) => this.setState({ inputStr: value })}
                        value={'~tz4VOxQS0HdJn2Yo1nEwaw==~1~'}>
                    </Input>
                    <Text style={styles.inputStr}
                        encrypt={true}
                        encryptFormat={2}
                        encryptSeckeyType={1}>
                        {this.state.inputStr}
                    </Text>
                    <Text style={styles.inputStr}>
                        {this.state.inputStr}
                    </Text>
                </View>

            </Page>

        );
    }
}
const styles = {
    lineWithMargin: {
        marginLeft: '30rem',
        marginRight: '30rem',

    },
    textLine: {
        marginTop: '20rem',
        marginBottom: '40rem',
    },
    text: {
        fontSize: '26rem'
    },
    inputStr: {
        fontSize: '22',
        textAlign: 'left',
        margin: 5
    },

}
render(<App />);
