/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import RefreshControl from 'nuke-refresh-control';
import Touchable from 'nuke-touchable';
import Icon from 'nuke-icon';
import ListView from 'nuke-list-view';
import Modal from "nuke-modal";

let listData = [];
for (var i = 0; i < 20; i++) {
    listData.push({key: i,text:'第' + i + '条数据'});
}

class ListViewDemo extends Component {
    constructor() {
        super();
        this.state = {
            data: Object.assign([],listData),
            stop: false,
            isRefreshing: false,
            showLoading:true,
            refreshText: '↓ 下拉刷新',
        };
        this.index = 0;

    }
    handleRefresh = (e) => {
        this.setState({
          isRefreshing: true,
          refreshText: '加载中',
        });
        this.refs.mylist.resetLoadmore();
        this.index = 0;
        setTimeout(() => {
            this.setState({
                showLoading:true,
                isRefreshing: false,
                data:  Object.assign([],listData),
                refreshText: '↓ 下拉刷新',
            });
            Modal.toast('Refresh finish');

        }, 1000);
      };

    handleLoadMore() {
        var self = this;

        if (self.index == 5) {
            //模拟ajax请求返回数据5次以后，数据不再有更新了
            self.setState({showLoading:false})
            return;
        }else{
            //模拟ajax请求返回数据，数据有新增
            setTimeout(function() {
                self.state.data.push({key: self.index + 'l1',text:'第' + self.index + '次，loadmore 1'}, {key: self.index + 'l2',text:'第' + self.index + '次，loadmore 2'});
                self.setState(self.state);
                self.index++;
                Modal.toast('Loadmore finish');
            }, 1000);

        }

    }
    linkTo(item,e) {
        console.log(e);
    }

    renderItem (item, index){
        return <Touchable style={app.cellItemList} onPress={this.linkTo.bind(this,item)}>
                <Text style={app.itemTextList}>{item.text}</Text>
            </Touchable>;

    }
    renderHeader=()=>{
        return <RefreshControl style={app.refresh} refreshing={this.state.isRefreshing} onRefresh={this.handleRefresh}><Text style={app.loadingText}>{this.state.refreshText}</Text></RefreshControl>;
    }
    renderFooter=()=>{
        return this.state.showLoading ?
        <View style={[app.loading]}><Text style={app.loadingText}>加载中...</Text></View>
        :null
    }

    render(){
        var self=this;
        return (
            <View style={app.wrapper}>
                <ListView
                    ref="mylist"
                    renderHeader={this.renderHeader}
                    renderFooter={this.renderFooter}
                    renderRow={this.renderItem.bind(this)}
                    dataSource={this.state.data}
                    showScrollbar={true}
                    style={app.listContainer}
                    onEndReached={this.handleLoadMore.bind(this)}
                />
            </View>

        )
    }
}

const app = {
    wrapper:{
        flex:1
    },
    listContainer:{
        flex:1
    },
    cellItemList:{
        backgroundColor:"#ffffff",
        height:"110rem",
        borderBottomWidth:"2rem",
        borderBottomStyle:"solid",
        borderBottomColor:"#e8e8e8",
        paddingLeft:"30rem",
        alignItems:"center",
        flexDirection:"row"
    },
    itemTextList:{
        fontSize:"30rem",
        color:"#5F646E"
    },
    refresh:{
        height:"80rem",
        width:"750rem",

        backgroundColor:"#cccccc",
        justifyContent:"center",
        alignItems:"center"
    },
    loading:{
        height:"80rem",
        display:"flex",
        width:"750rem",
        flexDirection:"row",
        backgroundColor:"#cccccc",
        alignItems:"center",
        justifyContent:"center"
    },
    loadingText:{
        color:"#666666"
    }
}
render(<ListViewDemo/>);
