'use strict';
/** @jsx createElement */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeEnv = require('nuke-env');

var _nukeEnv2 = _interopRequireDefault(_nukeEnv);

var _nukeTransition = require('nuke-transition');

var _nukeTransition2 = _interopRequireDefault(_nukeTransition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isWeb = _nukeEnv2.default.isWeb,
    isWeex = _nukeEnv2.default.isWeex,
    appInfo = _nukeEnv2.default.appInfo;

var weexEnv = typeof WXEnvironment !== 'undefined' ? WXEnvironment : {};
var deviceHeight = weexEnv.deviceHeight ? parseInt(weexEnv.deviceHeight, 10) : 0;

var Mask = function (_Component) {
  _inherits(Mask, _Component);

  function Mask(props) {
    _classCallCheck(this, Mask);

    var _this = _possibleConstructorReturn(this, (Mask.__proto__ || Object.getPrototypeOf(Mask)).call(this, props));

    _this.initFlag = false;
    var visible = true;

    if ('defaultVisible' in props) {
      visible = props.defaultVisible;
    }
    _this.state = {
      visible: visible
    };
    return _this;
  }

  _createClass(Mask, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (!this.initFlag) {
        this.initFlag = true;
        return nextProps.style !== this.props.style || nextState.visible !== this.state.visible;
      }
      return true;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.visible) {
        if (this.props.animate) {
          this.animateShow();
        } else {
          // this.setState({
          //   styleOpacity: 1
          // });
        }
      }
    }
  }, {
    key: 'show',
    value: function show() {
      this.setState({ visible: true });
    }
  }, {
    key: 'change',
    value: function change(e) {
      this.setState({ visible: e.visible || !this.state.visible });
      this.props.onVisibleChanged && this.props.onVisibleChanged(e);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.visible && this.props.animate) {
        this.animateShow();
      }
    }
  }, {
    key: 'animateShow',
    value: function animateShow() {
      var _this2 = this;

      var box = (0, _rax.findDOMNode)(this.maskNode);
      var _props = this.props,
          _props$effect = _props.effect,
          effect = _props$effect === undefined ? 'ease-in-out' : _props$effect,
          _props$duration = _props.duration,
          duration = _props$duration === undefined ? 200 : _props$duration;
      // 此处各种 bug，所以加了 setTimeout

      setTimeout(function () {
        if (box) {
          (0, _nukeTransition2.default)(box, { opacity: 1 }, {
            timingFunction: effect, //ease-in,ease-in-out,ease-out,linear,cubic-bezier
            delay: 0,
            duration: duration
          }, function () {
            _this2.props.onShow && _this2.props.onShow();
          });
        }
      }, 10);
    }
  }, {
    key: 'hide',
    value: function hide() {
      var _this3 = this;

      var _props2 = this.props,
          _props2$animate = _props2.animate,
          animate = _props2$animate === undefined ? true : _props2$animate,
          _props2$effect = _props2.effect,
          effect = _props2$effect === undefined ? 'ease-in-out' : _props2$effect,
          _props2$duration = _props2.duration,
          duration = _props2$duration === undefined ? 200 : _props2$duration;

      if (animate) {
        var box = this.maskNode;
        if (box) {
          (0, _nukeTransition2.default)(box, { opacity: 0 }, {
            timingFunction: effect,
            delay: 0,
            duration: duration
          }, function () {
            _this3.setState({ visible: false });
            _this3.props.onHide && _this3.props.onHide();
          });
        }
      } else {
        this.setState({
          visible: false
        });
      }
    }
  }, {
    key: 'maskPress',
    value: function maskPress(e) {
      if (this.props.maskClosable) {
        this.hide();
      }
      this.props.onMaskPress && this.props.onMaskPress();
    }
  }, {
    key: 'emptyEvent',
    value: function emptyEvent(e) {
      // EmptyEvent consumes event in android, so it would not be bubbled to mask press.
      if (isWeb) {
        e.stopPropagation();
      }
    }
  }, {
    key: 'getChildren',
    value: function getChildren() {
      var _this4 = this;

      var _props3 = this.props,
          children = _props3.children,
          _props3$contentStyle = _props3.contentStyle,
          contentStyle = _props3$contentStyle === undefined ? {} : _props3$contentStyle;

      if (!children) return null;
      if (!Array.isArray(children)) {
        return (0, _rax.cloneElement)(children, {
          onClick: function onClick(e) {
            _this4.emptyEvent(e);
          }
        });
      }
      if (children.length === 1) {
        return (0, _rax.cloneElement)(children[0], {
          onClick: function onClick(e) {
            _this4.emptyEvent(e);
          }
        });
      } else {
        return (0, _rax.createElement)(
          _nukeView2.default,
          {
            style: contentStyle,
            x: 'autowrap',
            onClick: function onClick(e) {
              return _this4.emptyEvent(e);
            }
          },
          children
        );
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var visible = this.state.visible;

      var _props4 = this.props,
          content = _props4.content,
          children = _props4.children,
          _props4$style = _props4.style,
          style = _props4$style === undefined ? {} : _props4$style,
          onVisibleChanged = _props4.onVisibleChanged,
          onClick = _props4.onClick,
          _props4$noPress = _props4.noPress,
          noPress = _props4$noPress === undefined ? false : _props4$noPress,
          others = _objectWithoutProperties(_props4, ['content', 'children', 'style', 'onVisibleChanged', 'onClick', 'noPress']);

      if (isWeex) {
        var nativeAttrs = _extends({}, others, {
          style: [appInfo.platform === 'iOS' ? styles.maskNativeIOS : {}, style],
          onClick: function onClick(e) {
            return _this5.maskPress(e);
          },
          onVisibleChanged: function onVisibleChanged(e) {
            return _this5.change(e);
          }
        });
        if (noPress) {
          delete nativeAttrs.onClick;
        }
        var maskWeex = visible ? (0, _rax.createElement)(
          'mask',
          _extends({
            ref: function ref(n) {
              _this5.maskNode = (0, _rax.findDOMNode)(n);
            }
          }, nativeAttrs),
          this.getChildren()
        ) : null;
        return maskWeex;
      } else {
        return visible ? (0, _rax.createElement)(
          'div',
          _extends({}, others, {
            ref: function ref(n) {
              _this5.maskNode = (0, _rax.findDOMNode)(n);
            },
            style: [styles.maskWeb, style],
            onClick: function onClick(e) {
              return _this5.maskPress(e);
            }
          }),
          this.getChildren()
        ) : null;
      }
    }
  }]);

  return Mask;
}(_rax.Component);

var styles = {
  // Since iOS does not help to calculate position, we have to calculate ourselves.In Android, android provides a new mask, that all calculated,so nothing added.
  maskNativeIOS: {
    position: 'absolute',
    width: 750,
    // top: 0,
    // left: 0,
    height: Math.round(deviceHeight / window.devicePixelRatio) + 'wx'
  },

  maskWeb: {
    display: 'flex',
    boxSizing: 'border-box',
    flexDirection: 'column',
    alignContent: 'flex-start',
    flexShrink: 0,
    position: 'fixed',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    zIndex: 100
  },
  transparent: {
    opacity: 0
  },
  shown: {
    opacity: 1
  }
};
exports.default = Mask;
module.exports = exports['default'];