'use strict';

var _nukeVarLoader = require('nuke-var-loader');

var _nukeCore = require('nuke-core');

var _nukeCore2 = _interopRequireDefault(_nukeCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// //
// / @module modalCustom: 自定义对话框
// / @tag modalCustom
// / @category component
// / @family modalCustom
// / @varPrefix $modal-custom-
// / @classPrefix {prefix}-modalCustom
// //

var modalCustomToastMaskBgColor = (0, _nukeVarLoader.varLoader)('modal-custom-toast-mask-bg-color', _nukeCore2.default['color-n1-9']);
// / background
// / @namespace statement
var modalCustomToastBgColor = (0, _nukeVarLoader.varLoader)('modal-custom-toast-bg-color', _nukeCore2.default['color-n1-9']);

// / text
// / @namespace statement
var modalCustomToastColor = (0, _nukeVarLoader.varLoader)('modal-custom-toast-color', _nukeCore2.default['color-n1-1']);

// / padding(l/r)
// / @namespace size/bounding
var modalCustomToastPaddingLeftRight = (0, _nukeVarLoader.varLoader)('modal-custom-toast-padding-left-right', _nukeCore2.default.s3);

// / padding(t,b)
// / @namespace size/bounding
var modalCustomToastPaddingTopBottom = (0, _nukeVarLoader.varLoader)('modal-custom-toast-padding-top-bottom', _nukeCore2.default.s4);

// / text
// / @namespace size/text
var modalCustomToastFontSize = (0, _nukeVarLoader.varLoader)('modal-custom-toast-font-size', _nukeCore2.default['font-size-base-caption']);

// / margin(b)
// / @namespace size/icon
var modalCustomToastIconMarginBottom = (0, _nukeVarLoader.varLoader)('modal-custom-toast-icon-margin-bottom', _nukeCore2.default.s3);

// / corner
// / @namespace statement
var modalCustomToastCorner = (0, _nukeVarLoader.varLoader)('modal-custom-toast-corner', _nukeCore2.default['corner-radius-r1']);

// / size
// / @namespace size/icon
var modalCustomToastIconSize = (0, _nukeVarLoader.varLoader)('modal-custom-toast-icon-size', _nukeCore2.default['icon-l']);

// / icon-color
// / @namespace statement
var modalCustomToastIconColor = (0, _nukeVarLoader.varLoader)('modal-custom-toast-icon-color', _nukeCore2.default['color-n1-1']);

// / opacity
// / @namespace statement
var modalCustomToastOpacity = (0, _nukeVarLoader.varLoader)('modal-custom-toast-opacity', '.7');

// / mask-opacity
// / @namespace statement
var modalCustomToastMaskOpacity = (0, _nukeVarLoader.varLoader)('modal-custom-toast-mask-opacity', '0');

// / min width
// / @namespace size
var modalCustomToastMinWidth = (0, _nukeVarLoader.varLoader)('modal-custom-toast-min-width', _nukeCore2.default.s25);

// / max width
// / @namespace size
var modalCustomToastMaxWidth = (0, _nukeVarLoader.varLoader)('modal-custom-toast-max-width', _nukeCore2.default.s40);

// / min height
// / @namespace size
var modalCustomToastMinHeight = (0, _nukeVarLoader.varLoader)('modal-custom-toast-min-height', _nukeCore2.default.s15);

// / min width
// / @namespace size
var modalCustomToastIconMinWidth = (0, _nukeVarLoader.varLoader)('modal-custom-toast-icon-min-width', _nukeCore2.default.s25);

// / max width
// / @namespace size
var modalCustomToastIconMaxWidth = (0, _nukeVarLoader.varLoader)('modal-custom-toast-icon-max-width', _nukeCore2.default.s30);

// / min height
// / @namespace size
var modalCustomToastIconMinHeight = (0, _nukeVarLoader.varLoader)('modal-custom-toast-icon-min-height', _nukeCore2.default.s15);
// / align
// / @namespace statement
var modalCustomToastAlign = (0, _nukeVarLoader.varLoader)('modal-custom-toast-align', 'center');
// / padding(l,r)
// / @namespace size
var modalCustomInlinePaddingLeftRight = (0, _nukeVarLoader.varLoader)('modal-custom-inline-padding-left-right', _nukeCore2.default.s4);
// / padding(t)
// / @namespace size
var modalCustomInlinePaddingTop = (0, _nukeVarLoader.varLoader)('modal-custom-inline-padding-top', _nukeCore2.default.s7);
// / padding(b)
// / @namespace size
var modalCustomInlinePaddingBottom = (0, _nukeVarLoader.varLoader)('modal-custom-inline-padding-bottom', _nukeCore2.default.s5);
// / text
// / @namespace size/text
var modalCustomInlineFontSize = (0, _nukeVarLoader.varLoader)('modal-custom-inline-font-size', _nukeCore2.default['font-size-base-body1']);
// / margin(b)
// / @namespace size/icon
var modalCustomInlineIconBottomMargin = (0, _nukeVarLoader.varLoader)('modal-custom-inline-icon-bottom-margin', _nukeCore2.default.s5);
// / size
// / @namespace size/icon
var modalCustomInlineIconSize = (0, _nukeVarLoader.varLoader)('modal-custom-inline-icon-size', _nukeCore2.default['icon-xl']);

// / icon
// / @namespace statement/success
var modalCustomInlineIconSuccessColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-icon-success-color', _nukeCore2.default['color-f3-1']);
// / icon
// / @namespace statement/error
var modalCustomInlineIconErrorColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-icon-error-color', _nukeCore2.default['color-f2-1']);
// / icon
// / @namespace statement/warning
var modalCustomInlineIconWarningColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-icon-warning-color', _nukeCore2.default['color-f1-3']);

// / text
// / @namespace statement/success
var modalCustomInlineSuccessColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-success-color', _nukeCore2.default['color-n2-3']);
// / text
// / @namespace statement/error
var modalCustomInlineErrorColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-error-color', _nukeCore2.default['color-n2-3']);
// / text
// / @namespace statement/warning
var modalCustomInlineWarningColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-warning-color', _nukeCore2.default['color-n2-3']);

// / background
// / @namespace statement/success
var modalCustomInlineSuccessBgColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-success-bg-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statement/error
var modalCustomInlineErrorBgColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-error-bg-color', _nukeCore2.default['color-n1-1']);
// / background
// / @namespace statement/warning
var modalCustomInlineWarningBgColor = (0, _nukeVarLoader.varLoader)('modal-custom-inline-warning-bg-color', _nukeCore2.default['color-n1-1']);

// / size
// / @namespace size/image
var modalCustomPrImageSize = (0, _nukeVarLoader.varLoader)('modal-custom-pr-image-size', _nukeCore2.default.s20);

// / margin(t)
// / @namespace size/text
var modalCustomPrTextMarginTop = (0, _nukeVarLoader.varLoader)('modal-custom-pr-text-margin-top', _nukeCore2.default.s5);

// / margin(b)
// / @namespace size/text
var modalCustomPrTextMarginBottom = (0, _nukeVarLoader.varLoader)('modal-custom-pr-text-margin-bottom', _nukeCore2.default.s5);

// / text
// / @namespace size/text
var modalCustomPrFontSize = (0, _nukeVarLoader.varLoader)('modal-custom-pr-font-size', _nukeCore2.default['font-size-base-body1']);

// / color
// / @namespace statement
var modalCustomPrColor = (0, _nukeVarLoader.varLoader)('modal-custom-pr-color', _nukeCore2.default['color-n2-4']);

module.exports = {
  'modal-custom-toast-mask-bg-color': modalCustomToastMaskBgColor,
  'modal-custom-toast-bg-color': modalCustomToastBgColor,
  'modal-custom-toast-color': modalCustomToastColor,
  'modal-custom-toast-padding-left-right': modalCustomToastPaddingLeftRight,
  'modal-custom-toast-padding-top-bottom': modalCustomToastPaddingTopBottom,
  'modal-custom-toast-font-size': modalCustomToastFontSize,
  'modal-custom-toast-icon-margin-bottom': modalCustomToastIconMarginBottom,
  'modal-custom-toast-corner': modalCustomToastCorner,
  'modal-custom-toast-icon-size': modalCustomToastIconSize,
  'modal-custom-toast-icon-color': modalCustomToastIconColor,
  'modal-custom-toast-opacity': modalCustomToastOpacity,
  'modal-custom-toast-mask-opacity': modalCustomToastMaskOpacity,
  'modal-custom-toast-min-width': modalCustomToastMinWidth,
  'modal-custom-toast-max-width': modalCustomToastMaxWidth,
  'modal-custom-toast-min-height': modalCustomToastMinHeight,
  'modal-custom-toast-icon-min-width': modalCustomToastIconMinWidth,
  'modal-custom-toast-icon-max-width': modalCustomToastIconMaxWidth,
  'modal-custom-toast-icon-min-height': modalCustomToastIconMinHeight,
  'modal-custom-toast-align': modalCustomToastAlign,
  'modal-custom-inline-padding-left-right': modalCustomInlinePaddingLeftRight,
  'modal-custom-inline-padding-top': modalCustomInlinePaddingTop,
  'modal-custom-inline-padding-bottom': modalCustomInlinePaddingBottom,
  'modal-custom-inline-font-size': modalCustomInlineFontSize,
  'modal-custom-inline-icon-bottom-margin': modalCustomInlineIconBottomMargin,
  'modal-custom-inline-icon-size': modalCustomInlineIconSize,
  'modal-custom-inline-icon-success-color': modalCustomInlineIconSuccessColor,
  'modal-custom-inline-icon-error-color': modalCustomInlineIconErrorColor,
  'modal-custom-inline-icon-warning-color': modalCustomInlineIconWarningColor,
  'modal-custom-inline-success-color': modalCustomInlineSuccessColor,
  'modal-custom-inline-error-color': modalCustomInlineErrorColor,
  'modal-custom-inline-warning-color': modalCustomInlineWarningColor,
  'modal-custom-inline-success-bg-color': modalCustomInlineSuccessBgColor,
  'modal-custom-inline-error-bg-color': modalCustomInlineErrorBgColor,
  'modal-custom-inline-warning-bg-color': modalCustomInlineWarningBgColor,
  'modal-custom-pr-image-size': modalCustomPrImageSize,
  'modal-custom-pr-text-margin-top': modalCustomPrTextMarginTop,
  'modal-custom-pr-text-margin-bottom': modalCustomPrTextMarginBottom,
  'modal-custom-pr-font-size': modalCustomPrFontSize,
  'modal-custom-pr-color': modalCustomPrColor
};