/** @jsx createElement */
import {createElement, Component,render } from 'rax';
import View from 'nuke-view';
import Button from 'nuke-button';
import Env from 'nuke-env';
import NativeDialog from 'nuke-native-dialog';
import Page from 'nuke-page';
const { isWeex } = Env;

class App extends Component {
    constructor(props) {
        super(props);

        this.state = {
            error:'',
            response:''
        };

    }
    showDialog = (src) => {
        NativeDialog.show(src, {
            width : '640rem',
            height: '460rem',
            showMask:true,
            cancelOnTouch:true,
            data:{
                id:123344444,
                xx:'xxx'
            }
        }, (ret) => {
            this.setState({'response':ret});
        }, (err) => {
            this.setState({'response':err});
            console.log(err);
        }, (info) => {
            this.setState({'response':JSON.stringify(info)});
            console.log(JSON.stringify(info));
        });
       
    }
    render() {
        return (
            <Page title="Native Dialog">
                <View style={styles.result}>
                    {this.state.response ? <Text style={styles.resultText}>{this.state.response}</Text> :null}
                    {this.state.error ? <Text style={[styles.resultText,styles.resultTextError]}>{this.state.error}</Text> :null}
                </View>
                <View style={styles.btns}>
                    
                    <Button type="primary" size="large" onPress={() => {this.showDialog('qap://docs/innerdialog.js')}}>show</Button>
                </View>
            </Page>
        );
    }

  
}

const styles={
    result : {
        height:'480rem',
        margin:'30rem',
        padding:'10rem',
        backgroundColor:'#ffffff',
        justifyContent:'center',
        alignItems:'center'
    },
    resultText : {
        fontSize:'28rem'
    },
    resultTextError:{
        color:'#ff6600'
    },
    btns:{
        margin:'30rem',
    },
    btn:{
        marginBottom:'30rem'
    }
}



render(<App/>);
