# NumberPicker demo

* order: 0

包含 onChange、step,error 样式等。

---

```js
/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Page from 'nuke-page';
import NumberPicker from 'nuke-number-picker';

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
    }
    changeHandle = e => {
        console.log(e);
    };
    render() {
        return (
            <Page title="Number Picker">
                <Page.Intro main="1-10 之间，默认 3" />
                <View style={styles.npwrapper}>
                    <NumberPicker
                        testId={{
                            reduceButton: 'reduce',
                            addButton: 'add',
                            input: 'input'
                        }}
                        min={1}
                        max={10}
                        defaultValue={3}
                        onChange={this.changeHandle}
                        step={1}
                    />
                </View>
                <Page.Intro main="auto correct" />
                <View style={styles.npwrapper}>
                    <NumberPicker
                        autoCorrect
                        min={1}
                        max={10}
                        defaultValue={2}
                        onChange={this.changeHandle}
                        step={3}
                    />
                </View>
                
                <Page.Intro main="disabled" />
                <View style={styles.npwrapper}>
                    <NumberPicker
                        disabled
                        min={1}
                        max={1000}
                        defaultValue={2}
                        onChange={this.changeHandle}
                        step={3}
                    />
                </View>
                <Page.Intro main="数字超长" />
                <View style={[styles.npwrapper, { width: 380 }]}>
                    <NumberPicker
                        min={99}
                        max={10000}
                        defaultValue={3443}
                        onChange={this.changeHandle}
                        step={50}
                    />
                </View>
            </Page>
        );
    }
};
const styles = {
    npwrapper: {
        width: 300,
        padding: 40
    }
};
render(<App />);
```
