/** @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('nuke-touchable');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _nukeIcon = require('nuke-icon');

var _nukeIcon2 = _interopRequireDefault(_nukeIcon);

var _nukeInput = require('nuke-input');

var _nukeInput2 = _interopRequireDefault(_nukeInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var NumberPicker = function (_Component) {
  _inherits(NumberPicker, _Component);

  function NumberPicker(props) {
    _classCallCheck(this, NumberPicker);

    var _this = _possibleConstructorReturn(this, (NumberPicker.__proto__ || Object.getPrototypeOf(NumberPicker)).call(this, props));

    _this.onAdd = function () {
      var _this$props = _this.props,
          max = _this$props.max,
          step = _this$props.step;

      if (_this.state.value + step <= max) {
        _this.setValue(_this.state.value + _this.props.step);
      }
    };

    _this.onReduce = function () {
      var _this$props2 = _this.props,
          min = _this$props2.min,
          step = _this$props2.step;

      if (_this.state.value - step >= min) {
        _this.setValue(_this.state.value - _this.props.step);
      }
    };

    _this.getValue = function () {

      return _this.refs.number.getValue();
    };

    var value = void 0;
    if ('value' in props) {
      value = props.value;
    } else {
      value = props.defaultValue;
    }

    value = _this.getValidValue(value);

    _this.state = {
      value: value,
      error: false,
      focused: false,
      displayValue: value
    };

    ['onAdd', 'onReduce', 'onChange', 'onFocus', 'onBlur'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });
    return _this;
  }

  _createClass(NumberPicker, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // todo: dynamic min & max
      if ('value' in nextProps) {
        var value = this.getValidValue(nextProps.value);
        this.setState({
          value: value,
          displayValue: value
        });
      }
    }
  }, {
    key: 'getValidValue',
    value: function getValidValue(value) {
      var _props = this.props,
          min = _props.min,
          max = _props.max;


      value = value === '' ? this.state.value : parseInt(value, 10);
      value = isNaN(value) ? this.state.value : value < min ? min : value > max ? max : value;

      return value;
    }
  }, {
    key: 'setValue',
    value: function setValue(displayValue) {
      var flag = void 0;
      var value = void 0;
      var error = false;
      var _props2 = this.props,
          disabled = _props2.disabled,
          autoCorrect = _props2.autoCorrect,
          onChange = _props2.onChange;


      if (disabled) {
        return;
      }

      value = this.state.value;
      var validValue = this.getValidValue(displayValue);

      if (autoCorrect) {
        value = displayValue = validValue;
      } else {
        error = validValue.toString() !== displayValue.toString();
        if (!error) {
          value = validValue;
        }
      }

      if (value !== this.state.value || (flag = true) && value.toString() !== this.state.displayValue.toString()) {
        if (!('value' in this.props)) {
          this.setState({
            value: value,
            displayValue: displayValue
          });
        } else if (!error) {
          this.setState({
            displayValue: this.state.value
          });
        }

        this.setState({
          error: error
        });

        if (!flag) {
          onChange(value);
        }
      } else {
        this.setState({
          error: error
        });
      }
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.state.value;
    }
  }, {
    key: 'onChange',
    value: function onChange(val) {
      if (this.props.editable) {
        this.setState({
          displayValue: val
        });
      }
      this.props.onChange && this.props.onChange(val);
    }
  }, {
    key: 'onFocus',
    value: function onFocus() {
      this.setState({ focused: true });
    }
  }, {
    key: 'onBlur',
    value: function onBlur(e) {
      var val = this.getValue();
      this.setValue(val);
      this.setState({ focused: false });
      this.props.onBlur && this.props.onBlur(this.state.value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          value = _state.value,
          displayValue = _state.displayValue,
          focused = _state.focused,
          error = _state.error;

      var _props3 = this.props,
          min = _props3.min,
          max = _props3.max,
          step = _props3.step,
          disabled = _props3.disabled,
          editable = _props3.editable,
          className = _props3.className,
          autoFocus = _props3.autoFocus,
          onChange = _props3.onChange,
          onBlur = _props3.onBlur,
          _props3$style = _props3.style,
          style = _props3$style === undefined ? {} : _props3$style,
          _props3$testId = _props3.testId,
          testId = _props3$testId === undefined ? {} : _props3$testId,
          others = _objectWithoutProperties(_props3, ['min', 'max', 'step', 'disabled', 'editable', 'className', 'autoFocus', 'onChange', 'onBlur', 'style', 'testId']);

      var x = {};
      if (disabled || !editable) {
        x['disabled'] = true;
      }
      var inputStyle = Object.assign({}, _styles2.default['input'], error ? _styles2.default['number-picker-error-input'] : {});
      return (0, _rax.createElement)(
        _nukeView2.default,
        _extends({}, others, { style: [_styles2.default['number-picker'], style] }),
        (0, _rax.createElement)(
          _nukeTouchable2.default,
          {
            testId: testId.reduceButton || '',
            style: _styles2.default['reduce'],
            onPress: this.onReduce,
            className: 'nuke-border-fix-1'
          },
          (0, _rax.createElement)(_nukeIcon2.default, {
            style: _styles2.default['reduce-icon'],
            disabled: disabled || value <= min,
            name: 'minus'
          })
        ),
        (0, _rax.createElement)(_nukeInput2.default, _extends({
          testId: testId.input || '',
          inputStyle: inputStyle,
          htmlType: 'number',
          ref: 'number',
          style: [_styles2.default['input-wrap'], error ? _styles2.default['number-picker-error-input-wrap'] : {}],
          min: min,
          max: max,
          step: step,
          autoFocus: autoFocus
        }, x, {
          value: focused || error ? displayValue : value,
          onFocus: this.onFocus,
          onBlur: this.onBlur,
          onChange: this.onChange
        })),
        (0, _rax.createElement)(
          _nukeTouchable2.default,
          {
            style: _styles2.default['add'],
            onPress: this.onAdd,
            testId: testId.addButton || '',
            className: 'nuke-border-fix-1'
          },
          (0, _rax.createElement)(_nukeIcon2.default, {
            style: _styles2.default['add-icon'],
            disabled: disabled || value >= max,
            name: 'add'
          })
        )
      );
    }
  }]);

  return NumberPicker;
}(_rax.Component);

NumberPicker.defaultProps = {
  min: 0,
  max: 100,
  step: 1,
  defaultValue: 0,
  editable: true,
  disabled: false,
  autoFocus: false,
  autoCorrect: false,
  onChange: noop
};

NumberPicker.propTypes = {
  min: _rax.PropTypes.number,
  max: _rax.PropTypes.number,
  step: _rax.PropTypes.number,
  value: _rax.PropTypes.number,
  editable: _rax.PropTypes.bool,
  disabled: _rax.PropTypes.bool,
  autoFocus: _rax.PropTypes.bool,
  autoCorrect: _rax.PropTypes.bool,
  defaultValue: _rax.PropTypes.number,
  onChange: _rax.PropTypes.func
};
exports.default = NumberPicker;
module.exports = exports['default'];