'use strict';

var _module$exports;

var _nukeVarLoader = require('nuke-var-loader');

var _nukeCore = require('nuke-core');

var _nukeCore2 = _interopRequireDefault(_nukeCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

////
/// @module number-picker: 数量选择
/// @tag NumberPicker
/// @category component
/// @family selector
/// @varPrefix $number-picker-
/// @classPrefix {prefix}-number-picker
////


/// height
/// @namespace size/bounding
var numberPickerHeight = (0, _nukeVarLoader.varLoader)('number-picker-height', _nukeCore2.default['s7']);
/// size
/// @namespace size/text
var numberPickerInputSizeText = (0, _nukeVarLoader.varLoader)('number-picker-input-size-text', _nukeCore2.default['font-size-base-body1']);
/// width
/// @namespace size/button
var numberPickerButtonWidth = (0, _nukeVarLoader.varLoader)('number-picker-button-width', _nukeCore2.default['s7']);
/// size
/// @namespace size/icon
var numberPickerIconSize = (0, _nukeVarLoader.varLoader)('number-picker-icon-size', _nukeCore2.default['icon-xs']);
/// width
/// @namespace size/border
var numberPickerBorderWidth = (0, _nukeVarLoader.varLoader)('number-picker-border-width', _nukeCore2.default['line-1-width']);
/// min-width
/// @namespace size/input
var numberPickerInputMinWidth = (0, _nukeVarLoader.varLoader)('number-picker-input-min-width', _nukeCore2.default['s5']);

/// input
/// @namespace statements/normal
var numberPickerInputColor = (0, _nukeVarLoader.varLoader)('number-picker-input-color', _nukeCore2.default['color-n2-4']);
/// input-background
/// @namespace statements/normal
var numberPickerInputBgColor = (0, _nukeVarLoader.varLoader)('number-picker-input-bg-color', _nukeCore2.default['color-n1-1']);
/// icon
/// @namespace statements/normal
var numberPickerIconColor = (0, _nukeVarLoader.varLoader)('number-picker-icon-color', _nukeCore2.default['color-n2-2']);
/// button-background
/// @namespace statements/normal
var numberPickerButtonBgColor = (0, _nukeVarLoader.varLoader)('number-picker-button-bg-color', _nukeCore2.default['color-n1-2']);
/// corner
/// @namespace statements/normal
var numberPickerBorderRadius = (0, _nukeVarLoader.varLoader)('number-picker-border-radius', _nukeCore2.default['corner-radius-r2']);
/// border
/// @namespace statements/normal
var numberPickerBorderColor = (0, _nukeVarLoader.varLoader)('number-picker-border-color', _nukeCore2.default['color-n1-6']);
/// border-style
/// @namespace statements/normal
var numberPickerBorderStyle = (0, _nukeVarLoader.varLoader)('number-picker-border-style', _nukeCore2.default['line-solid']);

/// input
/// @namespace statements/error
var numberPickerInputColorError = (0, _nukeVarLoader.varLoader)('number-picker-input-color-error', _nukeCore2.default['color-f2-1']);
/// input-border
/// @namespace statements/error
var numberPickerInputBorderColorError = (0, _nukeVarLoader.varLoader)('number-picker-input-border-color-error', _nukeCore2.default['color-f2-1']);

/// input
/// @namespace statements/disabled
var numberPickerInputColorDisabled = (0, _nukeVarLoader.varLoader)('number-picker-input-color-disabled', _nukeCore2.default['color-n2-1']);
/// input-background
/// @namespace statements/disabled
var numberPickerInputBgColorDisabled = (0, _nukeVarLoader.varLoader)('number-picker-input-bg-color-disabled', _nukeCore2.default['color-n1-2']);
/// icon
/// @namespace statements/disabled
var numberPickerIconColorDisabled = (0, _nukeVarLoader.varLoader)('number-picker-icon-color-disabled', _nukeCore2.default['color-n2-1']);
/// button-background
/// @namespace statements/disabled
var numberPickerButtonBgColorDisabled = (0, _nukeVarLoader.varLoader)('number-picker-button-bg-color-disabled', _nukeCore2.default['color-n1-2']);

/// input
/// @namespace statements/focus
var numberPickerInputColorFocus = (0, _nukeVarLoader.varLoader)('number-picker-input-color-focus', _nukeCore2.default['color-n2-4']);
/// input-border
/// @namespace statements/focus
var numberPickerInputBorderColorFocus = (0, _nukeVarLoader.varLoader)('number-picker-input-border-color-focus', _nukeCore2.default['color-n1-7']);

var numberPickerInputPadding = (0, _nukeVarLoader.varLoader)('number-picker-input-padding', _nukeCore2.default['s3']);
var numberPickerButtonBgColorActive = (0, _nukeVarLoader.varLoader)('number-picker-button-bg-color-active', _nukeCore2.default['color-n1-4']);

module.exports = (_module$exports = {}, _defineProperty(_module$exports, 'number-picker-height', numberPickerHeight), _defineProperty(_module$exports, 'number-picker-input-size-text', numberPickerInputSizeText), _defineProperty(_module$exports, 'number-picker-button-width', numberPickerButtonWidth), _defineProperty(_module$exports, 'number-picker-icon-size', numberPickerIconSize), _defineProperty(_module$exports, 'number-picker-border-width', numberPickerBorderWidth), _defineProperty(_module$exports, 'number-picker-input-min-width', numberPickerInputMinWidth), _defineProperty(_module$exports, 'number-picker-input-color', numberPickerInputColor), _defineProperty(_module$exports, 'number-picker-input-bg-color', numberPickerInputBgColor), _defineProperty(_module$exports, 'number-picker-icon-color', numberPickerIconColor), _defineProperty(_module$exports, 'number-picker-button-bg-color', numberPickerButtonBgColor), _defineProperty(_module$exports, 'number-picker-border-radius', numberPickerBorderRadius), _defineProperty(_module$exports, 'number-picker-border-color', numberPickerBorderColor), _defineProperty(_module$exports, 'number-picker-border-style', numberPickerBorderStyle), _defineProperty(_module$exports, 'number-picker-input-color-error', numberPickerInputColorError), _defineProperty(_module$exports, 'number-picker-input-border-color-error', numberPickerInputBorderColorError), _defineProperty(_module$exports, 'number-picker-input-color-disabled', numberPickerInputColorDisabled), _defineProperty(_module$exports, 'number-picker-input-bg-color-disabled', numberPickerInputBgColorDisabled), _defineProperty(_module$exports, 'number-picker-icon-color-disabled', numberPickerIconColorDisabled), _defineProperty(_module$exports, 'number-picker-button-bg-color-disabled', numberPickerButtonBgColorDisabled), _defineProperty(_module$exports, 'number-picker-input-color-focus', numberPickerInputColorFocus), _defineProperty(_module$exports, 'number-picker-input-border-color-focus', numberPickerInputBorderColorFocus), _defineProperty(_module$exports, 'number-picker-input-padding', numberPickerInputPadding), _defineProperty(_module$exports, 'number-picker-button-bg-color-active', numberPickerButtonBgColorActive), _module$exports);