# Radio demo

* order: 0

普通用法

---

```js
/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Radio from 'nuke-radio';
import Button from 'nuke-button';
import Page from 'nuke-page';

let App = class NukeDemoIndex extends Component {
  constructor() {
    super();
    this.state = {
      checked: false
    };
  }

  onChange = () => {
    let tmp = this.state.checked;
    this.setState({
      checked: !tmp
    });
  };
  onPress() {
    let tmp = this.state.checked;
    this.setState({
      checked: !tmp
    });
  }
  getChangeResult = value => {
    console.log(value);
  };

  render() {
    return (
      <Page title="Radio">
        <Page.Intro sub="通过外部 state 控制选中状态" />
        <View style={styles.demo_result}>
          <Text>this.state.checked : {this.state.checked}</Text>
        </View>
        <View style={styles.demo_item}>
          <Radio
            ref="x"
            size="small"
            checked={this.state.checked}
            onChange={this.onChange}
          />
          <Text>浙江省</Text>
        </View>

        <Page.Intro sub="Radio 内部自由切换，不受外部 state 控制" />
        <View style={styles.demo_item}>
          <Radio
            ref="xx"
            size="small"
            checkedStyle={{
              backgroundColor: 'red',
              borderColor: 'red'
            }}
            defaultChecked={this.state.checked}
            onChange={this.getChangeResult}
          />
          <Text>杭州</Text>
        </View>
      </Page>
    );
  }
};
const styles = {
  demo_item: {
    height: 104,
    marginBottom: 30,
    backgroundColor: '#ffffff',
    flexDirection: 'row',
    alignItems: 'center',
    paddingLeft: 12
  },
  demo_result: {
    backgroundColor: '#ffffff',
    paddingLeft: 32,
    height: 60,
    justifyContent: 'center',
    color: '#666666'
  }
};
render(<App />);
```
