# Radio demo

- order: 1

Group + 数据源

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Radio from 'nuke-radio';
import Button from 'nuke-button';
import Page from 'nuke-page';



let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            dataSource:0,
            group:'宁波市',
        }
    }

    onChange = (value) => {
        this.setState({
            dataSource:value
        })
    }
    groupChange = (value) => {
         this.setState({
            group:value
        });
        console.log('group',value);
    }
    render() {
         const dataSource = [
            {value:0, label: '苹果'},
            {value:1, label: '梨'},
            {value:2, label: '橘子'}
        ];
        
        return (
            <Page title="Radio">
                <Page.Intro main="Group 数据源模式"></Page.Intro>
                <Radio.Group style={styles.groupWrap} value={this.state.dataSource} onChange={ this.onChange } size="small" dataSource={ dataSource }></Radio.Group>
                <View style={styles.demo_result}>
                    <Text>this.state.value : {this.state.dataSource}</Text>
                </View>
                <Page.Intro main="Group 非数据源模式"></Page.Intro>
                    <Radio.Group style={styles.groupWrap} onChange = {this.groupChange} value={this.state.group}>
                    <View style={styles.demo_item}>
                        <Radio size="small"  value="杭州市"></Radio>
                        <Text>杭州市</Text>
                    </View>
                    <View style={styles.demo_item}>
                        <Radio size="small" value="宁波市"></Radio>
                        <Text>宁波市</Text>
                    </View>
                    <View style={styles.demo_item}>
                        <Radio size="small" value="温州市"></Radio>
                        <Text>温州市</Text>
                    </View>    
                    <View style={styles.demo_item}>
                        <Radio size="small" value="绍兴市"></Radio>
                        <Text>绍兴市</Text>
                    </View>
                </Radio.Group>
            </Page>

        );
    }
}
const styles = {
    groupWrap:{
        backgroundColor:'#ffffff',
        flexDirection:'column',
        paddingLeft:12
    },
    demo_result:{
        backgroundColor:'#ffffff',
        paddingLeft:32,
        height:60,
        justifyContent:'center',
        color:'#666666'
    },
    demo_item:{
        height:104,
        marginTop:30,
        backgroundColor:'#ffffff',
        flexDirection:'row',
        alignItems:'center',
        paddingLeft:12
    }
}
render(<App />);

````
