/** @jsx createElement */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _radio = require('./radio');

var _radio2 = _interopRequireDefault(_radio);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RADIO_TYPES = {
  group: 'radio-group',
  horizontal: 'RadioHorizontal',
  'small-text': 'radio-group-small-text',
  'medium-text': 'radio-group-medium-text'
};

var RadioGroup = function (_Component) {
  _inherits(RadioGroup, _Component);

  function RadioGroup(props) {
    _classCallCheck(this, RadioGroup);

    var _this = _possibleConstructorReturn(this, (RadioGroup.__proto__ || Object.getPrototypeOf(RadioGroup)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    var value = void 0;
    if ('value' in props) {
      value = props.value;
    }
    _this.state = {
      selectedValue: value
    };
    return _this;
  }

  _createClass(RadioGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextContext) {
      if (nextProps.value != this.state.selectedValue) {
        this.setState({
          selectedValue: nextProps.value
        });
      }
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        __group__: true,
        onChange: this.onChange,
        selectedValue: this.state.selectedValue
      };
    }
  }, {
    key: 'onChange',
    value: function onChange(value, e) {
      //同一个group下只能有一个被选中
      //
      this.setState({
        selectedValue: value
      });
      this.props.onChange(value);
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var _props = this.props,
          onChange = _props.onChange,
          _props$dataSource = _props.dataSource,
          dataSource = _props$dataSource === undefined ? [] : _props$dataSource,
          _props$style = _props.style,
          style = _props$style === undefined ? {} : _props$style,
          size = _props.size,
          horizontal = _props.horizontal;

      var groupStyle = _styles2.default[RADIO_TYPES['group']];
      var wrapStle = _extends({}, style);
      if (horizontal) {
        wrapStle = Object.assign({}, _styles2.default[RADIO_TYPES['horizontal']], style);
      }
      var textStyle = size && size == 'small' ? _styles2.default[RADIO_TYPES['small-text']] : _styles2.default[RADIO_TYPES['medium-text']];
      var current = this.state.selectedValue;

      if (!children) {
        children = dataSource.map(function (item, index) {
          if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) !== 'object') {
            item = { label: item, value: item };
          }

          var _item = item,
              label = _item.label,
              value = _item.value,
              others = _objectWithoutProperties(_item, ['label', 'value']);

          var checked = false;
          current == value ? checked = true : checked = false;

          if (label) {
            return (0, _rax.createElement)(
              _nukeView2.default,
              { t: 'radio-item-wrap', key: index, style: groupStyle },
              (0, _rax.createElement)(_radio2.default, _extends({
                t: 'radioitem'
              }, others, {
                size: size,
                value: value,
                checked: checked
              })),
              (0, _rax.createElement)(
                _nukeText2.default,
                { t: 'radiotext', style: textStyle },
                label
              )
            );
          } else {
            return (0, _rax.createElement)(
              _nukeView2.default,
              { t: 'radio-item-wrap', style: groupStyle },
              (0, _rax.createElement)(_radio2.default, _extends({}, others, { checked: checked }))
            );
          }
        });
      }

      return (0, _rax.createElement)(
        _nukeView2.default,
        { t: 'radio-group-wrap', style: wrapStle },
        children
      );
    }
  }]);

  return RadioGroup;
}(_rax.Component);

RadioGroup.propTypes = {
  dataSource: _rax.PropTypes.array,
  onChange: _rax.PropTypes.func,
  value: _rax.PropTypes.any
};

RadioGroup.defaultProps = {
  dataSource: [],
  onChange: function onChange() {},
  value: ''
};
RadioGroup.childContextTypes = {
  onChange: _rax.PropTypes.func,
  __group__: _rax.PropTypes.bool,
  selectedValue: _rax.PropTypes.any
};
exports.default = RadioGroup;
module.exports = exports['default'];