
/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Radio from 'nuke-radio';
import Button from 'nuke-button';


const style ={
    title:{
        color:'#383B3E',
        height:'44px',
        lineHeight: '44px'
    },
    item:{
        display:'flex',
        flexDirection:'row',
        alignItems:'center',
        justifyContent:'space-between',
        borderTopWidth:'1px',
        borderTopColor:'#EDEDEF',
        borderTopStyle:'solid',
        paddingTop:'5px',
        paddingBottom:'5px',
        paddingLeft:'20px',
        paddingRight:'20px'
    },
    delayValue:{
        color:'#383B3E'
    }
}

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            value:2
        }
    }

    groupChange(value){
         this.setState({
            value:value
            });
        console.log('group',value);
    }

    onChange(value){

        console.log('item',value);
    }
    press(){
        let tmp = this.state.value;
        this.setState({
            value:++tmp
            });
    }

    render() {
        const {value} = this.state;
        return (
            <View>
                <Radio.Group onChange = {this.groupChange.bind(this)} value={value}>
                    <View style={style.item}>
                        <View style={style.title}>
                           延迟天数
                        </View>
                    </View>
                    <View style={style.item}>
                        <Text style={style.delayValue}>
                            3天
                        </Text>
                        <Radio size="small" value={1} onChange={this.onChange.bind(this)}></Radio>
                    </View>
                    <View style={style.item}>
                        <Text style={style.delayValue}>
                            5天
                        </Text>
                        <Radio size="small" value={2} onChange={this.onChange.bind(this)}></Radio>
                    </View>
                    <View style={style.item}>
                        <Text style={style.delayValue}>
                            7天
                        </Text>
                        <Radio size="small" value={3} onChange={this.onChange.bind(this)}></Radio>
                    </View>
                    <View style={style.item}>
                        <Text style={style.delayValue}>
                            10天
                        </Text>
                        <Radio size="small" value={4} onChange={this.onChange.bind(this)}></Radio>
                    </View>
                    <View style={style.item}>
                        <Text style={style.delayValue}>
                            11天
                        </Text>
                        <Radio size="small" value={5} onChange={this.onChange.bind(this)}></Radio>
                    </View>
                    <View style={style.item}>
                        <Text style={style.delayValue}>
                            12天
                        </Text>
                        <Radio size="small" value={6} onChange={this.onChange.bind(this)}></Radio>
                    </View>
                </Radio.Group>
            </View>
        );
    }
}

render(<App/>);
