# 区间选择器类型

- order: 0

普通区间选择器。

---

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import Text from 'nuke-text';
import View from 'nuke-view';
import Page from 'nuke-page';
import Button from 'nuke-button';
import Range from 'nuke-range';
//import QN from 'QAP-SDK';

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            value:50
        };

    }

    changeValue(){
        this.setState({
            value:100
        })
    }

    onChange(value){
        console.log('拖动停止',value);
        this.setState({
            value:value
        })
    }
    onProcess(value){
        console.log(value);
      this.setState({
            value:value
        });
    }
    render() {
        return (
           <Page title="Range 范围选择">
                <Page.Intro main="无默认值" sub="单个滑块"></Page.Intro>
                <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                     <Range  slider="single" min={0} max={100}  style={{width:500}}  highPerformance={true}/>
                </View>
                <Page.Intro main="有默认值" sub="单个滑块"></Page.Intro>
                <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                     <Range  slider="single" min={0} max={100} defaultValue={80} style={{width:500}} highPerformance={true}/>
                </View>
                <Page.Intro main="受控使用" sub=""></Page.Intro>
                <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                     <Range  slider="single" min={0} max={100} value={this.state.value} style={{width:500}} onProcess={this.onProcess.bind(this)} onChange={this.onChange.bind(this)} highPerformance={true}/>
                     <Button type="primary" onPress={this.changeValue.bind(this)}>{'点我设置:'+this.state.value}</Button>
                </View>
                <Page.Intro main="样式自定义" sub=""></Page.Intro>
                <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                     <Range  slider="single" min={0} max={100} value={this.state.value} style={{width:500}} handlerStyle={{width:56,height:56}} barStyle={{color:'#007AFF',height:4}} afterBarStyle={{height:4}}/>
                </View>
                 <Page.Intro main="double" sub="两个滑块"></Page.Intro>
                <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                     <Range  slider="double" min={0} max={100} value={[10,80]} style={{width:500}}/>
                </View>
                 <Page.Intro main="double" sub="禁用"></Page.Intro>
                <View style={{justifyContent:'center',alignItems:'center',flex:1}}>
                     <Range disabled slider="double" min={0} max={100} value={[10,80]}  style={{width:500}}/>
                </View>
            </Page>
        );
    }
}

render(<App/>);

````
