'use strict';

import { varLoader } from 'nuke-var-loader';
import core from 'nuke-core';



////
/// @module range: 区间选择器
/// @tag Range
/// @category component
/// @family range
/// @varPrefix $range-
/// @classPrefix {prefix}-range
////

/// handler
/// @namespace statement
let rangeHandlerBgColor = varLoader('range-handler-bg-color', core['color-n1-1']);
/// size
/// @namespace size/handle
let rangeHandlerSize = varLoader('range-handler-size', core['s6']);
/// shadow
/// @namespace statement
let rangeHandlerShadow = varLoader('range-handler-shadow', core['shadow-sd1']);

/// handler
/// @namespace statement/disabled
let rangeDisabledHandlerBgColor = varLoader('range-disabled-handler-bg-color', core['color-n1-4']);

/// bar-underlay
/// @namespace statement
let rangeLineBarBgColor = varLoader('range-line-bar-bg-color', core['color-n1-7']);

/// bar-overlay
/// @namespace statement
let rangeBarOverlayColor = varLoader('range-bar-overlay-color', core['color-b1-8']);

/// height
/// @namespace size/scale
let rangeScaleLineHeight = varLoader('range-scale-line-height', core['s2']);

/// width
/// @namespace size/scale
let rangeScaleLineWidth = varLoader('range-scale-line-width', 2);

/// height
/// @namespace size/bar
let rangeBarHeight = varLoader('range-bar-height', '0.5');

/// scale-item
/// @namespace statement
let rangeScaleLineColor = varLoader('range-scale-line-color', core['color-n1-7']);

/// text
/// @namespace statement
let rangeScaleLabelColor = varLoader('range-scale-label-color', core['color-n2-2']);

/// tips-text
/// @namespace statement
let rangeTipsColor = varLoader('range-tips-color', core['color-n2-4']);

/// tips-background
/// @namespace statement
let rangeTipsBgColor = varLoader('range-tips-bg-color', core['color-n1-4']);

/// padding(l,r)
/// @namespace size/tips
let rangeTipsPaddingLeftRight = varLoader('range-tips-padding-left-right', core['s2']);

/// padding(t,b)
/// @namespace size/tips
let rangeTipsPaddingTopBottom = varLoader('range-tips-padding-top-bottom', core['s1']);

/// tips-radius
/// @namespace statement
let rangeTipsRadius = varLoader('range-tips-radius', core['corner-radius-r1']);

/// text
/// @namespace size/text
let rangeTipsFontSize = varLoader('range-tips-font-size', core['font-size-base-body1']);

/// padding(l,r)
/// @namespace size/bounding
let rangePaddingLeftRight = varLoader('range-padding-left-right', core['s4']);

/// padding(t,b)
/// @namespace size/bounding
let rangePaddingTopBottom = varLoader('range-padding-top-bottom', core['s2']);

/// width
/// @namespace size/scale
let rangeTipsWidth = varLoader('range-tips-width',100);

module.exports = {
    ['range-handler-bg-color']: rangeHandlerBgColor,
    ['range-handler-size']: rangeHandlerSize,
    ['range-handler-shadow']: rangeHandlerShadow,
    ['range-disabled-handler-bg-color']: rangeDisabledHandlerBgColor,
    ['range-line-bar-bg-color']: rangeLineBarBgColor,
    ['range-bar-overlay-color']: rangeBarOverlayColor,
    ['range-scale-line-height']: rangeScaleLineHeight,
    ['range-scale-line-width']: rangeScaleLineWidth,
    ['range-bar-height']: rangeBarHeight,
    ['range-scale-line-color']: rangeScaleLineColor,
    ['range-scale-label-color']: rangeScaleLabelColor,
    ['range-tips-color']: rangeTipsColor,
    ['range-tips-bg-color']: rangeTipsBgColor,
    ['range-tips-padding-left-right']: rangeTipsPaddingLeftRight,
    ['range-tips-padding-top-bottom']: rangeTipsPaddingTopBottom,
    ['range-tips-radius']: rangeTipsRadius,
    ['range-tips-font-size']: rangeTipsFontSize,
    ['range-padding-left-right']: rangePaddingLeftRight,
    ['range-padding-top-bottom']: rangePaddingTopBottom,
    ['range-tips-width']:rangeTipsWidth
}
