/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import Text from 'nuke-text';
import View from 'nuke-view';
import Range from 'nuke-range';

const App = class NukeDemoIndex extends Component {
  constructor() {
    super();
  }

  onChange(value) {
    console.log('checked', value);
  }

  render() {
    return (
      <View>
        <Text>自由无Tips</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="single"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={100}
          />
        </View>
        <Text>均分刻度</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="single"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={50}
            hasTips
            marks={10}
          />
        </View>
        <Text>步长</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="single"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={40}
            hasTips
            marks={10}
            step={10}
          />
        </View>
        <Text>范围</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="double"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={[50, 80]}
            hasTips
            marks={10}
            step={10}
          />
        </View>
        <Text>指定marks和formatter</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="double"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={[25, 80]}
            hasTips
            formatter="{0}°C"
            marks={{ 0: '0°C', 26: '26°C', 37: '37°C', 100: '100°C' }}
          />
        </View>
        <Text>disabled</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="single"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={20}
            disabled
            marks={20}
          />
        </View>
        <Text>指定marks和formatter</Text>
        <View style={{ width: 750, alignItems: 'center' }}>
          <Range
            slider="double"
            style={{ width: 700 }}
            min={0}
            max={100}
            defaultValue={[25, 80]}
            hasTips
            formatter="{0}°C"
            marks={{ 0: '0°C', 26: '26°C', 37: '37°C', 100: '100°C' }}
          />
        </View>
      </View>
    );
  }
};

render(<App />);
