/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * @providesModule
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeEnv = require('nuke-env');

var _nukeTouchable = require('nuke-touchable');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// 下面的属性需要在Text上手工继承
var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight'];
var ActiveAttr = ['color', 'backgroundColor', 'borderColor'];

var Button = function (_Component) {
  _inherits(Button, _Component);

  function Button(props) {
    _classCallCheck(this, Button);

    var _this = _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.onPress = _this.onPress.bind(_this);
    _this.onTextPress = _this.onTextPress.bind(_this);
    return _this;
  }

  _createClass(Button, [{
    key: 'onPress',
    value: function onPress(e) {
      if (this.props.disabled) return;
      this.props.onPress(e);
    }
  }, {
    key: 'onTextPress',
    value: function onTextPress(e) {
      if (this.props.disabled) return;
      if (_nukeEnv.isWeb) {
        e.stopPropagation();
      }
      this.props.onPress(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          size = _props.size,
          shape = _props.shape,
          type = _props.type,
          style = _props.style,
          disabled = _props.disabled,
          block = _props.block,
          rect = _props.rect,
          onPress = _props.onPress,
          others = _objectWithoutProperties(_props, ['size', 'shape', 'type', 'style', 'disabled', 'block', 'rect', 'onPress']);

      var btnStyle = {},
          textStyle = {};
      ActiveAttr.forEach(function (item) {
        if (style && style[item] && !style[item + ':active']) {
          style[item + ':active'] = style[item];
        }
      });
      btnStyle = Object.assign({}, _styles2.default.button, shape === 'warning' ? _styles2.default[shape] : {}, type && shape !== 'warning' ? _styles2.default[type] : {}, disabled ? _styles2.default.disabled : {}, disabled ? _styles2.default[shape === 'warning' ? shape + '-disabled' : type + '-disabled'] : {}, size ? _styles2.default['' + size] : {}, block ? _styles2.default.block : {}, rect ? _styles2.default.rect : {}, style);
      TextAttrArr.forEach(function (item) {
        if (btnStyle[item]) {
          textStyle[item] = btnStyle[item];
        }
        // 也加上伪类继承
        if (btnStyle[item + ':active']) {
          textStyle[item + ':active'] = btnStyle[item + ':active'];
        }
      });
      // Text 也添加 onClick={ this.props.onPress} 为了解决安卓端 点击text 无法触发 onPress 的问题
      return (0, _rax.createElement)(
        _nukeTouchable2.default,
        _extends({
          onPress: this.onPress,
          style: btnStyle,
          className: 'nuke-border-fix-1'
        }, others),
        (0, _rax.createElement)(
          _nukeText2.default,
          { style: textStyle, onClick: this.onTextPress },
          this.props.children
        )
      );
    }
  }]);

  return Button;
}(_rax.Component);

Button.propTypes = {
  type: _rax.PropTypes.oneOf(['normal', 'primary', 'link']),
  size: _rax.PropTypes.oneOf(['medium', 'large']),
  shape: _rax.PropTypes.oneOf(['warning', 'normal']),
  onPress: _rax.PropTypes.func,
  warning: _rax.PropTypes.boolean
};

Button.defaultProps = {
  shape: 'normal',
  type: 'normal',
  size: 'medium',
  onPress: function onPress() {}
};
exports.default = Button;
module.exports = exports['default'];