# SliderNeighbor

- order: 0

scale=0.8

---

````js

/** @jsx createElement */
import {createElement, Component,render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Dimensions from 'nuke-dimensions';
import SliderNeighbor from 'nuke-slider-neighbor';
import BizPage from 'nuke-biz-page';
let { height, width } = Dimensions.get('window');

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state={
            scale:0.8,
            sliderData:[
                {style:'c1',text:'1'},
                {style:'c2',text:'2'},
                {style:'c3',text:'3'},
                {style:'c4',text:'4'},
                {style:'c5',text:'5'},
                {style:'c6',text:'6'},
            ]
        }
    }
    getItems(){
        let content = [];
        this.state.sliderData.forEach((item,index)=>{
            content.push(<View style={[styles.slideItem,styles[item['style']]]}>
                        <Text style={styles['slideItemText']}>第{item['text']}页</Text>
                        <Text style={styles['slideItemText']}>自动缩放全屏至 scale {this.state.scale}</Text>
                    </View>)
        });
        return content;
    }
    change=(e)=>{
        console.log('switchto ',e);
    }
    render() {
        return (
                <SliderNeighbor width="750rem" scale={this.state.scale} neighborScale="0.7" distanceLevel={9}  height={`${height}rem`} showPagination={false} onChange={this.change}>
                    {this.getItems()}
                </SliderNeighbor>

        );
    }
}
const styles = {
  
  slideItem: {
    width: '750rem',
    height: `${height}rem`,
    justifyContent:'center',
    alignItems:'center'
  },
  slideItemText: {
    color:'#ffffff',
    fontSize:'40rem'
  },
  c1:{
    backgroundColor:'red'
  },
  c2:{
    backgroundColor:'orange'
  },
  c3:{
    backgroundColor:'yellow'
  },
  c4:{
    backgroundColor:'green'
  },
  c5:{
    backgroundColor:'blue'
  },
  c6:{
    backgroundColor:'purple'
  },
  img: {
    width: '750rem',
    height: '1154rem'
  }
};

render(<App/>);

````
