'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _variables = require('./variables');

var _variables2 = _interopRequireDefault(_variables);

var _mixin = require('./mixin');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Variables = (0, _variables2.default)();

exports.default = {

  wrap: {
    width: Variables['wrap-width'],
    height: Variables['wrap-height'],
    minWidth: Variables['wrap-min-width'],
    minHeight: Variables['wrap-min-height'],
    borderRadius: Variables['wrap-border-radius'],
    position: 'relative',
    display: 'inline-block',
    margin: Variables['wrap-margin'],
    padding: Variables['wrap-padding'],
    cursor: 'default', // pointer will cause a grey background color on chrome
    verticalAlign: 'middle',
    borderColor: Variables['wrap-border-color'],
    borderStyle: 'solid',
    borderWidth: Variables['wrap-border-width'],
    WebkitUserSelect: 'none',
    WebkitBoxSizing: 'content-box',
    WebkitBackfaceVisibility: 'hidden'
  },
  checkedWrap: {
    borderColor: Variables['checked-border-color'],
    backgroundColor: Variables['checked-bg-color'],
    boxShadow: Variables['checked-boxshadow-color'] + ' 0 0 0 16px inset',
    WebkitTransition: 'border 0.2s, box-shadow 0.2s, background-color 1s'
  },
  uncheckedWrap: {
    borderColor: Variables['unchecked-border-color'], // '#dfdfdf',
    backgroundColor: Variables['unchecked-bg-color'],
    boxShadow: Variables['unchecked-boxshadow-color'] + ' 0 0 0 0 inset', // #dfdfdf
    WebkitTransition: 'border 0.2s, box-shadow 0.2s'
  },
  disabledWrap: {

    cursor: 'not-allowed',
    boxShadow: 'none'
  },
  disabledCheckedWrap: {
    borderColor: (0, _mixin.rgba)(Variables['disabled-checked-border-color'], 0.5),
    backgroundColor: Variables['disabled-checked-bg-color']
  },
  disabledUnCheckedWrap: {
    backgroundColor: Variables['disabled-unchecked-bg-color']
    // borderColor: Variables['unchecked-border-color']
  },
  dot: {
    position: 'absolute',
    top: Variables['dot-top'],
    left: Variables['dot-left'],
    width: Variables['dot-size'], //60,
    height: Variables['dot-size'], //60,
    backgroundColor: Variables['dot-bg-color'],
    borderRadius: Variables['dot-size'],
    boxShadow: '0 1px 3px rgba(0,0,0,0.4)',
    WebkitTransition: '-webkit-transform 0.2s ease-in'
  },
  checkedDot: {
    WebkitTransform: 'translateX(' + Variables['dot-transform'] + 'rem)', // should with rem unit that the value is string type
    backgroundColor: Variables['dot-checked-bg-color']
  },
  uncheckedDot: {
    WebkitTransform: 'translateX(0)'
  },
  disabledDot: {
    backgroundColor: Variables['dot-disabled-bg-color']
  }

};
module.exports = exports['default'];