# TabSlider

- category: UI
- chinese: 滑动Tab切换
- type: UI组件

---

## API
### tabSlider

| 名称      |     类型 |   默认   | 说明 |
| :-------- | --------:| :------: | :------: |
| style    |  Object |  {}  | 导航区域的外观样式 |
| active | number | 0 | 当前选中的tab |
| navTop | boolean | false | 导航条位置 |
| width | number | 750 | swipe区 |
| height | number |1000 | swipe区域的高度,如果未设置，将会取屏幕dimension自动计算填满屏幕 |
| customTitle | boolean | false | 是否设置自定义的导航|
| renderTitleCustom | function | (){} | 渲染自定义导航条的方法 |


## 方法
| 名称      |     类型 |   默认   | 说明 |
| :-------- | --------:| :------: | :------: |
| onChange | function(index) | () | 切换tab的回调 |

## 实例方法
`this.refs.TabSlider.slideTo(index)`  用于从外部主动切换到对应的tab项，index为`number`类型

说明：

- index参数在android下的支持问题将会在下一个客户端版本修复。

- ios在tab个数小于两个的时候index参数无效的问题将于下个客户端版本修复

### tabSlider.pane

| 名称      |    类型 |   默认   | 说明 |
| :-------- | --------:| :------: |
|  title   |   String |  空 | 导航文字 |
| icon | Obeject：{src：xxx,selected:xxx} | 空 | 导航图标,src:正常态，selected:选中态。需要是一张图片 |
| style | Object | {} | pane内容样式 |
| renderContent | function | {} | 提供自定义的title设置,当设置此项时,选中状态的设置需由开发者自行实现，不可与title等自动配置情况混合使用 |
| num | number | 0 | 消息数，暂未提供，todo |

pane的自定义样式可以通过customTitle进行icon或者图标的设置。

### 一些特殊用法

- 当customTitle为true时，用户可以自定义title布局，超出屏幕的部分可滑动。
- 否则所有title均分750rem。

### todo

受限于weex，暂时还无法实现导航区域的自定义滚动[滚动到选中项的位置]
