# 基础使用

- order: 0

简单的渲染示例

-----------


````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import { View, Text,Image,TouchableHighlight,ScrollView} from 'nuke-components';
import  TabSlider  from 'nuke-tab-slider';
import  Button  from 'nuke-button';

const { Pane } = TabSlider;
let styles = {
  slider: {
    width: '750rem',
    position: 'relative',
    overflow: 'hidden',
    height: '452rem',
    backgroundColor: '#cccccc'
  },
  itemWrap: {
    width: '750rem',
    height: '352rem'
  },
  image: {
    width: '750rem',
    height: '352rem'
  },
  button: {
    marginTop: '20rem',
    width: '340rem',
    height: '80rem'
  },
  paginationStyle: {
    position: 'absolute',
    width: '750rem',
    height: '40rem',
    bottom: '20rem',
    left: 0,
    itemColor: 'rgba(255, 255, 255, 0.5)',
    itemSelectedColor: 'rgb(255, 80, 0)'
  },
  tab:{
    position:'relative',

  },
  tabBottom:{
    height:166,
    width:750,
    backgroundColor:'#333333',
    display:'flex',
    alignItems:'center',
    justifyContent:'middle'
  },
  barStyle:{
    backgroundColor:'#ffffff',
    height:200
  }
};

class NukeDemoIndex extends Component{
  constructor(props) {
    super(props);
    this.state =  {
            notifCount: 0,
            index:2,
            active:0
        };
  }

  sliderChange(index){
    console.log('slide-to', index);
  }

  btnClick(){
      this.refs.TabSlider.slideTo(3);
  }

  _renderContent(color, pageText) {
      return (
        <View>
          <Text style={{ color: color,fontSize:'40rem' }}>{pageText}</Text>
        </View>
      );
  }

  render() {
      return (
        <View>
         <TabSlider ref="TabSlider" width={750} style={styles.barStyle} active={this.state.active} onChange={this.sliderChange.bind(this)}  customBar={false}>
            <Pane title={'首页'} icon={{src:'//img.alicdn.com/tfs/TB1cCLYMVXXXXXHXpXXXXXXXXXX-64-64.png',selected:'//img.alicdn.com/tfs/TB1MzYIMVXXXXXYXVXXXXXXXXXX-64-64.png'}} style={{justifyContent:'center',alignItems:'center',width:750,height:1500}}>
              <View>
                <Button onPress={this.btnClick.bind(this)}>切换tab至第四个</Button>
              </View>
            </Pane>
            <Pane title={'个人'} icon={{src:'//img.alicdn.com/tfs/TB1aoTvMVXXXXaKaXXXXXXXXXXX-64-64.png',selected:'//img.alicdn.com/tfs/TB1AZ_yMVXXXXX8aXXXXXXXXXXX-64-64.png'}} style={{justifyContent:'center',alignItems:'center',width:750,height:1200}}>
              <View style={styles.tab}>{this._renderContent('#783E33', '内容2')}</View>
            </Pane>
            <Pane title={'购物车1'} icon={{src:'//img.alicdn.com/tfs/TB1UsjYMVXXXXXaXpXXXXXXXXXX-64-64.png',selected:'//img.alicdn.com/tfs/TB12mLPMVXXXXa5XFXXXXXXXXXX-64-64.png'}} style={{justifyContent:'center',alignItems:'center',width:750,height:1200}}>
              <View style={styles.tab}>{this._renderContent('#21551C', '内容3')}</View>
            </Pane>
            <Pane title={'购物车2'} icon={{src:'//img.alicdn.com/tfs/TB1UsjYMVXXXXXaXpXXXXXXXXXX-64-64.png',selected:'//img.alicdn.com/tfs/TB12mLPMVXXXXa5XFXXXXXXXXXX-64-64.png'}} style={{justifyContent:'center',alignItems:'center',width:750,height:1200}}>
              <View style={styles.tab}>{this._renderContent('#21551C', '内容4')}</View>
            </Pane>
        </TabSlider>
       </View>
        )
  }
}
render(<NukeDemoIndex/>);

````
