# Tabbar Capsule 模式

- order: 8

胶囊模式

-----------

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Image from 'nuke-image';
import Tabbar from 'nuke-tabbar';
import Page from 'nuke-page';
import Iconfont from 'nuke-iconfont';


let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state =  {
            activeKey: {key: 'tab1'}
        };
    }

    renderItemCapsule = (Name,isActive) =>{
        return (<View style={styles.itemCapsule}>
            <Text style={[styles.itemTextCapsule,isActive ? styles.activeTextCapsule:{}]}>{Name}</Text>
        </View>);
    }
    renderContent = (pageText) => {
        return (
          <View style={[styles.tabContent]}>
            <Text style={styles.tabText}>{pageText}</Text>
          </View>
        );
    }
    onItemCapsulePress(tab){
        alert('点击了==>'+tab);
    }

    render() {
        return (

            <Tabbar style={styles.wrapper} capsule={true} activeKey={this.state.activeKey}>
                <Tabbar.Item
                    tabKey="tab1"
                    onPress={()=>this.onItemCapsulePress('tab1')}
                    render={this.renderItemCapsule.bind(this,'标题一')}>
                    {this.renderContent('tab1')}
                </Tabbar.Item>
                <Tabbar.Item
                    tabKey="tab2"
                    onPress={()=>this.onItemCapsulePress('tab2')}
                    render={this.renderItemCapsule.bind(this,'标题二')}>
                    {this.renderContent('tab2')}
                </Tabbar.Item>

            </Tabbar>
                
        );
    }
}
const styles = {
    wrapper: {
        flex:1
    },
    tabContent:{
        flex:1,
        backgroundColor:'#ffffff',
        alignItems: 'center',
        justifyContent:'center'
    },
    tabText: {
        fontSize:'40rem'
    },
    item:{
        height:'70rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    icon:{
        fontFamily: 'tabicons',
        fontSize:'32rem',
        color:'#999999'
    },
    itemFixWidth:{
        width:'150rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    itemIcon:{
        width:'48rem',
        height:'48rem',
        borderRadius:'24rem',
        marginBottom:'6rem',
        marginTop:'14rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    activeText:{
        color:'#3089dc'
    },
    activeTextWithIcon:{
        color:'#ffffff'
    },

    itemIconActiveBg:{
        backgroundColor:'#3089dc',
    },
    itemCapsule:{
        alignItems: 'center',
        justifyContent:'center',
        width:'150rem',
    },
    itemTextCapsule:{
        color:'#3089dc',
        fontSize:'32rem'
    },
    activeTextCapsule:{
        color:'#ffffff'
    },
}


render(<App/>);
````
