# Tabbar Slider 模式

- order: 3

Slider 模式下，activeKey 必须是 { key : number.toString() }

-----------

````js

/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Image from 'nuke-image';
import Touchable from 'nuke-touchable';
import Tabbar from 'nuke-tabbar';
import Page from 'nuke-page';
import Icon from 'nuke-icon';
import Iconfont from 'nuke-iconfont';
const iconsMap = {
    tab1:{
        icon:'\ue650',
        name:'标题一'
    },
    tab2:{
        icon:'\ue631',
        name:'标题二'
    },
    tab3:{
        icon:'\ue65e',
        name:'标题三'
    },
    tab4:{
        icon:'\ue65d',
        name:'标题四'
    }
}
let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        Iconfont({name:"tabicons",url:"https://at.alicdn.com/t/font_jw65w2xs3tm7k3xr.ttf"});
        
    }

    renderContent = (pageText,bg) => {
        return (
          <View style={[styles.tabContent,{backgroundColor:bg}]}>
            <Text style={styles.tabText}>{pageText}</Text>
          </View>
        );
    }

    renderItemWithIcon = (iconName,isActive, key) =>{
        return (<View style={styles.item}>
            <View style={[styles.itemIcon, isActive ? styles.itemIconActiveBg : {}]}>
                <Text style={[styles.icon,isActive ? styles.activeTextWithIcon:{}]}>{iconsMap[iconName]['icon']}</Text>
            </View>
            <Text style={[styles.itemText,isActive ? styles.activeText:{}]}>{iconsMap[iconName]['name']}</Text>
        </View>);
    }


    render() {
        return (


            <Tabbar slider={true} style={styles.wrap} iconBar={true} activeKey={{key: '0'}}>
                <Tabbar.Item
                    tabKey="0"
                    render={this.renderItemWithIcon.bind(this,'tab1')}
                    >
                    {this.renderContent('tab1','#ff6600')}
                </Tabbar.Item>
                <Tabbar.Item
                    tabKey="1"
                    render={this.renderItemWithIcon.bind(this,'tab2')}
                    >
                    {this.renderContent('tab2','#3089dc')}
                </Tabbar.Item>
                <Tabbar.Item
                    tabKey="2"
                    render={this.renderItemWithIcon.bind(this,'tab3')}
                    >
                    {this.renderContent('tab3','#cccccc')}
                </Tabbar.Item>
                
                
            </Tabbar>

        );
    }
}
const styles = {
    wrap: {
        flex:1,
    },
    tabWithoutContent: {
        marginTop:'20rem',
        height:'200rem'
    },
    tabContent:{
        flex:1,
        backgroundColor:'#ffffff',
        alignItems: 'center',
        justifyContent:'center'
    },
    tabText: {
        fontSize:'40rem'
    },
    item:{
        height:'70rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    icon:{
        fontFamily: 'tabicons',
        fontSize:'32rem',
        color:'#999999'
    },
    itemFixWidth:{
        width:'150rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    itemIcon:{
        width:'48rem',
        height:'48rem',
        borderRadius:'24rem',
        marginBottom:'6rem',
        marginTop:'14rem',
        alignItems: 'center',
        justifyContent:'center'
    },
    activeText:{
        color:'#3089dc'
    },
    activeTextWithIcon:{
        color:'#ffffff'
    },

    itemIconActiveBg:{
        backgroundColor:'#3089dc',
    },
    itemCapsule:{
        alignItems: 'center',
        justifyContent:'center',
        width:'150rem',
    },
    itemTextCapsule:{
        color:'#3089dc',
        fontSize:'32rem'
    },
    activeTextCapsule:{
        color:'#ffffff'
    },
}


render(<App/>);
````
