/** @jsx createElement */
import {createElement, Component,render} from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Image from 'nuke-image';
import Touchable from 'nuke-touchable';
import Tabbar from 'nuke-tabbar';
import Icon from 'nuke-icon';
import Iconfont from 'nuke-iconfont';

const iconsMap = {
    home:'\ue601',
    cart:'\ue600',
    my:'\ue602'
}

let App = class NukeDemoIndex extends Component {
    constructor() {
        super();
        Iconfont({name:"tabicons",url:"//at.alicdn.com/t/font_3ife2q6deoxkcsor.ttf"});
        this.state =  {
            activeKey: "tab1"
        };
    }

    renderContent = (pageText) => {
        return (
          <View style={[styles.tabContent]}>
            <Text style={styles.tabText}>{pageText}</Text>
          </View>
        );
    }
    renderItem = (iconName,isActive, key) =>{
        return (<View style={styles.item}>
            <Text style={[styles.icon,isActive ? styles.activeText:{}]}>{iconsMap[iconName]}</Text>
            <Text style={isActive ? styles.activeText:{}}>{iconName}</Text>
        </View>);
    }

    render() {
        return (
            <View style={styles.container}>
                <Tabbar navStyle={{active: styles.activeBorder, inactive: styles.inactiveBorder}} activeKey={this.state.activeKey}>
                    <Tabbar.Item
                        tabKey="tab1"
                        render={this.renderItem.bind(this,'home')}>
                        {this.renderContent('home')}
                    </Tabbar.Item>
                    <Tabbar.Item
                        tabKey="tab2"
                        render={this.renderItem.bind(this,'cart')}>
                        {this.renderContent('cart')}
                    </Tabbar.Item>
                    <Tabbar.Item
                        tabKey="tab3"
                        render={this.renderItem.bind(this,'my')}>
                        {this.renderContent('my')}
                    </Tabbar.Item>
                </Tabbar>
            </View>
        );
    }
}
const styles = {
    tabContent: {
        flex: 1,
        alignItems: 'center',
        justifyContent:'center'
    },
    tabText: {
        fontSize:'40rem'
    },
    container: {
        flex: 1 
    },
    item:{
        alignItems: 'center',
        justifyContent:'center'
    },
    icon:{
        fontFamily: 'tabicons',
        fontSize:'32rem'
    },
    activeText:{
        color:'#337838'
    },
    activeBorder: {
        borderTopWidth: "5rem", 
        borderTopStyle: "solid", 
        borderTopColor: "#337838"
    },
    inactiveBorder: {
        borderTopWidth: "5rem", 
        borderTopStyle: "solid", 
        borderTopColor: "#eeeeee"
    }
}


render(<App/>);