/* @jsx createElement */

'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeEnv = require('nuke-env');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var typeMap = {
    'default': 'text',
    'ascii-capable': 'text',
    'numbers-and-punctuation': 'number',
    'url': 'url',
    'number-pad': 'number',
    'phone-pad': 'tel',
    'name-phone-pad': 'text',
    'email-address': 'email',
    'decimal-pad': 'number',
    'twitter': 'text',
    'web-search': 'search',
    'numeric': 'number',
    'number': 'number'
};

var TextInput = function (_Component) {
    _inherits(TextInput, _Component);

    function TextInput() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, TextInput);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextInput.__proto__ || Object.getPrototypeOf(TextInput)).call.apply(_ref, [this].concat(args))), _this), _this.handleInput = function (e) {
            var text = e.value;
            // Shim Event
            if (_nukeEnv.isWeex) {
                e = {
                    nativeEvent: {
                        text: text
                    },
                    value: text
                };
            }
            _this.props.onInput(e);
        }, _this.handleChange = function (e) {
            var text = e.value;
            // Shim Event
            if (_nukeEnv.isWeex) {
                e = {
                    nativeEvent: {
                        text: text
                    },
                    value: text
                };
            }

            _this.props.onChange && _this.props.onChange(e);
            _this.props.onChangeText && _this.props.onChangeText(text);
        }, _this.handleFocus = function (e) {
            return _this.props.onFocus(e);
        }, _this.handleBlur = function (e) {
            return _this.props.onBlur(e);
        }, _this.focus = function () {
            _this.refs.input.focus && _this.refs.input.focus();
        }, _this.blur = function () {
            _this.refs.input.blur && _this.refs.input.blur();
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(TextInput, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                accessibilityLabel = _props.accessibilityLabel,
                autoComplete = _props.autoComplete,
                _props$autoFocus = _props.autoFocus,
                autoFocus = _props$autoFocus === undefined ? false : _props$autoFocus,
                editable = _props.editable,
                keyboardType = _props.keyboardType,
                maxLength = _props.maxLength,
                maxNumberOfLines = _props.maxNumberOfLines,
                numberOfLines = _props.numberOfLines,
                onBlur = _props.onBlur,
                onFocus = _props.onFocus,
                onChange = _props.onChange,
                onChangeText = _props.onChangeText,
                onInput = _props.onInput,
                placeholder = _props.placeholder,
                password = _props.password,
                secureTextEntry = _props.secureTextEntry,
                style = _props.style,
                value = _props.value,
                id = _props.id,
                _props$encrypt = _props.encrypt,
                encrypt = _props$encrypt === undefined ? false : _props$encrypt,
                encryptFormat = _props.encryptFormat,
                searchEncryptFormat = _props.searchEncryptFormat,
                encryptSeckeyType = _props.encryptSeckeyType,
                others = _props.others;
            var _props2 = this.props,
                _props2$type = _props2.type,
                type = _props2$type === undefined ? 'default' : _props2$type,
                multiline = _props2.multiline,
                multiple = _props2.multiple;


            multiline = multiple || multiline;
            var propsCommon = {
                'aria-label': accessibilityLabel,
                autoComplete: autoComplete && 'on',
                autofocus: autoFocus,
                maxlength: maxLength,
                onChange: (onChange || onChangeText) && this.handleChange,
                onInput: onInput && this.handleInput,
                onBlur: onBlur && this.handleBlur,
                onFocus: onFocus && this.handleFocus,
                placeholder: placeholder,
                style: _extends({}, styles.initial, style),
                value: value,
                encrypt: encrypt,
                encryptFormat: encryptFormat,
                searchEncryptFormat: searchEncryptFormat,
                encryptSeckeyType: encryptSeckeyType,
                id: id,
                ref: 'input'
            };

            if (typeof editable !== 'undefined' && !editable) {
                propsCommon.readOnly = true;
            } else {
                //由于weex input readOnly默认值恢复还成问题，此处需要强制指定false,否则如果用户设置过readonly true 就永远无法修改了。
                if (_nukeEnv.isWeex) {
                    propsCommon.readOnly = false;
                }
            }

            type = typeMap[keyboardType] || type;
            if (password || secureTextEntry) {
                type = 'password';
            }

            if (_nukeEnv.isWeex) {
                if (multiline) {
                    return (0, _rax.createElement)('textarea', _extends({}, propsCommon, { rows: 20, disabled: propsCommon.readOnly }));
                } else {
                    // https://github.com/alibaba/weex/blob/dev/doc/components/input.md
                    return (0, _rax.createElement)('input', _extends({}, propsCommon, { type: type, disabled: propsCommon.readOnly }));
                }
            } else {
                // 删除autofocus
                if (!propsCommon.autofocus) {
                    delete propsCommon.autofocus;
                }
                var input = void 0;
                if (multiline) {
                    var propsMultiline = {
                        maxRows: maxNumberOfLines || numberOfLines,
                        minRows: numberOfLines
                    };

                    input = (0, _rax.createElement)(
                        'textarea',
                        _extends({}, propsCommon, propsMultiline, others),
                        propsCommon.value
                    );
                } else {
                    input = (0, _rax.createElement)('input', _extends({}, propsCommon, others, { type: type }));
                }

                return input;
            }
        }
    }]);

    return TextInput;
}(_rax.Component);

var styles = {
    initial: {
        appearance: 'none',
        backgroundColor: 'transparent',
        borderColor: '#000000',
        borderWidth: 0,
        boxSizing: 'border-box',
        color: '#000000',
        padding: 0,
        paddingLeft: '8rem',
        // lineHeight: '24rem',
        fontSize: '24rem',
        minHeight: '36rem' // default height
    }
};

exports.default = TextInput;
module.exports = exports['default'];