# TimePicker Demo

* order: 0

日期选择器 demo

---

```js
/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Button from 'nuke-button';
import TimePicker from 'nuke-time-picker';
import Page from 'nuke-page';
class NukeDemoIndex extends Component {
    constructor() {
        super();
        this.state = {
            data: ''
        };
    }
    date = () => {
        TimePicker.show(
            {
                title: '请选择日期',
                type: 'date'
            },
            e => {
                this.setState({ data: e });
                console.log('select date ', e);
            },
            e => {
                console.log('canceled ', e);
            }
        );
    };
    time = () => {
        TimePicker.show(
            {
                // range: ['2018/01/01 12:12:12', '2018/01/01 13:20:20'],
                title: '请选择时间',
                type: 'time'
            },
            e => {
                this.setState({ data: e });
                console.log('select time ', e);
            }
        );
    };
    datetime = () => {
        TimePicker.show(
            {
                title: '请选择时间',
                default: '2016/12/31 11:11:22',
                type: 'datetime'
            },
            e => {
                this.setState({ data: e });
                console.log('select datetime', e);
            }
        );
    };

    render() {
        return (
            <Page title="TimePicker">
                <View style={styles.result}>
                    {this.state.data ? (
                        <Text style={styles.resultText}>{this.state.data}</Text>
                    ) : null}
                </View>
                <View style={styles.btns}>
                    <Button
                        style={styles.btn}
                        block
                        onPress={this.date}
                        type="primary"
                    >
                        date
                    </Button>
                    <Button
                        style={styles.btn}
                        block
                        onPress={this.time}
                        type="primary"
                    >
                        time
                    </Button>
                    <Button
                        style={styles.btn}
                        block
                        onPress={this.datetime}
                        type="primary"
                    >
                        datetime
                    </Button>
                </View>
            </Page>
        );
    }
}
const styles = {
    result: {
        height: '480rem',
        margin: '30rem',
        padding: '10rem',
        backgroundColor: '#ffffff',
        justifyContent: 'center',
        alignItems: 'center'
    },
    resultText: {
        fontSize: '28rem'
    },
    btns: {
        margin: '30rem'
    },
    btn: {
        marginBottom: '30rem'
    }
};
render(<NukeDemoIndex />);
```
