'use strict';

var _nukeVars = require('nuke-vars');

var _nukeVars2 = _interopRequireDefault(_nukeVars);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_nukeVars2.default._nuke_custom_vars = _nukeVars2.default._nuke_custom_vars || {};

module.exports = {
    varsLoader: function varsLoader(config) {
        return Object.assign(config, _nukeVars2.default._nuke_custom_vars);
    },
    varLoader: function varLoader(key, value) {
        if (key in _nukeVars2.default._nuke_custom_vars) {
            return _nukeVars2.default._nuke_custom_vars[key];
        };
        return value;
    },
    setVars: function setVars(config) {
        Object.assign(_nukeVars2.default._nuke_custom_vars, config);
    },
    setVar: function setVar(key, value) {
        _nukeVars2.default._nuke_custom_vars[key] = value;
    },
    getVar: function getVar(key) {
        return _nukeVars2.default._nuke_custom_vars[key];
    },
    androidVar: function androidVar(config) {
        var style = {};
        for (var i in config) {
            style['android-' + i] = config[i];
        }
        return varLoader(style);
    },
    iosVar: function iosVar(config) {
        var style = {};
        for (var i in config) {
            style['ios-' + i] = config[i];
        }
        return varLoader(style);
    }
};