'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _universalEnv = require('universal-env');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PLAY = 'play';
var PAUSE = 'pause';

var Video = function (_Component) {
  _inherits(Video, _Component);

  function Video() {
    _classCallCheck(this, Video);

    return _possibleConstructorReturn(this, (Video.__proto__ || Object.getPrototypeOf(Video)).apply(this, arguments));
  }

  _createClass(Video, [{
    key: 'render',
    value: function render() {
      var props = this.props;

      if (_universalEnv.isWeex) {
        props.playStatus = props.playControl;
        return (0, _rax.createElement)('video', props);
      } else {
        var nativeProps = _extends({}, props);

        delete nativeProps.autoPlay;
        delete nativeProps.src;

        if (props.autoPlay || props.playControl === PLAY) {
          nativeProps.autoPlay = props.autoPlay;
        }
        // Default controls is true
        if (props.controls == null || props.controls === true) {
          nativeProps.controls = true;
        } else {
          delete nativeProps.controls;
        }

        var node = this.refs.video;
        if (node) {
          if (props.playControl === PAUSE) {
            node.pause();
          } else if (props.playControl === PLAY) {
            node.play();
          }
        }

        return (0, _rax.createElement)(
          'video',
          _extends({
            ref: 'video'
          }, nativeProps, {
            'webkit-playsinline': true,
            playsinline: true }),
          (0, _rax.createElement)('source', { src: props.src })
        );
      }
    }
  }]);

  return Video;
}(_rax.Component);

exports.default = Video;
module.exports = exports['default'];